<?php
/***************************************************************************
 *                              admin_board.php
 *                            -------------------
 *   begin                : Thursday, Jul 12, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: admin_board.php 438 2006-04-12 18:55:46Z arthurschreiber $
 *
 *
 ***************************************************************************/

if ( !empty($setmodules) )
{
	$module['General']['Configuration'] = basename(__FILE__);
	return;
}
define('IN_PHPBB', true);
//
// Let's set the root dir for phpBB
//
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include($phpbb_root_path . 'includes/functions_selects.'.$phpEx);

//clear vars
$confirm_yes						=	'';
$confirm_no							=	'';
$custom_title_mode_replace_rank		=	'';
$custom_title_mode_replace_both		=	'';

//
// Pull all config data
//
$sql = "SELECT *
	FROM " . CONFIG_TABLE;
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query config information in admin_board", "", __LINE__, __FILE__, $sql);
}
else
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$config_name = $row['config_name'];
		$config_value = $row['config_value'];
		$default_config[$config_name] = str_replace("'", "\'", $config_value); // 2.0.9
		$default_config[$config_name] = isset($HTTP_POST_VARS['submit']) ? str_replace("'", "\'", $config_value) : $config_value; // 2.0.10

		$new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];

		//Server Offset
		if ($config_name == 'board_offset')
		{
			$new['board_offset'] = ( isset($HTTP_POST_VARS['offset_minutes']) ) ? ( $HTTP_POST_VARS['offset_days'] * 86400 + $HTTP_POST_VARS['offset_hours'] * 3600 + $HTTP_POST_VARS['offset_minutes'] * 60 ) * $HTTP_POST_VARS['offset_polar'] : $new['board_offset'];
		}
		//End Server Offset

		if ($config_name == 'cookie_name')
		{
			$new['cookie_name'] = str_replace('.', '_', $new['cookie_name']);
		}

		// Attempt to prevent a common mistake with this value,
		// http:// is the protocol and not part of the server name
		if ($config_name == 'server_name')
		{
			$new['server_name'] = str_replace('http://', '', $new['server_name']);
		}

		if( isset($HTTP_POST_VARS['submit']) )
		{
			$sql = "UPDATE " . CONFIG_TABLE . " SET
				config_value = '" . str_replace("\'", "''", $new[$config_name]) . "'
				WHERE config_name = '$config_name'";
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Failed to update general configuration for $config_name", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['submit']) )
	{
		$message = $lang['Config_updated'] . "<br /><br />" . sprintf($lang['Click_return_config'], "<a href=\"" . append_sid("admin_board.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
}

$style_select = style_select($new['default_style'], 'default_style', "../templates");
$lang_select = language_select($new['default_lang'], 'default_lang', "language");
$timezone_select = tz_select($new['board_timezone'], 'board_timezone');

$disable_board_yes = ( $new['board_disable'] ) ? "checked=\"checked\"" : "";
$disable_board_no = ( !$new['board_disable'] ) ? "checked=\"checked\"" : "";

$debug_value_yes = ( $new['debug_value'] ) ? "checked=\"checked\"" : "";
$debug_value_no = ( !$new['debug_value'] ) ? "checked=\"checked\"" : "";

$disable_reg_yes = ( $new['disable_reg'] ) ? "checked=\"checked\"" : "";
$disable_reg_no = ( !$new['disable_reg'] ) ? "checked=\"checked\"" : "";

$cookie_secure_yes = ( $new['cookie_secure'] ) ? "checked=\"checked\"" : "";
$cookie_secure_no = ( !$new['cookie_secure'] ) ? "checked=\"checked\"" : "";

$db_read_tracking_yes = ( $new['db_read_tracking'] ) ? "checked=\"checked\"" : "";
$db_read_tracking_no = ( !$new['db_read_tracking'] ) ? "checked=\"checked\"" : "";

$html_tags = $new['allow_html_tags'];

$override_user_style_yes = ( $new['override_user_style'] ) ? "checked=\"checked\"" : "";
$override_user_style_no = ( !$new['override_user_style'] ) ? "checked=\"checked\"" : "";

$html_yes = ( $new['allow_html'] ) ? "checked=\"checked\"" : "";
$html_no = ( !$new['allow_html'] ) ? "checked=\"checked\"" : "";

$bbcode_yes = ( $new['allow_bbcode'] ) ? "checked=\"checked\"" : "";
$bbcode_no = ( !$new['allow_bbcode'] ) ? "checked=\"checked\"" : "";

$activation_none = ( $new['require_activation'] == USER_ACTIVATION_NONE ) ? "checked=\"checked\"" : "";
$activation_user = ( $new['require_activation'] == USER_ACTIVATION_SELF ) ? "checked=\"checked\"" : "";
$activation_admin = ( $new['require_activation'] == USER_ACTIVATION_ADMIN ) ? "checked=\"checked\"" : "";

$allow_autologin_yes = ($new['allow_autologin']) ? 'checked="checked"' : '';
$allow_autologin_no = (!$new['allow_autologin']) ? 'checked="checked"' : '';

$board_email_form_yes = ( $new['board_email_form'] ) ? "checked=\"checked\"" : "";
$board_email_form_no = ( !$new['board_email_form'] ) ? "checked=\"checked\"" : "";

$gzip_yes = ( $new['gzip_compress'] ) ? "checked=\"checked\"" : "";
$gzip_no = ( !$new['gzip_compress'] ) ? "checked=\"checked\"" : "";

$privmsg_on = ( !$new['privmsg_disable'] ) ? "checked=\"checked\"" : "";
$privmsg_off = ( $new['privmsg_disable'] ) ? "checked=\"checked\"" : "";

$prune_yes = ( $new['prune_enable'] ) ? "checked=\"checked\"" : "";
$prune_no = ( !$new['prune_enable'] ) ? "checked=\"checked\"" : "";
$hidde_last_logon_yes = ( $new['hidde_last_logon'] ) ? "checked=\"checked\"" : "";
$hidde_last_logon_no = ( !$new['hidde_last_logon'] ) ? "checked=\"checked\"" : "";

$password_not_login_yes = ( $new['password_not_login'] ) ? "checked=\"checked\"" : "";
$password_not_login_no = ( !$new['password_not_login'] ) ? "checked=\"checked\"" : "";
$password_complex_yes = ( $new['force_complex_password'] ) ? "checked=\"checked\"" : "";
$password_complex_no = ( !$new['force_complex_password'] ) ? "checked=\"checked\"" : "";

$birthday_greeting_yes = ( $new['birthday_greeting'] ) ? "checked=\"checked\"" : "";
$birthday_greeting_no = ( !$new['birthday_greeting'] ) ? "checked=\"checked\"" : "";
$birthday_required_yes = ( $new['birthday_required'] ) ? "checked=\"checked\"" : "";
$birthday_required_no = ( !$new['birthday_required'] ) ? "checked=\"checked\"" : "";

$smile_yes = ( $new['allow_smilies'] ) ? "checked=\"checked\"" : "";
$smile_no = ( !$new['allow_smilies'] ) ? "checked=\"checked\"" : "";

$sig_yes = ( $new['allow_sig'] ) ? "checked=\"checked\"" : "";
$sig_no = ( !$new['allow_sig'] ) ? "checked=\"checked\"" : "";
//sig suite mod
$sig_images_yes = ( $new['allow_sig_images'] ) ? "checked=\"checked\"" : "";
$sig_images_no = ( !$new['allow_sig_images'] ) ? "checked=\"checked\"" : "";

$sig_links_yes = ( $new['allow_sig_links'] ) ? "checked=\"checked\"" : "";
$sig_links_no = ( !$new['allow_sig_links'] ) ? "checked=\"checked\"" : "";
//EOM

$namechange_yes = ( $new['allow_namechange'] ) ? "checked=\"checked\"" : "";
$namechange_no = ( !$new['allow_namechange'] ) ? "checked=\"checked\"" : "";

$avatars_local_yes = ( $new['allow_avatar_local'] ) ? "checked=\"checked\"" : "";
$avatars_local_no = ( !$new['allow_avatar_local'] ) ? "checked=\"checked\"" : "";
$avatars_remote_yes = ( $new['allow_avatar_remote'] ) ? "checked=\"checked\"" : "";
$avatars_remote_no = ( !$new['allow_avatar_remote'] ) ? "checked=\"checked\"" : "";
$avatars_upload_yes = ( $new['allow_avatar_upload'] ) ? "checked=\"checked\"" : "";
$avatars_upload_no = ( !$new['allow_avatar_upload'] ) ? "checked=\"checked\"" : "";
//
// Start System Specs MOD
//
$specs_link_enable_yes = ( $new['specs_link_enable'] ) ? "checked=\"checked\"" : "";
$specs_link_enable_no = ( !$new['specs_link_enable'] ) ? "checked=\"checked\"" : "";
$system_specs_enable_yes = ( $new['system_specs_enable'] ) ? "checked=\"checked\"" : "";
$system_specs_enable_no = ( !$new['system_specs_enable'] ) ? "checked=\"checked\"" : "";
//
// Finish System Specs MOD
//

// MOD STICKY_AVATAR BEGIN
$avatars_sticky_yes = ( $new['allow_avatar_sticky'] ) ? "checked=\"checked\"" : "";
$avatars_sticky_no = ( !$new['allow_avatar_sticky'] ) ? "checked=\"checked\"" : "";
// MOD STICKY_AVATAR END

$smtp_yes = ( $new['smtp_delivery'] ) ? "checked=\"checked\"" : "";
$smtp_no = ( !$new['smtp_delivery'] ) ? "checked=\"checked\"" : "";

function auth_auto_response_select($default, $select_name = 'auth_auto_response')
{
	global $auth_auto_response, $lang;
	if ( !isset($default) )
	{
		$default == $auth_auto_response;
	}
	$auth_auto_response_select = '<select name="' . $select_name . '">';
			$auth_auto_response = $lang['Auth_response'];
	while( list($offset, $user_type) = @each($auth_auto_response) )
	{
		$selected = ( $offset == $default ) ? ' selected="selected"' : '';
		$auth_auto_response_select .= '<option value="' . $offset . '"' . $selected . '>' . $user_type . '</option>';
	}
	$auth_auto_response_select .= '</select>';
	return $auth_auto_response_select;
}
$auth_auto_response_select = auth_auto_response_select($new['auth_auto_response'], 'auth_auto_response');

switch( $new['custom_title_mode'] )
{
	case CUSTOM_TITLE_MODE_INDEPENDENT:
		$custom_title_mode_independent = "checked=\"checked\"";
		break;
	case CUSTOM_TITLE_MODE_REPLACE_RANK:
		$custom_title_mode_replace_rank = "checked=\"checked\"";
		break;
	case CUSTOM_TITLE_MODE_REPLACE_BOTH:
		$custom_title_mode_replace_both = "checked=\"checked\"";
		break;
	default:
		break;
}

//Server Offset
$offset_add = ( $new['board_offset'] >= 0 ) ? "checked=\"checked\"" : "";
$offset_subtract = ( $new['board_offset'] < 0 ) ? "checked=\"checked\"" : "";

$day_offset = floor(abs($new['board_offset']) / 86400 );

$tempdefault = ( floor(abs($new['board_offset']) / 3600) % 24 );
$hour_select = '<select name="offset_hours">';
for ( $hour = 0; $hour < 24; $hour++ )
{
	$selected = ( $hour == $tempdefault ) ? ' selected="selected"' : '';
	$hour_select .= '<option value="' . $hour . '"' . $selected . '>' . $hour . '</option>';
}
$hour_select .= '</select>';

$tempdefault = ( floor(abs($new['board_offset']) / 60) % 60 );
$minute_select = '<select name="offset_minutes">';
for ( $minute = 0; $minute < 60; $minute++ )
{
	$selected = ( $minute == $tempdefault ) ? ' selected="selected"' : '';
	$minute_select .= '<option value="' . $minute . '"' . $selected . '>' . $minute . '</option>';
}
$minute_select .= '</select>';
//End Server Offset

//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- add v1.0.2
$sub_forum_yes = ( $new['sub_forum'] ) ? "checked=\"checked\"" : "";
$sub_forum_no = ( !$new['sub_forum'] ) ? "checked=\"checked\"" : "";
//-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

//-- mod : split topic type ------------------------------------------------------------------------
//-- add
if ( isset($lang['Post_global_announcement']) )
{
	$split_global_announce_yes = ( $new['split_global_announce'] ) ? "checked=\"checked\"" : "";
	$split_global_announce_no  = (!$new['split_global_announce'] ) ? "checked=\"checked\"" : "";
}
$split_announce_yes = ( $new['split_announce'] ) ? "checked=\"checked\"" : "";
$split_announce_no  = (!$new['split_announce'] ) ? "checked=\"checked\"" : "";
$split_sticky_yes   = ( $new['split_sticky'] )   ? "checked=\"checked\"" : "";
$split_sticky_no	= (!$new['split_sticky'] )   ? "checked=\"checked\"" : "";
//-- fin mod : split topic type --------------------------------------------------------------------

$template->set_filenames(array(
	"body" => "admin/board_config_body.tpl")
);

//
// Profile Photo Mod
//
if ( !file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_profilephoto.'.$phpEx) )
{
	include($phpbb_root_path . 'language/lang_english/lang_profilephoto.'.$phpEx);
}
else
{
	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_profilephoto.' . $phpEx);
}

$photo_remote_yes = ( $new['allow_photo_remote'] ) ? 'checked="checked"' : '';
$photo_remote_no = ( !$new['allow_photo_remote'] ) ? 'checked="checked"' : '';
$photo_upload_yes = ( $new['allow_photo_upload'] ) ? 'checked="checked"' : '';
$photo_upload_no = ( !$new['allow_photo_upload'] ) ? 'checked="checked"' : '';

$template->assign_vars(array(
	"L_ALLOW_AUTOLOGIN" => $lang['Allow_autologin'],
	"L_ALLOW_AUTOLOGIN_EXPLAIN" => $lang['Allow_autologin_explain'],
	"L_AUTOLOGIN_TIME" => $lang['Autologin_time'],
	"L_AUTOLOGIN_TIME_EXPLAIN" => $lang['Autologin_time_explain'],

	'L_PROFLE_PHOTO_SETTINGS' => $lang['Profile_photo_settings'],
	'L_ALLOW_PHOTO_REMOTE' => $lang['Allow_photo_remote'],
	'L_ALLOW_PHOTO_REMOTE_EXPLAIN' => $lang['Allow_photo_remote_explain'],
	'L_ALLOW_PHOTO_UPLOAD' => $lang['Allow_photo_upload'],
	'L_PHOTO_MAX_FILESIZE' => $lang['Photo_max_filesize'],
	'L_PHOTO_MAX_FILESIZE_EXPLAIN' => $lang['Photo_max_filesize_explain'],
	'L_MAX_PHOTO_SIZE' => $lang['Max_photo_size'],
	'L_PHOTO_STORAGE_PATH' => $lang['Photo_storage_path'],
	'L_PHOTO_STORAGE_PATH_EXPLAIN' => $lang['Photo_storage_path_explain'],

	'PHOTO_REMOTE_YES' => $photo_remote_yes,
	'PHOTO_REMOTE_NO' => $photo_remote_no,
	'PHOTO_UPLOAD_YES' => $photo_upload_yes,
	'PHOTO_UPLOAD_NO' => $photo_upload_no,
	'PHOTO_FILESIZE' => $new['photo_filesize'],
	'PHOTO_MAX_HEIGHT' => $new['photo_max_height'],
	'PHOTO_MAX_WIDTH' => $new['photo_max_width'],
	'PHOTO_PATH' => $new['photo_path'])
);


//
// Escape any quotes in the site description for proper display in the text
// box on the admin page
//
$new['site_desc'] = str_replace('"', '&quot;', $new['site_desc']);
$new['sitename'] = str_replace('"', '&quot;', strip_tags($new['sitename']));
$new['disable_reg_msg'] = str_replace('"', '&quot;', strip_tags($new['disable_reg_msg']));
$template->assign_vars(array(
//-- mod : split topic type ------------------------------------------------------------------------
//-- add
	"L_ANNOUNCEMENT_SETTINGS" => $lang['Announce_settings'],
	"L_SPLIT_GLOBAL_ANNOUNCE" => $lang['split_global_announce'],
	"SPLIT_GLOBAL_ANNOUNCE_YES" => $split_global_announce_yes,
	"SPLIT_GLOBAL_ANNOUNCE_NO" => $split_global_announce_no,
	"L_SPLIT_ANNOUNCE"		=> $lang['split_announce'],
	"SPLIT_ANNOUNCE_YES"	  => $split_announce_yes,
	"SPLIT_ANNOUNCE_NO"	   => $split_announce_no,
	"L_SPLIT_STICKY"		  => $lang['split_sticky'],
	"SPLIT_STICKY_YES"		=> $split_sticky_yes,
	"SPLIT_STICKY_NO"		 => $split_sticky_no,
//-- fin mod : split topic type --------------------------------------------------------------------

	"S_CONFIG_ACTION" => append_sid("admin_board.$phpEx"),

	//Server Offset
	"L_DAYS" => $lang['Days'],
	"L_HOURS" => $lang['Hours'],
	"L_MINUTES" => $lang['Minutes'],
	"L_ADD" => $lang['Add'],
	"L_SUBTRACT" => $lang['Subtract'],
	"L_SYSTEM_TIME_OFFSET" => $lang['System_time_offset'],
	"OFFSET_ADD" => $offset_add,
	"OFFSET_SUBTRACT" => $offset_subtract,
	"DAY_OFFSET" => $day_offset,
	"HOUR_SELECT" => $hour_select,
	"MINUTE_SELECT" => $minute_select,
	//End Server Offset

//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- add v1.0.2
	"SUB_FORUM_YES" => $sub_forum_yes,
	"SUB_FORUM_NO" => $sub_forum_no,
	"L_SUB_FORUM" => $lang['Use_sub_forum'],
//-- add v1.0.7
	"L_HIERARCHY_SETTINGS" => $lang['Hierarchy_setting'],
//-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------
	"L_YES" => $lang['Yes'],
	"L_NO" => $lang['No'],
	"L_CONFIGURATION_TITLE" => $lang['General_Config'],
	"L_CONFIGURATION_EXPLAIN" => $lang['Config_explain'],
	"L_GENERAL_SETTINGS" => $lang['General_settings'],
	"L_SERVER_NAME" => $lang['Server_name'],
	"L_SERVER_NAME_EXPLAIN" => $lang['Server_name_explain'],
	"L_SERVER_PORT" => $lang['Server_port'],
	"L_SERVER_PORT_EXPLAIN" => $lang['Server_port_explain'],
	"L_SCRIPT_PATH" => $lang['Script_path'],
	"L_SCRIPT_PATH_EXPLAIN" => $lang['Script_path_explain'],
	"L_SITE_NAME" => $lang['Site_name'],
	"L_SITE_DESCRIPTION" => $lang['Site_desc'],
	"L_DISABLE_REG" => $lang['disable_reg'],
	"L_DISABLE_REG_EXPLAIN" => $lang['disable_reg_explain'],
	"L_DISABLE_REG_MSG" => $lang['disable_reg_msg'],
	"L_DISABLE_REG_MSG_EXPLAIN" => $lang['disable_reg_msg_explain'],
	"S_DISABLE_REG_YES" => $disable_reg_yes,
	"S_DISABLE_REG_NO" => $disable_reg_no,
	"DISABLE_REG_MSG" => $new['disable_reg_msg'],
	"L_DISABLE_BOARD" => $lang['Board_disable'],
	"L_DISABLE_BOARD_EXPLAIN" => $lang['Board_disable_explain'],
	"L_DISABLE_BOARD_TEXT" => $lang['Board_disable_text'],
	"L_DISABLE_BOARD_TEXT_EXPLAIN" => $lang['Board_disable_text_explain'],
	"L_DEBUG_VALUE" => $lang['Debug_value'],
	"L_DEBUG_VALUE_EXPLAIN" => $lang['Debug_value_explain'],
	"L_ACCT_ACTIVATION" => $lang['Acct_activation'],
	"L_NONE" => $lang['Acc_None'],
	"L_USER" => $lang['Acc_User'],
	"L_ADMIN" => $lang['Acc_Admin'],
	"L_COOKIE_SETTINGS" => $lang['Cookie_settings'],
	"L_COOKIE_SETTINGS_EXPLAIN" => $lang['Cookie_settings_explain'],
	"L_COOKIE_DOMAIN" => $lang['Cookie_domain'],
	"L_COOKIE_NAME" => $lang['Cookie_name'],
	"L_COOKIE_PATH" => $lang['Cookie_path'],
	"L_COOKIE_SECURE" => $lang['Cookie_secure'],
	"L_COOKIE_SECURE_EXPLAIN" => $lang['Cookie_secure_explain'],
	"L_DB_READ_TRACKING" => $lang['DB_read_tracking'],
	"L_DB_READ_TRACKING_EXPLAIN" => $lang['DB_read_tracking_explain'],
	"L_SESSION_LENGTH" => $lang['Session_length'],
	"L_PRIVATE_MESSAGING" => $lang['Private_Messaging'],
	"L_INBOX_LIMIT" => $lang['Inbox_limits'],
	"L_SENTBOX_LIMIT" => $lang['Sentbox_limits'],
	"L_SAVEBOX_LIMIT" => $lang['Savebox_limits'],
	"L_AUTH_AUTO_RESPONSE" => $lang['Auth_auto_response'],
	"L_AUTH_AUTO_RESPONSE_EXPLAIN" => $lang['Auth_auto_response_explain'],
	"L_AUTO_RESPONSE_LENGTH" => $lang['Auto_response_length'],
	"L_AUTO_RESPONSE_LENGTH_EXPLAIN" => $lang['Auto_response_length_explain'],
	"AUTH_AUTO_RESPONSE" => $auth_auto_response_select,
	"AUTO_RESPONSE_LENGTH" => $new['auto_response_length'],
	"L_DISABLE_PRIVATE_MESSAGING" => $lang['Disable_privmsg'],
	"L_ENABLED" => $lang['Enabled'],
	"L_DISABLED" => $lang['Disabled'],
	"L_ABILITIES_SETTINGS" => $lang['Abilities_settings'],
	"L_MAX_POLL_OPTIONS" => $lang['Max_poll_options'],
	'L_MAX_LOGIN_ATTEMPTS'			=> $lang['Max_login_attempts'],
	'L_MAX_LOGIN_ATTEMPTS_EXPLAIN'	=> $lang['Max_login_attempts_explain'],
	'L_LOGIN_RESET_TIME'			=> $lang['Login_reset_time'],
	'L_LOGIN_RESET_TIME_EXPLAIN'	=> $lang['Login_reset_time_explain'],
	'MAX_LOGIN_ATTEMPTS'			=> $new['max_login_attempts'],
	'LOGIN_RESET_TIME'				=> $new['login_reset_time'],
	"L_FLOOD_INTERVAL" => $lang['Flood_Interval'],
	"L_FLOOD_INTERVAL_EXPLAIN" => $lang['Flood_Interval_explain'],
	"L_SEARCH_FLOOD_INTERVAL" => $lang['Search_Flood_Interval'],
	"L_SEARCH_FLOOD_INTERVAL_EXPLAIN" => $lang['Search_Flood_Interval_explain'],
	"L_MESSAGE_LENGTH" => $lang['Message_length'],
	"L_MESSAGE_LENGTH_EXPLAIN" => $lang['Message_length_explain'],
	"L_BOARD_EMAIL_FORM" => $lang['Board_email_form'],
	"L_BOARD_EMAIL_FORM_EXPLAIN" => $lang['Board_email_form_explain'],
	"L_TOPICS_PER_PAGE" => $lang['Topics_per_page'],
	"L_POSTS_PER_PAGE" => $lang['Posts_per_page'],
	"L_HOT_THRESHOLD" => $lang['Hot_threshold'],
	"L_DEFAULT_STYLE" => $lang['Default_style'],
	"L_OVERRIDE_STYLE" => $lang['Override_style'],
	"L_OVERRIDE_STYLE_EXPLAIN" => $lang['Override_style_explain'],
	"L_DEFAULT_LANGUAGE" => $lang['Default_language'],
	"L_DATE_FORMAT" => $lang['Date_format'],
	"L_SYSTEM_TIMEZONE" => $lang['System_timezone'],
	"L_ENABLE_GZIP" => $lang['Enable_gzip'],
	"L_GZIP_LEVEL" => $lang['Gzip_level'],
	"L_CUSTOM_TITLE_SETTINGS" => $lang['Custom_title_settings'],
	"L_CUSTOM_TITLE_DAYS" => $lang['Custom_title_days'],
	"L_CUSTOM_TITLE_POSTS" => $lang['Custom_title_posts'],
	"L_CUSTOM_TITLE_MODE" => $lang['Custom_title_mode'],
	"L_CUSTOM_TITLE_MODE_EXPLAIN" => $lang['Custom_title_mode_explain'],
	"L_CUSTOM_TITLE_MODE_INDEPENDENT" => $lang['Custom_title_mode_independent'],
	"L_CUSTOM_TITLE_MODE_REPLACE_RANK" => $lang['Custom_title_mode_replace_rank'],
	"L_CUSTOM_TITLE_MODE_REPLACE_BOTH" => $lang['Custom_title_mode_replace_both'],
	"L_CUSTOM_TITLE_MAXLENGTH" => $lang['Custom_title_maxlength'],
	"L_CUSTOM_TITLE_MAXLENGTH_EXPLAIN" => $lang['Custom_title_maxlength_explain'],
	"L_ENABLE_PRUNE" => $lang['Enable_prune'],
	"L_META_SETTINGS" => $lang['Meta_settings'],
	"L_META_SETTINGS_EXPLAIN" => $lang['Meta_settings_explain'],
	"L_META_KEYWORDS" => $lang['Meta_keywords'],
	"L_META_KEYWORDS_EXPLAIN" => $lang['Meta_keywords_explain'],
	"L_META_DESCRIPTION" => $lang['Meta_description'],
	"L_META_DESCRIPTION_EXPLAIN" => $lang['Meta_description_explain'],
	"L_META_REVISIT" => $lang['Meta_revisit'],
	"L_META_REVISIT_EXPLAIN" => $lang['Meta_revisit_explain'],
	"L_META_AUTHOR" => $lang['Meta_author'],
	"L_META_AUTHOR_EXPLAIN" => $lang['Meta_author_explain'],
	"L_META_OWNER" => $lang['Meta_owner'],
	"L_META_OWNER_EXPLAIN" => $lang['Meta_owner_explain'],
	"L_META_DISTRIBUTION" => $lang['Meta_distribution'],
	"L_META_DISTRIBUTION_EXPLAIN" => $lang['Meta_distribution_explain'],
	"L_META_ROBOTS" => $lang['Meta_robots'],
	"L_META_ROBOTS_EXPLAIN" => $lang['Meta_robots_explain'],
	"L_META_ABSTRACT" => $lang['Meta_abstract'],
	"L_META_ABSTRACT_EXPLAIN" => $lang['Meta_abstract_explain'],
	"L_HIDDE_LAST_LOGON" => $lang['Hidde_last_logon'],
	"L_HIDDE_LAST_LOGON_EXPLAIN" => $lang['Hidde_last_logon_expain'],
	'L_USER_PASSWORD_SETTINGS' => $lang['user_password_settings'],
	'L_PASSWORD_COMPLEX' => $lang['Password_complex'],
	'L_PASSWORD_COMPLEX_EXPLAIN' => $lang['Password_complex_explain'],
	'L_PASSWORD_NOT_LOGIN' => $lang['Password_not_login'],
	'L_PASSWORD_NOT_LOGIN_EXPLAIN' => $lang['Password_not_login_explain'],
	'L_PASSWORD_LEN' => $lang['Password_len'],
	'L_PASSWORD_LEN_EXPLAIN' => $lang['Password_len_explain'],
	'L_BLOCK_TIME' => $lang['Block_time'],
	'L_BLOCK_TIME_EXPLAIN' => $lang['Block_time_explain'],
	'L_MAX_LOGIN_ERROR' => $lang['Max_login_error'],
	'L_MAX_LOGIN_ERROR_EXPLAIN' => $lang['Max_login_error_explain'],

	'L_ENABLE_BIRTHDAY_GREETING' => $lang['Enable_birthday_greeting'],
	'L_BIRTHDAY_GREETING_EXPLAIN' => $lang['Birthday_greeting_expain'],
	'L_BIRTHDAY_REQUIRED' => $lang['Birthday_required'],
	'L_MAX_USER_AGE' => $lang['Max_user_age'],
	'L_MIN_USER_AGE' => $lang['Min_user_age'],
	'L_BIRTHDAY_LOOKFORWARD' => $lang['Birthday_lookforward'],
	'L_BIRTHDAY_LOOKFORWARD_EXPLAIN' => $lang['Birthday_lookforward_explain'],

	"L_ALLOW_HTML" => $lang['Allow_HTML'],
	"L_ALLOW_BBCODE" => $lang['Allow_BBCode'],
	"L_ALLOWED_TAGS" => $lang['Allowed_tags'],
	"L_ALLOWED_TAGS_EXPLAIN" => $lang['Allowed_tags_explain'],
	"L_ALLOW_SMILIES" => $lang['Allow_smilies'],
	"L_SMILIES_PATH" => $lang['Smilies_path'],
	"L_SMILIES_PATH_EXPLAIN" => $lang['Smilies_path_explain'],
	"L_ALLOW_SIG" => $lang['Allow_sig'],
	//sig suite mod
	"L_ALLOW_SIG_IMAGES" => $lang['Allow_sig_images'],
	"L_ALLOW_SIG_IMAGES_EXPLAIN" => $lang['Allow_sig_images_explain'],
	"L_ALLOW_SIG_LINKS" => $lang['Allow_sig_links'],
	"L_ALLOW_SIG_LINKS_EXPLAIN" => $lang['Allow_sig_links_explain'],
	"L_NO_SIG_LINK_MESSAGE" => $lang['No_sig_link_message'],
	"L_NO_SIG_LINK_MESSAGE_EXPLAIN" => $lang['No_sig_link_message_explain'],
	"L_NO_SIG_IMAGE_MESSAGE" => $lang['No_sig_image_message'],
	"L_NO_SIG_IMAGE_MESSAGE_EXPLAIN" => $lang['No_sig_image_message_explain'],
	//eom
	"L_MAX_SMILEY" => $lang['Max_smiley'],
	"L_MAX_SMILEY_EXPLAIN" => $lang['Max_smiley_explain'],
	"L_MAX_SIG_LENGTH" => $lang['Max_sig_length'],
	"L_MAX_SIG_LENGTH_EXPLAIN" => $lang['Max_sig_length_explain'],
	"L_ALLOW_NAME_CHANGE" => $lang['Allow_name_change'],
	"L_AVATAR_SETTINGS" => $lang['Avatar_settings'],
	"L_ALLOW_LOCAL" => $lang['Allow_local'],
	"L_ALLOW_REMOTE" => $lang['Allow_remote'],
	"L_ALLOW_REMOTE_EXPLAIN" => $lang['Allow_remote_explain'],
	"L_ALLOW_UPLOAD" => $lang['Allow_upload'],
	"L_MAX_FILESIZE" => $lang['Max_filesize'],
	"L_MAX_FILESIZE_EXPLAIN" => $lang['Max_filesize_explain'],
	"L_MAX_AVATAR_SIZE" => $lang['Max_avatar_size'],
	"L_MAX_AVATAR_SIZE_EXPLAIN" => $lang['Max_avatar_size_explain'],
	"L_AVATAR_STORAGE_PATH" => $lang['Avatar_storage_path'],
	"L_AVATAR_STORAGE_PATH_EXPLAIN" => $lang['Avatar_storage_path_explain'],
	"L_AVATAR_GALLERY_PATH" => $lang['Avatar_gallery_path'],
	"L_AVATAR_GALLERY_PATH_EXPLAIN" => $lang['Avatar_gallery_path_explain'],
	"L_MAX_IMAGES_LIMIT" => $lang['Max_images_limit'],
	"L_MAX_IMAGES_SIZE" => $lang['Max_images_size'],
	"L_MAX_IMAGES_SIZE_EXPLAIN" => $lang['Max_images_size_explain'],
	"L_COPPA_SETTINGS" => $lang['COPPA_settings'],
	"L_COPPA_FAX" => $lang['COPPA_fax'],
	"L_COPPA_MAIL" => $lang['COPPA_mail'],
	"L_COPPA_MAIL_EXPLAIN" => $lang['COPPA_mail_explain'],
	"L_EMAIL_SETTINGS" => $lang['Email_settings'],
	"L_ADMIN_EMAIL" => $lang['Admin_email'],
	"L_EMAIL_SIG" => $lang['Email_sig'],
	"L_EMAIL_SIG_EXPLAIN" => $lang['Email_sig_explain'],
	"L_USE_SMTP" => $lang['Use_SMTP'],
	"L_USE_SMTP_EXPLAIN" => $lang['Use_SMTP_explain'],
	"L_SMTP_SERVER" => $lang['SMTP_server'],
	"L_SMTP_USERNAME" => $lang['SMTP_username'],
	"L_SMTP_USERNAME_EXPLAIN" => $lang['SMTP_username_explain'],
	"L_SMTP_PASSWORD" => $lang['SMTP_password'],
	"L_SMTP_PASSWORD_EXPLAIN" => $lang['SMTP_password_explain'],
	"L_SUBMIT" => $lang['Submit'],
	"L_RESET" => $lang['Reset'],
//
// Start System Specs MOD
//
	"L_SYSTEM_SPEC_SETTINGS" => $lang['System_spec_settings'],
	"L_ENABLE_RANKING_LINK_ADMIN" => $lang['Enable_ranking_link_admin'],
	"L_ALLOW_SYSTEM_SPECS_ADMIN" => $lang['Allow_system_specs_admin'],
	"SPECS_LINK_ENABLE_YES" => $specs_link_enable_yes,
	"SPECS_LINK_ENABLE_NO" => $specs_link_enable_no,
	"SYSTEM_SPECS_ENABLE_YES" => $system_specs_enable_yes,
	"SYSTEM_SPECS_ENABLE_NO" => $system_specs_enable_no,
//
// Finish System Specs MOD
//

// MOD STICKY_AVATAR BEGIN
	"L_ALLOW_STICKY" => $lang['Avatars_Sticky'],
	"L_ALLOW_STICKY_EXPLAIN" => $lang['Avatars_Sticky_Explain'],
	"AVATARS_STICKY_YES" => $avatars_sticky_yes,
	"AVATARS_STICKY_NO" => $avatars_sticky_no,
// MOD STICKY_AVATAR END

	"SERVER_NAME" => $new['server_name'],
	"SCRIPT_PATH" => $new['script_path'],
	"SERVER_PORT" => $new['server_port'],
	"SITENAME" => $new['sitename'],
	"SITE_DESCRIPTION" => $new['site_desc'],
	"S_DISABLE_BOARD_YES" => $disable_board_yes,
	"S_DISABLE_BOARD_NO" => $disable_board_no,
	"BOARD_DISABLE_TEXT" => $new['board_disable_text'],
	"S_DEBUG_VALUE_ENABLED" => $debug_value_yes,
	"S_DEBUG_VALUE_DISABLED" => $debug_value_no,
	"ACTIVATION_NONE" => USER_ACTIVATION_NONE,
	'ALLOW_AUTOLOGIN_YES' => $allow_autologin_yes,
	'ALLOW_AUTOLOGIN_NO' => $allow_autologin_no,
	'AUTOLOGIN_TIME' => (int) $new['max_autologin_time'],
	"ACTIVATION_USER" => USER_ACTIVATION_SELF,
	"ACTIVATION_USER_CHECKED" => $activation_user,
	"ACTIVATION_ADMIN" => USER_ACTIVATION_ADMIN,
	"ACTIVATION_ADMIN_CHECKED" => $activation_admin,
	"CONFIRM_ENABLE" => $confirm_yes,
	"CONFIRM_DISABLE" => $confirm_no,
	"BOARD_EMAIL_FORM_ENABLE" => $board_email_form_yes,
	"BOARD_EMAIL_FORM_DISABLE" => $board_email_form_no,
	"MAX_POLL_OPTIONS" => $new['max_poll_options'],
	"FLOOD_INTERVAL" => $new['flood_interval'],
	"SEARCH_FLOOD_INTERVAL" => $new['search_flood_interval'],
	"MESSAGE_LENGTH" => $new['message_length'],
	"TOPICS_PER_PAGE" => $new['topics_per_page'],
	"POSTS_PER_PAGE" => $new['posts_per_page'],
	"HOT_TOPIC" => $new['hot_threshold'],
	"STYLE_SELECT" => $style_select,
	"OVERRIDE_STYLE_YES" => $override_user_style_yes,
	"OVERRIDE_STYLE_NO" => $override_user_style_no,
	"LANG_SELECT" => $lang_select,
	"L_DATE_FORMAT_EXPLAIN" => $lang['Date_format_explain'],
	"DEFAULT_DATEFORMAT" => default_date_format_select($new['default_dateformat'], $timezone_select),
	"TIMEZONE_SELECT" => $timezone_select,
	"S_PRIVMSG_ENABLED" => $privmsg_on,
	"S_PRIVMSG_DISABLED" => $privmsg_off,
	"INBOX_LIMIT" => $new['max_inbox_privmsgs'],
	"SENTBOX_LIMIT" => $new['max_sentbox_privmsgs'],
	"SAVEBOX_LIMIT" => $new['max_savebox_privmsgs'],
	"COOKIE_DOMAIN" => $new['cookie_domain'],
	"COOKIE_NAME" => $new['cookie_name'],
	"COOKIE_PATH" => $new['cookie_path'],
	"SESSION_LENGTH" => $new['session_length'],
	"S_COOKIE_SECURE_ENABLED" => $cookie_secure_yes,
	"S_COOKIE_SECURE_DISABLED" => $cookie_secure_no,
	"S_DB_READ_TRACKING_ENABLED" => $db_read_tracking_yes,
	"S_DB_READ_TRACKING_DISABLED" => $db_read_tracking_no,
	"GZIP_YES" => $gzip_yes,
	"GZIP_NO" => $gzip_no,
	"GZIP_LEVEL_" . $new['gzip_level'] . "_SELECTED" => "selected",
	"CUSTOM_TITLE_DAYS" => $new['custom_title_days'],
	"CUSTOM_TITLE_POSTS" => $new['custom_title_posts'],
	"CUSTOM_TITLE_MODE_INDEPENDENT" => $custom_title_mode_independent,
	"CUSTOM_TITLE_MODE_REPLACE_RANK" => $custom_title_mode_replace_rank,
	"CUSTOM_TITLE_MODE_REPLACE_BOTH" => $custom_title_mode_replace_both,
	"CUSTOM_TITLE_MAXLENGTH" => $new['custom_title_maxlength'],
	"SMILEY_COUNT" => $new['max_smiley'],
	"PRUNE_YES" => $prune_yes,
	"PRUNE_NO" => $prune_no,
	"META_KEYWORDS" => $new['meta_keywords'],
	"META_DESCRIPTION" => $new['meta_description'],
	"META_REVISIT" => $new['meta_revisit'],
	"META_AUTHOR" => $new['meta_author'],
	"META_OWNER" => $new['meta_owner'],
	"META_DISTRIBUTION" => $new['meta_distribution'],
	"META_ROBOTS" => $new['meta_robots'],
	"META_ABSTRACT" => $new['meta_abstract'],
	"HIDDE_LAST_LOGON_YES" => $hidde_last_logon_yes,
	"HIDDE_LAST_LOGON_NO" => $hidde_last_logon_no,
	'BLOCK_TIME' => $new['block_time'],
	'MAX_LOGIN_ERROR' => $new['max_login_error'],
	'MIN_PASSWORD_LEN' => $new['min_password_len'],
	'S_PASSWORD_COMPLEX_ENABLED' => $password_complex_yes,
	'S_PASSWORD_COMPLEX_DISABLED' => $password_complex_no,
	'S_PASSWORD_NOT_LOGIN_ENABLED' => $password_not_login_yes,
	'S_PASSWORD_NOT_LOGIN_DISABLED' => $password_not_login_no,
	'BIRTHDAY_GREETING_YES' => $birthday_greeting_yes,
	'BIRTHDAY_GREETING_NO' => $birthday_greeting_no,
	'BIRTHDAY_REQUIRED_YES' => $birthday_required_yes,
	'BIRTHDAY_REQUIRED_NO' => $birthday_required_no,
	'MAX_USER_AGE' => $new['max_user_age'],
	'MIN_USER_AGE' => $new['min_user_age'],
	'BIRTHDAY_LOOKFORWARD' => $new['birthday_check_day'],
	"HTML_TAGS" => $html_tags,
	"HTML_YES" => $html_yes,
	"HTML_NO" => $html_no,
	"BBCODE_YES" => $bbcode_yes,
	"BBCODE_NO" => $bbcode_no,
	"SMILE_YES" => $smile_yes,
	"SMILE_NO" => $smile_no,
	"SIG_YES" => $sig_yes,
	"SIG_NO" => $sig_no,
	//sig suite mod
	"SIG_IMAGES_YES" => $sig_images_yes,
	"SIG_IMAGES_NO" => $sig_images_no,
	"SIG_LINKS_YES" => $sig_links_yes,
	"SIG_LINKS_NO" => $sig_links_no,
	"NO_SIG_IMAGE_MESSAGE" => $new['no_sig_image_message'],
	"NO_SIG_LINK_MESSAGE" => $new['no_sig_link_message'],
	//eom
	"SIG_SIZE" => $new['max_sig_chars'],
	"NAMECHANGE_YES" => $namechange_yes,
	"NAMECHANGE_NO" => $namechange_no,
	"AVATARS_LOCAL_YES" => $avatars_local_yes,
	"AVATARS_LOCAL_NO" => $avatars_local_no,
	"AVATARS_REMOTE_YES" => $avatars_remote_yes,
	"AVATARS_REMOTE_NO" => $avatars_remote_no,
	"AVATARS_UPLOAD_YES" => $avatars_upload_yes,
	"AVATARS_UPLOAD_NO" => $avatars_upload_no,
	"AVATAR_FILESIZE" => $new['avatar_filesize'],
	"AVATAR_MAX_HEIGHT" => $new['avatar_max_height'],
	"AVATAR_MAX_WIDTH" => $new['avatar_max_width'],
	"AVATAR_PATH" => $new['avatar_path'],
	"AVATAR_GALLERY_PATH" => $new['avatar_gallery_path'],
	"IMAGES_MAX_LIMIT" => $new['images_max_limit'],
	"IMAGES_MAX_HEIGHT" => $new['images_max_height'],
	"IMAGES_MAX_WIDTH" => $new['images_max_width'],
	"SMILIES_PATH" => $new['smilies_path'],
	"INBOX_PRIVMSGS" => $new['max_inbox_privmsgs'],
	"SENTBOX_PRIVMSGS" => $new['max_sentbox_privmsgs'],
	"SAVEBOX_PRIVMSGS" => $new['max_savebox_privmsgs'],
	"EMAIL_FROM" => $new['board_email'],
	"EMAIL_SIG" => $new['board_email_sig'],
	"SMTP_YES" => $smtp_yes,
	"SMTP_NO" => $smtp_no,
	"SMTP_HOST" => $new['smtp_host'],
	"SMTP_USERNAME" => $new['smtp_username'],
	"SMTP_PASSWORD" => $new['smtp_password'],
	"COPPA_MAIL" => $new['coppa_mail'],
	"COPPA_FAX" => $new['coppa_fax'])
);

//-- mod : split topic type ------------------------------------------------------------------------
//-- add
if ( isset($lang['Post_global_announcement']) ) $template->assign_block_vars('switch_global_announce', array());
//-- fin mod : split topic type --------------------------------------------------------------------

$template->pparse("body");

include('./page_footer_admin.'.$phpEx);

?>
