<?php
/***************************************************************************
 *                              admin_board.php
 *                            -------------------
 *   begin                : Thursday, Jul 12, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: admin_cache.php 366 2005-05-24 10:17:50Z toonarmy $
 *
 *
 ***************************************************************************/

if ( !empty($setmodules) )
{
    $module['Cache']['Configuration'] = basename(__FILE__) . '?mode=config';
    return;
}
else
{
	function cache_dir_test (&$READ, &$WRITE, &$DELETE)
	{
		global $cache;

		$result = array(
			'READ' => array(),
			'WRITE' => array(),
			'DELETE' => array()
		);

		$mode = 'READ';

		if (is_dir($cache->cache_dir))
		{
			if ($dir = @opendir($cache->cache_dir))
			{
				if (false !== ($entry = @readdir($dir))) 
				{
					$result[$mode]['ERROR'] = TRUE;
					$result[$mode]['MSG'] = "Couldnt Open Directory (Access Denied?)";
				}
				@closedir($dir);
				$result[$mode]['ERROR'] = FALSE;
				$result[$mode]['MSG'] = "Successfully Opened and Read the Directory";
			}
			else
			{
				$result[$mode]['ERROR'] = TRUE;
				$result[$mode]['MSG'] = "Couldnt Open Directory (Access Denied?)";
			}
		}
		else
		{
			$result[$mode]['ERROR'] = TRUE;
			$result[$mode]['MSG'] = "Directory Doesnt Exist or is a File";
		}

		if (!$result[$mode]['ERROR'])
		{
			$mode = 'WRITE';
		
			if ($fp = @fopen($cache->cache_dir . "ACP_TEST_FILE.txt", 'wb'))
			{
				@flock($fp, LOCK_EX);
			
				if (@fwrite($fp, "test") === FALSE)
				{
					$result[$mode]['ERROR'] = TRUE;
					$result[$mode]['MSG'] = "Couldnt Output Text to File (Access Denied?)";
				}
			
				@flock($fp, LOCK_UN);
				@fclose($fp);
		
				$result[$mode]['ERROR'] = FALSE;
				$result[$mode]['MSG'] = "Successfully Created and Wrote to File";
			}
			else
			{
				$result[$mode]['ERROR'] = TRUE;
				$result[$mode]['MSG'] = "Couldnt Open/Create File For Writing (Access Denied?)";
			}

			if (!$result[$mode]['ERROR'])
			{
				$mode = 'DELETE';
			
				if (file_exists($cache->cache_dir . "ACP_TEST_FILE.txt"))
				{
					if (@unlink($cache->cache_dir . "ACP_TEST_FILE.txt"))
					{
						$result[$mode]['ERROR'] = FALSE;
						$result[$mode]['MSG'] = "File Successfully Deleted";
					}
					else
					{
						$result[$mode]['ERROR'] = TRUE;
						$result[$mode]['MSG'] = "Couldnt Delete Test File (Access Denied?)";
					}
				}
				else
				{
					$result[$mode]['ERROR'] = TRUE;
					$result[$mode]['MSG'] = "Test File went missing!";
				}
			}
			else
			{
				$mode = 'DELETE';
				$result[$mode]['ERROR'] = TRUE;
				$result[$mode]['MSG'] = "Previous Test(s) Failed";
			}
		}
		else
		{
			$mode = 'WRITE';
			$result[$mode]['ERROR'] = TRUE;
			$result[$mode]['MSG'] = "Previous Test(s) Failed";
		}

		// Sort Results

		foreach ($result as $mode => $res_arr)
		{
			if ($res_arr['ERROR'])
			{
				$$mode = '<span style="color: red;">' . $res_arr['MSG'] . '</span>';
			}
			else
			{
				$$mode = '<span style="color: green;">' . $res_arr['MSG'] . '</span>';
			}
		}
	}
}
define('IN_PHPBB', true);
//
// Let's set the root dir for phpBB
//
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

$mode = ( isset($HTTP_GET_VARS['mode']) ) ? $HTTP_GET_VARS['mode'] : ( ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : 'config' );

if ( SQL_LAYER != 'mysql' && SQL_LAYER != 'mysql4')
{
	message_die (GENERAL_ERROR, "This Database Is not Supported (Only MySQL and MySQL4 are supported).", '', __LINE__, __FILE__);
}
elseif ( !defined('CACHE_ON') || CACHE_ON == FALSE  && $mode != 'enable')
{
	$temp_url = "<a href='" . append_sid("admin_cache.$phpEx?mode=enable") . "'>Instructions</a>";

	message_die (GENERAL_ERROR, "You Have Disabled the Cache, please re-enable it ($temp_url)", '', __LINE__, __FILE__);
}

$template->set_filenames(array(
    "body" => "admin/cache_config_body.tpl")
);

$template->assign_vars(array(
	'MODE' => $mode,
	'U_BACK' => "<a href='" . append_sid("admin_cache.$phpEx") . "'>" . $lang['Back'] . "</a>"
));

if ( $mode == 'config' )
{
	include($phpbb_root_path . 'includes/functions_selects.'.$phpEx);
	
	//
	// Pull all config data
	//
	$sql = "SELECT *
	    FROM " . CONFIG_TABLE . "
		WHERE config_name LIKE 'cache_%'";
	

	if(!$result = $db->sql_query($sql))
	{
	    message_die(CRITICAL_ERROR, "Could not query cache config information in admin_cache", "", __LINE__, __FILE__, $sql);
	}
	else
	{
	    while( $row = $db->sql_fetchrow($result) )
	    {
	        $config_name = $row['config_name'];
	        $config_value = $row['config_value'];
	        $default_config[$config_name] = $config_value;

	        $new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];
			
	        if( isset($HTTP_POST_VARS['submit']) )
	        {
	            $sql = "UPDATE " . CONFIG_TABLE . " SET
	                config_value = '" . str_replace("\'", "''", $new[$config_name]) . "'
	                WHERE config_name = '$config_name'";
	            if( !$db->sql_query($sql) )
	            {
	                message_die(GENERAL_ERROR, "Failed to update cache configuration for $config_name", "", __LINE__, __FILE__, $sql);
	            }
	        }
	    }
	
	    if( isset($HTTP_POST_VARS['submit']) )
	    {
	        $message = $lang['Cache_Config_updated'] . "<br /><br />" . sprintf($lang['Click_return_cache_config'], "<a href=\"" . append_sid("admin_cache.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
	
	        message_die(GENERAL_MESSAGE, $message);
	    }
	}

	$read_test = $write_test = $delete_test = '';

	cache_dir_test($read_test, $write_test, $delete_test);

	$default_ttl = $new['cache_def_ttl'];
	$default_recompile = $new['cache_def_recompile_int'];

	$new['cache_colorg_mode'] = intval($new['cache_colorg_mode']);

	$color_groups_mode_off = ( $new['cache_colorg_mode'] == 0) ? "checked=\"checked\"" : "";
	$color_groups_mode_one = ( $new['cache_colorg_mode'] == 1) ? "checked=\"checked\"" : "";
	$color_groups_mode_two = ( $new['cache_colorg_mode'] == 2) ? "checked=\"checked\"" : "";
	
	$template->assign_vars(array(

		"S_CONFIG_ACTION" => append_sid("admin_cache.$phpEx?mode=config"),
		"L_YES" => $lang['Yes'],
		"L_NO" => $lang['No'],

		"L_CACHE_TITLE" => $lang['Cache_Config'],
		"L_CACHE_EXPLAIN" => $lang['Cache_Config_explain'],

		"L_DATABASE_SETTINGS"		=> $lang['Database_Cache'],
		"L_DISABLE_CACHE"			=> sprintf($lang['disable_db_cache'], $phpEx, append_sid("admin_cache.$phpEx?mode=disable")),
		"L_DEFAULT_TTL"				=> $lang['default_cache_ttl'],
		"L_DEFAULT_TTL_EXPLAIN"		=> $lang['default_cache_ttl_explain'],
		"DEFAULT_TTL_VALUE"			=> $default_ttl,

		"L_RECOMPILE_TIME"			=> $lang['index_recompile_time'],
		"L_RECOMPILE_TIME_EXPLAIN"	=> $lang['index_recompile_time_explain'],
		"RECOMPILE_TIME_VALUE"		=> $default_recompile,

		"L_CACHE_DIR"				=> $lang['cache_dir'],
		"L_CACHE_DIR_EXPLAIN"		=> $lang['cache_dir_explain'],
		"CACHE_DIR"					=> phpbb_realpath($cache->cache_dir),

		"L_READ_TEST"				=> $lang['cache_dir_read_test'],
		"L_READ_TEST_EXPLAIN"		=> $lang['cache_dir_read_test_explain'],
		"READ_TEST"					=> $read_test,

		"L_WRITE_TEST"				=> $lang['cache_dir_write_test'],
		"L_WRITE_TEST_EXPLAIN"		=> $lang['cache_dir_write_test_explain'],
		"WRITE_TEST"				=> $write_test,

		"L_DELETE_TEST"				=> $lang['cache_dir_delete_test'],
		"L_DELETE_TEST_EXPLAIN"		=> $lang['cache_dir_delete_test_explain'],
		"DELETE_TEST"				=> $delete_test,

		"L_COLOR_GROUPS_SETTINGS"	=> $lang['Color_Groups_Cache'],
		"L_COLOR_GROUPS"			=> $lang['Color_Groups_Cache_Mode'],
		"L_COLOR_GROUPS_EXPLAIN"	=> $lang['Color_Groups_Cache_Mode_explain'],

		"L_MODE_OFF"				=> $lang['OFF'],
		"L_MODE_ONE"				=> $lang['Mode_One'],
		"L_MODE_TWO"				=> $lang['Mode_Two'],

		"MODE_OFF"				=> 0,
		"MODE_ONE"				=> 1,
		"MODE_TWO"				=> 2,

		"CHECKED_MODE_OFF"		=> $color_groups_mode_off,
		"CHECKED_MODE_ONE"		=> $color_groups_mode_one,
		"CHECKED_MODE_TWO"		=> $color_groups_mode_two,

		"L_CACHE_UTILITIES"				=> "<a href='" . append_sid("admin_cache.$phpEx?mode=utilities") . "'>" . $lang['Cache_Utilities'] . "</a>",
		"L_CACHE_UTILITIES_EXPLAIN"		=> $lang['Cache_Utilities_Explain'],

		"L_SUBMIT" => $lang['Submit'],
		"L_RESET" => $lang['Reset'],
		"S_HIDDEN_FIELDS" => ""
	));

}
elseif ($mode == "enable" || $mode == "disable")
{
	$template->assign_vars(array(
		"L_CACHE_TITLE" => $mode == 'enable' ? $lang['enabling_cache'] : $lang['disabling_cache'],
		"L_CACHE_EXPLAIN" => $mode == 'enable' ? $lang['enabling_cache_explain'] : $lang['disabling_cache_explain'],

		"PHP_EX" => $phpEx,
		"L_OPEN" => $lang['cache_Open'],
		"L_FIND" => $lang['cache_Find'],
		"L_REPLACE_W" => $lang['cache_Replace_W'],
		"L_SAVECLOSE" => $lang['cache_SaveClose']
	));
}
elseif ($mode == "utilities")
{
	$action = ( isset($HTTP_GET_VARS['action']) ) ? $HTTP_GET_VARS['action'] : ( ( isset($HTTP_POST_VARS['action']) ) ? $HTTP_POST_VARS['action'] : '' );

	switch ($action)
	{
		case 'recompile':
			$cache->rebuild_index();
			$template->assign_var('MESSAGE', $lang['Recompile'] . " " . $lang['Complete']);
			break;
		case 'purge':
			$cache->destroy('sql');
			$template->assign_var('MESSAGE', $lang['Purge'] . " " . $lang['Complete']);
			break;
		case 'tidy':
			$cache->tidy();
			$template->assign_var('MESSAGE', $lang['Tidy'] . " " . $lang['Complete']);
			break;
		default:
	}

	$template->assign_vars(array(
		"L_DOIT"				=> $lang['Perform_Action'],

		"L_CACHE_TITLE"			=> $lang['Cache_Utilities'],
		"L_CACHE_EXPLAIN"		=> $lang['Cache_Utilities_Explain'],

		"L_CACHE_FILE_LIST"		=> "File List",

		"L_RECOMPILE"			=> $lang['Recompile'],
		"L_RECOMPILE_EXPLAIN"	=> $lang['Recompile_Explain'],
		"L_PURGE"				=> $lang['Purge'],
		"L_PURGE_EXPLAIN"		=> $lang['Purge_Explain'],
		"L_TIDY"				=> $lang['Tidy'],
		"L_TIDY_EXPLAIN"		=> $lang['Tidy_Explain'],

		"U_DOIT"				=> append_sid(basename(__FILE__) . "?mode=utilities"),


		""				=> ""
	));


}
else
{
	message_die (GENERAL_ERROR, "Invalid Mode", '', __LINE__, __FILE__);
}

	
$template->pparse("body");

include('./page_footer_admin.'.$phpEx);
?>
