<?php
/***************************************************************************
 *                                admin_clean.php
 *                              -------------------
 *     begin                : 2003-06-36
 *     email                : florian@developpez.biz
 *
 *   $Id: admin_clean.php,v 1.1.0
 *
 ****************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !empty($setmodules) )
{
	$module['General']['Database_Cleaner'] = basename(__FILE__) . '?mode=activate';
	return;
}
define('IN_PHPBB', true);
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

//
// Language File
//
include($phpbb_root_path.'language/lang_' . $board_config['default_lang'] . '/lang_admin_clean.'.$phpEx);

$template->set_filenames(array(
	"body" => "admin/admin_clean.tpl")
);

$template->assign_vars(array(
	'ACTION' => append_sid("admin_clean.$phpEx"),
	'L_TITLE' => $lang['Title'],
	'L_CHOICE' => $lang['Choice'],
	'L_TYPE' => $lang['Type'],
	'L_NUMBER' => $lang['Items'],
	'L_LAUNCH' => $lang['Submit'])
	);

// ----------------------------------------
// Counting items
// ----------------------------------------
function items_count($sql,$choice,$type)
{
	global $affected, $db, $template, $lang;
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, $lang['Retrieve_error'] . $error, '', __LINE__, __FILE__, $sql); // TODO: WTF does $error here? -- Arthur
	}
	$row = $db->sql_fetchrow($result);
	if($row == 0)
	{
		$choice = "";
	}
	$affected = $affected + intval($row);
	$template->assign_block_vars("admin_clean", array(
			'CHOICE' => $choice,
			'TYPE' => $type,
			'NUMBER' => $row['0'])
	);
	$db->sql_freeresult($result);
}
// ----------------------------------------

// ----------------------------------------
// Deleting items
// ----------------------------------------
function items_delete($sql_select,$sql_delete,$type)
{
	global $db, $template, $lang;

	if ( !($result = $db->sql_query($sql_select)) )
	{
		message_die(GENERAL_ERROR, $lang['Retrieve_error'] . $type, '', __LINE__, __FILE__, $sql_select);
	}
	$i=0;
	while($row = $db->sql_fetchrow($result))
	{
		if($i!=0)
		{
			$sql_delete .= ",";
		}
		$sql_delete .= $row[0]; // TODO: Is this correct?! =| -- Arthur
		$i++;
	}
	$sql_delete .= ")";
	$db->sql_freeresult($row);
	if( ! $db->sql_query($sql_delete) )
	{
		message_die(GENERAL_ERROR, $lang['Delete_error'] . $type, "", __LINE__, __FILE__, $sql_delete);
	}
}
// ----------------------------------------

$n = 0;
$affected = 0;

// ----------------------------------------
// Topics without posts
// ----------------------------------------
// Deleting?
$type = $lang['Topic_post'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT t.topic_id FROM " . TOPICS_TABLE . " t LEFT JOIN ". POSTS_TABLE . " p ON t.topic_id = p.topic_id WHERE p.topic_id Is NULL";
	$sql_delete = "DELETE FROM " .TOPICS_TABLE . " where topic_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql= "SELECT count(DISTINCT t.topic_id) FROM ". TOPICS_TABLE . " t LEFT JOIN ". POSTS_TABLE . "  p ON t.topic_id = p.topic_id WHERE p.topic_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Posts without topics
// ----------------------------------------
// Deleting?
$type = $lang['Posts_topics'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT p.post_id
	FROM " . POSTS_TABLE . " p LEFT JOIN " . TOPICS_TABLE . " t ON p.topic_id = t.topic_id
	WHERE t.topic_id Is NULL";
	$sql_delete = "DELETE FROM " . POSTS_TABLE . " WHERE post_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT p.post_id)
FROM " . POSTS_TABLE . " p LEFT JOIN " . TOPICS_TABLE . " t ON p.topic_id = t.topic_id
WHERE t.topic_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Posts without text
// ----------------------------------------
// Deleting?
$type = $lang['Posts_without_text'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{

	//SELECT p.post_id FROM phpbb_posts p LEFT JOIN phpbb_posts_text txt ON p.post_id = txt.post_id WHERE txt.post_id Is NULL;
	$sql_select = "SELECT DISTINCT p.post_id FROM " . POSTS_TABLE . " p LEFT JOIN " . POSTS_TEXT_TABLE . " txt ON p.post_id = txt.post_id WHERE txt.post_id Is NULL";
	$sql_delete = "DELETE FROM " . POSTS_TABLE . " WHERE post_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT p.post_id) FROM " . POSTS_TABLE . " p LEFT JOIN " . POSTS_TEXT_TABLE . " txt ON p.post_id = txt.post_id WHERE txt.post_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Topics watch without user
// ----------------------------------------
// Deleting?
$type = $lang['Watchs_user'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT w.topic_id
	FROM " . TOPICS_WATCH_TABLE . " w LEFT JOIN " . USERS_TABLE . " u ON w.user_id = u.user_id
	WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM " . TOPICS_WATCH_TABLE . " WHERE topic_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT w.topic_id)
FROM " . TOPICS_WATCH_TABLE . " w LEFT JOIN " . USERS_TABLE . " u ON w.user_id = u.user_id
WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Topic watch without topic
// ----------------------------------------
// Deleting?
$type = $lang['Watchs_topics'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT w.topic_id
	FROM " . TOPICS_WATCH_TABLE . " w LEFT JOIN " . TOPICS_TABLE . " t ON w.topic_id = t.topic_id
	WHERE t.topic_id Is NULL";
	$sql_delete = "DELETE FROM " . TOPICS_WATCH_TABLE . " WHERE topic_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT w.topic_id)
FROM " . TOPICS_WATCH_TABLE . " w LEFT JOIN " . TOPICS_TABLE . " t ON w.topic_id = t.topic_id
WHERE t.topic_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Favorites without user
// ----------------------------------------
// Deleting?
$type = $lang['Favorites_user'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT f.topic_id
	FROM " . FAVORITES_TABLE . " f LEFT JOIN " . USERS_TABLE . " u ON f.user_id = u.user_id
	WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM " . FAVORITES_TABLE . " WHERE topic_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT f.topic_id)
FROM " . FAVORITES_TABLE . " f LEFT JOIN " . USERS_TABLE . " u ON f.user_id = u.user_id
WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Favorites without topic
// ----------------------------------------
// Deleting?
$type = $lang['Favorites_topics'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT f.topic_id FROM " . FAVORITES_TABLE . " f LEFT JOIN " . TOPICS_TABLE . " t ON f.topic_id = t.topic_id WHERE t.topic_id Is NULL";
	$sql_delete = "DELETE FROM " . FAVORITES_TABLE . " WHERE topic_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT f.topic_id) FROM " . FAVORITES_TABLE . " f LEFT JOIN " . TOPICS_TABLE . " t ON f.topic_id = t.topic_id WHERE t.topic_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Viewed topics without a user
// ----------------------------------------
// Deleting?
$type = $lang['Viewed_topics_without_user'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT v.user_id FROM ". TOPIC_VIEW_TABLE ." v LEFT JOIN ". USERS_TABLE ." u ON v.user_id = u.user_id WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM ". TOPIC_VIEW_TABLE ." WHERE user_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT v.user_id) FROM ". TOPIC_VIEW_TABLE ." v LEFT JOIN " . USERS_TABLE . " u ON v.user_id = u.user_id WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Viewed topics without a topic
// ----------------------------------------
// Deleting?
$type = $lang['Viewed_topics_without_topic'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT v.topic_id FROM " . TOPIC_VIEW_TABLE . " v LEFT JOIN " . TOPICS_TABLE . " t ON v.topic_id = t.topic_id WHERE t.topic_id Is NULL";
	$sql_delete = "DELETE FROM " . TOPIC_VIEW_TABLE . " WHERE topic_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT v.topic_id) FROM " . TOPIC_VIEW_TABLE . " v LEFT JOIN " . TOPICS_TABLE . " t ON v.topic_id = t.topic_id WHERE t.topic_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Referrals without a user
// ----------------------------------------
// Deleting?
$type = $lang['Referrals_user'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT r.nuid FROM ". REFERRAL_TABLE ." r LEFT JOIN ". USERS_TABLE ." u ON r.nuid = u.user_id WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM ". REFERRAL_TABLE ." WHERE nuid in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT r.nuid) FROM ". REFERRAL_TABLE ." r LEFT JOIN " . USERS_TABLE . " u ON r.nuid = u.user_id WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Buddies without a user
// ----------------------------------------
// Deleting?
$type = $lang['Buddies_user'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT b.user_id FROM ". BUDDY_TABLE ." b LEFT JOIN ". USERS_TABLE ." u ON b.user_id = u.user_id WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM ". BUDDY_TABLE ." WHERE user_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT b.user_id) FROM ". BUDDY_TABLE ." b LEFT JOIN " . USERS_TABLE . " u ON b.user_id = u.user_id WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Prillian account without user
// ----------------------------------------
// Deleting?
$type = $lang['Prillian_user'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT p.user_id FROM ". IM_PREFS_TABLE ." p LEFT JOIN ". USERS_TABLE ." u ON p.user_id = u.user_id WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM ". IM_PREFS_TABLE ." WHERE user_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT p.user_id) FROM " . IM_PREFS_TABLE . " p LEFT JOIN " . USERS_TABLE . " u ON p.user_id = u.user_id WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Purge Prillian Logs
// ----------------------------------------
// Deleting?
$type = $lang['Prillian_logs'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT pm.privmsgs_id, pm.privmsgs_type FROM ". PRIVMSGS_TABLE ." pm WHERE pm.privmsgs_type = 7";
	$sql_delete = "DELETE FROM " . PRIVMSGS_TABLE . " WHERE privmsgs_id IN (";
	items_delete($sql_select,$sql_delete,$type);
}

// Counting
$sql = "SELECT count(DISTINCT pm.privmsgs_id, pm.privmsgs_type) FROM ". PRIVMSGS_TABLE ." pm WHERE pm.privmsgs_type = 7";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// PM from unknown user
// ----------------------------------------
// Deleting?
$type = $lang['PM_from_unknown'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT pm.privmsgs_from_userid FROM " . PRIVMSGS_TABLE . " pm LEFT JOIN " . USERS_TABLE . " u ON pm.privmsgs_from_userid = u.user_id WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM " . PRIVMSGS_TABLE . " WHERE privmsgs_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT pm.privmsgs_from_userid) FROM ". PRIVMSGS_TABLE." pm LEFT JOIN ". USERS_TABLE ." u ON pm.privmsgs_from_userid = u.user_id WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// PM to unknown user
// ----------------------------------------
// Deleting?
$type = $lang['PM_to_unknown'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT pm.privmsgs_to_userid FROM " . PRIVMSGS_TABLE . " pm LEFT JOIN " . USERS_TABLE . " u ON pm.privmsgs_to_userid = u.user_id WHERE u.user_id Is NULL";
	$sql_delete = "DELETE FROM " . PRIVMSGS_TABLE . " WHERE privmsgs_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT pm.privmsgs_to_userid) FROM " . PRIVMSGS_TABLE . " pm LEFT JOIN " . USERS_TABLE . " u ON pm.privmsgs_to_userid = u.user_id WHERE u.user_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// PM's without PM text
// ----------------------------------------
// Deleting?
$type = $lang['PM_without_PM_text'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT pm.privmsgs_id FROM ". PRIVMSGS_TABLE ." pm LEFT JOIN ". PRIVMSGS_TEXT_TABLE ." txt ON pm.privmsgs_id = txt.privmsgs_text_id WHERE txt.privmsgs_text_id Is NULL";
	$sql_delete = "DELETE FROM " .PRIVMSGS_TABLE . " where privmsgs_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql= "SELECT count(DISTINCT pm.privmsgs_id) FROM ".PRIVMSGS_TABLE." pm LEFT JOIN ". PRIVMSGS_TEXT_TABLE . "  txt ON pm.privmsgs_id = txt.privmsgs_text_id WHERE txt.privmsgs_text_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// PM text without PM
// ----------------------------------------
// Deleting?
$type = $lang['PM_text_without_PM'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT txt.privmsgs_text_id FROM ". PRIVMSGS_TEXT_TABLE ." txt LEFT JOIN ". PRIVMSGS_TABLE ." pm ON txt.privmsgs_text_id = pm.privmsgs_id WHERE pm.privmsgs_id Is NULL";
	$sql_delete = "DELETE FROM " . PRIVMSGS_TEXT_TABLE . " WHERE privmsgs_text_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT txt.privmsgs_text_id) FROM ". PRIVMSGS_TEXT_TABLE ." txt LEFT JOIN ". PRIVMSGS_TABLE ." pm ON txt.privmsgs_text_id = pm.privmsgs_id WHERE pm.privmsgs_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Vote without topic
// ----------------------------------------
// Deleting?
$type = $lang['Votes_topics'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT v.vote_id
	FROM " . VOTE_DESC_TABLE . " v LEFT JOIN " . TOPICS_TABLE . " t ON v.topic_id = t.topic_id
	WHERE t.topic_id Is NULL";
	$sql_delete = "DELETE FROM " . VOTE_DESC_TABLE . " WHERE vote_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT v.vote_id)
FROM " . VOTE_DESC_TABLE . " v LEFT JOIN " . TOPICS_TABLE . " t ON v.topic_id = t.topic_id
WHERE t.topic_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Vote results without vote
// ----------------------------------------
// Deleting?
$type = $lang['Results_poll'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT r.vote_id
	FROM " . VOTE_RESULTS_TABLE . " r LEFT JOIN " . VOTE_DESC_TABLE . " v ON r.vote_id = v.vote_id
	WHERE v.vote_id Is NULL";
	$sql_delete = "DELETE FROM " . VOTE_RESULTS_TABLE . " WHERE vote_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT r.vote_id)
FROM " . VOTE_RESULTS_TABLE . " r LEFT JOIN " . VOTE_DESC_TABLE . " v ON r.vote_id = v.vote_id
WHERE v.vote_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

// ----------------------------------------
// Voters without vote
// ----------------------------------------
// Deleting?
$type = $lang['Voters_poll'];

if ( isset($HTTP_POST_VARS['action']) && isset($HTTP_POST_VARS['c' . $n ]) )
{
	$sql_select = "SELECT DISTINCT v.vote_id
	FROM " .VOTE_USERS_TABLE . " v LEFT JOIN " . VOTE_DESC_TABLE . " d ON v.vote_id = d.vote_id
	WHERE d.vote_id Is NULL";
	$sql_delete = "DELETE FROM " .VOTE_USERS_TABLE . " WHERE vote_id in (";
	items_delete($sql_select,$sql_delete,$type);
}
// Counting
$sql = "SELECT count(DISTINCT v.vote_id)
FROM " .VOTE_USERS_TABLE . " v LEFT JOIN " . VOTE_DESC_TABLE . " d ON v.vote_id = d.vote_id
WHERE d.vote_id Is NULL";
$choice = "<input type=checkbox name=c" . $n . ">";
$n++;
items_count($sql,$choice,$type);
// ----------------------------------------

$template->pparse('body');
if ($affected == 0)
{
	echo "No action required, your database is consistent.";
}
else
{
	echo "<b><i>NOTE!</i></b> You have inconsistant data in your database.";
}
include('./page_footer_admin.'.$phpEx);
?>
