<?php
/***************************************************************************
 *                              admin_users.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: admin_users.php 438 2006-04-12 18:55:46Z arthurschreiber $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !empty($setmodules) )
{
	$module['Users']['Manage'] = basename(__FILE__);
	return;
}

define('IN_PHPBB', true);

if ( isset($HTTP_POST_VARS['mode']) && $HTTP_POST_VARS['mode'] == 'lookup' )
{
	$no_page_header = true;
}

$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
require($phpbb_root_path . 'includes/bbcode.'.$phpEx);
require($phpbb_root_path . 'includes/functions_post.'.$phpEx);
require($phpbb_root_path . 'includes/functions_selects.'.$phpEx);
require($phpbb_root_path . 'includes/functions_validate.'.$phpEx);

$html_entities_match = array('#<#', '#>#');
$html_entities_replace = array('&lt;', '&gt;');

//
// Set mode
//
if( isset( $HTTP_POST_VARS['mode'] ) || isset( $HTTP_GET_VARS['mode'] ) )
{
	$mode = ( isset( $HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
	$mode = htmlspecialchars($mode);
}
else
{
	$mode = '';
}

//
// Begin program
//
if( $mode == 'edit' || $mode == 'save' && ( isset($HTTP_POST_VARS['username']) || isset($HTTP_GET_VARS[POST_USERS_URL]) || isset( $HTTP_POST_VARS[POST_USERS_URL]) ) )
{
	attachment_quota_settings('user', $HTTP_POST_VARS['submit'], $mode);
	//
	// Ok, the profile has been modified and submitted, let's update
	//
	if( ( $mode == 'save' && isset( $HTTP_POST_VARS['submit'] ) ) || isset( $HTTP_POST_VARS['avatargallery'] ) || isset( $HTTP_POST_VARS['submitavatar'] ) || isset( $HTTP_POST_VARS['cancelavatar'] ) )
	{
		$user_id = intval( $HTTP_POST_VARS['id'] );

		if (!($this_userdata = get_userdata($user_id)))
		{
			message_die(GENERAL_MESSAGE, $lang['No_user_id_specified'] );
		}

		if( $HTTP_POST_VARS['deleteuser'] && ( $userdata['user_id'] != $user_id ) )
		{
			$sql = "SELECT g.group_id
				FROM " . USER_GROUP_TABLE . " ug, " . GROUPS_TABLE . " g
				WHERE ug.user_id = $user_id
					AND g.group_id = ug.group_id
					AND g.group_single_user = 1";
			if( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain group information for this user', '', __LINE__, __FILE__, $sql);
			}

			$row = $db->sql_fetchrow($result);

			if( $this_userdata['user_level'] == ADMIN )
			{
			   message_die(GENERAL_ERROR, 'You cannot delete an Administrator of this Board');
			}
			else
			{

				$sql = "UPDATE " . POSTS_TABLE . "
					SET poster_id = " . DELETED . ", post_username = '" . str_replace("\\'", "''", addslashes($this_userdata['username'])) . "'
					WHERE poster_id = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not update posts for this user', '', __LINE__, __FILE__, $sql);
				}

				$sql = "UPDATE " . TOPICS_TABLE . "
					SET topic_poster = " . DELETED . "
					WHERE topic_poster = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not update topics for this user', '', __LINE__, __FILE__, $sql);
				}

				$sql = "UPDATE " . VOTE_USERS_TABLE . "
					SET vote_user_id = " . DELETED . "
					WHERE vote_user_id = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not update votes for this user', '', __LINE__, __FILE__, $sql);
				}

				$sql = "SELECT group_id
					FROM " . GROUPS_TABLE . "
					WHERE group_moderator = $user_id";
				if( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Could not select groups where user was moderator', '', __LINE__, __FILE__, $sql);
				}

				while ( $row_group = $db->sql_fetchrow($result) )
				{
					$group_moderator[] = $row_group['group_id'];
				}

				if ( count($group_moderator) )
				{
					$update_moderator_id = implode(', ', $group_moderator);

					$sql = "UPDATE " . GROUPS_TABLE . "
						SET group_moderator = " . $userdata['user_id'] . "
						WHERE group_moderator IN ($update_moderator_id)";
					if( !$db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, 'Could not update group moderators', '', __LINE__, __FILE__, $sql);
					}
				}

				$sql = "DELETE FROM " . USERS_TABLE . "
						WHERE user_id = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . USER_GROUP_TABLE . "
						WHERE user_id = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user from user_group table', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . GROUPS_TABLE . "
					WHERE group_id = " . $row['group_id'];
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete group for this user', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . AUTH_ACCESS_TABLE . "
					WHERE group_id = " . $row['group_id'];
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete group for this user', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . TOPICS_WATCH_TABLE . "
					WHERE user_id = $user_id";
				if ( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user from topic watch table', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM ". FAVORITES_TABLE . "
					WHERE user_id = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user_favorites', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . IM_PREFS_TABLE . "
					WHERE user_id = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user IM prefs', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . BUDDY_TABLE . "
					WHERE user_id = $user_id
					OR buddy_id = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user BID List entries', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . TOPIC_VIEW_TABLE . "
					WHERE user_id = $user_id";
				if ( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user from topic view table', '', __LINE__, __FILE__, $sql);
				}

				//
				// START - REFERRAL MOD - AbelaJohnB
				$sql = "DELETE FROM " . REFERRAL_TABLE . "
					WHERE nuid = $user_id";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user from referral table', '', __LINE__, __FILE__, $sql);
				}
				//
				// END - REFERRAL MOD - AbelaJohnB
				//

				$sql = "DELETE FROM " . BANLIST_TABLE . "
					WHERE ban_userid = $user_id";
				if ( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete user from banlist table', '', __LINE__, __FILE__, $sql);
				}

				$sql = "DELETE FROM " . SESSIONS_TABLE . "
					WHERE session_user_id = $user_id";
				if ( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete sessions for this user', '', __LINE__, __FILE__, $sql);
				}
				
				$sql = "DELETE FROM " . SESSIONS_KEYS_TABLE . "
					WHERE user_id = $user_id";
				if ( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, 'Could not delete auto-login keys for this user', '', __LINE__, __FILE__, $sql);
				}

				//Added for DB read_tracking
				if ( $board_config['db_read_tracking'] )
				{

					$sql = "DELETE FROM " . READ_HIST_TABLE . "
						WHERE user_id = $user_id";
					if( !$db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, 'Could not delete read history', '', __LINE__, __FILE__, $sql);
					}
				}

				$sql = "SELECT privmsgs_id
					FROM " . PRIVMSGS_TABLE . "
					WHERE privmsgs_from_userid = $user_id
					OR privmsgs_to_userid = $user_id";
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Could not select all users private messages', '', __LINE__, __FILE__, $sql);
				}

				// This little bit of code directly from the private messaging section.
				while ( $row_privmsgs = $db->sql_fetchrow($result) )
				{
					$mark_list[] = $row_privmsgs['privmsgs_id'];
				}

				if ( count($mark_list) )
				{
					$delete_sql_id = implode(', ', $mark_list);

					$delete_text_sql = "DELETE FROM " . PRIVMSGS_TEXT_TABLE . "
						WHERE privmsgs_text_id IN ($delete_sql_id)";
					$delete_sql = "DELETE FROM " . PRIVMSGS_TABLE . "
						WHERE privmsgs_id IN ($delete_sql_id)";

					if ( !$db->sql_query($delete_sql) )
					{
						message_die(GENERAL_ERROR, 'Could not delete private message info', '', __LINE__, __FILE__, $delete_sql);
					}


					if ( !$db->sql_query($delete_text_sql) )
					{
						message_die(GENERAL_ERROR, 'Could not delete private message text', '', __LINE__, __FILE__, $delete_text_sql);
					}
				}

				// START - Email notify on user delete
				$email_headers = 'From: ' . $board_config['board_email'] . "\nReturn-Path: " . $board_config['board_email'] . "\n";

				include($phpbb_root_path . 'includes/emailer.'.$phpEx);
				$emailer = new emailer($board_config['smtp_delivery']);

				$emailer->use_template('deluser_notify', $to_userdata['user_lang']);
				$emailer->extra_headers($email_headers);
				$emailer->email_address($email);
				$emailer->set_subject(); //$lang['Notification_subject']

				$emailer->assign_vars(array(
					'USERNAME' => $username,
					'SITENAME' => $board_config['sitename'],
					'EMAIL_SIG' => str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig'])
				)
				);

				$emailer->send();
				$emailer->reset();
				// END - Email notify on user delete

				$message = $lang['User_deleted'] . '<br /><br />' . sprintf($lang['Click_return_useradmin'], '<a href="' . append_sid("admin_users.$phpEx") . '">', '</a>') . '<br /><br />' . sprintf($lang['Click_return_admin_index'], '<a href="' . append_sid("index.$phpEx?pane=right") . '">', '</a>');

				message_die(GENERAL_MESSAGE, $message);
			}
		}

		if( $HTTP_POST_VARS['block_account'] )
		{
			$sql = "UPDATE ".USERS_TABLE." SET
				user_blocktime='".(time()+$board_config['block_time']*60)."', user_block_by='$user_ip'
				WHERE user_id = '$user_id'";
			if( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not block user', '', __LINE__, __FILE__, $sql);
			}
			$sql = 'UPDATE ' . SESSIONS_TABLE . ' SET session_logged_in="0" WHERE session_user_id="'.$user_id.'"';
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't update blocked sessions from database", "", __LINE__, __FILE__, $sql);
			}
		}
		if( $HTTP_POST_VARS['unblock_account'] )
		{
			$sql = "UPDATE ".USERS_TABLE." SET
				user_blocktime='0', user_badlogin='0'
				WHERE user_id = '$user_id'";
			if( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not unblock user', '', __LINE__, __FILE__, $sql);
			}
		}

		$username = ( !empty($HTTP_POST_VARS['username']) ) ? phpbb_clean_username($HTTP_POST_VARS['username']) : '';
		$email = ( !empty($HTTP_POST_VARS['email']) ) ? trim(strip_tags(htmlspecialchars( $HTTP_POST_VARS['email'] ) )) : '';

		$password = ( !empty($HTTP_POST_VARS['password']) ) ? trim(strip_tags(htmlspecialchars( $HTTP_POST_VARS['password'] ) )) : '';
		$password_confirm = ( !empty($HTTP_POST_VARS['password_confirm']) ) ? trim(strip_tags(htmlspecialchars( $HTTP_POST_VARS['password_confirm'] ) )) : '';

		$icq = ( !empty($HTTP_POST_VARS['icq']) ) ? trim(strip_tags( $HTTP_POST_VARS['icq'] ) ) : '';
		$aim = ( !empty($HTTP_POST_VARS['aim']) ) ? trim(strip_tags( $HTTP_POST_VARS['aim'] ) ) : '';
		$msn = ( !empty($HTTP_POST_VARS['msn']) ) ? trim(strip_tags( $HTTP_POST_VARS['msn'] ) ) : '';
		$yim = ( !empty($HTTP_POST_VARS['yim']) ) ? trim(strip_tags( $HTTP_POST_VARS['yim'] ) ) : '';

		$website = ( !empty($HTTP_POST_VARS['website']) ) ? trim(strip_tags( $HTTP_POST_VARS['website'] ) ) : '';
		$location = ( !empty($HTTP_POST_VARS['location']) ) ? trim(strip_tags( $HTTP_POST_VARS['location'] ) ) : '';
		$occupation = ( !empty($HTTP_POST_VARS['occupation']) ) ? trim(strip_tags( $HTTP_POST_VARS['occupation'] ) ) : '';
		$interests = ( !empty($HTTP_POST_VARS['interests']) ) ? trim(strip_tags( $HTTP_POST_VARS['interests'] ) ) : '';
		$vacances = ( isset($HTTP_POST_VARS['vacances']) ) ? $HTTP_POST_VARS['vacances'] : 0;
		$custom_title = ( !empty($HTTP_POST_VARS['custom_title']) ) ? trim(strip_tags( $HTTP_POST_VARS['custom_title'] ) ) : '';
		$custom_title_status = ( isset( $HTTP_POST_VARS['custom_title_status']) ) ? intval( $HTTP_POST_VARS['custom_title_status'] ) : 0;
		$auto_response = ( !empty($HTTP_POST_VARS['auto_response']) ) ? trim(strip_tags( $HTTP_POST_VARS['auto_response'] ) ) : '';
//
// Start System Specs MOD
//
		$computer_name = ( !empty($HTTP_POST_VARS['computer_name']) ) ? trim(strip_tags( $HTTP_POST_VARS['computer_name'] ) ) : '';
		$system_enclosure = ( !empty($HTTP_POST_VARS['system_enclosure']) ) ? trim(strip_tags( $HTTP_POST_VARS['system_enclosure'] ) ) : '';
		$system_motherboard = ( !empty($HTTP_POST_VARS['system_motherboard']) ) ? trim(strip_tags( $HTTP_POST_VARS['system_motherboard'] ) ) : '';
		$processor_brand = ( !empty($HTTP_POST_VARS['processor_brand']) ) ? trim(strip_tags( $HTTP_POST_VARS['processor_brand'] ) ) : '';
		$processor_desc = ( !empty($HTTP_POST_VARS['processor_desc']) ) ? trim(strip_tags( $HTTP_POST_VARS['processor_desc'] ) ) : '';
		$memory_amt = ( !empty($HTTP_POST_VARS['memory_amt']) ) ? trim(strip_tags( $HTTP_POST_VARS['memory_amt'] ) ) : '';
		$memory_details = ( !empty($HTTP_POST_VARS['memory_details']) ) ? trim(strip_tags( $HTTP_POST_VARS['memory_details'] ) ) : '';
		$vid_brand = ( !empty($HTTP_POST_VARS['vid_brand']) ) ? trim(strip_tags( $HTTP_POST_VARS['vid_brand'] ) ) : '';
		$vid_desc = ( !empty($HTTP_POST_VARS['vid_desc']) ) ? trim(strip_tags( $HTTP_POST_VARS['vid_desc'] ) ) : '';
		$storage_details = ( !empty($HTTP_POST_VARS['storage_details']) ) ? trim(strip_tags( $HTTP_POST_VARS['storage_details'] ) ) : '';
		$audio_details = ( !empty($HTTP_POST_VARS['audio_details']) ) ? trim(strip_tags( $HTTP_POST_VARS['audio_details'] ) ) : '';
		$system_cooling = ( !empty($HTTP_POST_VARS['system_cooling']) ) ? trim(strip_tags( $HTTP_POST_VARS['system_cooling'] ) ) : '';
		$system_os = ( !empty($HTTP_POST_VARS['system_os']) ) ? trim(strip_tags( $HTTP_POST_VARS['system_os'] ) ) : '';
		$system_monitor = ( !empty($HTTP_POST_VARS['system_monitor']) ) ? trim(strip_tags( $HTTP_POST_VARS['system_monitor'] ) ) : '';
		$favorite_game = ( !empty($HTTP_POST_VARS['favorite_game']) ) ? trim(strip_tags( $HTTP_POST_VARS['favorite_game'] ) ) : '';
		$threedmark = ( !empty($HTTP_POST_VARS['threedmark']) ) ? trim(strip_tags( $HTTP_POST_VARS['threedmark'] ) ) : '';
		$futuremark = ( !empty($HTTP_POST_VARS['futuremark']) ) ? trim(strip_tags( $HTTP_POST_VARS['futuremark'] ) ) : '';
		$cpu_dhry = ( !empty($HTTP_POST_VARS['cpu_dhry']) ) ? trim(strip_tags( $HTTP_POST_VARS['cpu_dhry'] ) ) : '';
		$cpu_whet = ( !empty($HTTP_POST_VARS['cpu_whet']) ) ? trim(strip_tags( $HTTP_POST_VARS['cpu_whet'] ) ) : '';
		$cpu_integer = ( !empty($HTTP_POST_VARS['cpu_integer']) ) ? trim(strip_tags( $HTTP_POST_VARS['cpu_integer'] ) ) : '';
		$cpu_floating = ( !empty($HTTP_POST_VARS['cpu_floating']) ) ? trim(strip_tags( $HTTP_POST_VARS['cpu_floating'] ) ) : '';
		$ram_integer = ( !empty($HTTP_POST_VARS['ram_integer']) ) ? trim(strip_tags( $HTTP_POST_VARS['ram_integer'] ) ) : '';
		$ram_floating = ( !empty($HTTP_POST_VARS['ram_floating']) ) ? trim(strip_tags( $HTTP_POST_VARS['ram_floating'] ) ) : '';
		$drive_idx = ( !empty($HTTP_POST_VARS['drive_idx']) ) ? trim(strip_tags( $HTTP_POST_VARS['drive_idx'] ) ) : '';
		$total_idx_score = ((($this_userdata['user_threedmark'] * 1.2) + ($this_userdata['user_futuremark'] * 6.5) * .5) + (($this_userdata['user_cpu_dhry'] * 1.7) + ($this_userdata['user_cpu_whet'] * 4.3) + ($this_userdata['user_cpu_integer'] * 1.1) + ($this_userdata['user_cpu_floating'] * 1.1) * .25) + (($this_userdata['user_ram_integer'] * 5.4) + ($this_userdata['user_ram_floating'] * 5.8) * .5) + ($this_userdata['user_drive_idx'] * .25)) * .015;
//
// Finish System Specs MOD
//
		if (isset($HTTP_POST_VARS['birthday']) )
		{
			$birthday = intval ($HTTP_POST_VARS['birthday']);
			$b_day = realdate('j',$birthday);
			$b_md = realdate('n',$birthday);
			$b_year = realdate('Y',$birthday);
		} else
		{
			$b_day = ( isset($HTTP_POST_VARS['b_day']) ) ? intval ($HTTP_POST_VARS['b_day']) : 0;
			$b_md = ( isset($HTTP_POST_VARS['b_md']) ) ? intval ($HTTP_POST_VARS['b_md']) : 0;
			$b_year = ( isset($HTTP_POST_VARS['b_year']) ) ? intval ($HTTP_POST_VARS['b_year']) : 0;
			$birthday = mkrealdate($b_day,$b_md,$b_year);
		}
		$next_birthday_greeting = ( !empty($HTTP_POST_VARS['next_birthday_greeting']) ) ? intval( $HTTP_POST_VARS['next_birthday_greeting'] ) : 0;

		$gender = ( isset($HTTP_POST_VARS['gender']) ) ? $HTTP_POST_VARS['gender'] : 0;
		$signature = ( !empty($HTTP_POST_VARS['signature']) ) ? trim(str_replace('<br />', "\n", $HTTP_POST_VARS['signature'] ) ) : '';

		validate_optional_fields($icq, $aim, $msn, $yim, $website, $location, $occupation, $interests, $auto_response, $computer_name, $system_enclosure, $system_motherboard, $processor_brand, $processor_desc, $memory_amt, $memory_details, $vid_brand, $vid_desc, $storage_details, $audio_details, $system_cooling, $system_os, $system_monitor, $favorite_game, $threedmark, $futuremark, $cpu_dhry, $cpu_whet, $cpu_integer, $cpu_floating, $ram_integer, $ram_floating, $drive_idx, $signature, $infotext);

		$viewemail = ( isset( $HTTP_POST_VARS['viewemail']) ) ? ( ( $HTTP_POST_VARS['viewemail'] ) ? TRUE : 0 ) : 0;
		$allowviewonline = ( isset( $HTTP_POST_VARS['hideonline']) ) ? ( ( $HTTP_POST_VARS['hideonline'] ) ? 0 : TRUE ) : TRUE;
		$notifyreply = ( isset( $HTTP_POST_VARS['notifyreply']) ) ? ( ( $HTTP_POST_VARS['notifyreply'] ) ? TRUE : 0 ) : 0;
		$auto_response_on = ( isset( $HTTP_POST_VARS['auto_response_on']) ) ? ( ( $HTTP_POST_VARS['auto_response_on'] ) ? TRUE : 0 ) : 0;
		$allow_response = ( isset( $HTTP_POST_VARS['allow_response']) ) ? ( ( $HTTP_POST_VARS['allow_response'] ) ? TRUE : 0 ) : 0;
		$notifypm = ( isset( $HTTP_POST_VARS['notifypm']) ) ? ( ( $HTTP_POST_VARS['notifypm'] ) ? TRUE : 0 ) : TRUE;
		$popuppm = ( isset( $HTTP_POST_VARS['popup_pm']) ) ? ( ( $HTTP_POST_VARS['popup_pm'] ) ? TRUE : 0 ) : TRUE;
		$attachsig = ( isset( $HTTP_POST_VARS['attachsig']) ) ? ( ( $HTTP_POST_VARS['attachsig'] ) ? TRUE : 0 ) : 0;
		// MOD NOTIFY MODERATOR BEGIN
		$notifymod = ( isset($HTTP_POST_VARS['notifymod']) ) ? ( ($HTTP_POST_VARS['notifymod']) ? TRUE : 0 ) : 0;
		// MOD NOTIFY MODERATOR END

		$allowhtml = ( isset( $HTTP_POST_VARS['allowhtml']) ) ? intval( $HTTP_POST_VARS['allowhtml'] ) : $board_config['allow_html'];
		$allowbbcode = ( isset( $HTTP_POST_VARS['allowbbcode']) ) ? intval( $HTTP_POST_VARS['allowbbcode'] ) : $board_config['allow_bbcode'];
		$allowsmilies = ( isset( $HTTP_POST_VARS['allowsmilies']) ) ? intval( $HTTP_POST_VARS['allowsmilies'] ) : $board_config['allow_smilies'];

		$user_style = ( isset( $HTTP_POST_VARS['style'] ) ) ? intval( $HTTP_POST_VARS['style'] ) : $board_config['default_style'];
		$user_lang = ( $HTTP_POST_VARS['language'] ) ? $HTTP_POST_VARS['language'] : $board_config['default_lang'];
		$user_timezone = ( isset( $HTTP_POST_VARS['timezone']) ) ? doubleval( $HTTP_POST_VARS['timezone'] ) : $board_config['board_timezone'];
		// FLAGHACK-start
		$user_flag = ( !empty($HTTP_POST_VARS['user_flag']) ) ? $HTTP_POST_VARS['user_flag'] : '' ;
		// FLAGHACK-end
		$user_dateformat = ( $HTTP_POST_VARS['dateformat'] ) ? trim( $HTTP_POST_VARS['dateformat'] ) : $board_config['default_dateformat'];

		$user_avatar_local = ( isset( $HTTP_POST_VARS['avatarselect'] ) && !empty($HTTP_POST_VARS['submitavatar'] ) && $board_config['allow_avatar_local'] ) ? $HTTP_POST_VARS['avatarselect'] : ( ( isset( $HTTP_POST_VARS['avatarlocal'] )  ) ? $HTTP_POST_VARS['avatarlocal'] : '' );
		$user_avatar_category = ( isset($HTTP_POST_VARS['avatarcatname']) && $board_config['allow_avatar_local'] ) ? htmlspecialchars($HTTP_POST_VARS['avatarcatname']) : '' ;

		$user_avatar_remoteurl = ( !empty($HTTP_POST_VARS['avatarremoteurl']) ) ? trim( $HTTP_POST_VARS['avatarremoteurl'] ) : '';
		$user_avatar_url = ( !empty($HTTP_POST_VARS['avatarurl']) ) ? trim( $HTTP_POST_VARS['avatarurl'] ) : '';
		$user_avatar_loc = ( $HTTP_POST_FILES['avatar']['tmp_name'] != "none") ? $HTTP_POST_FILES['avatar']['tmp_name'] : '';
		$user_avatar_name = ( !empty($HTTP_POST_FILES['avatar']['name']) ) ? $HTTP_POST_FILES['avatar']['name'] : '';
		$user_avatar_size = ( !empty($HTTP_POST_FILES['avatar']['size']) ) ? $HTTP_POST_FILES['avatar']['size'] : 0;
		$user_avatar_filetype = ( !empty($HTTP_POST_FILES['avatar']['type']) ) ? $HTTP_POST_FILES['avatar']['type'] : '';

		$user_avatar = ( empty($user_avatar_loc) ) ? $this_userdata['user_avatar'] : '';
		$user_avatar_type = ( empty($user_avatar_loc) ) ? $this_userdata['user_avatar_type'] : '';

		$user_status = ( !empty($HTTP_POST_VARS['user_status']) ) ? intval( $HTTP_POST_VARS['user_status'] ) : 0;
		$infotext = ( !empty($HTTP_POST_VARS['infotext']) ) ? trim(strip_tags( $HTTP_POST_VARS['infotext'] ) ) : '';
		$user_allowpm = ( !empty($HTTP_POST_VARS['user_allowpm']) ) ? intval( $HTTP_POST_VARS['user_allowpm'] ) : 0;
		$user_rank = ( !empty($HTTP_POST_VARS['user_rank']) ) ? intval( $HTTP_POST_VARS['user_rank'] ) : 0;
		$user_allowavatar = ( !empty($HTTP_POST_VARS['user_allowavatar']) ) ? intval( $HTTP_POST_VARS['user_allowavatar'] ) : 0;
		$user_level = ( !empty($HTTP_POST_VARS['user_level']) ) ? intval( $HTTP_POST_VARS['user_level'] ) : 0;

		if( isset( $HTTP_POST_VARS['avatargallery'] ) || isset( $HTTP_POST_VARS['submitavatar'] ) || isset( $HTTP_POST_VARS['cancelavatar'] ) )
		{
			$username = stripslashes($username);
			$email = stripslashes($email);
			$password = '';
			$password_confirm = '';

			$icq = stripslashes($icq);
			$aim = htmlspecialchars(stripslashes($aim));
			$msn = htmlspecialchars(stripslashes($msn));
			$yim = htmlspecialchars(stripslashes($yim));

			$website = htmlspecialchars(stripslashes($website));
			$location = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($location)));
			$occupation = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($occupation)));
			$interests = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($interests)));
			$custom_title = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($custom_title)));
			$auto_response = htmlspecialchars(stripslashes($auto_response));
//
// Start System Specs MOD
//
			$computer_name = htmlspecialchars(stripslashes($computer_name));
			$system_enclosure = htmlspecialchars(stripslashes($system_enclosure));
			$system_motherboard = htmlspecialchars(stripslashes($system_motherboard));
			$processor_brand = htmlspecialchars(stripslashes($processor_brand));
			$processor_desc = htmlspecialchars(stripslashes($processor_desc));
			$memory_amt = htmlspecialchars(stripslashes($memory_amt));
			$memory_details = htmlspecialchars(stripslashes($memory_details));
			$vid_brand = htmlspecialchars(stripslashes($vid_brand));
			$vid_desc = htmlspecialchars(stripslashes($vid_desc));
			$storage_details = htmlspecialchars(stripslashes($storage_details));
			$audio_details = htmlspecialchars(stripslashes($audio_details));
			$system_cooling = htmlspecialchars(stripslashes($system_cooling));
			$system_os = htmlspecialchars(stripslashes($system_os));
			$system_monitor = htmlspecialchars(stripslashes($system_monitor));
			$favorite_game = htmlspecialchars(stripslashes($favorite_game));
			$threedmark = htmlspecialchars(stripslashes($threedmark));
			$futuremark = htmlspecialchars(stripslashes($futuremark));
			$cpu_dhry = htmlspecialchars(stripslashes($cpu_dhry));
			$cpu_whet = htmlspecialchars(stripslashes($cpu_whet));
			$cpu_integer = htmlspecialchars(stripslashes($cpu_integer));
			$cpu_floating = htmlspecialchars(stripslashes($cpu_floating));
			$ram_integer = htmlspecialchars(stripslashes($ram_integer));
			$ram_floating = htmlspecialchars(stripslashes($ram_floating));
			$drive_idx = htmlspecialchars(stripslashes($drive_idx));
//
// Finish System Specs MOD
//
			$signature = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($signature)));
			$infotext = htmlspecialchars(stripslashes($infotext));

			$user_lang = stripslashes($user_lang);
			$user_dateformat = htmlspecialchars(stripslashes($user_dateformat));

			if ( !isset($HTTP_POST_VARS['cancelavatar']))
			{
				$user_avatar = $user_avatar_category . '/' . $user_avatar_local;
				$user_avatar_type = USER_AVATAR_GALLERY;
			}
		}
	}

	if( isset( $HTTP_POST_VARS['submit'] ) )
	{
		include($phpbb_root_path . 'includes/usercp_avatar.'.$phpEx);

		$error = FALSE;

		if( stripslashes($username) != $this_userdata['username'] )
		{
			unset($rename_user);

			if ( stripslashes(strtolower($username)) != strtolower($this_userdata['username']) )
			{
			$result = validate_username($username);
			if ( $result['error'] )
			{
				$error = TRUE;
				$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $result['error_msg'];
			}
				else if ( strtolower(str_replace("\\'", "''", $username)) == strtolower($userdata['username']) )
				{
					$error = TRUE;
					$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Username_taken'];
				}
			}

			if (!$error)
			{
				$username_sql = "username = '" . str_replace("\\'", "''", $username) . "', ";
				$rename_user = $username; // Used for renaming usergroup
			}
		}

		$passwd_sql = '';
		if( !empty($password) && !empty($password_confirm) )
		{
			//
			// Awww, the user wants to change their password, isn't that cute..
			//
			if($password != $password_confirm)
			{
				$error = TRUE;
				$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Password_mismatch'];
			}
			else
			{
				$password = md5($password);
				$passwd_sql = "user_password = '$password', ";
			}
		}
		else if( $password && !$password_confirm )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Password_mismatch'];
		}
		else if( !$password && $password_confirm )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Password_mismatch'];
		}

		if ($signature != '')
		{
			$sig_length_check = preg_replace('/(\[.*?)(=.*?)\]/is', '\\1]', stripslashes($signature));
			if ( $allowhtml )
			{
				$sig_length_check = preg_replace('/(\<.*?)(=.*?)( .*?=.*?)?([ \/]?\>)/is', '\\1\\3\\4', $sig_length_check);
			}

			// Only create a new bbcode_uid when there was no uid yet.
			if ( $signature_bbcode_uid == '' )
			{
				$signature_bbcode_uid = ( $allowbbcode ) ? make_bbcode_uid() : '';
			}
			$signature = prepare_message($signature, $allowhtml, $allowbbcode, $allowsmilies, $signature_bbcode_uid);

			if ( strlen($sig_length_check) > $board_config['max_sig_chars'] )
			{
				$error = TRUE;
				$error_msg .=  ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Signature_too_long'];
			}
		}

		if ($auto_response != '')
		{
			$auto_response_length = preg_replace('/(\[.*?)(=.*?)\]/is', '\\1]', stripslashes($auto_response));
			if ( $allowhtml )
			{
				$auto_response_length = preg_replace('/(\<.*?)(=.*?)( .*?=.*?)?([ \/]?\>)/is', '\\1\\3\\4', $auto_response_length);
			}

			if ( $auto_response_bbcode_uid == '' )
			{
				$auto_response_bbcode_uid = ( $allowbbcode ) ? make_bbcode_uid() : '';
			}
			$auto_response = prepare_message($auto_response, $allowhtml, $allowbbcode, $allowsmilies, $auto_response_bbcode_uid);

			if ( strlen($auto_response_length) > $board_config['auto_response_length'] )
			{
				$error = TRUE;
				$error_msg .=  ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Auto_response_too_long'];
			}
		}

		//
		// Avatar stuff
		//
		$avatar_sql = "";
		if( isset($HTTP_POST_VARS['avatardel']) )
		{
			if( $this_userdata['user_avatar_type'] == USER_AVATAR_UPLOAD && $this_userdata['user_avatar'] != "" )
			{
				if( @file_exists(@phpbb_realpath('./../' . $board_config['avatar_path'] . "/" . $this_userdata['user_avatar'])) )
				{
					@unlink('./../' . $board_config['avatar_path'] . "/" . $this_userdata['user_avatar']);
				}
			}
			$avatar_sql = ", user_avatar = '', user_avatar_type = " . USER_AVATAR_NONE;
		}
		else if( ( $user_avatar_loc != "" || !empty($user_avatar_url) ) && !$error )
		{
			//
			// Only allow one type of upload, either a
			// filename or a URL
			//
			if( !empty($user_avatar_loc) && !empty($user_avatar_url) )
			{
				$error = TRUE;
				if( isset($error_msg) )
				{
					$error_msg .= "<br />";
				}
				$error_msg .= $lang['Only_one_avatar'];
			}

			if( $user_avatar_loc != "" )
			{
				if( file_exists(@phpbb_realpath($user_avatar_loc)) && ereg(".jpg$|.gif$|.png$", $user_avatar_name) )
				{
					if( $user_avatar_size <= $board_config['avatar_filesize'] && $user_avatar_size > 0)
					{
						$error_type = false;

						//
						// Opera appends the image name after the type, not big, not clever!
						//
						preg_match("'image\/[x\-]*([a-z]+)'", $user_avatar_filetype, $user_avatar_filetype);
						$user_avatar_filetype = $user_avatar_filetype[1];

						switch( $user_avatar_filetype )
						{
							case "jpeg":
							case "pjpeg":
							case "jpg":
								$imgtype = '.jpg';
								break;
							case "gif":
								$imgtype = '.gif';
								break;
							case "png":
								$imgtype = '.png';
								break;
							default:
								$error = true;
								$error_msg = (!empty($error_msg)) ? $error_msg . "<br />" . $lang['Avatar_filetype'] : $lang['Avatar_filetype'];
								break;
						}

						if( !$error )
						{
							list($width, $height) = @getimagesize($user_avatar_loc);

							if( $width <= $board_config['avatar_max_width'] && $height <= $board_config['avatar_max_height'] )
							{
								$user_id = $this_userdata['user_id'];

								$avatar_filename = $user_id . $imgtype;

								if( $this_userdata['user_avatar_type'] == USER_AVATAR_UPLOAD && $this_userdata['user_avatar'] != "" )
								{
									if( @file_exists(@phpbb_realpath("./../" . $board_config['avatar_path'] . "/" . $this_userdata['user_avatar'])) )
									{
										@unlink("./../" . $board_config['avatar_path'] . "/". $this_userdata['user_avatar']);
									}
								}
								@copy($user_avatar_loc, "./../" . $board_config['avatar_path'] . "/$avatar_filename");

								$avatar_sql = ", user_avatar = '$avatar_filename', user_avatar_type = " . USER_AVATAR_UPLOAD;
							}
							else
							{
								$l_avatar_size = sprintf($lang['Avatar_imagesize'], $board_config['avatar_max_width'], $board_config['avatar_max_height']);

								$error = true;
								$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $l_avatar_size : $l_avatar_size;
							}
						}
					}
					else
					{
						$l_avatar_size = sprintf($lang['Avatar_filesize'], round($board_config['avatar_filesize'] / 1024));

						$error = true;
						$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $l_avatar_size : $l_avatar_size;
					}
				}
				else
				{
					$error = true;
					$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $lang['Avatar_filetype'] : $lang['Avatar_filetype'];
				}
			}
			else if( !empty($user_avatar_url) )
			{
				//
				// First check what port we should connect
				// to, look for a :[xxxx]/ or, if that doesn't
				// exist assume port 80 (http)
				//
				preg_match("/^(http:\/\/)?([\w\-\.]+)\:?([0-9]*)\/(.*)$/", $user_avatar_url, $url_ary);

				if( !empty($url_ary[4]) )
				{
					$port = (!empty($url_ary[3])) ? $url_ary[3] : 80;

					$fsock = @fsockopen($url_ary[2], $port, $errno, $errstr);
					if( $fsock )
					{
						$base_get = "/" . $url_ary[4];

						//
						// Uses HTTP 1.1, could use HTTP 1.0 ...
						//
						@fputs($fsock, "GET $base_get HTTP/1.1\r\n");
						@fputs($fsock, "HOST: " . $url_ary[2] . "\r\n");
						@fputs($fsock, "Connection: close\r\n\r\n");

						unset($avatar_data);
						while( !@feof($fsock) )
						{
							$avatar_data .= @fread($fsock, $board_config['avatar_filesize']);
						}
						@fclose($fsock);

						if( preg_match("/Content-Length\: ([0-9]+)[^\/ ][\s]+/i", $avatar_data, $file_data1) && preg_match("/Content-Type\: image\/[x\-]*([a-z]+)[\s]+/i", $avatar_data, $file_data2) )
						{
							$file_size = $file_data1[1];
							$file_type = $file_data2[1];

							switch( $file_type )
							{
								case "jpeg":
								case "pjpeg":
								case "jpg":
									$imgtype = '.jpg';
									break;
								case "gif":
									$imgtype = '.gif';
									break;
								case "png":
									$imgtype = '.png';
									break;
								default:
									$error = true;
									$error_msg = (!empty($error_msg)) ? $error_msg . "<br />" . $lang['Avatar_filetype'] : $lang['Avatar_filetype'];
									break;
							}

							if( !$error && $file_size > 0 && $file_size < $board_config['avatar_filesize'] )
							{
								$avatar_data = substr($avatar_data, strlen($avatar_data) - $file_size, $file_size);

								$tmp_filename = tempnam ("/tmp", $this_userdata['user_id'] . "-");
								$fptr = @fopen($tmp_filename, "wb");
								$bytes_written = @fwrite($fptr, $avatar_data, $file_size);
								@fclose($fptr);

								if( $bytes_written == $file_size )
								{
									list($width, $height) = @getimagesize($tmp_filename);

									if( $width <= $board_config['avatar_max_width'] && $height <= $board_config['avatar_max_height'] )
									{
										$user_id = $this_userdata['user_id'];

										$avatar_filename = $user_id . $imgtype;

										if( $this_userdata['user_avatar_type'] == USER_AVATAR_UPLOAD && $this_userdata['user_avatar'] != "")
										{
											if( file_exists(@phpbb_realpath("./../" . $board_config['avatar_path'] . "/" . $this_userdata['user_avatar'])) )
											{
												@unlink("./../" . $board_config['avatar_path'] . "/" . $this_userdata['user_avatar']);
											}
										}
										@copy($tmp_filename, "./../" . $board_config['avatar_path'] . "/$avatar_filename");
										@unlink($tmp_filename);

										$avatar_sql = ", user_avatar = '$avatar_filename', user_avatar_type = " . USER_AVATAR_UPLOAD;
									}
									else
									{
										$l_avatar_size = sprintf($lang['Avatar_imagesize'], $board_config['avatar_max_width'], $board_config['avatar_max_height']);

										$error = true;
										$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $l_avatar_size : $l_avatar_size;
									}
								}
								else
								{
									//
									// Error writing file
									//
									@unlink($tmp_filename);
									message_die(GENERAL_ERROR, "Could not write avatar file to local storage. Please contact the board administrator with this message", "", __LINE__, __FILE__);
								}
							}
						}
						else
						{
							//
							// No data
							//
							$error = true;
							$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $lang['File_no_data'] : $lang['File_no_data'];
						}
					}
					else
					{
						//
						// No connection
						//
						$error = true;
						$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $lang['No_connection_URL'] : $lang['No_connection_URL'];
					}
				}
				else
				{
					$error = true;

					$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $lang['Incomplete_URL'] : $lang['Incomplete_URL'];
				}
			}
			else if( !empty($user_avatar_name) )
			{
				$l_avatar_size = sprintf($lang['Avatar_filesize'], round($board_config['avatar_filesize'] / 1024));

				$error = true;
				$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $l_avatar_size : $l_avatar_size;
			}
		}
		else if( $user_avatar_remoteurl != "" && $avatar_sql == "" && !$error )
		{
			if( !preg_match("#^http:\/\/#i", $user_avatar_remoteurl) )
			{
				$user_avatar_remoteurl = "http://" . $user_avatar_remoteurl;
			}

			if( preg_match("#^(http:\/\/[a-z0-9\-]+?\.([a-z0-9\-]+\.)*[a-z]+\/.*?\.(gif|jpg|png)$)#is", $user_avatar_remoteurl) )
			{
				$avatar_sql = ", user_avatar = '" . str_replace("\'", "''", $user_avatar_remoteurl) . "', user_avatar_type = " . USER_AVATAR_REMOTE;
			}
			else
			{
				$error = true;
				$error_msg = ( !empty($error_msg) ) ? $error_msg . "<br />" . $lang['Wrong_remote_avatar_format'] : $lang['Wrong_remote_avatar_format'];
			}
		}
		else if( $user_avatar_local != "" && $avatar_sql == "" && !$error )
		{
			$avatar_sql = ", user_avatar = '" . str_replace("\'", "''", phpbb_ltrim(basename($user_avatar_category), "'") . '/' . phpbb_ltrim(basename($user_avatar_local), "'")) . "', user_avatar_type = " . USER_AVATAR_GALLERY;
		}

		// find the birthday values, reflected by the $lang['Submit_date_format']
		if ($b_day || $b_md || $b_year) //if a birthday is submited, then validate it
		{
			$user_age=(date('md')>=$b_md.(($b_day <= 9) ? '0':'').$b_day) ? date('Y') - $b_year : date('Y') - $b_year - 1 ;
			// Check date, maximum / minimum user age
			if (!checkdate($b_md,$b_day,$b_year))
			{
				$error = TRUE;
				if( isset($error_msg) )$error_msg .= "<br />";
				$error_msg .= $lang['Wrong_birthday_format'];
			} else
			if ($user_age>$board_config['max_user_age'])
			{
				$error = TRUE;
				if( isset($error_msg) )$error_msg .= "<br />";
				$error_msg .= sprintf($lang['Birthday_to_high'],$board_config['max_user_age']);
			} else
			if ($user_age<$board_config['min_user_age'])
			{
				$error = TRUE;
				if( isset($error_msg) )$error_msg .= "<br />";
				$error_msg .= sprintf($lang['Birthday_to_low'],$board_config['min_user_age']);
			} else
			{
				$birthday = ($error) ? $birthday : mkrealdate($b_day,$b_md,$b_year);
			}
		} else $birthday = ($error) ? '' : 999999;

		//
		// Update entry in DB
		//
		if( !$error )
		{
//
// Start System Specs MOD
//
				if ($board_config['system_specs_enable'] == '1')
				{
					$sql = "UPDATE " . USERS_TABLE . "
						SET user_computer_name = '" . str_replace("\'", "''", $computer_name) . "', user_system_enclosure = '" . str_replace("\'", "''", $system_enclosure) . "', user_system_motherboard = '" . str_replace("\'", "''", $system_motherboard) . "', user_processor_brand = '" . str_replace("\'", "''", $processor_brand) . "', user_processor_desc = '" . str_replace("\'", "''", $processor_desc) . "', user_memory_amt = '" . str_replace("\'", "''", $memory_amt) . "', user_memory_details = '" . str_replace("\'", "''", $memory_details) . "', user_vid_brand = '" . str_replace("\'", "''", $vid_brand) . "', user_vid_desc = '" . str_replace("\'", "''", $vid_desc) . "', user_storage_details = '" . str_replace("\'", "''", $storage_details) . "', user_audio_details = '" . str_replace("\'", "''", $audio_details) . "', user_system_cooling = '" . str_replace("\'", "''", $system_cooling) . "', user_system_monitor = '" . str_replace("\'", "''", $system_monitor) . "', user_system_os = '" . str_replace("\'", "''", $system_os) . "', user_favorite_game = '" . str_replace("\'", "''", $favorite_game) . "', user_threedmark = '" . str_replace("\'", "''", $threedmark) . "', user_futuremark = '" . str_replace("\'", "''", $futuremark) . "', user_cpu_dhry = '" . str_replace("\'", "''", $cpu_dhry) . "', user_cpu_whet = '" . str_replace("\'", "''", $cpu_whet) . "', user_cpu_integer = '" . str_replace("\'", "''", $cpu_integer) . "', user_cpu_floating = '" . str_replace("\'", "''", $cpu_floating) . "', user_ram_integer = '" . str_replace("\'", "''", $ram_integer) . "', user_ram_floating = '" . str_replace("\'", "''", $ram_floating) . "', user_drive_idx = '" . str_replace("\'", "''", $drive_idx) . "'
						WHERE user_id = $user_id";
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql);
					}
					$sql = "SELECT user_id, user_threedmark, user_futuremark, user_cpu_dhry, user_cpu_whet, user_cpu_integer, user_cpu_floating,	user_ram_integer, user_ram_floating, user_drive_idx, user_total_idx
					FROM " . USERS_TABLE . "
					WHERE user_id = $user_id";
					if( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
					}
					if ( $row = $db->sql_fetchrow($result) )
					{
						$i = 0;
						do
						{
							$user_id = $row['user_id'];
							$threedmark = $row['user_threedmark'];
							$futuremark = $row['user_futuremark'];
							$cpu_dhry = $row['user_cpu_dhry'];
							$cpu_whet = $row['user_cpu_whet'];
							$cpu_integer = $row['user_cpu_integer'];
							$cpu_floating = $row['user_cpu_floating'];
							$ram_integer = $row['user_ram_integer'];
							$ram_floating = $row['user_ram_floating'];
							$drive_idx = $row['user_drive_idx'];
							$total_idx_score = '';
							$total_idx_score = ((($threedmark * 1.2) + ($futuremark * 6.5) * .5) + (($cpu_dhry * 1.7) + ($cpu_whet * 4.3) + ($cpu_integer * 1.1) + ($cpu_floating * 1.1) * .25) + (($ram_integer * 5.4) + ($ram_floating * 5.8) * .5) + ($drive_idx * .25)) * .015;

							$i++;
						}
						while ( $row = $db->sql_fetchrow($result) );
					}
					$sql = "UPDATE " . USERS_TABLE . "
						SET user_total_idx = '$total_idx_score'
						WHERE user_id = $user_id";
					if ( !($result = $db->sql_query($sql)) )
					{
						message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql);
					}
				}
//
// Finish System Specs MOD
//

			$sql = "UPDATE " . USERS_TABLE . "
				SET " . $username_sql . $passwd_sql . "user_email = '" . str_replace("\'", "''", $email) . "', user_icq = '" . str_replace("\'", "''", $icq) . "', user_website = '" . str_replace("\'", "''", $website) . "', user_occ = '" . str_replace("\'", "''", $occupation) . "', user_from = '" . str_replace("\'", "''", $location) . "', user_from_flag = '$user_flag', user_interests = '" . str_replace("\'", "''", $interests) . "', user_response = '" . str_replace("\'", "''", $auto_response) . "', user_response_bbcode_uid = '$auto_response_bbcode_uid', user_response_on = $auto_response_on, user_allow_response = $allow_response, user_custom_title = '" . str_replace("\'", "''", $custom_title) . "', user_custom_title_status = $custom_title_status, user_birthday='$birthday', user_next_birthday_greeting=$next_birthday_greeting, user_sig = '" . str_replace("\'", "''", $signature) . "', user_viewemail = $viewemail, user_aim = '" . str_replace("\'", "''", $aim) . "', user_yim = '" . str_replace("\'", "''", $yim) . "', user_msnm = '" . str_replace("\'", "''", $msn) . "', user_attachsig = $attachsig, user_sig_bbcode_uid = '$signature_bbcode_uid', user_allowsmile = $allowsmilies, user_allowhtml = $allowhtml, user_allowavatar = $user_allowavatar, user_allowbbcode = $allowbbcode, user_allow_viewonline = $allowviewonline, user_notify = $notifyreply, user_allow_pm = $user_allowpm, user_notify_pm = $notifypm, user_popup_pm = $popuppm, user_lang = '" . str_replace("\'", "''", $user_lang) . "', user_style = $user_style, user_timezone = $user_timezone, user_dateformat = '" . str_replace("\'", "''", $user_dateformat) . "', user_active = $user_status, user_rank = $user_rank, user_gender = '$gender', user_vacances = '$vacances' " . $avatar_sql . ", user_infotext = '" . str_replace("\'", "''", $infotext) . "', user_notify_mod=$notifymod
				WHERE user_id = $user_id";

			if( $result = $db->sql_query($sql) )
			{
				if( isset($rename_user) )
				{
					$sql = "UPDATE " . GROUPS_TABLE . "
						SET group_name = '".str_replace("\'", "''", $rename_user)."'
						WHERE group_name = '".str_replace("'", "''", $this_userdata['username'] )."'";
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, 'Could not rename users group', '', __LINE__, __FILE__, $sql);
					}
				}

				// Delete user session, to prevent the user navigating the forum (if logged in) when disabled
				if (!$user_status)
				{
					$sql = "DELETE FROM " . SESSIONS_TABLE . "
						WHERE session_user_id = " . $user_id;

					if ( !$db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, 'Error removing user session', '', __LINE__, __FILE__, $sql);
					}
				}

				// We remove all stored login keys since the password has been updated
				// and change the current one (if applicable)
				if ( !empty($passwd_sql) )
				{
					session_reset_keys($user_id, $user_ip);
				}
				
				$message .= $lang['Admin_user_updated'];
			}
			else
			{
				message_die(GENERAL_ERROR, 'Admin_user_fail', '', __LINE__, __FILE__, $sql);
			}

			$message .= '<br /><br />' . sprintf($lang['Click_return_useradmin'], '<a href="' . append_sid("admin_users.$phpEx") . '">', '</a>') . '<br /><br />' . sprintf($lang['Click_return_admin_index'], '<a href="' . append_sid("index.$phpEx?pane=right") . '">', '</a>');

			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			$template->set_filenames(array(
				'reg_header' => 'error_body.tpl')
			);

			$template->assign_vars(array(
				'ERROR_MESSAGE' => $error_msg)
			);

			$template->assign_var_from_handle('ERROR_BOX', 'reg_header');

			$username = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($username)));
			$email = stripslashes($email);
			$password = '';
			$password_confirm = '';

			$icq = stripslashes($icq);
			$aim = htmlspecialchars(str_replace('+', ' ', stripslashes($aim)));
			$msn = htmlspecialchars(stripslashes($msn));
			$yim = htmlspecialchars(stripslashes($yim));

			$website = htmlspecialchars(stripslashes($website));
			$location = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($location)));
			$occupation = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($occupation)));
			$interests = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($interests)));
			$custom_title = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($custom_title)));
			$auto_response = htmlspecialchars(stripslashes($auto_response));
//
// Start System Specs MOD
//
			$computer_name = htmlspecialchars(stripslashes($computer_name));
			$system_enclosure = htmlspecialchars(stripslashes($system_enclosure));
			$system_motherboard = htmlspecialchars(stripslashes($system_motherboard));
			$processor_brand = htmlspecialchars(stripslashes($processor_brand));
			$processor_desc = htmlspecialchars(stripslashes($processor_desc));
			$memory_amt = htmlspecialchars(stripslashes($memory_amt));
			$memory_details = htmlspecialchars(stripslashes($memory_details));
			$vid_brand = htmlspecialchars(stripslashes($vid_brand));
			$vid_desc = htmlspecialchars(stripslashes($vid_desc));
			$storage_details = htmlspecialchars(stripslashes($storage_details));
			$audio_details = htmlspecialchars(stripslashes($audio_details));
			$system_cooling = htmlspecialchars(stripslashes($system_cooling));
			$system_os = htmlspecialchars(stripslashes($system_os));
			$system_monitor = htmlspecialchars(stripslashes($system_monitor));
			$favorite_game = htmlspecialchars(stripslashes($favorite_game));
			$threedmark = htmlspecialchars(stripslashes($threedmark));
			$futuremark = htmlspecialchars(stripslashes($futuremark));
			$cpu_dhry = htmlspecialchars(stripslashes($cpu_dhry));
			$cpu_whet = htmlspecialchars(stripslashes($cpu_whet));
			$cpu_integer = htmlspecialchars(stripslashes($cpu_integer));
			$cpu_floating = htmlspecialchars(stripslashes($cpu_floating));
			$ram_integer = htmlspecialchars(stripslashes($ram_integer));
			$ram_floating = htmlspecialchars(stripslashes($ram_floating));
			$drive_idx = htmlspecialchars(stripslashes($drive_idx));
//
// Finish System Specs MOD
//
			$signature = ereg_replace("&amp;","&",htmlspecialchars(stripslashes($signature)));
			$infotext = htmlspecialchars(stripslashes($infotext));

			$user_lang = stripslashes($user_lang);
			$user_dateformat = htmlspecialchars(stripslashes($user_dateformat));
		}
	}
	else if( !isset( $HTTP_POST_VARS['submit'] ) && $mode != 'save' && !isset( $HTTP_POST_VARS['avatargallery'] ) && !isset( $HTTP_POST_VARS['submitavatar'] ) && !isset( $HTTP_POST_VARS['cancelavatar'] ) )
	{
		if( isset( $HTTP_GET_VARS[POST_USERS_URL]) || isset( $HTTP_POST_VARS[POST_USERS_URL]) )
		{
			$user_id = ( isset( $HTTP_POST_VARS[POST_USERS_URL]) ) ? intval( $HTTP_POST_VARS[POST_USERS_URL]) : intval( $HTTP_GET_VARS[POST_USERS_URL]);
			$this_userdata = get_userdata($user_id);
			if( !$this_userdata )
			{
				message_die(GENERAL_MESSAGE, $lang['No_user_id_specified'] );
			}
		}
		else
		{
			$this_userdata = get_userdata($HTTP_POST_VARS['username'], true);
			if( !$this_userdata )
			{
				message_die(GENERAL_MESSAGE, $lang['No_user_id_specified'] );
			}
		}

		//
		// Now parse and display it as a template
		//
		$user_id = $this_userdata['user_id'];
		$username = $this_userdata['username'];
		$email = $this_userdata['user_email'];
		$password = '';
		$password_confirm = '';

		$icq = $this_userdata['user_icq'];
		$aim = htmlspecialchars(str_replace('+', ' ', $this_userdata['user_aim'] ));
		$msn = htmlspecialchars($this_userdata['user_msnm']);
		$yim = htmlspecialchars($this_userdata['user_yim']);

		$website = htmlspecialchars($this_userdata['user_website']);
		$location = ereg_replace("&amp;","&",htmlspecialchars($this_userdata['user_from']));
		// FLAGHACK-start
		$user_flag = $this_userdata['user_from_flag'];
		// FLAGHACK-end
		$occupation = ereg_replace("&amp;","&",htmlspecialchars($this_userdata['user_occ']));
		$interests = ereg_replace("&amp;","&",htmlspecialchars($this_userdata['user_interests']));
		$vacances = $this_userdata['user_vacances'];
		$custom_title = ereg_replace("&amp;","&",htmlspecialchars($this_userdata['user_custom_title']));
		$custom_title_status = $this_userdata['user_custom_title_status'];
		$auto_response = ($this_userdata['user_response_bbcode_uid'] != '') ? preg_replace('#:' . $this_userdata['user_response_bbcode_uid'] . '#si', '', $this_userdata['user_response']) : $this_userdata['user_response'];
		$auto_response = preg_replace($html_entities_match, $html_entities_replace, $auto_response);
		$auto_response_on = $this_userdata['user_response_on'];
		$allow_response = $this_userdata['user_allow_response'];
		include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);
		if ( $board_config['allow_bbcode'] )
		{
			if ( $userdata['user_response_bbcode_uid'] != '' )
			{
				$current_response = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($userdata['user_response'], $userdata['user_response_bbcode_uid']) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $userdata['user_response']);
			}
		}
		$board_config['smilies_path'] = '../images/smiles';
		$current_response = smilies_pass($current_response);
		$current_response = make_clickable($current_response);
		$current_response = str_replace("\n", "\n<br />\n", $current_response);
//
// Start System Specs MOD
//
		$computer_name = htmlspecialchars($this_userdata['user_computer_name']);
		$system_enclosure = htmlspecialchars($this_userdata['user_system_enclosure']);
		$system_motherboard = htmlspecialchars($this_userdata['user_system_motherboard']);
		$processor_brand = htmlspecialchars($this_userdata['user_processor_brand']);
		$processor_desc = htmlspecialchars($this_userdata['user_processor_desc']);
		$memory_amt = htmlspecialchars($this_userdata['user_memory_amt']);
		$memory_details = htmlspecialchars($this_userdata['user_memory_details']);
		$vid_brand = htmlspecialchars($this_userdata['user_vid_brand']);
		$vid_desc = htmlspecialchars($this_userdata['user_vid_desc']);
		$storage_details = htmlspecialchars($this_userdata['user_storage_details']);
		$audio_details = htmlspecialchars($this_userdata['user_audio_details']);
		$system_cooling = htmlspecialchars($this_userdata['user_system_cooling']);
		$system_os = htmlspecialchars($this_userdata['user_system_os']);
		$system_monitor = htmlspecialchars($this_userdata['user_system_monitor']);
		$favorite_game = htmlspecialchars($this_userdata['user_favorite_game']);
		$threedmark = htmlspecialchars($this_userdata['user_threedmark']);
		$futuremark = htmlspecialchars($this_userdata['user_futuremark']);
		$cpu_dhry = htmlspecialchars($this_userdata['user_cpu_dhry']);
		$cpu_whet = htmlspecialchars($this_userdata['user_cpu_whet']);
		$cpu_integer = htmlspecialchars($this_userdata['user_cpu_integer']);
		$cpu_floating = htmlspecialchars($this_userdata['user_cpu_floating']);
		$ram_integer = htmlspecialchars($this_userdata['user_ram_integer']);
		$ram_floating = htmlspecialchars($this_userdata['user_ram_floating']);
		$drive_idx = htmlspecialchars($this_userdata['user_drive_idx']);
		$total_idx_score = ((($this_userdata['user_threedmark'] * 1.2) + ($this_userdata['user_futuremark'] * 6.5) * .5) + (($this_userdata['user_cpu_dhry'] * 1.7) + ($this_userdata['user_cpu_whet'] * 4.3) + ($this_userdata['user_cpu_integer'] * 1.1) + ($this_userdata['user_cpu_floating'] * 1.1) * .25) + (($this_userdata['user_ram_integer'] * 5.4) + ($this_userdata['user_ram_floating'] * 5.8) * .5) + ($this_userdata['user_drive_idx'] * .25)) * .015;
//
// Finish System Specs MOD
//
		$next_birthday_greeting = $this_userdata['user_next_birthday_greeting'];
		if ($this_userdata['user_birthday']!=999999)
		{
			$birthday = realdate($lang['Submit_date_format'],$this_userdata['user_birthday']);
			$b_day = realdate('j',$this_userdata['user_birthday']);
			$b_md = realdate('n',$this_userdata['user_birthday']);
			$b_year = realdate('Y',$this_userdata['user_birthday']);
		} else
		{
			$b_day = '';
			$b_md = '';
			$b_year = '';
			$birthday = '';
		}
		$gender = $this_userdata['user_gender'];

		//$signature = ($this_userdata['user_sig_bbcode_uid'] != '') ? preg_replace('#:' . $this_userdata['user_sig_bbcode_uid'] . '#si', '', $this_userdata['user_sig']) : $this_userdata['user_sig'];
		//new code
		$signature_bbcode_uid = $this_userdata['user_sig_bbcode_uid'];
		$signature = ($signature_bbcode_uid != '') ? preg_replace("/:(([a-z0-9]+:)?)$signature_bbcode_uid(=|\])/si", '\\3', $this_userdata['user_sig']) : $this_userdata['user_sig'];
		//new code
		$signature = preg_replace($html_entities_match, $html_entities_replace, $signature);
		$infotext = $this_userdata['user_infotext'];

		$viewemail = $this_userdata['user_viewemail'];
		$notifypm = $this_userdata['user_notify_pm'];
		$popuppm = $this_userdata['user_popup_pm'];
		$notifyreply = $this_userdata['user_notify'];
		$attachsig = $this_userdata['user_attachsig'];
		$allowhtml = $this_userdata['user_allowhtml'];
		$allowbbcode = $this_userdata['user_allowbbcode'];
		$allowsmilies = $this_userdata['user_allowsmile'];
		$allowviewonline = $this_userdata['user_allow_viewonline'];
		// MOD NOTIFY MOD BEGIN
		$notifymod = $this_userdata['user_notify_mod'];
		// MOD NOTIFY MOD END

		$user_avatar = $this_userdata['user_avatar'];
		$user_avatar_type = $this_userdata['user_avatar_type'];
		$user_style = $this_userdata['user_style'];
		$user_lang = $this_userdata['user_lang'];
		$user_timezone = $this_userdata['user_timezone'];
		$user_dateformat = htmlspecialchars($this_userdata['user_dateformat']);

		$user_status = $this_userdata['user_active'];
		$user_allowavatar = $this_userdata['user_allowavatar'];
		$user_allowpm = $this_userdata['user_allow_pm'];

		$COPPA = false;

		$html_status =  ($this_userdata['user_allowhtml'] ) ? $lang['HTML_is_ON'] : $lang['HTML_is_OFF'];
		$bbcode_status = ($this_userdata['user_allowbbcode'] ) ? $lang['BBCode_is_ON'] : $lang['BBCode_is_OFF'];
		$smilies_status = ($this_userdata['user_allowsmile'] ) ? $lang['Smilies_are_ON'] : $lang['Smilies_are_OFF'];
	}

	if( isset($HTTP_POST_VARS['avatargallery']) && !$error )
	{
		if( !$error )
		{
			$user_id = intval($HTTP_POST_VARS['id']);

			$template->set_filenames(array(
				"body" => "admin/user_avatar_gallery.tpl")
			);

			$dir = @opendir("../" . $board_config['avatar_gallery_path']);

			$avatar_images = array();
			while( $file = @readdir($dir) )
			{
				if( $file != "." && $file != ".." && !is_file(phpbb_realpath("./../" . $board_config['avatar_gallery_path'] . "/" . $file)) && !is_link(phpbb_realpath("./../" . $board_config['avatar_gallery_path'] . "/" . $file)) )
				{
					$sub_dir = @opendir("../" . $board_config['avatar_gallery_path'] . "/" . $file);

					$avatar_row_count = 0;
					$avatar_col_count = 0;

					while( $sub_file = @readdir($sub_dir) )
					{
						if( preg_match("/(\.gif$|\.png$|\.jpg)$/is", $sub_file) )
						{
							$avatar_images[$file][$avatar_row_count][$avatar_col_count] = $sub_file;

							$avatar_col_count++;
							if( $avatar_col_count == 5 )
							{
								$avatar_row_count++;
								$avatar_col_count = 0;
							}
						}
					}
				}
			}

			@closedir($dir);

			if( isset($HTTP_POST_VARS['avatarcategory']) )
			{
				$category = htmlspecialchars($HTTP_POST_VARS['avatarcategory']);
			}
			else
			{
				list($category, ) = each($avatar_images);
			}
			@reset($avatar_images);

			$s_categories = "";
			while( list($key) = each($avatar_images) )
			{
				$selected = ( $key == $category ) ? "selected=\"selected\"" : "";
				if( count($avatar_images[$key]) )
				{
					$s_categories .= '<option value="' . $key . '"' . $selected . '>' . ucfirst($key) . '</option>';
				}
			}

			$s_colspan = 0;
			for($i = 0; $i < count($avatar_images[$category]); $i++)
			{
				$template->assign_block_vars("avatar_row", array());

				$s_colspan = max($s_colspan, count($avatar_images[$category][$i]));

				for($j = 0; $j < count($avatar_images[$category][$i]); $j++)
				{
					$template->assign_block_vars("avatar_row.avatar_column", array(
						"AVATAR_IMAGE" => "../" . $board_config['avatar_gallery_path'] . '/' . $category . '/' . $avatar_images[$category][$i][$j])
					);

					$template->assign_block_vars("avatar_row.avatar_option_column", array(
						"S_OPTIONS_AVATAR" => $avatar_images[$category][$i][$j])
					);
				}
			}

			$coppa = ( ( !$HTTP_POST_VARS['coppa'] && !$HTTP_GET_VARS['coppa'] ) || $mode == "register") ? 0 : TRUE;

			$s_hidden_fields = '<input type="hidden" name="mode" value="edit" /><input type="hidden" name="agreed" value="true" /><input type="hidden" name="coppa" value="' . $coppa . '" /><input type="hidden" name="avatarcatname" value="' . $category . '" />';
			$s_hidden_fields .= '<input type="hidden" name="id" value="' . $user_id . '" />';

			$s_hidden_fields .= '<input type="hidden" name="username" value="' . str_replace("\"", "&quot;", $username) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="email" value="' . str_replace("\"", "&quot;", $email) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="icq" value="' . str_replace("\"", "&quot;", $icq) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="aim" value="' . str_replace("\"", "&quot;", $aim) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="msn" value="' . str_replace("\"", "&quot;", $msn) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="yim" value="' . str_replace("\"", "&quot;", $yim) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="website" value="' . str_replace("\"", "&quot;", $website) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="location" value="' . str_replace("\"", "&quot;", $location) . '" />';
// FLAGHACK-start
			$s_hidden_fields .= '<input type="hidden" name="user_flag" value="' . $user_flag . '" />';
// FLAGHACK-end
			$s_hidden_fields .= '<input type="hidden" name="occupation" value="' . str_replace("\"", "&quot;", $occupation) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="interests" value="' . str_replace("\"", "&quot;", $interests) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="custom_title" value="' . str_replace("\"", "&quot;", $custom_title) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="custom_title_status"  value="' . $custom_title_status .'" />';
			$s_hidden_fields .= '<input type="hidden" name="auto_response" value="' . str_replace("\"", "&quot;", $auto_response) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="auto_response_on" value="' . $auto_response_on . '" />';
			$s_hidden_fields .= '<input type="hidden" name="allow_response" value="' . $allow_response . '" />';
//
// Start System Specs MOD
//
			$s_hidden_fields .= '<input type="hidden" name="computer_name" value="' . str_replace("\"", "&quot;", $computer_name) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="system_enclosure" value="' . str_replace("\"", "&quot;", $system_enclosure) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="system_motherboard" value="' . str_replace("\"", "&quot;", $system_motherboard) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="processor_brand" value="' . str_replace("\"", "&quot;", $processor_brand) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="processor_desc" value="' . str_replace("\"", "&quot;", $processor_desc) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="memory_amt" value="' . str_replace("\"", "&quot;", $memory_amt) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="memory_details" value="' . str_replace("\"", "&quot;", $memory_details) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="vid_brand" value="' . str_replace("\"", "&quot;", $vid_brand) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="vid_desc" value="' . str_replace("\"", "&quot;", $vid_desc) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="storage_details" value="' . str_replace("\"", "&quot;", $storage_details) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="audio_details" value="' . str_replace("\"", "&quot;", $audio_details) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="system_cooling" value="' . str_replace("\"", "&quot;", $system_cooling) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="system_os" value="' . str_replace("\"", "&quot;", $system_os) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="system_monitor" value="' . str_replace("\"", "&quot;", $system_monitor) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="favorite_game" value="' . str_replace("\"", "&quot;", $favorite_game) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="threedmark" value="' . str_replace("\"", "&quot;", $threedmark) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="futuremark" value="' . str_replace("\"", "&quot;", $futuremark) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="cpu_dhry" value="' . str_replace("\"", "&quot;", $cpu_dhry) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="cpu_whet" value="' . str_replace("\"", "&quot;", $cpu_whet) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="cpu_integer" value="' . str_replace("\"", "&quot;", $cpu_integer) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="cpu_floating" value="' . str_replace("\"", "&quot;", $cpu_floating) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="ram_integer" value="' . str_replace("\"", "&quot;", $ram_integer) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="ram_floating" value="' . str_replace("\"", "&quot;", $ram_floating) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="drive_idx" value="' . str_replace("\"", "&quot;", $drive_idx) . '" />';
//
// Finish System Specs MOD
//
			$s_hidden_fields .= '<input type="hidden" name="birthday" value="'.$birthday.'" />';
			$s_hidden_fields .= '<input type="hidden" name="next_birthday_greeting" value="'.$next_birthday_greeting.'" />';
			$s_hidden_fields .= '<input type="hidden" name="signature" value="' . str_replace("\"", "&quot;", $signature) . '" />';
			$s_hidden_fields .= '<input type="hidden" name="infotext" value="' . str_replace("\"", "&quot;", $infotext) . '" />';
			// MOD NOTIFY MOD BEGIN
			$s_hidden_fields .= '<input type="hidden" name="notifymod" value="' . $notifymod . '" />';
			// MOD NOTIFY MOD END
			$s_hidden_fields .= '<input type="hidden" name="viewemail" value="' . $viewemail . '" />';
			$s_hidden_fields .= '<input type="hidden" name="vacances" value="' . $vacances . '" />';
			$s_hidden_fields .= '<input type="hidden" name="gender" value="' . $gender . '" />';
			$s_hidden_fields .= '<input type="hidden" name="notifypm" value="' . $notifypm . '" />';
			$s_hidden_fields .= '<input type="hidden" name="popup_pm" value="' . $popuppm . '" />';
			$s_hidden_fields .= '<input type="hidden" name="notifyreply" value="' . $notifyreply . '" />';
			$s_hidden_fields .= '<input type="hidden" name="attachsig" value="' . $attachsig . '" />';
			$s_hidden_fields .= '<input type="hidden" name="allowhtml" value="' . $allowhtml . '" />';
			$s_hidden_fields .= '<input type="hidden" name="allowbbcode" value="' . $allowbbcode . '" />';
			$s_hidden_fields .= '<input type="hidden" name="allowsmilies" value="' . $allowsmilies . '" />';
			$s_hidden_fields .= '<input type="hidden" name="hideonline" value="' . !$allowviewonline . '" />';
			$s_hidden_fields .= '<input type="hidden" name="style" value="' . $user_style . '" />';
			$s_hidden_fields .= '<input type="hidden" name="language" value="' . $user_lang . '" />';
			$s_hidden_fields .= '<input type="hidden" name="timezone" value="' . $user_timezone . '" />';
			$s_hidden_fields .= '<input type="hidden" name="dateformat" value="' . str_replace("\"", "&quot;", $user_dateformat) . '" />';

			$s_hidden_fields .= '<input type="hidden" name="user_status" value="' . $user_status . '" />';
			$s_hidden_fields .= '<input type="hidden" name="user_allowpm" value="' . $user_allowpm . '" />';
			$s_hidden_fields .= '<input type="hidden" name="user_allowavatar" value="' . $user_allowavatar . '" />';
			$s_hidden_fields .= '<input type="hidden" name="user_rank" value="' . $user_rank . '" />';

			$template->assign_vars(array(
				"L_USER_TITLE" => $lang['User_admin'],
				"L_USER_EXPLAIN" => $lang['User_admin_explain'],
				"L_AVATAR_GALLERY" => $lang['Avatar_gallery'],
				"L_SELECT_AVATAR" => $lang['Select_avatar'],
				"L_RETURN_PROFILE" => $lang['Return_profile'],
				"L_CATEGORY" => $lang['Select_category'],
				"L_GO" => $lang['Go'],

				"S_OPTIONS_CATEGORIES" => $s_categories,
				"S_COLSPAN" => $s_colspan,
				"S_PROFILE_ACTION" => append_sid("admin_users.$phpEx?mode=$mode"),
				"S_HIDDEN_FIELDS" => $s_hidden_fields)
			);
		}
	}
	else
	{
		$s_hidden_fields = '<input type="hidden" name="mode" value="save" /><input type="hidden" name="agreed" value="true" /><input type="hidden" name="coppa" value="' . $coppa . '" />';
		$s_hidden_fields .= '<input type="hidden" name="id" value="' . $this_userdata['user_id'] . '" />';

		if( !empty($user_avatar_local) )
		{
			$s_hidden_fields .= '<input type="hidden" name="avatarlocal" value="' . $user_avatar_local . '" /><input type="hidden" name="avatarcatname" value="' . $user_avatar_category . '" />';
		}

		if( $user_avatar_type )
		{
			switch( $user_avatar_type )
			{
				case USER_AVATAR_UPLOAD:
					$avatar = '<img src="../' . $board_config['avatar_path'] . '/' . $user_avatar . '" alt="" />';
					break;
				case USER_AVATAR_REMOTE:
					$avatar = '<img src="' . $user_avatar . '" alt="" />';
					break;
				case USER_AVATAR_GALLERY:
					$avatar = '<img src="../' . $board_config['avatar_gallery_path'] . '/' . $user_avatar . '" alt="" />';
					break;
			}
		}
		else
		{
			$avatar = "";
		}

		$sql = "SELECT * FROM " . RANKS_TABLE . "
			WHERE rank_special = 1
			ORDER BY rank_title";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not obtain ranks data', '', __LINE__, __FILE__, $sql);
		}

		$rank_select_box = '<option value="0">' . $lang['No_assigned_rank'] . '</option>';
		while( $row = $db->sql_fetchrow($result) )
		{
			$rank = $row['rank_title'];
			$rank_id = $row['rank_id'];

			$selected = ( $this_userdata['user_rank'] == $rank_id ) ? ' selected="selected"' : '';
			$rank_select_box .= '<option value="' . $rank_id . '"' . $selected . '>' . $rank . '</option>';
		}

		$template->set_filenames(array(
			"body" => "admin/user_edit_body.tpl")
		);
		switch ($custom_title_status)
		{
			case CUSTOM_TITLE_REGDATE: $custom_title_status_regdate = "checked=\"checked\"";break;
			case CUSTOM_TITLE_DISABLED: $custom_title_status_disabled = "checked=\"checked\"";break;
			case CUSTOM_TITLE_ENABLED: $custom_title_status_enabled = "checked=\"checked\"";break;
		}

		$s_b_day = $lang['Day'].'&nbsp;<select name="b_day" size="1" class="gensmall" size="1">
		<option value="0">&nbsp;-&nbsp;</option>
		<option value="1">&nbsp;1&nbsp;</option>
		<option value="2">&nbsp;2&nbsp;</option>
		<option value="3">&nbsp;3&nbsp;</option>
		<option value="4">&nbsp;4&nbsp;</option>
		<option value="5">&nbsp;5&nbsp;</option>
		<option value="6">&nbsp;6&nbsp;</option>
		<option value="7">&nbsp;7&nbsp;</option>
		<option value="8">&nbsp;8&nbsp;</option>
		<option value="9">&nbsp;9&nbsp;</option>
		<option value="10">&nbsp;10&nbsp;</option>
		<option value="11">&nbsp;11&nbsp;</option>
		<option value="12">&nbsp;12&nbsp;</option>
		<option value="13">&nbsp;13&nbsp;</option>
		<option value="14">&nbsp;14&nbsp;</option>
		<option value="15">&nbsp;15&nbsp;</option>
		<option value="16">&nbsp;16&nbsp;</option>
		<option value="17">&nbsp;17&nbsp;</option>
		<option value="18">&nbsp;18&nbsp;</option>
		<option value="19">&nbsp;19&nbsp;</option>
		<option value="20">&nbsp;20&nbsp;</option>
		<option value="21">&nbsp;21&nbsp;</option>
		<option value="22">&nbsp;22&nbsp;</option>
		<option value="23">&nbsp;23&nbsp;</option>
		<option value="24">&nbsp;24&nbsp;</option>
		<option value="25">&nbsp;25&nbsp;</option>
		<option value="26">&nbsp;26&nbsp;</option>
		<option value="27">&nbsp;27&nbsp;</option>
		<option value="28">&nbsp;28&nbsp;</option>
		<option value="29">&nbsp;29&nbsp;</option>
		<option value="30">&nbsp;30&nbsp;</option>
		<option value="31">&nbsp;31&nbsp;</option>
		</select>&nbsp;&nbsp;';
		$s_b_md = $lang['Month'].'&nbsp;<select name="b_md" size="1" class="gensmall" size="1"}">
		<option value="0">&nbsp;-&nbsp;</option>
		<option value="1">&nbsp;'.$lang['datetime']['January'].'&nbsp;</option>
		<option value="2">&nbsp;'.$lang['datetime']['February'].'&nbsp;</option>
		<option value="3">&nbsp;'.$lang['datetime']['March'].'&nbsp;</option>
		<option value="4">&nbsp;'.$lang['datetime']['April'].'&nbsp;</option>
		<option value="5">&nbsp;'.$lang['datetime']['May'].'&nbsp;</option>
		<option value="6">&nbsp;'.$lang['datetime']['June'].'&nbsp;</option>
		<option value="7">&nbsp;'.$lang['datetime']['July'].'&nbsp;</option>
		<option value="8">&nbsp;'.$lang['datetime']['August'].'&nbsp;</option>
		<option value="9">&nbsp;'.$lang['datetime']['September'].'&nbsp;</option>
		<option value="10">&nbsp;'.$lang['datetime']['October'].'&nbsp;</option>
		<option value="11">&nbsp;'.$lang['datetime']['November'].'&nbsp;</option>
		<option value="12">&nbsp;'.$lang['datetime']['December'].'&nbsp;</option>
		</select>&nbsp;&nbsp;';
		$s_b_day= str_replace("value=\"".$b_day."\">", "value=\"".$b_day."\" SELECTED>" ,$s_b_day);
		$s_b_md = str_replace("value=\"".$b_md."\">", "value=\"".$b_md."\" SELECTED>" ,$s_b_md);
		$s_b_year = $lang['Year'].'&nbsp;<input type="text" class="post"style="width: 80px"  name="b_year" size="4" maxlength="4" value="'.$b_year.'" />&nbsp;&nbsp; ';
		$i=0;
		$s_birthday='';
		for ($i=0;$i<=strlen($lang['Submit_date_format']);$i++)
		{
			switch ($lang['Submit_date_format'][$i])
			{
				case d:  $s_birthday .=$s_b_day;break;
				case m:  $s_birthday .=$s_b_md;break;
				case Y:  $s_birthday .=$s_b_year;break;
			}
		}

		switch ($gender)
		{
			case 1: $gender_male_checked="checked=\"checked\"";break;
			case 2: $gender_female_checked="checked=\"checked\"";break;
			default:$gender_no_specify_checked="checked=\"checked\"";
		}

		if ($this_userdata['user_blocktime']<time() )
		{
			$template->assign_vars(array(
				'BLOCK_BY' => ($this_userdata['user_block_by']) ? sprintf($lang['Last_block_by'],decode_ip($this_userdata['user_block_by'])).'<br/>' : '',
				'BLOCK' => '<br/><input type="checkbox" name="block_account">'.sprintf ($lang['Block_user'],$board_config['block_time']) ));
		} else
		{
			$template->assign_vars(array(
				'BLOCK_UNTIL' => sprintf($lang['Block_until'], create_date($board_config['default_dateformat'], $this_userdata['user_blocktime'], $board_config['board_timezone']) ).'<br/>',
				'BLOCK_BY' => ($this_userdata['user_block_by']) ? sprintf($lang['Block_by'],decode_ip($this_userdata['user_block_by'])).'<br/>' : '',
				'BLOCK' => '<br/><input type="checkbox" name="unblock_account">'.$lang['Unblock_user'] )).'<br/>';
		}

		switch ($vacances)
		{
			case 1: $vacances_oui_checked="checked=\"checked\"";break;
			case 2: $vacances_non_checked="checked=\"checked\"";break;
			default:$vacances_no_specify_checked="checked=\"checked\"";
		}

		//
		// Let's do an overall check for settings/versions which would prevent
		// us from doing file uploads....
		//
		$ini_val = ( phpversion() >= '4.0.0' ) ? 'ini_get' : 'get_cfg_var';
		$form_enctype = ( !@$ini_val('file_uploads') || phpversion() == '4.0.4pl1' || !$board_config['allow_avatar_upload'] || ( phpversion() < '4.0.3' && @$ini_val('open_basedir') != '' ) ) ? '' : 'enctype="multipart/form-data"';

		// FLAGHACK-start
		// query to get the list of flags
		$sql = "SELECT *
			FROM " . FLAG_TABLE . "
			ORDER BY flag_id";
		if(!$flags_result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Couldn't obtain flags information.", "", __LINE__, __FILE__, $sql);
		}
		$flag_row = $db->sql_fetchrowset($ranksresult);
		$num_flags = $db->sql_numrows($ranksresult) ;

		// build the html select statement
		$flag_start_image = 'blank.gif' ;
		$selected = ( isset($user_flag) ) ? '' : ' selected="selected"'  ;
		$flag_select = "<select name=\"user_flag\" onChange=\"document.images['user_flag'].src = '../images/flags/' + this.value;\" >";
		$flag_select .= "<option value=\"blank.gif\"$selected>" . $lang['Select_Country'] . "</option>";
		for ($i = 0; $i < $num_flags; $i++)
		{
			$flag_name = $flag_row[$i]['flag_name'];
			$flag_image = $flag_row[$i]['flag_image'];
			$selected = ( isset( $user_flag) ) ? (($user_flag == $flag_image) ? 'selected="selected"' : '' ) : '' ;
			$flag_select .= "\t<option value=\"$flag_image\"$selected>$flag_name</option>";
			if ( isset( $user_flag) && ($user_flag == $flag_image))
			{
				$flag_start_image = $flag_image ;
			}
		}
		$flag_select .= '</select>';
		// FLAGHACK-end

		$template->assign_vars(array(
			'USERNAME' => $username,
			'EMAIL' => $email,
			'YIM' => $yim,
			'ICQ' => $icq,
			'MSN' => $msn,
			'AIM' => $aim,
			'OCCUPATION' => $occupation,
			'INTERESTS' => $interests,
			'VACANCES' => $vacances,
			'VACANCES_NO_SPECIFY_CHECKED' => $vacances_no_specify_checked,
			'VACANCES_OUI_CHECKED' => $vacances_oui_checked,
			'VACANCES_NON_CHECKED' => $vacances_non_checked,
			'CUSTOM_TITLE' => $custom_title,
			'CUSTOM_TITLE_STATUS_REGDATE' => $custom_title_status_regdate,
			'CUSTOM_TITLE_STATUS_DISABLED' => $custom_title_status_disabled,
			'CUSTOM_TITLE_STATUS_ENABLED' => $custom_title_status_enabled,
			'CURRENT_RESPONSE' => ( $auto_response != '' && !$error ) ? sprintf($lang['Current_response'], $current_response) : '',
			'AUTO_RESPONSE' => $auto_response,
			'AUTO_RESPONSE_YES' => ($auto_response_on) ? 'checked="checked"' : '',
			'AUTO_RESPONSE_NO' => (!$auto_response_on) ? 'checked="checked"' : '',
			'ALLOW_RESPONSE_YES' => ($allow_response) ? 'checked="checked"' : '',
			'ALLOW_RESPONSE_NO' => (!$allow_response) ? 'checked="checked"' : '',
			'L_AUTO_RESPONSE' => $lang['Auto_response'],
			'L_AUTO_RESPONSE_EXPLAIN' => sprintf($lang['Auto_response_explain'], $board_config['auto_response_length']),
			'L_AUTO_RESPONSE_ON' => $lang['Auto_response_on'],
			'L_ALLOW_AUTO_RESPONSE' => $lang['Allow_auto_response'],
//
// Start System Specs MOD
//
			'COMPUTER_NAME' => $computer_name,
			'SYSTEM_ENCLOSURE' => $system_enclosure,
			'SYSTEM_MOTHERBOARD' => $system_motherboard,
			'PROCESSOR_BRAND' => $processor_brand,
			'PROCESSOR_DESC' => $processor_desc,
			'MEMORY_AMT' => $memory_amt,
			'MEMORY_DETAILS' => $memory_details,
			'VID_BRAND' => $vid_brand,
			'VID_DESC' => $vid_desc,
			'STORAGE_DETAILS' => $storage_details,
			'AUDIO_DETAILS' => $audio_details,
			'SYSTEM_COOLING' => $system_cooling,
			'SYSTEM_OS' => $system_os,
			'SYSTEM_MONITOR' => $system_monitor,
			'FAVORITE_GAME' => $favorite_game,
			'THREEDMARK' => $threedmark,
			'FUTUREMARK' => $futuremark,
			'CPU_DHRY' => $cpu_dhry,
			'CPU_WHET' => $cpu_whet,
			'CPU_INTEGER' => $cpu_integer,
			'CPU_FLOATING' => $cpu_floating,
			'RAM_INTEGER' => $ram_integer,
			'RAM_FLOATING' => $ram_floating,
			'DRIVE_IDX' => $drive_idx,
//
// Finish System Specs MOD
//
			'NEXT_BIRTHDAY_GREETING' => $next_birthday_greeting,
			'S_BIRTHDAY' => $s_birthday,
			'GENDER' => $gender,
			'GENDER_NO_SPECIFY_CHECKED' => $gender_no_specify_checked,
			'GENDER_MALE_CHECKED' => $gender_male_checked,
			'GENDER_FEMALE_CHECKED' => $gender_female_checked,
			'LOCATION' => $location,
			// FLAGHACK-start
			'L_FLAG' => $lang['Country_Flag'],
			'FLAG_SELECT' => $flag_select,
			'FLAG_START' => $flag_start_image,
			// FLAGHACK-end
			'WEBSITE' => $website,
			'SIGNATURE' => str_replace('<br />', "\n", $signature),
			'VIEW_EMAIL_YES' => ($viewemail) ? 'checked="checked"' : '',
			'VIEW_EMAIL_NO' => (!$viewemail) ? 'checked="checked"' : '',
			'HIDE_USER_YES' => (!$allowviewonline) ? 'checked="checked"' : '',
			'HIDE_USER_NO' => ($allowviewonline) ? 'checked="checked"' : '',
			'NOTIFY_PM_YES' => ($notifypm) ? 'checked="checked"' : '',
			'NOTIFY_PM_NO' => (!$notifypm) ? 'checked="checked"' : '',
			'POPUP_PM_YES' => ($popuppm) ? 'checked="checked"' : '',
			'POPUP_PM_NO' => (!$popuppm) ? 'checked="checked"' : '',
			'ALWAYS_ADD_SIGNATURE_YES' => ($attachsig) ? 'checked="checked"' : '',
			'ALWAYS_ADD_SIGNATURE_NO' => (!$attachsig) ? 'checked="checked"' : '',
			'NOTIFY_REPLY_YES' => ( $notifyreply ) ? 'checked="checked"' : '',
			'NOTIFY_REPLY_NO' => ( !$notifyreply ) ? 'checked="checked"' : '',
			'ALWAYS_ALLOW_BBCODE_YES' => ($allowbbcode) ? 'checked="checked"' : '',
			'ALWAYS_ALLOW_BBCODE_NO' => (!$allowbbcode) ? 'checked="checked"' : '',
			'ALWAYS_ALLOW_HTML_YES' => ($allowhtml) ? 'checked="checked"' : '',
			'ALWAYS_ALLOW_HTML_NO' => (!$allowhtml) ? 'checked="checked"' : '',
			'ALWAYS_ALLOW_SMILIES_YES' => ($allowsmilies) ? 'checked="checked"' : '',
			'ALWAYS_ALLOW_SMILIES_NO' => (!$allowsmilies) ? 'checked="checked"' : '',
			'AVATAR' => $avatar,
			'LANGUAGE_SELECT' => language_select($user_lang),
			'TIMEZONE_SELECT' => tz_select($user_timezone),
			'STYLE_SELECT' => style_select($user_style, 'style'),
			'DATE_FORMAT_SELECT' => date_format_select($user_dateformat, $user_timezone),
			'ALLOW_PM_YES' => ($user_allowpm) ? 'checked="checked"' : '',
			'ALLOW_PM_NO' => (!$user_allowpm) ? 'checked="checked"' : '',
			'ALLOW_AVATAR_YES' => ($user_allowavatar) ? 'checked="checked"' : '',
			'ALLOW_AVATAR_NO' => (!$user_allowavatar) ? 'checked="checked"' : '',
			'INFOTEXT' => $infotext,
			'USER_ACTIVE_YES' => ($user_status) ? 'checked="checked"' : '',
			'USER_ACTIVE_NO' => (!$user_status) ? 'checked="checked"' : '',
			'RANK_SELECT_BOX' => $rank_select_box,
			'BAD_LOGIN_COUNT' => $this_userdata['user_badlogin'],

			'L_USERNAME' => $lang['Username'],
			'L_USER_TITLE' => $lang['User_admin'],
			'L_USER_EXPLAIN' => $lang['User_admin_explain'],
			'L_NEW_PASSWORD' => $lang['New_password'],
			'L_PASSWORD_IF_CHANGED' => $lang['password_if_changed'],
			'L_CONFIRM_PASSWORD' => $lang['Confirm_password'],
			'L_PASSWORD_CONFIRM_IF_CHANGED' => $lang['password_confirm_if_changed'],
			'L_SUBMIT' => $lang['Submit'],
			'L_RESET' => $lang['Reset'],
			'L_ICQ_NUMBER' => $lang['ICQ'],
			'L_MESSENGER' => $lang['MSNM'],
			'L_YAHOO' => $lang['YIM'],
			'L_WEBSITE' => $lang['Website'],
			'L_AIM' => $lang['AIM'],
			'L_LOCATION' => $lang['Location'],
			'L_OCCUPATION' => $lang['Occupation'],
			'L_BOARD_LANGUAGE' => $lang['Board_lang'],
			'L_BOARD_STYLE' => $lang['Board_style'],
			'L_TIMEZONE' => $lang['Timezone'],
			'L_DATE_FORMAT' => $lang['Date_format'],
			'L_DATE_FORMAT_EXPLAIN' => $lang['Date_format_explain'],
			'L_YES' => $lang['Yes'],
			'L_NO' => $lang['No'],
			'L_INTERESTS' => $lang['Interests'],
			'L_VACANCES' =>$lang['vacances'],
			'L_VACANCES_OUI' =>$lang['oui'],
			'L_VACANCES_NON' =>$lang['non'],
			'L_VACANCES_NOT_SPECIFY' =>$lang['No_vacances_specify'],
			'L_CUSTOM_TITLE' => $lang['Custom_title'],
			'L_CUSTOM_TITLE_STATUS' => $lang['Custom_title_status'],
			'L_CUSTOM_TITLE_STATUS_REGDATE' => $lang['Custom_title_status_regdate'],
			'L_CUSTOM_TITLE_STATUS_DISABLED' => $lang['Custom_title_status_disabled'],
			'L_CUSTOM_TITLE_STATUS_ENABLED' => $lang['Custom_title_status_enabled'],
//
// Start System Specs MOD
//
			'L_BENCH_TITLE' => $lang['Bench_title'],
			'L_SPEC_TITLE' => $lang['Spec_title'],
			'L_THREED_TITLE' => $lang['threed_title'],
			'L_WINDOWS_A' => $lang['Windows_a'],
			'L_WINDOWS_B' => $lang['Windows_b'],
			'L_WINDOWS_C' => $lang['Windows_c'],
			'L_WINDOWS_D' => $lang['Windows_d'],
			'L_WINDOWS_E' => $lang['Windows_e'],
			'L_LINDOWS' => $lang['Lindows'],
			'L_LINUX_A' => $lang['Linux_a'],
			'L_LINUX_B' => $lang['Linux_b'],
			'L_NIX_OTHER' => $lang['nix_other'],
			'L_BSD_OS' => $lang['Bsd_os'],
			'L_MAC_OS' => $lang['Mac_os'],
			'L_THREED_MARKS' => $lang['Threed_marks'],
			'L_RAM_A' => $lang['Ram_a'],
			'L_RAM_B' => $lang['Ram_b'],
			'L_RAM_C' => $lang['Ram_c'],
			'L_RAM_D' => $lang['Ram_d'],
			'L_RAM_E' => $lang['Ram_e'],
			'L_RAM_F' => $lang['Ram_f'],
			'L_RAM_G' => $lang['Ram_g'],
			'L_RAM_H' => $lang['Ram_h'],
			'L_RAM_I' => $lang['Ram_i'],
			'L_RAM_J' => $lang['Ram_j'],
			'L_RAM_K' => $lang['Ram_k'],
			'L_RAM_L' => $lang['Ram_l'],
			'L_RAM_M' => $lang['Ram_m'],
			'L_ATI' => $lang['Ati'],
			'L_NVIDIA' => $lang['Nvidia'],
			'L_MATROX' => $lang['Matrox'],
			'L_RAM_SUFFIX' => $lang['Ram_suffix'],
			'L_OTHER' => $lang['Other'],
			'L_INTEL' => $lang['Intel'],
			'L_AMD' => $lang['Amd'],
			'L_MIPS' => $lang['Mips'],
			'L_MFLOPS' => $lang['Mflops'],
			'L_ITERATIONS_SEC' => $lang['Iterations_sec'],
			'L_K_PER_SEC' => $lang['K_per_sec'],
			'L_M_PER_SEC' => $lang['M_per_sec'],
			'L_USERNAME_MACHINENAME' => $lang['Username_machinename'],
			'L_SYSTEM_SPECS' => $lang['System_specs'],
			'L_BENCHMARKS' => $lang['Benchmarks'],
			'L_COMPUTER_NAME' => $lang['Computer_name'],
			'L_ENCLOSURE' => $lang['Enclosure'],
			'L_MOTHERBOARD' => $lang['Motherboard'],
			'L_PROCESSOR_BRAND' => $lang['Processor_brand'],
			'L_DROP_DOWN_EXPLAIN' => $lang['Drop_down_explain'],
			'L_PROCESSOR_DESC' => $lang['Processor_desc'],
			'L_MEMORY_AMT' => $lang['Memory_amt'],
			'L_MEMORY_DETAILS' => $lang['Memory_details'],
			'L_VIDEO_CARD_BRAND' => $lang['Video_card_brand'],
			'L_VIDEO_CARD_DETAILS' => $lang['Video_card_details'],
			'L_STORAGE_DETAILS' => $lang['Storage_details'],
			'L_AUDIO_DETAILS' => $lang['Audio_details'],
			'L_SYSTEM_COOLING' => $lang['System_cooling'],
			'L_SYSTEM_OS' => $lang['System_os'],
			'L_MONITOR_DETAILS' => $lang['Monitor_details'],
			'L_FAVORITE_GAME' => $lang['Favorite_game'],
			'L_THREEDMARK' => $lang['Threedmark'],
			'L_FUTUREMARK' => $lang['Futuremark'],
			'L_SISOFT_SANDRA' => $lang['Sisoft_sandra'],
			'L_CPU_DHRYSTONE' => $lang['Cpu_dhrystone'],
			'L_CPU_WHETSTONE' => $lang['Cpu_whetstone'],
			'L_CPU_INTEGER' => $lang['Cpu_integer'],
			'L_CPU_FLOATING' => $lang['Cpu_floating'],
			'L_RAM_INTEGER' => $lang['Ram_integer'],
			'L_RAM_FLOATING' => $lang['Ram_floating'],
			'L_SYSTEM_DRIVE_INDEX' => $lang['System_drive_index'],
			'L_THREED_TITLE' => $lang['threed_title'],
			'L_DOWNLOAD_3DMARK' => $lang['Download_3dmark'],
			'L_DOWNLOAD_SANDRA' => $lang['Download_sandra'],
//
// Finish System Specs MOD
//
			'L_ACCOUNT_BLOCK' => $lang['Account_block'],
			'L_ACCOUNT_BLOCK_EXPLAIN' => $lang['Account_block_explain'],
			'L_UNBLOCK' => $lang['Unblock_user'],
			'L_BAD_LOGIN_COUNT' => $lang['Badlogin_count'],
			'L_BIRTHDAY' => $lang['Birthday'],
			'L_NEXT_BIRTHDAY_GREETING'=>$lang['Next_birthday_greeting'],
			'L_NEXT_BIRTHDAY_GREETING_EXPLAIN'=> $lang['Next_birthday_greeting_expain'],

			'L_GENDER' =>$lang['Gender'],
			'L_GENDER_MALE' =>$lang['Male'],
			'L_GENDER_FEMALE' =>$lang['Female'],
			'L_GENDER_NOT_SPECIFY' =>$lang['No_gender_specify'],

			'L_ALWAYS_ALLOW_SMILIES' => $lang['Always_smile'],
			'L_ALWAYS_ALLOW_BBCODE' => $lang['Always_bbcode'],
			'L_ALWAYS_ALLOW_HTML' => $lang['Always_html'],
			'L_HIDE_USER' => $lang['Hide_user'],
			'L_ALWAYS_ADD_SIGNATURE' => $lang['Always_add_sig'],
			'L_SPECIAL' => $lang['User_special'],
			'L_SPECIAL_EXPLAIN' => $lang['User_special_explain'],
			'L_USER_ACTIVE' => $lang['User_status'],
			'L_ALLOW_PM' => $lang['User_allowpm'],
			'L_ALLOW_AVATAR' => $lang['User_allowavatar'],

			'L_AVATAR_PANEL' => $lang['Avatar_panel'],
			'L_AVATAR_EXPLAIN' => $lang['Admin_avatar_explain'],
			'L_DELETE_AVATAR' => $lang['Delete_Image'],
			'L_CURRENT_IMAGE' => $lang['Current_Image'],
			'L_UPLOAD_AVATAR_FILE' => $lang['Upload_Avatar_file'],
			'L_UPLOAD_AVATAR_URL' => $lang['Upload_Avatar_URL'],
			'L_AVATAR_GALLERY' => $lang['Select_from_gallery'],
			'L_SHOW_GALLERY' => $lang['View_avatar_gallery'],
			'L_LINK_REMOTE_AVATAR' => $lang['Link_remote_Avatar'],

			'L_SIGNATURE' => $lang['Signature'],
			'L_SIGNATURE_EXPLAIN' => sprintf($lang['Signature_explain'], $board_config['max_sig_chars'] ),
			'L_NOTIFY_ON_PRIVMSG' => $lang['Notify_on_privmsg'],
			'L_NOTIFY_ON_REPLY' => $lang['Always_notify'],
			'L_POPUP_ON_PRIVMSG' => $lang['Popup_on_privmsg'],
			'L_PREFERENCES' => $lang['Preferences'],
			'L_PUBLIC_VIEW_EMAIL' => $lang['Public_view_email'],
			'L_ITEMS_REQUIRED' => $lang['Items_required'],
			'L_REGISTRATION_INFO' => $lang['Registration_info'],
			'L_PROFILE_INFO' => $lang['Profile_info'],
			'L_PROFILE_INFO_NOTICE' => $lang['Profile_info_warn'],
			'L_INFOTEXT' => $lang['infotext'],
			'L_EMAIL_ADDRESS' => $lang['Email_address'],
			'S_FORM_ENCTYPE' => $form_enctype,

			'HTML_STATUS' => $html_status,
			'BBCODE_STATUS' => sprintf($bbcode_status, '<a href="../' . append_sid("help.$phpEx?mode=bbcode") . '" target="_phpbbcode">', '</a>'),
			'SMILIES_STATUS' => $smilies_status,

			'L_DELETE_USER' => $lang['User_delete'],
			'L_DELETE_USER_EXPLAIN' => $lang['User_delete_explain'],
			'L_SELECT_RANK' => $lang['Rank_title'],

			'S_HIDDEN_FIELDS' => $s_hidden_fields,
			'S_PROFILE_ACTION' => append_sid("admin_users.$phpEx"))
		);

		// MOD NOTIFY MOD BEGIN
		if ( $this_userdata['user_level'] == MOD || $this_userdata['user_level'] == ADMIN )
		{
			$template->assign_block_vars('switch_notify_mod', array(
				'L_NOTIFY_MOD' => $lang['Always_notify_mod'],
				'NOTIFY_MOD_YES' => ( $notifymod ) ? 'checked="checked"' : '',
				'NOTIFY_MOD_NO' => ( !$notifymod ) ? 'checked="checked"' : '',
				)
			);
		}
		// MOD NOTIFY MOD END

		if( file_exists(@phpbb_realpath('./../' . $board_config['avatar_path'])) && ($board_config['allow_avatar_upload'] == TRUE) )
		{
			if ( $form_enctype != '' )
			{
				$template->assign_block_vars('avatar_local_upload', array() );
			}
			$template->assign_block_vars('avatar_remote_upload', array() );
		}

		if( file_exists(@phpbb_realpath('./../' . $board_config['avatar_gallery_path'])) && ($board_config['allow_avatar_local'] == TRUE) )
		{
			$template->assign_block_vars('avatar_local_gallery', array() );
		}

		if( $board_config['allow_avatar_remote'] == TRUE )
		{
			$template->assign_block_vars('avatar_remote_link', array() );
		}
	}
//
// Start System Specs MOD
//
	if ($board_config['system_specs_enable'] == '1')
	{
		$template->assign_block_vars('switch_enable_system_specs', array());
	}
//
// Finish System Specs MOD
//
	$template->pparse('body');
}

else if ( $mode == 'lookup' )
{
	//
	// Lookup user
	//
	$username = ( !empty($HTTP_POST_VARS['username']) ) ? str_replace('%', '%%', trim(strip_tags( $HTTP_POST_VARS['username'] ) )) : '';
	$email = ( !empty($HTTP_POST_VARS['email']) ) ? trim(strip_tags(htmlspecialchars( $HTTP_POST_VARS['email'] ) )) : '';
	$posts = ( !empty($HTTP_POST_VARS['posts']) ) ? intval(trim(strip_tags( $HTTP_POST_VARS['posts'] ) )) : '';
	$joined = ( !empty($HTTP_POST_VARS['joined']) ) ? trim(strtotime( $HTTP_POST_VARS['joined'] ) ) : 0;

	$sql_where = ( !empty($username) ) ? 'u.username LIKE "%' . str_replace("\'", "''", $username) . '%"' : '';
	$sql_where .= ( !empty($email) ) ? ( ( !empty($sql_where) ) ? ' AND u.user_email LIKE "%' . $email . '%"' : 'u.user_email LIKE "%' . $email . '%"' ) : '';
	$sql_where .= ( !empty($posts) ) ? ( ( !empty($sql_where) ) ? ' AND u.user_posts >= ' . $posts : 'u.user_posts >= ' . $posts ) : '';
	$sql_where .= ( $joined ) ? ( ( !empty($sql_where) ) ? ' AND u.user_regdate >= ' . $joined : 'u.user_regdate >= ' . $joined ) : '';

	if ( !empty($sql_where) )
	{
		$sql = "SELECT u.user_id, u.username, u.user_email, u.user_posts, u.user_active, u.user_regdate
			FROM " . USERS_TABLE . " u
			WHERE $sql_where
			ORDER BY u.username ASC";

		if ( !( $result = $db->sql_query($sql) ) )
		{
			message_die(GENERAL_ERROR, 'Unable to query users', '', __LINE__, __FILE__, $sql);
		}
		else if ( !$db->sql_numrows($result) )
		{
			$message = $lang['No_user_id_specified'];
			$message .= '<br /><br />' . sprintf($lang['Click_return_useradmin'], '<a href="' . append_sid("admin_users.$phpEx") . '">', '</a>') . '<br /><br />' . sprintf($lang['Click_return_admin_index'], '<a href="' . append_sid("index.$phpEx?pane=right") . '">', '</a>');
			message_die(GENERAL_MESSAGE, $message);
		}
		else if ( $db->sql_numrows($result) == 1 )
		{
			// Redirect to this user
			$row = $db->sql_fetchrow($result);

			$template->assign_vars(array(
				"META" => '<meta http-equiv="refresh" content="3;url=' . append_sid("admin_users.$phpEx?mode=edit&" . POST_USERS_URL . "=" . $row['user_id']) . '">')
			);

			$message .= $lang['One_user_found'];
			$message .= '<br /><br />' . sprintf($lang['Click_goto_user'], '<a href="' . append_sid("admin_users.$phpEx?mode=edit&" . POST_USERS_URL . "=" . $row['user_id']) . '">', '</a>');

			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			// Show select screen
			include('page_header_admin.'.$phpEx);

			$template->set_filenames(array(
				'body' => 'admin/user_lookup_body.tpl')
			);

			$template->assign_vars(array(
				'L_USERNAME' => $lang['Username'],
				'L_USER_TITLE' => $lang['User_admin'],
				'L_POSTS' => $lang['Posts'],
				'L_JOINED' => $lang['Sort_Joined'],
				'L_USER_EXPLAIN' => $lang['User_admin_explain'],
				'L_ACTIVE' => $lang['User_status'],
				'L_EMAIL_ADDRESS' => $lang['Email_address'])
			);

			$i = 0;
			while ( $row = $db->sql_fetchrow($result) )
			{
				$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
				$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

				$template->assign_block_vars('user_row', array(
					'ROW_COLOR' => '#' . $row_color,
					'ROW_CLASS' => $row_class,
					'USERNAME' => $row['username'],
					'EMAIL' => $row['user_email'],
					'POSTS' => $row['user_posts'],
					'ACTIVE' => ( $row['user_active'] ) ? $lang['Yes'] : $lang['No'],
					'JOINED' => create_date($lang['DATE_FORMAT'], $row['user_regdate'], $board_config['board_timezone']),

					'U_USERNAME' => append_sid("admin_users.$phpEx?mode=edit&" . POST_USERS_URL . "=" . $row['user_id']))
				);

				$i++;
			}
			$template->pparse('body');
		}
	}
	else
	{
		$message = $lang['No_user_id_specified'];
		$message .= '<br /><br />' . sprintf($lang['Click_return_useradmin'], '<a href="' . append_sid("admin_users.$phpEx") . '">', '</a>') . '<br /><br />' . sprintf($lang['Click_return_admin_index'], '<a href="' . append_sid("index.$phpEx?pane=right") . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);
	}
}

else
{
	//
	// Default user selection box
	//
	$template->set_filenames(array(
		'body' => 'admin/user_select_body.tpl')
	);

	$template->assign_vars(array(
		'L_USER_TITLE' => $lang['User_admin'],
		'L_USER_EXPLAIN' => $lang['User_admin_explain'],
		'L_USER_SELECT' => $lang['Select_a_User'],
		'L_LOOK_UP' => $lang['Look_up_user'],
		'L_FIND_USERNAME' => $lang['Find_username'],
		'L_USERNAME' => $lang['Username'],
		'L_POSTS' => $lang['Posts'],
		'L_JOINED' => $lang['Sort_Joined'],
		'L_ACTIVE' => $lang['User_status'],

		'L_USER_LOOKUP_EXPLAIN' => $lang['User_lookup_explain'],
		'L_EMAIL_ADDRESS' => $lang['Email_address'],
		'L_JOINED_EXPLAIN' => $lang['User_joined_explain'],

		'U_SEARCH_USER' => append_sid("./../search.$phpEx?mode=searchuser"),

		'S_USER_ACTION' => append_sid("admin_users.$phpEx"),
		'S_USER_SELECT' => ((!empty($select_list)) ? $select_list : ''))
	);
	$template->pparse('body');

}

include('./page_footer_admin.'.$phpEx);

?>
