<?php
/*
 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 $                            album_search.php
 $                           +-+-+-+-+-+-+-+-+-+
 $
 $   Released           : Saturday, August 30, 2003
 $   Copyright          : (C) 2003 Volodymyr (CLowN) Skoryk
 $   E-Mail             : blaatimmy72@yahoo.com
 $
 $
 $   % album_search.php v1.4.0 8.30.03, 11:00:08am Volodymyr (CLowN) Skoryk %
 $
 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
*/

/*
 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 $
 $   This program is free software; you can redistribute it and/or modify
 $   it under the terms of the GNU General Public License as published by
 $   the Free Software Foundation; either version 2 of the License, or
 $   (at your option) any later version.
 $
 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
*/

/*
 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 $
 $   Change Log:
 $
 $      1.4.0
 $          -made search of personal gallerys possible
 $
 $      1.3.0
 $          -totally rewrote search.php and templet file to use phpbbs
 $           template system
 $          -fixed bug in mysql query line
 $          -implemented use of $HTTP_GET_VARS and $HTTP_POST_VARS
 $
 $      1.2.0
 $          -fixed session problem,and php opening tag before comments bug
 $
 $      1.1.0
 $          -fixed bug were username and picture name were rewerced in the
 $           template
 $
 $      1.0.0
 $          -initial release
 $
 $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
*/

define('IN_PHPBB', true);
define('IN_ALBUM', true);
$phpbb_root_path = './';
$album_root_path = $phpbb_root_path . 'mods/album/';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

// Start session management
//
    $userdata = session_pagestart($user_ip, PAGE_ALBUM);
    init_userprefs($userdata);
//
// End session management

$page_title = $lang['Album'] . ' ' . $lang['Search'];
include_once($phpbb_root_path.'includes/functions_color_groups.'.$phpEx);
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

    $template->set_filenames(array(
        'body' => 'album_search_body.tpl')
    );

    if ( !isset($HTTP_POST_VARS['search']) && !isset($HTTP_GET_VARS['search']) )
    {
        $template->assign_block_vars('switch_search', array());
    }
    else
    {
        $template->assign_block_vars('switch_search', array());
        $template->assign_block_vars('switch_search_results', array());

        if ( isset($HTTP_POST_VARS['mode']) || isset($HTTP_GET_VARS['mode']) )
        {
            $m = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
        }
        else
        {
            $m = '';
            message_die(GENERAL_ERROR, 'Bad request');
        }

        if ( isset($HTTP_POST_VARS['search']) || isset($HTTP_GET_VARS['search']) )
        {
            $search = ( isset($HTTP_POST_VARS['search']) ) ? $HTTP_POST_VARS['search'] : $HTTP_GET_VARS['search'];
        }

        if ($m == 'user')
            $where = 'p.pic_username';
        else if ($m == 'name')
            $where = 'p.pic_title';
        else if ($m == 'desc')
            $where = 'p.pic_desc';

        //echo "[ m     = ".$m;
        //echo " ] [ where = ".$where;
        //echo " ] [ search = ".$search." ]";

        $sql = "SELECT p.pic_id, p.pic_title, p.pic_user_id, p.pic_username, p.pic_time, p.pic_cat_id, c.cat_id, c.cat_title
                FROM " . ALBUM_TABLE . " AS p," . ALBUM_CAT_TABLE . " AS c
                WHERE p.pic_cat_id = c.cat_id OR p.pic_cat_id = 0 AND ". $where ." LIKE '%" . $search . "%'";
        //message_die(GENERAL_ERROR, "(searching for: $search)", "", __LINE__, __FILE__, $sql);


        if ( !($result = $db->sql_query($sql)) )
        {
            message_die(GENERAL_ERROR, "Couldn't obtain list of matching information (searching for: $search)", "", __LINE__, __FILE__, $sql);
        }

        $numres = 0;

        if ( $row = $db->sql_fetchrow($result) )
        {
            do
            {
                $template->assign_block_vars('switch_search_results.search_results', array(
                    'L_USERNAME' => color_group_colorize_name($row['pic_user_id']),
                    'U_PROFILE' => append_sid('profile.php?mode=viewprofile&u=' . $row['pic_user_id']),

                    'L_CAT' => ($row['pic_cat_id'] == 0 ) ? $lang['User_Personal'] : $row['cat_title'],
                    'U_CAT' => ($row['pic_cat_id'] == 0 ) ? append_sid('album_personal.php?user_id=' . $row['pic_user_id']) : append_sid('album_cat.php?cat_id=' . $row['cat_id']),

                    'L_PIC' => $row['pic_title'],
                    'U_PIC' => append_sid('album_showpage.php?pic_id=' . $row['pic_id']),

                    'L_TIME' => create_date($board_config['default_dateformat'], $row['pic_time'], $board_config['board_timezone'])
                ));

                $numres++;
            }
            while( $row = $db->sql_fetchrow($result) );

            $template->assign_vars(array(
				'L_SEARCH' => $lang['Search'],
                'L_RESULTS' => sprintf ($lang['Search_found'], $numres),
                'L_TCATEGORY' => $lang['Category'],
                'L_TTITLE' => $lang['Pic_Title'],
                'L_TSUBMITER' => $lang['Submitter'],
                'L_TSUBMITED' => $lang['Submited_on'],
                'L_SUBMIT' => $lang['Search'],
                'L_RESET' => $lang['Reset'],
                'L_SEARCH_FOR' => $lang['Search_for'],
                'L_CONTAINING' => $lang['Containing'],
            ));
        }
        else
        {
            message_die(GENERAL_MESSAGE, $lang['No_search_match']);
        }
    }

    $template->pparse('body');
    include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>