<?php
/***************************************************************************
 *                                forum.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: forum.php 435 2006-03-25 13:03:14Z arthurschreiber $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);

$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
//Added for read_tracking
include($phpbb_root_path . 'includes/read_history.'.$phpEx);

//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- add v1.0.1
//
// enhance categories informations : description, last post, numbers of posts/topics, and so
function enhance_cat($cat_id)
{
//-- fix v 1.0.6
    global $db, $HTTP_COOKIE_VARS, $category_rows, $forum_data, $is_auth_ary, $tracking_forums, $tracking_topics, $new_topic_data, $images, $lang, $board_config, $userdata, $phpEx;
//--

    if ($cat_id < 0) $cat_id=0;

    // default values
    $ind = -1;
    //-- v 1.0.5
    $categories_desc = ''; // all the sub-cat titles
    $forums_desc = ''; // all the sub-forum titles
    //--
    $cat_display = false;
    $cat_locked = true;
    $cat_unread_topics = false;
    $cat_posts = 0;
    $cat_topics = 0;
    $cat_post_time = 0;
    $cat_last_post = '';

    // look up for sub-categories
    for ($i = 0, $max = count($category_rows); $i < $max; $i++)
    {
        // let's fix the cat_main : attached to  index : lvl 0
        if ($category_rows[$i]['cat_main'] == $category_rows[$i]['cat_id'])
        {
        	$category_rows[$i]['cat_main'] = 0;
		}
        // get the tab index for $cat_id
        if (($cat_id > 0) && ($category_rows[$i]['cat_id']==$cat_id))
        {
        	$ind = $i;
        }

        // identify category which are daughters of the one running
        if ( $category_rows[$i]['cat_main'] == $cat_id && $category_rows[$i]['cat_id'] > 0 )
        {
            // enhance sub-categories
            enhance_cat($category_rows[$i]['cat_id']);

            // get the result
            //-- v 1.0.5
            $categories_desc .= empty($categories_desc) ? '':', ';
            $categories_desc .= $category_rows[$i]['cat_title'];
            //--
            if ($category_rows[$i]['cat_display'])
            {
            	$cat_display = true;
            }
            if (!($category_rows[$i]['cat_locked']))
            {
            	$cat_locked = false;
            }
            if ($category_rows[$i]['unread_topics'])
            {
            	$cat_unread_topics = true;
            }
            $cat_posts = $cat_posts + $category_rows[$i]['posts'];
            $cat_topics = $cat_topics + $category_rows[$i]['topics'];
            if ($cat_post_time < $category_rows[$i]['post_time'])
            {
                $cat_post_time = $category_rows[$i]['post_time'];
                $cat_last_post = $category_rows[$i]['last_post'];
            }
        }
    }

    // deal with the forums of the category
    if ($ind > -1)
    {
        // Raz
        $category_rows[$ind]['cat_display'] = false;
        $category_rows[$ind]['cat_locked'] = true;
        $category_rows[$ind]['unread_topics'] = false;
        $category_rows[$ind]['posts'] = 0;
        $category_rows[$ind]['topics'] = 0;
        $category_rows[$ind]['post_time'] = 0;
        $category_rows[$ind]['last_post'] = '';

        // look up for the forums of the category
        for ($j = 0, $max = count($forum_data); $j < $max; $j++)
        {
            if ($forum_data[$j]['cat_id'] == $cat_id)
            {
                $forum_id = $forum_data[$j]['forum_id'];

                // valeur par d�faut
                $display_forum = false;
                $last_post = '';

                $unread_topics = false;
                // forum visible ?
                if ($display_forum = $is_auth_ary[$forum_id]['auth_view'])
                {
                    if ($forum_data[$j]['forum_status'] != FORUM_LOCKED)
                    {
                        if ($board_config['db_read_tracking'] )
                        {
                            ///hmmmm, something should happen here to check if the forum have new posts.
                            $unread_topics = smart_is_new_forum($forum_id);
                        }
                        elseif ($userdata['session_logged_in'] && !empty($new_topic_data[$forum_id]))
                        {
                            $forum_last_post_time = 0;
                            foreach ($new_topic_data[$forum_id] as $check_topic_id => $check_post_time)
                            {
                                if (empty($tracking_topics[$check_topic_id]) || $tracking_topics[$check_topic_id] < $check_post_time)
                                {
                                    $unread_topics = true;
                                    $forum_last_post_time = max($check_post_time, $forum_last_post_time);
                                }
                            } //  end while( list($check_topic_id, $check_post_time) = @each($new_topic_data[$forum_id]) )
                            if (!empty($tracking_forums[$forum_id]) && $tracking_forums[$forum_id] > $forum_last_post_time)
                            {
                                    $unread_topics = false;
                            }
                            elseif (isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f_all']) && $HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f_all'] > $forum_last_post_time)
                            {
                                    $unread_topics = false;
                            }
                        }
                    } //  if ($forum_data[$j]['forum_status'] != FORUM_LOCKED)
                    
                    if (!$is_auth_ary[$forum_id]['auth_delayedpost'])
                    {
                        // find number of posts and topics that should not be in the count...

                        $current_time = time();
                        $sql = 'SELECT topic_id, topic_replies 
                        	FROM ' . TOPICS_TABLE . ' 
                        	WHERE forum_id = ' . $forum_id . ' 
                        	AND topic_time > ' . $current_time;
                        if (!($result = $db->sql_query($sql)))
                        {
                            message_die(GENERAL_ERROR, 'Could not query delayed topics list', '', __LINE__, __FILE__, $sql);
                        }

                        // ... and remove them from the count
                        while ($row = $db->sql_fetchrow($result))
                        {
                            $forum_data[$j]['forum_topics']--;
                            $forum_data[$j]['forum_posts'] -= $row['topic_replies'] + 1;
                        }
                        $db->sql_freeresult($result);
                    }

                    // MOD: Delayed Topics {end}
                    //-----------------------------------------------------------------------------

                    $posts = $forum_data[$j]['forum_posts'];
                    $topics = $forum_data[$j]['forum_topics'];

                    $last_post = $lang['No_Posts'];
                    if ($forum_data[$j]['forum_last_post_id'])
                    {
                        $last_post_time = create_date($board_config['default_dateformat'], $forum_data[$j]['post_time'], $board_config['board_timezone']);
                        // OLD
                        $last_post = $last_post_time . '<br />';
                        //Color Groups
                        $last_post .= ( $forum_data[$j]['user_id'] == ANONYMOUS ) ? ( ($forum_data[$j]['post_username'] != '' ) ? $forum_data[$j]['post_username'] . ' ' : $lang['Guest'] . ' ' ) : color_group_colorize_name($forum_data[$j]['user_id'],true);
                        $last_post .= '<a href="' . append_sid('viewtopic.' . $phpEx . '?'  . POST_POST_URL . '=' . $forum_data[$j]['forum_last_post_id']) . '#' . $forum_data[$j]['forum_last_post_id'] . '"><img src="' . $images['icon_latest_reply'] . '" border="0" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" /></a>';
                    }

                } //  if ($display_forums = $is_auth_ary[$forum_data[$j]['forum_id']]['auth_view'])

                // enhanced forum row
                $forum_data[$j]['display_forum'] = $display_forum;
                $forum_data[$j]['unread_topics'] = $unread_topics;
                $forum_data[$j]['last_post'] = $last_post;

                // ok : add forum informations to the category
                if ($forum_data[$j]['display_forum'])
                {
                    //-- v 1.0.5
                    $forums_desc .= empty($forums_desc) ? '':', ';
                    $forums_desc .= $forum_data[$j]['forum_name'];
                    //--
                    $category_rows[$ind]['cat_display'] = true;
                    if ($forum_data[$j]['forum_status'] != FORUM_LOCKED)
                    {
                    	$category_rows[$ind]['cat_locked'] = false;
                    }
                    if ($forum_data[$j]['unread_topics'])
                    {
                    	$category_rows[$ind]['unread_topics'] = true;
                    }
                    $category_rows[$ind]['posts'] = $category_rows[$ind]['posts'] + $forum_data[$j]['forum_posts'];
                    $category_rows[$ind]['topics'] = $category_rows[$ind]['topics'] + $forum_data[$j]['forum_topics'];
                    if ($forum_data[$j]['post_time'] > $category_rows[$ind]['post_time'])
                    {
                        $category_rows[$ind]['post_time'] = $forum_data[$j]['post_time'];
                        $category_rows[$ind]['last_post'] = $forum_data[$j]['last_post'];
                    }
                } //  if ($display_forum)
            } // if ($forum_data['cat_id'] == $cat_id)
        } // for ($j=0;$j<count($forum_data);$j++)

        // all is done for the forums : add the sub-categories informations
        //-- v 1.0.5
        if (empty($category_rows[$ind]['cat_desc']))
        {
            $category_rows[$ind]['cat_desc']  = $forums_desc;
            $category_rows[$ind]['cat_desc'] .= (empty($forums_desc) || empty($categories_desc)) ? '': ', ';
            $category_rows[$ind]['cat_desc'] .= $categories_desc;
        }
        //--
        if ($cat_display)
        {
        	$category_rows[$ind]['cat_display'] = true;
        }
        if (!$cat_locked)
        {
        	$category_rows[$ind]['cat_locked'] = false;
        }
        if ($cat_unread_topics)
        {
        	$category_rows[$ind]['unread_topics'] = true;
        }
        $category_rows[$ind]['posts'] = $category_rows[$ind]['posts'] + $cat_posts;
        $category_rows[$ind]['topics'] = $category_rows[$ind]['topics'] + $cat_topics;
        if ($cat_post_time > $category_rows[$ind]['post_time'])
        {
            $category_rows[$ind]['post_time'] = $cat_post_time;
            $category_rows[$ind]['last_post'] = $cat_last_post;
        }
    } // if ($ind > -1)
} // function enhance_cat_forum

function display_index_cat($catrow, $sub_forum, $main, $cur_depth = 0)
{
    global $board_config, $theme, $total_categories, $category_rows, $total_forums, $forum_data, $forum_moderators, $images, $lang, $template, $phpEx;
    global $max_depth;
    if ($sub_forum)
    {
    	$cur_depth = 0;
    }

    $cat_id = $catrow['cat_id'];
    if ($catrow['cat_display'])
    {
        // display cat title
        $class_catLeft = 'cat';
        $class_rowpic  = 'rowpic';
        $template->assign_block_vars('catrow', array(
            'INC_SPAN'      => $max_depth-$cur_depth + 2,
            'CLASS_CATLEFT' => $class_catLeft,
            'CLASS_ROWPIC'  => $class_rowpic,
            'CAT_ID'        => $cat_id,
            'CAT_DESC'      => $catrow['cat_title'],
            'U_VIEWCAT'     => append_sid("forum.$phpEx?" . POST_CAT_URL . "=$cat_id")
            )
        );
        $color = true;
        $inc_row = true;
        for ($k = 0; $k < $cur_depth; $k++ )
        {
            $template->assign_block_vars('catrow.inc', array('INC_ROW' => $inc_row ? 'row1' : 'row2' ) );
            $inc_row = !$inc_row;
        }

        // display forums
        for($j = 0; $j < $total_forums; $j++)
        {
            if ( ($forum_data[$j]['cat_id']==$cat_id) && $forum_data[$j]['display_forum'] )
            {
                $forum_id = $forum_data[$j]['forum_id'];

                //New for read_tracking
                if ($board_config['db_read_tracking'])
                {
                    $folder_image	= (smart_is_new_forum($forum_id)) ? $images['forum_new'] : $images['forum'];
                    $folder_alt		= (smart_is_new_forum($forum_id)) ? $lang['New_posts'] : $lang['No_new_posts'];
                }
                else
                {
                    $folder_image	= ($forum_data[$j]['unread_topics']) ? $images['forum_new'] : $images['forum'];
                    $folder_alt		= ($forum_data[$j]['unread_topics']) ? $lang['New_posts'] : $lang['No_new_posts'];
                }

                if ($forum_data[$j]['forum_status'] == FORUM_LOCKED)
                {
                    $folder_image = $images['forum_locked'];
                    $folder_alt = $lang['Forum_locked'];
                }
                $l_moderators = '&nbsp;';
                $moderator_list = '&nbsp;';
                if (isset($forum_moderators[$forum_id]) && count($forum_moderators[$forum_id]) > 0)
                {
                    $l_moderators = (count($forum_moderators[$forum_id]) == 1) ? $lang['Moderator'] : $lang['Moderators'];
                    $moderator_list = implode(', ', $forum_moderators[$forum_id]);
                }
                $row_color = ($color) ? $theme['td_color1'] : $theme['td_color2'];
                $row_class = ($color) ? $theme['td_class1'] : $theme['td_class2'];
                $color = !$color;
                $odd = ($sub_forum || (intval($cur_depth / 2) == ($cur_depth/2)));

                if (strlen($forum_data[$j]['topic_title']) > 24)
                {
                    $last_topic_in_forum = substr($forum_data[$j]['topic_title'], 0, 21) . '...';
                }
                else
                {
                    $last_topic_in_forum = $forum_data[$j]['topic_title'];
                }

                if ($forum_data[$j]['forum_external'])
                {
                    $forum_url = '<a href="'.append_sid('view_external.' . $phpEx . '?' . POST_FORUM_URL . '=' . $forum_id).'" target="_blank">'.$forum_data[$j]['forum_name'].'</a>';

                    $member_hits = $forum_data[$j]['forum_redirects_user'];
                    $guest_hits = $forum_data[$j]['forum_redirects_guest'];
                    $all_hits = ($member_hits + $guest_hits);

                    $forum_details = $lang['External_text'] . '<b>' . $all_hits . '</b>';
                    $forum_details .= ( $all_hits == 1 ) ? $lang['External_hit'] : $lang['External_hits'];

                    $forum_details .= '<br />(' . $lang['External_members'] . ': <b>' . $member_hits . '</b>&nbsp;&middot;&nbsp;' . $lang['External_guests'] . ': <b>' . $guest_hits . '</b>)';

                    $folder_image = $images['forum_external'];
                    $forum_posts = '--';
                    $forum_topics = '--';
                }
                else
                {
                    $forum_url = '<a href="'.append_sid('viewforum.' . $phpEx . '?' . POST_FORUM_URL . '=' . $forum_id).'">'.$forum_data[$j]['forum_name'].'</a>';

                    $forum_posts = $forum_data[$j]['forum_posts'];
                    $forum_topics = $forum_data[$j]['forum_topics'];
                    $forum_details = $forum_data[$j]['last_post'];
                }

                $template->assign_block_vars('catrow.forumrow', array(
                    'INC_SPAN'      => $max_depth-$cur_depth+1,
                    'INC_ROW'       => ( $odd ? "row1" : "row2" ),
                    'ROW_COLOR' => '#' . $row_color,
                    'ROW_CLASS' => $row_class,
                    'FORUM_FOLDER_IMG' => $folder_image,
                    'FORUM_NAME' => $forum_data[$j]['forum_name'],
                    'FORUM_DESC' => $forum_data[$j]['forum_desc'],
                    'POSTS' => $forum_posts,
                    'TOPICS' => $forum_topics,
                    'LAST_POST' => $forum_details,
                    'MODERATORS' => $moderator_list,
                    'LAST_TOPIC' => $last_topic_in_forum,
                    'U_LAST_TOPIC' => append_sid('viewtopic.' . $phpEx . '?'  . POST_TOPIC_URL . '=' . $forum_data[$j]['topic_id']),
                    'L_MODERATOR' => $l_moderators,
                    'L_FORUM_FOLDER_ALT' => $folder_alt,
                    'U_VIEWFORUM' => $forum_url)
                );
                $inc_row = true;
                for ($k = 0; $k < $cur_depth; $k++)
                {
                    $template->assign_block_vars('catrow.forumrow.inc', array('INC_ROW' => $inc_row ? 'row1' : 'row2' ) );
                    $inc_row = !$inc_row;
                }
            } //  if ( ($forum_data[$j]['cat_id']==$cat_id) && $forum_data[$j]['display_forum'] )
        } //  for($j = 0; $j < $total_forums; $j++)

        // display sub-cat title
        for ($j = 0; $j < $total_categories; $j++)
        {
            if (($category_rows[$j]['cat_main'] == $cat_id) && ($category_rows[$j]['cat_display']))
            {
                if (!$sub_forum)
                {
                    display_index_cat($category_rows[$j], $sub_forum, false, $cur_depth+1);
                }
                if ($sub_forum)
                {
                    $subcat_id = $category_rows[$j]['cat_id'];
                    $folder_image = ( $category_rows[$j]['unread_topics'] ) ? $images['category_new'] : $images['category'];
                    $folder_alt   = ( $category_rows[$j]['unread_topics'] ) ? $lang['New_posts'] : $lang['No_new_posts'];
                    if ($category_rows[$j]['cat_locked'] )
                    {
                        $folder_image = $images['category_locked'];
                        $folder_alt = $lang['Forum_locked'];
                    }
                    $row_color = ( $color ) ? $theme['td_color1'] : $theme['td_color2'];
                    $row_class = ( $color ) ? $theme['td_class1'] : $theme['td_class2'];
                    $color = !$color;

                    if (isset($category_rows[$j]['forum_external']) && $category_rows[$j]['forum_external'])
                    {
                        $forum_url = '<a href="'.append_sid('view_external.' . $phpEx . '?' . POST_FORUM_URL . '=' . $forum_id).'" target="_blank">'.$category_rows[$j]['cat_title'].'</a>';

                        $member_hits = $forum_data[$j]['forum_redirects_user'];
                        $guest_hits = $forum_data[$j]['forum_redirects_guest'];
                        $all_hits = ($member_hits + $guest_hits);

                        $forum_details = $lang['External_text'] . '<b>' . $all_hits . '</b>';

                        $forum_details .= ( $all_hits == 1 ) ? $lang['External_hit'] : $lang['External_hits'];

                        $forum_details .= '<br />(' . $lang['External_members'] . ': <b>' . $member_hits . '</b>&nbsp;&middot;&nbsp;' . $lang['External_guests'] . ': <b>' . $guest_hits . '</b>)';

                        $folder_image = $images['forum_external'];
                        $forum_posts = '--';
                        $forum_topics = '--';
                    }
                    else
                    {
                        $forum_url = '<a href="'.append_sid('forum.' . $phpEx . '?' . POST_CAT_URL . '=' . $subcat_id).'">'.$category_rows[$j]['cat_title'].'</a>';

                        $forum_posts = $category_rows[$j]['posts'];
                        $forum_topics = $category_rows[$j]['topics'];
                        $forum_details = $category_rows[$j]['last_post'];
                    }

                    $template->assign_block_vars('catrow.forumrow', array(
                        'INC_ROW'   => 'row1',
                        'ROW_COLOR' => '#' . $row_color,
                        'ROW_CLASS' => $row_class,
                        'FORUM_FOLDER_IMG' => $folder_image,
                        'FORUM_NAME' => $category_rows[$j]['cat_title'],
                        'FORUM_DESC' => $category_rows[$j]['cat_desc'],
                        'POSTS' => $forum_posts,
                        'TOPICS' => $forum_topics,
                        'LAST_POST' => $forum_details,
                        'MODERATORS' => '',
                        'L_MODERATOR' => '',
                        'L_FORUM_FOLDER_ALT' => $folder_alt,
                        'U_VIEWFORUM' => $forum_url)
                    );
                } //  if ($sub_forum)
            } //  if ($category_rows[$j]['cat_main']==$cat_id)
        } // for ($j=0; $j < $total_categories; $j++)
    } //  if ($catrow['cat_display'])
} // end function display_index_cat($catrow, $sub_forum, $main)
//-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_FORUM);
init_userprefs($userdata);
//
// End session management
//

//Color Groups
include_once($phpbb_root_path.'includes/functions_color_groups.'.$phpEx);
color_groups_setup_list();
//Color Groups - End

//Added for read_tracking
if ($userdata['session_logged_in'])
{
	// 60 days limit
	if ($userdata['user_lastvisit'] < (time() - 5184000))
	{
		$userdata['user_lastvisit'] = time() - 5184000;
	}

    if ($board_config['db_read_tracking'])
    {
        $unread_post_count = smart_unread_post_count();
    }
    else
    {
        //Cookie read_tracking
        $sql = 'SELECT COUNT(post_id) as total
            FROM ' . POSTS_TABLE . '
            WHERE post_time >= ' . $userdata['user_lastvisit'] . '
            AND poster_id != ' . $userdata['user_id'];

        $result = $db->sql_query($sql);
		$unread_post_count = ($result) ? $db->sql_fetchfield('total', -1, $result) : 0;
		$db->sql_freeresult($result);
    }
    $lang['Search_new'] = $lang['Search_unread'] . ' (' . $unread_post_count . ')';
    unset($unread_post_count);
}

$viewcat = (isset($HTTP_GET_VARS[POST_CAT_URL]) && !empty($HTTP_GET_VARS[POST_CAT_URL])) ? $HTTP_GET_VARS[POST_CAT_URL] : -1;

if (isset($HTTP_GET_VARS['mark']) || isset($HTTP_POST_VARS['mark']))
{
    $mark_read = (isset($HTTP_POST_VARS['mark'])) ? $HTTP_POST_VARS['mark'] : $HTTP_GET_VARS['mark'];
}
else
{
    $mark_read = '';
}

//
// Handle marking posts
//
if ($mark_read == 'forums')
{
    //-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
    //-- add v 1.0.9
    if ($viewcat < 0)
    {
    //-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

        if ($userdata['session_logged_in'])
        {
            //For read_tracking
            if ($board_config['db_read_tracking'])
            {
                smart_mark_all_read();
            }
            else
            {
                setcookie($board_config['cookie_name'] . '_f_all', time(), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
            }
        }

        $template->assign_vars(array(
            'META' => '<meta http-equiv="refresh" content="3;url='  .append_sid('forum.' . $phpEx) . '">')
        );

    //-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
    //-- add v 1.0.9
    }
    else
    {
        if ($userdata['session_logged_in'])
        {
            // get the list of the involved cats
            $catrows = array();
            $catrows = get_cat($viewcat);

            // build the string list
            $catids = array();
            for ($i = 0, $max = count($catrows); $i < $max; $i++)
            {
            	$catids[] = $catrows[$i]['cat_id'];
            }
            $s_cat = implode(', ', $catids);

            // get the list of the involved forums
            $forumids = array();
            $sql = 'SELECT forum_id 
            	FROM ' . FORUMS_TABLE . ' 
            	WHERE cat_id IN (' . $s_cat . ')';
            if (!($result = $db->sql_query($sql)))
            {
            	message_die(GENERAL_ERROR, 'Could not query new forums information', '', __LINE__, __FILE__, $sql);
            }
            $forum_ids = array();
            while ($row = $db->sql_fetchrow($result))
            {
            	$forum_ids[] = $row['forum_id'];
            }
            $db->sql_freeresult($result);
			if ($board_config['db_read_tracking'])
			{
				foreach ($forum_ids as $forum_id)
				{
					smart_mark_forum_read($forum_id);
				}
			}
			else
			{
				$sql = 'SELECT MAX(post_time) AS last_post 
					FROM ' . POSTS_TABLE . '
					WHERE forum_id IN (' . implode(', ', $forum_ids) . ')';
				if (!($result = $db->sql_query($sql)))
				{
					message_die(GENERAL_ERROR, 'Could not obtain forum information', '', __LINE__, __FILE__, $sql);
				}
				$forum_ids = array();
				while ($row = $db->sql_fetchrow($result))
				{
					$forum_ids[$row['forum_id']] = $row['last_post'];
				}
				$db->sql_freeresult($result);
				$tracking_forums = (isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) : array();
				$tracking_topics = (isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) : array();
				$tracking_count = count($tracking_forums) + count($tracking_topics);
				foreach ($forum_ids as $forum_id => $last_post)
				{
                    if ($tracking_count >= 150 && empty($tracking_forums[$forum_id]))
                    {
						asort($tracking_forums);
						//reset($tracking_forums);
						//unset($tracking_forums[key($tracking_forums)]);
						array_shift($tracking_forums);
                    }
                    if ($last_post > $userdata['user_lastvisit'])
                    {
                        $tracking_forums[$forum_id] = time();
                    }
                }
                setcookie($board_config['cookie_name'] . '_f', serialize($tracking_forums), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
                unset($tracking_forums, $tracking_topics, $tracking_count);
            }
            unset ($forum_ids);
        }

        $template->assign_vars(array(
            'META' => '<meta http-equiv="refresh" content="3;url='  .append_sid("forum.$phpEx?" . POST_CAT_URL . "=$viewcat") . '">')
        );
    }
//-- fin mod : hi�rarchie des rubriques -----------------------------------------------------------

    $message = $lang['Forums_marked_read'] . '<br /><br />' . sprintf($lang['Click_return_index'], '<a href="' . append_sid("forum.$phpEx") . '">', '</a> ');
    message_die(GENERAL_MESSAGE, $message);
}
//
// End handle marking posts
//
if (!$board_config['db_read_tracking'] )
{
    $tracking_topics = (isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t'])) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) : array();
    $tracking_forums = (isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f'])) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) : array();
}

//
// If you don't use these stats on your index you may want to consider
// removing them
//
$total_posts = get_db_stat('postcount');
$total_users = get_db_stat('usercount');
$newest_userdata = get_db_stat('newestuser');
$newest_user = $newest_userdata['username'];
$newest_uid = $newest_userdata['user_id'];

if ($total_posts == 0)
{
    $l_total_post_s = $lang['Posted_articles_zero_total'];
}
elseif ($total_posts == 1)
{
    $l_total_post_s = $lang['Posted_article_total'];
}
else
{
    $l_total_post_s = $lang['Posted_articles_total'];
}

if ($total_users == 0)
{
    $l_total_user_s = $lang['Registered_users_zero_total'];
}
else if ($total_users == 1)
{
    $l_total_user_s = $lang['Registered_user_total'];
}
else
{
    $l_total_user_s = $lang['Registered_users_total'];
}


//
// Start page proper
//

$nav_cat_desc = make_cat_nav_tree($viewcat, false);
$custom_html = get_cat_headers($viewcat);
$category_rows = get_cat($viewcat);

if ($total_categories = count($category_rows))
{
    //
    // Define appropriate SQL
    //
    switch (SQL_LAYER)
    {
        case 'postgresql':
            $sql = 'SELECT f.*, p.post_time, p.post_username, u.username, u.user_id
                FROM ' . FORUMS_TABLE . ' f, ' . POSTS_TABLE . ' p, ' . USERS_TABLE . ' u
                WHERE p.post_id = f.forum_last_post_id
                    AND u.user_id = p.poster_id
                    UNION (
                        SELECT f.*, NULL, NULL, NULL, NULL
                        FROM ' . FORUMS_TABLE . ' f
                        WHERE NOT EXISTS (
                            SELECT p.post_time
                            FROM ' . POSTS_TABLE . ' p
                            WHERE p.post_id = f.forum_last_post_id
                        )
                    )
                    ORDER BY cat_id, forum_order';
            break;

        case 'oracle':
            $sql = 'SELECT f.*, p.post_time, p.post_username, u.username, u.user_id
                FROM ' . FORUMS_TABLE . ' f, ' . POSTS_TABLE . ' p, ' . USERS_TABLE . ' u
                WHERE p.post_id = f.forum_last_post_id(+)
                    AND u.user_id = p.poster_id(+)
                ORDER BY f.cat_id, f.forum_order';
            break;

        default:
            /* Original phpBB 2.0.6
            $sql = "SELECT f.*, p.post_time, p.post_username, u.username, u.user_id
                FROM (( " . FORUMS_TABLE . " f
                LEFT JOIN " . POSTS_TABLE . " p ON p.post_id = f.forum_last_post_id )
                LEFT JOIN " . USERS_TABLE . " u ON u.user_id = p.poster_id )
                ORDER BY f.cat_id, f.forum_order";
            */
// TODO: Investigate
            // Last Topic Post on Index
            $sql = 'SELECT f.*, p.post_time, p.post_username, u.username, u.user_id, t.topic_title, t.topic_id
                FROM ((( ' . FORUMS_TABLE . ' f
                LEFT JOIN ' . POSTS_TABLE . ' p ON p.post_id = f.forum_last_post_id )
                LEFT JOIN ' . TOPICS_TABLE . ' t ON t.topic_id = p.topic_id )
                LEFT JOIN ' . USERS_TABLE . ' u ON u.user_id = p.poster_id )
                ORDER BY f.cat_id, f.forum_order';
            break;
    }
    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not query forums information', '', __LINE__, __FILE__, $sql);
    }
    $forum_data = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);
    if (!($total_forums = count($forum_data)))
    {
        message_die(GENERAL_MESSAGE, $lang['No_forums']);
    }

    //
    // Obtain a list of topic ids which contain
    // posts made since user last visited
    //

    if (!$board_config['db_read_tracking'] && $userdata['session_logged_in'])
    {
        $sql = 'SELECT t.forum_id, t.topic_id, p.post_time
            FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TABLE . ' p
            WHERE p.post_id = t.topic_last_post_id
                AND p.post_time > ' . $userdata['user_lastvisit'] . '
                AND t.topic_moved_id = 0';
        if ( !($result = $db->sql_query($sql)) )
        {
            message_die(GENERAL_ERROR, 'Could not query new topic information', '', __LINE__, __FILE__, $sql);
        }

        $new_topic_data = array();
        while ($topic_data = $db->sql_fetchrow($result))
        {
            $new_topic_data[$topic_data['forum_id']][$topic_data['topic_id']] = $topic_data['post_time'];
        }
        unset ($topic_data);
		$db->sql_freeresult($result);
    }

    //
    // Obtain list of moderators of each forum
    // First users, then groups ... broken into two queries
    //
    // TODO: Moderator Caching ... like in phpBB3?
    $sql = 'SELECT aa.forum_id, u.user_id, u.username
        FROM ' . AUTH_ACCESS_TABLE . ' aa, ' . USER_GROUP_TABLE . ' ug, ' . GROUPS_TABLE . ' g, ' . USERS_TABLE . ' u
        WHERE aa.auth_mod = ' . TRUE . '
            AND g.group_single_user = 1
            AND ug.group_id = aa.group_id
            AND g.group_id = aa.group_id
            AND u.user_id = ug.user_id
        GROUP BY u.user_id, u.username, aa.forum_id
        ORDER BY aa.forum_id, u.user_id';
    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not query forum moderator information', '', __LINE__, __FILE__, $sql);
    }
	$moderator_profile_url = '<a href="' . append_sid('profile.' . $phpEx . '?mode=viewprofile&amp;' . POST_USERS_URL . '=%d') . '">%s</a>';
    $forum_moderators = array();
    while ($row = $db->sql_fetchrow($result))
    {
        $forum_moderators[$row['forum_id']][] = sprintf($moderator_profile_url, $row['user_id'], $row['username']);
    }
	$db->sql_freeresult($result);
	unset ($moderator_profile_url);
    $sql = 'SELECT aa.forum_id, g.group_id, g.group_name
        FROM ' . AUTH_ACCESS_TABLE . ' aa, ' . USER_GROUP_TABLE . ' ug, ' . GROUPS_TABLE . ' g
        WHERE aa.auth_mod = ' . TRUE . '
            AND g.group_single_user = 0
            AND g.group_type <> ' . GROUP_HIDDEN . '
            AND ug.group_id = aa.group_id
            AND g.group_id = aa.group_id
        GROUP BY g.group_id, g.group_name, aa.forum_id
        ORDER BY aa.forum_id, g.group_id';
    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not query forum moderator information', '', __LINE__, __FILE__, $sql);
    }
	$moderator_url = '<a href="' . append_sid('groupcp.' . $phpEx . '?' . POST_GROUPS_URL . '=%d') . '">%s</a>';
    while ($row = $db->sql_fetchrow($result))
    {
        $forum_moderators[$row['forum_id']][] = sprinf($moderator_url, $row['group_id'], $row['group_name']);
    }
	$db->sql_freeresult($result);
	unset ($moderator_url);
    //
    // Find which forums are visible for this user
    //
    $is_auth_ary = array();

    /* - Original phpBB 2.0.6
    $is_auth_ary = auth(AUTH_VIEW, AUTH_LIST_ALL, $userdata, $forum_data);
    */

    // - Last Topic Post on Index
    $is_auth_ary = auth(AUTH_ALL, AUTH_LIST_ALL, $userdata, $forum_data);
    if (!isset($board_config['topic_title_index_size']))
    {
        $board_config['topic_title_index_size'] = 24;  // Title long
    }

    //
    // BEGIN - Birthday Fix
    //

    // Birthday Mod, Show users with birthday
	if ($board_config['birthday_check_day'])
	{
		$sql = 'SELECT user_id, username, user_birthday, user_level 
			FROM ' . USERS_TABLE. ' 
			WHERE user_birthday != 999999 ORDER BY username';
		if (!($result = $db->sql_query($sql)))
		{
			$birthday_week_list = array();
			$birthday_today_list = array();
			$time_now = time();
			$this_year = create_date('Y', $time_now, $board_config['board_timezone']);
			$date_today = create_date('Ymd', $time_now, $board_config['board_timezone']);
			$date_forward = create_date('Ymd', $time_now + ($board_config['birthday_check_day'] * 86400), $board_config['board_timezone']);
			$profile_url = '<a href="' . append_sid('profile.' . $phpEx . '?mode=viewprofile&amp;' . POST_USERS_URL . '=%i') . '">%s (%i)</a>';
			while ($birthdayrow = $db->sql_fetchrow($result))
			{
				$user_birthday2 = $this_year . ($user_birthday = realdate('md', $birthdayrow['user_birthday']));
				if ($user_birthday2 < $date_today)
				{
					$user_birthday2 += 10000;
				}
				if ($user_birthday2 > $date_today  && $user_birthday2 <= $date_forward)
				{
					// user are having birthday within the next days
					$user_age = ($this_year.$user_birthday < $date_today) ? $this_year - realdate ('Y', $birthdayrow['user_birthday']) + 1 : $this_year - realdate('Y', $birthdayrow['user_birthday']);
					$birthday_week_list[] = sprintf($profile_url, $birthdayrow['user_id'], color_group_colorize_name($birthdayrow['user_id'], true), $user_age);
				}
				else if ( $user_birthday2 == $date_today )
				{
					//user have birthday today
					$user_age = $this_year - realdate('Y', $birthdayrow['user_birthday']);
					$birthday_today_list[] = sprintf($profile_url, $birthdayrow['user_id'], color_group_colorize_name($birthdayrow['user_id'], true), $user_age);
				}
			}
			$birthday_today_list = (!empty($birthday_today_list)) ? implode(', ', $birthday_today_list) : '';
			$birthday_week_list = (!empty($birthday_week_list)) ? implode(', ', $birthday_week_list) : '';
			unset ($profile_url, $date_forward, $date_today, $this_year, $time_now);
		}
		$db->sql_freeresult($result);
	}
    //
    // END - Birthday Fix
    //

    //
    // Start output of page
    //
    define('SHOW_ONLINE', true);
    $page_title = $lang['Index'];
    include($phpbb_root_path . 'includes/page_header.'.$phpEx);

    $template->set_filenames(array(
        'body' => 'forum_body.tpl')
    );

    //-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
    //-- add
	if ($nav_cat_desc != '')
	{
		$nav_cat_desc = $nav_separator . $nav_cat_desc;
	}
	$mark = ($viewcat == -1 ) ? '' : '&amp;' . POST_CAT_URL . '=' . $viewcat;
    //-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

    // ChatBox Mod
    require_once($phpbb_root_path . 'chatbox_front.php');

    if ($viewcat == -1 && $userdata['session_logged_in'])
    {
        $template->assign_block_vars('switch_forumview', array());
    }
	
	if ($board_config['birthday_check_day'] > 1)
	{
		if (isset($birthday_week_list))
		{
			$birthdays_week_list = sprintf((empty($birthday_week_list) ? $lang['Nobirthday_week'] : ($lang['Birthday_week'] . $birthday_week_list)), $board_config['birthday_check_day']);
		}
		if (isset($birthday_today_list))
		{
			$birthday_today_list = empty($birthday_today_list) ? $lang['Nobirthday_today'] : $lang['Birthday_today'] . $birthday_today_list;
		}
	}
	else
	{
		unset($birthday_today_list, $birthday_week_list);
	}
	//

    $template->assign_vars(array(
        'TOTAL_POSTS' => sprintf($l_total_post_s, $total_posts),
        'TOTAL_USERS' => sprintf($l_total_user_s, $total_users),
	    'NEWEST_USER' => sprintf($lang['Newest_user'], color_group_colorize_name($newest_uid, FALSE)),

        'FORUM_IMG' => $images['forum'],
        'FORUM_NEW_IMG' => $images['forum_new'],
        'FORUM_LOCKED_IMG' => $images['forum_locked'],
        'CATEGORY_IMG' => $images['category'],
        'CATEGORY_NEW_IMG' => $images['category_new'],
        'CATEGORY_LOCKED_IMG' => $images['category_locked'],
        'FORUM_EXTERNAL' => $images['forum_external'],
        'L_FORUM_EXTERNAL' => $lang['External_link'],

        'L_FORUM' => $lang['Forum'],
        'L_WHOSBIRTHDAY_WEEK' => isset($birthday_week_list) ? $birthday_week_list : '',
        'L_WHOSBIRTHDAY_TODAY' => isset($birthday_today_list) ? $birthday_today_list : '',
        'L_TOPICS' => $lang['Topics'],
        'L_REPLIES' => $lang['Replies'],
        'L_VIEWS' => $lang['Views'],
        'L_POSTS' => $lang['Posts'],
        'L_LASTPOST' => $lang['Last_Post'],
        'L_NO_NEW_POSTS' => $lang['No_new_posts'],
        'L_NEW_POSTS' => $lang['New_posts'],
        'L_NO_NEW_POSTS_LOCKED' => $lang['No_new_posts_locked'],
        'L_NEW_POSTS_LOCKED' => $lang['New_posts_locked'],
        'L_NEW_POSTS_IN_SUBCAT' => $lang['New_posts_in_subcat'],
        'L_SUBCAT' => $lang['Subcat'],
        'L_ONLINE_EXPLAIN' => $lang['Online_explain'],
        // Forum Features MOD
        'L_FORUM_FEATURES' => $lang['Forum_features'],
        'L_NEWEST_DESC' => $lang['Newest_desc'],
        'CAT_HEAD' => $custom_html['head'],
        'CAT_FOOT' => $custom_html['foot'],
        'L_MODERATOR' => $lang['Moderators'],
        'L_FORUM_LOCKED' => $lang['Forum_is_locked'],
        'L_MARK_FORUMS_READ' => $lang['Mark_all_forums'],
        // ChatBox Mod
        'TOTAL_CHATTERS_ONLINE' => sprintf($lang['How_Many_Chatters'], $howmanychat),
        'CHATTERS_LIST' => sprintf($lang['Who_Are_Chatting' ],$chatters),
        'L_CLICK_TO_JOIN_CHAT' => $lang['Click_to_join_chat'],
        'S_JOIN_CHAT' => append_sid('mods/chatbox/chatbox.' . $phpEx),
        'CHATBOX_NAME' => $userdata['user_id'] . '_ChatBox', // To make easier to test on my PC
        'L_LOGIN_TO_JOIN_CHAT' => $lang['Login_to_join_chat'],

        'U_MARK_READ' => append_sid('forum.' . $phpEx . '?mark=forums' . $mark))
    );

    $template->assign_vars(array(
        'NAV_CAT_DESC' => $nav_cat_desc
        )
    );
    $max_depth = ( !$sub_forum ) ? get_max_depth($viewcat) : 0;
    $template->assign_vars(array(
        'INC_SPAN' => $max_depth + 2)
    );
    enhance_cat($viewcat);
    // display the index
    $found = false;
    for ($i=0; ($i < $total_categories) && !$found; $i++)
    {
        if ( ($viewcat==-1 && $category_rows[$i]['cat_main']==0) || ($viewcat > 0 && $category_rows[$i]['cat_id']==$viewcat) )
        {
            display_index_cat($category_rows[$i], $sub_forum, true);
            $found = ($viewcat > 0);
        }
    }
    //  end for ($i=0; ($i < $total_categories) && !$found; $i++)
    //-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

}// if ... total_categories
else
{
    message_die(GENERAL_MESSAGE, $lang['No_forums']);
}
//
// Generate the page
//

$template->pparse('body');
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>
