<?php
/***************************************************************************
 *                                  help.php
 *                            -------------------
 *   begin                : Sunday, Jul 8, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: help.php 414 2005-07-26 16:01:12Z mikethecoder $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$faq = array();

if ( !defined('IN_PRILLIAN_LANG') )
{
    include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_prillian.' . $phpEx);
}

if ( !defined('IN_BID_LANG') )
{
    include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_bid.' . $phpEx);
}

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_HELP);
init_userprefs($userdata);
//
// End session management
//

//
// MOD: Custom Help Page Links
//

//
// Prepare Help names, file names, and modes
//
$allmodes = array();
$allmodes['faq'] = array('lang_file' => 'lang_faq',
                        'l_title' => $lang['Forum'] . ' ' . $lang['Help'],
                        'mode' => 'faq');
$allmodes['bbcode'] = array('lang_file' => 'lang_bbcode',
                        'l_title' => $lang['BBCode_guide'],
                        'mode' => 'bbcode');
$allmodes['attach'] = array('lang_file' => 'lang_faq_attach',
                        'l_title' => $lang['Attach_guide'],
                        'mode' => 'attach');
$allmodes['prill'] = array('lang_file' => 'lang_prillian_faq',
                        'l_title' => $lang['Prillian_FAQ'],
                        'mode' => 'prill');
$allmodes['bid'] = array('lang_file' => 'lang_bid_faq',
                        'l_title' => $lang['BID_List_FAQ'],
                        'mode' => 'bid');
/*
To add more online help:
Copy the block below and paste it above the "/*" line.  You'll also need to fill
in some information.  This list should explain that:
MODE_NAME - The mode used to access the file in a url, like help.php?mode=MODE_NAME
FILE_NAME - The filename of your new lang_help.php style file, without the file
            extension. For example, if the file is lang_cool.php, use 'lang_cool'
LANG_HELP_TITLE - The title of the Help and the name used in the link. This needs to
            be the same as the variable you'll add to lang_main.php later.
Copy the block for each new Help and be sure to leave the single quotes in.
$lang['Cool_Stuff'] is good, $lang[Cool_Stuff] is bad.


$allmodes['MODE_NAME'] = array('lang_file' => 'FILE_NAME',
                        'l_title' => $lang['LANG_HELP_TITLE'],
                        'mode' => 'MODE_NAME');
*/

//
// MOD: -END-
//


//
// Load the appropriate Help file
//
if( isset($HTTP_GET_VARS['mode']) )
{
    switch( $HTTP_GET_VARS['mode'] )
    {
        /*  Original phpBB code - commented out for Custom FAQs Page Links
        case 'bbcode':
            $lang_file = 'lang_bbcode';
            $l_title = $lang['BBCode_guide'];
            break;
        default:
            $lang_file = 'lang_faq';
            $l_title = $lang['Help'];
            break;
    }
}
else
{
    $lang_file = 'lang_faq';
    $l_title = $lang['FAQ'];
}
*/

//
// MOD: Custom FAQs Page Links
//

/*
To add more Help:
Add a new line above the "case 'bbcode':" line. This should be a line like:
        case 'MODE_NAME':
Obviously, replace MODE_NAME with a MODE_NAME you added above.

*/
        case 'prill':
            $lang_file = $allmodes[$HTTP_GET_VARS['mode']]['lang_file'];
            $l_title = $allmodes[$HTTP_GET_VARS['mode']]['l_title'];
            $mode = $allmodes[$HTTP_GET_VARS['mode']]['mode'];
            break;
        case 'bid':
            $lang_file = $allmodes[$HTTP_GET_VARS['mode']]['lang_file'];
            $l_title = $allmodes[$HTTP_GET_VARS['mode']]['l_title'];
            $mode = $allmodes[$HTTP_GET_VARS['mode']]['mode'];
            break;
        case 'attach':
            $lang_file = $allmodes[$HTTP_GET_VARS['mode']]['lang_file'];
            $l_title = $allmodes[$HTTP_GET_VARS['mode']]['l_title'];
            $mode = $allmodes[$HTTP_GET_VARS['mode']]['mode'];
            break;
        case 'bbcode':
            $lang_file = $allmodes[$HTTP_GET_VARS['mode']]['lang_file'];
            $l_title = $allmodes[$HTTP_GET_VARS['mode']]['l_title'];
            $mode = $allmodes[$HTTP_GET_VARS['mode']]['mode'];
            break;
        case 'faq':
        default:
            $lang_file = $allmodes['faq']['lang_file'];
            $l_title = $allmodes['faq']['l_title'];
            $mode = $allmodes['faq']['mode'];
            break;
    }
}
else
{
    $lang_file = $allmodes['faq']['lang_file'];
    $l_title = $allmodes['faq']['l_title'];
    $mode = $allmodes['faq']['mode'];
}

//
// MOD: -END-
//

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/' . $lang_file . '.' . $phpEx);
attach_faq_include($lang_file);

//
// Pull the array data from the lang pack
//
$j = 0;
$counter = 0;
$counter_2 = 0;
$faq_block = array();
$faq_block_titles = array();
$countfaq = count($faq);

for($i = 0; $i < $countfaq; $i++)
{
    if( $faq[$i][0] != '--' )
    {
        $faq_block[$j][$counter]['id'] = $counter_2;
        $faq_block[$j][$counter]['question'] = $faq[$i][0];
        $faq_block[$j][$counter]['answer'] = $faq[$i][1];

        $counter++;
        $counter_2++;
    }
    else
    {
        $j = ( $counter != 0 ) ? $j + 1 : 0;

        $faq_block_titles[$j] = $faq[$i][1];

        $counter = 0;
    }
}
$countfaqblock = count($faq_block);
//
// Lets build a page ...
//
$page_title = $l_title;
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
    'body' => 'help_body.tpl')
);
//make_jumpbox('viewforum.'.$phpEx, $forum_id);

//
// MOD: Custom FAQs Page Links
//

$template->assign_block_vars('other_help', array(
    'L_OTHER_HELP_TITLE' => $lang['Other_Help'])
);

$allmodes_first_pass = TRUE;

reset($allmodes);
while ( list( $key, $val) = each( $allmodes ) )
{
    if( $allmodes_first_pass )
    {
        $divider  = '';
    }
    else
    {
        $divider = ' | ';
    }

    if( $mode != $key )
    {
        $allmodes_first_pass = FALSE;

        $template->assign_block_vars('other_help.other_help_link', array(
            'U_OTHER_HELP' => append_sid("help.$phpEx?mode=" . $val['mode'], true),
            'OTHER_HELP_NAME' => $val['l_title'],
            'DIVIDER' => $divider)
        );
    }
}

//
// MOD: -END-
//

$template->assign_vars(array(
    'L_HELP_TITLE' => $l_title,
    'L_BACK_TO_TOP' => $lang['Back_to_top'])
);

for($i = 0; $i < $countfaqblock; $i++)
{
    if( count($faq_block[$i]) )
    {
        $template->assign_block_vars('help_block', array(
            'BLOCK_TITLE' => $faq_block_titles[$i])
        );
        $template->assign_block_vars('help_block_link', array(
            'BLOCK_TITLE' => $faq_block_titles[$i])
        );

        for($j = 0; $j < count($faq_block[$i]); $j++)
        {
            $row_color = ( !($j % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
            $row_class = ( !($j % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

            $template->assign_block_vars('help_block.help_row', array(
                'ROW_COLOR' => '#' . $row_color,
                'ROW_CLASS' => $row_class,
                'HELP_QUESTION' => $faq_block[$i][$j]['question'],
                'HELP_ANSWER' => $faq_block[$i][$j]['answer'],

                'U_HELP_ID' => $faq_block[$i][$j]['id'])
            );

            $template->assign_block_vars('help_block_link.help_row_link', array(
                'ROW_COLOR' => '#' . $row_color,
                'ROW_CLASS' => $row_class,
                'HELP_LINK' => $faq_block[$i][$j]['question'],

                'U_HELP_LINK' => '#' . $faq_block[$i][$j]['id'])
            );
        }
    }
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>