<?php
/***************************************************************************
 *                            def_qbar.php
 *                            ------------
 *  begin           : 22/07/2003
 *  copyright       : Ptirhiik
 *  email           : admin@rpgnet-fr.com
 *  version         : 1.0.3 - 29/10/2003
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
    die("Hacking attempt");
}

//----------------------------------------------------------------------------
//  $qbar_maps[map_name]
//  --------------------
//      [class]             constant : class of bar : System, Bar, Menu
//      [display]           switch : do we display this qbar (System never are)
//      [cells]             value : number of cells used to display the bar before carriage return
//      [in_table]          switch : Do we draw a table around the qbar
//      [style]             value : Qbar specific to a style
//      [sub_template]      value : Qbar specific to a sub-template (optionnal) : *ALL means ignore
//      [fields]            array : options of the qbar
//          [shortcut]      value : lang[] key or value for the shortcut displayed
//          [alternate]     value : lang[] key or value for shortcut when pms are more than one
//          [explain]       value : lang[] key or value for the shortcut used as title or alt on mouseover
//          [icon]          value : images[] key or url to the icon
//          [use_value]     switch : we use the value to display
//          [use_icon]      switch : we use the icon to display
//          [is_droplet]    switch : The URL is not a link but uses the code as a Droplet (Block)
//          [use_indent]    switch : we use an indent
//          [url]           value : url of the prog to call while clicking on shortcut
//          [internal]      switch : does tbe program is in phpBB dirs ? if true, do append_sid() with
//          [auth_logged]   switch : ignore/required/denied to : the option will be display if
//          [auth_admin]    switch : ignore/required/denied to : admin user check
//          [auth_pm]       switch : ignore/new_pm/unread pm/no new nor unread : pm check
//          [tree_id]       value : if the user is authorized to the forum tree level (auth view)
//----------------------------------------------------------------------------

$qbar_maps = array(
    
    'Navigation Bar' => array(
        'class'         => 'Bar',
        'display'       => true,
        'cells'         => 11,
        'in_table'      => false,
        'style'         => 0,
        'sub_template'  => '',
        'fields'        => array(
                        'Home' => array(
                                'shortcut'         => 'Home',
                                'explain'         => 'Home Short',
                                'use_value'     => true,
                                'url'             => 'index.php',
                                'internal'         => true,
                            ),
                        'Knowledge Base' => array(
                                'shortcut'         => 'KB_title',
                                'explain'         => 'KB_title',
                                'use_value'     => true,
                                'url'             => 'kb.php',
                                'internal'         => true,
                            ),
                        'Forums' => array(
                                'shortcut'         => 'Forums',
                                'explain'         => 'Forums',
                                'use_value'     => true,
                                'url'             => 'forum.php',
                                'internal'         => true,
                            ),
                        'FAQ' => array(
                                'shortcut'         => 'FAQ',
                                'explain'         => 'FAQ',
                                'use_value'     => true,
                                'url'             => 'faq.php',
                                'internal'         => true,
                            ),
                        'Links' => array(
                                'shortcut'         => 'Links',
                                'explain'         => 'Links',
                                'use_value'     => true,
                                'url'             => 'directory.php',
                                'internal'         => true,
                            ),
                        'Downloads' => array(
                                'shortcut'         => 'Downloads',
                                'explain'         => 'Downloads',
                                'use_value'     => true,
                                'url'             => 'dload.php',
                                'internal'         => true,
                            ),
                        'Album' => array(
                                'shortcut'         => 'Album',
                                'explain'         => 'Album',
                                'use_value'     => true,
                                'url'             => 'album.php',
                                'internal'         => true,
                            ),
                        'Calendar' => array(
                                'shortcut'         => 'Calendar',
                                'explain'         => 'Calendar',
                                'use_value'     => true,
                                'url'             => 'mycalendar.php',
                                'internal'         => true,
                            ),
                        'Help' => array(
                                'shortcut'         => 'Help',
                                'explain'         => 'Help',
                                'use_value'     => true,
                                'url'             => 'help.php',
                                'internal'         => true,
                            ),
                        'Register' => array(
                                'shortcut'         => 'Register',
                                'explain'         => 'Register_explain',
                                'use_value'     => true,
                                'url'             => 'profile.php?mode=register',
                                'internal'         => true,
                                'auth_logged'     => 2,
                            ),
                        'Profile' => array(
                                'shortcut'         => 'Profile',
                                'explain'         => 'Profile_explain',
                                'use_value'     => true,
                                'url'             => 'profile.php?mode=editprofile',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Login' => array(
                                'shortcut'         => 'Login',
                                'explain'         => 'Login_explain',
                                'use_value'     => true,
                                'url'             => 'login.php',
                                'internal'         => true,
                                'auth_logged'     => 2,
                            ),
                        'Logout' => array(
                                'shortcut'         => 'Logout',
                                'explain'         => 'Logout_explain',
                                'use_value'     => true,
                                'url'             => 'login.php?logout=true',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                    ),
    ),
    
    'Navigation Menu' => array(
        'class'         => 'Left',
        'display'       => true,
        'cells'         => 1,
        'in_table'      => false,
        'style'         => 0,
        'sub_template'  => '',
        'fields'        => array(
                        'News' => array(
                                'shortcut'         => 'News',
                                'explain'         => 'News',
                                'use_value'     => true,
                                'url'             => 'index.php',
                                'internal'         => true,
                            ),
                        'News Archives' => array(
                                'shortcut'         => 'Archives',
                                'explain'         => 'Archives',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'index.php?archives=1',
                                'internal'         => true,
                            ),
                        'News Categories' => array(
                                'shortcut'         => 'Categories',
                                'explain'         => 'Categories',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'index.php?topics=1',
                                'internal'         => true,
                            ),
                        'Knowledge Base' => array(
                                'shortcut'         => 'KB_title',
                                'explain'         => 'KB_title',
                                'use_value'     => true,
                                'url'             => 'kb.php',
                                'internal'         => true,
                            ),
                        'KB Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'kb_search.php',
                                'internal'         => true,
                            ),
                        'Forums' => array(
                                'shortcut'         => 'Forums',
                                'explain'         => 'Forums',
                                'use_value'     => true,
                                'url'             => 'forum.php',
                                'internal'         => true,
                            ),
                        'Forum Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'search.php',
                                'internal'         => true,
                            ),
                        'FAQ' => array(
                                'shortcut'         => 'FAQ',
                                'explain'         => 'FAQ',
                                'use_value'     => true,
                                'url'             => 'faq.php',
                                'internal'         => true,
                            ),
                        'Links' => array(
                                'shortcut'         => 'Links',
                                'explain'         => 'Links',
                                'use_value'     => true,
                                'url'             => 'directory.php',
                                'internal'         => true,
                            ),
                        'Links Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'directory.php?mode=search',
                                'internal'         => true,
                            ),
                        'Downloads' => array(
                                'shortcut'         => 'Downloads',
                                'explain'         => 'Downloads',
                                'use_value'     => true,
                                'url'             => 'dload.php',
                                'internal'         => true,
                            ),
                        'Downloads Top Rated' => array(
                                'shortcut'         => 'Top_rated',
                                'explain'         => 'Top_rated',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'dload.php?action=toplist',
                                'internal'         => true,
                            ),
                        'Download Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'dload.php?action=search',
                                'internal'         => true,
                            ),
                        'Photo Album' => array(
                                'shortcut'         => 'Album',
                                'explain'         => 'Album',
                                'use_value'     => true,
                                'url'             => 'album.php',
                                'internal'         => true,
                            ),
                        'Radio' => array(
                                'shortcut'         => 'Radio',
                                'explain'         => 'Radio',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'javascript:openRadioPopup();',
                            ),
                        'Calendar' => array(
                                'shortcut'         => 'Calendar',
                                'explain'         => 'Calendar',
                                'use_value'     => true,
                                'url'             => 'mycalendar.php',
                                'internal'         => true,
                            ),
                        'Games' => array(
                                'shortcut'         => 'Activity',
                                'explain'         => 'Activity',
                                'use_value'     => true,
                                'url'             => 'activity.php',
                                'internal'         => true,
                            ),
                        'Help' => array(
                                'shortcut'         => 'Help',
                                'explain'         => 'Help',
                                'use_value'     => true,
                                'url'             => 'help.php',
                                'internal'         => true,
                            ),
                    ),
    ),
    
    'Site Information' => array(
        'class'         => 'Left',
        'display'       => true,
        'cells'         => 1,
        'in_table'      => false,
        'style'         => 0,
        'sub_template'  => '',
        'fields'        => array(
                        'Rules' => array(
                                'shortcut'         => 'Rules',
                                'explain'         => 'Rules',
                                'use_value'     => true,
                                'url'             => 'rules.php',
                                'internal'         => true,
                            ),
                        'Staff List' => array(
                                'shortcut'         => 'Staff',
                                'explain'         => 'Staff',
                                'use_value'     => true,
                                'url'             => 'staff.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Memberlist' => array(
                                'shortcut'         => 'Memberlist',
                                'explain'         => 'Memberlist_explain',
                                'use_value'     => true,
                                'url'             => 'memberlist.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Buddies' => array(
                                'shortcut'         => 'Buddies',
                                'explain'         => 'Buddies',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'bid.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Usergroups' => array(
                                'shortcut'         => 'Usergroups',
                                'explain'         => 'Usergroups_explain',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'groupcp.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'System Specs' => array(
                                'shortcut'         => 'View_ranking',
                                'explain'         => 'View_ranking',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'system_ranking.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Admin_configuration_panel' => array(
                                'shortcut'         => 'Admin',
                                'explain'         => 'Admin',
                                'use_value'     => true,
                                'url'             => 'admin/index.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                                'auth_admin'     => 1,
                            ),
                    ),
    ),
    
    'Links' => array(
        'class'         => 'Left',
        'display'       => true,
        'cells'         => 5,
        'in_table'      => true,
        'style'         => 0,
        'sub_template'  => '',
        'fields'        => array(
                        'Minerva' => array(
                                'shortcut'         => 'Minerva',
                                'explain'         => 'Official Project Minerva Support Site',
                                'use_value'     => true,
                                'url'             => 'http://www.project-minerva.org/',
                            ),
                    ),
    ),
    
    'default_nav_menu' => array(
        'class'         => 'System',
        'display'       => false,
        'cells'         => 0,
        'in_table'      => false,
        'style'         => 0,
        'sub_template'  => '',
        'fields'        => array(
                        'News' => array(
                                'shortcut'         => 'News',
                                'explain'         => 'News',
                                'use_value'     => true,
                                'url'             => 'index.php',
                                'internal'         => true,
                            ),
                        'News Archives' => array(
                                'shortcut'         => 'Archives',
                                'explain'         => 'Archives',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'index.php?archives=1',
                                'internal'         => true,
                            ),
                        'News Categories' => array(
                                'shortcut'         => 'Categories',
                                'explain'         => 'Categories',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'index.php?topics=1',
                                'internal'         => true,
                            ),
                        'Knowledge Base' => array(
                                'shortcut'         => 'KB_title',
                                'explain'         => 'KB_title',
                                'use_value'     => true,
                                'url'             => 'kb.php',
                                'internal'         => true,
                            ),
                        'KB Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'kb_search.php',
                                'internal'         => true,
                            ),
                        'Forums' => array(
                                'shortcut'         => 'Forums',
                                'explain'         => 'Forums',
                                'use_value'     => true,
                                'url'             => 'forum.php',
                                'internal'         => true,
                            ),
                        'Forum Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'search.php',
                                'internal'         => true,
                            ),
                        'FAQ' => array(
                                'shortcut'         => 'FAQ',
                                'explain'         => 'FAQ',
                                'use_value'     => true,
                                'url'             => 'faq.php',
                                'internal'         => true,
                            ),
                        'Links' => array(
                                'shortcut'         => 'Links',
                                'explain'         => 'Links',
                                'use_value'     => true,
                                'url'             => 'directory.php',
                                'internal'         => true,
                            ),
                        'Links Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'directory.php?mode=search',
                                'internal'         => true,
                            ),
                        'Downloads' => array(
                                'shortcut'         => 'Downloads',
                                'explain'         => 'Downloads',
                                'use_value'     => true,
                                'url'             => 'dload.php',
                                'internal'         => true,
                            ),
                        'Downloads Top Rated' => array(
                                'shortcut'         => 'Top_rated',
                                'explain'         => 'Top_rated',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'dload.php?action=toplist',
                                'internal'         => true,
                            ),
                        'Download Search' => array(
                                'shortcut'         => 'Search',
                                'explain'         => 'Search',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'dload.php?action=search',
                                'internal'         => true,
                            ),
                        'Photo Album' => array(
                                'shortcut'         => 'Album',
                                'explain'         => 'Album',
                                'use_value'     => true,
                                'url'             => 'album.php',
                                'internal'         => true,
                            ),
                        'Radio' => array(
                                'shortcut'         => 'Radio',
                                'explain'         => 'Radio',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'javascript:openRadioPopup();',
                            ),
                        'Calendar' => array(
                                'shortcut'         => 'Calendar',
                                'explain'         => 'Calendar',
                                'use_value'     => true,
                                'url'             => 'mycalendar.php',
                                'internal'         => true,
                            ),
                        'Games' => array(
                                'shortcut'         => 'Activity',
                                'explain'         => 'Activity',
                                'use_value'     => true,
                                'url'             => 'activity.php',
                                'internal'         => true,
                            ),
                        'PM_simple' => array(
                                'shortcut'         => 'Private_Messaging',
                                'explain'         => 'Private_Messaging_explain',
                                'use_value'     => true,
                                'url'             => 'privmsg.php?folder=inbox',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Prillian' => array(
                                'shortcut'         => 'Launch_phpBB_IM',
                                'explain'         => 'Launch_phpBB_IM',
                                'use_value'     => true,
                                'url'             => 'javascript:prill_launch(\'imclient.php?mode=frames&oldmode=main\', \'225\', \'400\');',
                                'auth_logged'     => 1,
                            ),
                    ),
    ),
    
    'default_sysinfo_menu' => array(
        'class'         => 'System',
        'display'       => false,
        'cells'         => 0,
        'in_table'      => false,
        'style'         => 0,
        'sub_template'  => '',
        'fields'        => array(
                        'Acronym' => array(
                                'shortcut'         => 'Acronym',
                                'explain'         => 'Acronym',
                                'use_value'     => true,
                                'url'             => 'acronyms.php',
                                'internal'         => true,
                            ),
                        'Smart' => array(
                                'shortcut'         => 'Smart',
                                'explain'         => 'Smart',
                                'use_value'     => true,
                                'url'             => 'smart.php',
                                'internal'         => true,
                            ),
                        'Rules' => array(
                                'shortcut'         => 'Rules',
                                'explain'         => 'Rules',
                                'use_value'     => true,
                                'url'             => 'rules.php',
                                'internal'         => true,
                            ),
                        'Staff List' => array(
                                'shortcut'         => 'Staff',
                                'explain'         => 'Staff',
                                'use_value'     => true,
                                'url'             => 'staff.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Memberlist' => array(
                                'shortcut'         => 'Memberlist',
                                'explain'         => 'Memberlist_explain',
                                'use_value'     => true,
                                'url'             => 'memberlist.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Buddies' => array(
                                'shortcut'         => 'Buddies',
                                'explain'         => 'Buddies',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'bid.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Usergroups' => array(
                                'shortcut'         => 'Usergroups',
                                'explain'         => 'Usergroups_explain',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'groupcp.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'System Specs' => array(
                                'shortcut'         => 'View_ranking',
                                'explain'         => 'View_ranking',
                                'use_value'     => true,
                                'use_indent'     => true,
                                'url'             => 'system_ranking.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                            ),
                        'Statistics' => array(
                                'shortcut'         => 'Statistics',
                                'explain'         => 'Statistics',
                                'use_value'     => true,
                                'url'             => 'statistics.php',
                                'internal'         => true,
                            ),
                        'Admin_configuration_panel' => array(
                                'shortcut'         => 'Admin',
                                'explain'         => 'Admin',
                                'use_value'     => true,
                                'url'             => 'admin/index.php',
                                'internal'         => true,
                                'auth_logged'     => 1,
                                'auth_admin'     => 1,
                            ),
                    ),
    ),
    
    // standard forum tree
    'default_tree' => array(
        'class'         => 'System',
        'display'       => false,
        'cells'         => 0,
        'in_table'      => false,
        'sub_template'  => '*ALL',
        'fields'        => array(
        ),
    ),
);

?>
