<?php

function month_to_int($mon) 
{

	$months = array(
		'January'	=> 1,
		'February'	=> 2,
		'March'		=> 3,
		'April'		=> 4,
		'May'		=> 5,
		'June'		=> 6,
		'July'		=> 7,
		'August'	=> 8,
		'September'	=> 9,
		'October'	=> 10,
		'November'	=> 11,
		'December'	=> 12,
	);

	return $months[$mon];
}

function update_topic_time($topic_id, $time)
{
	global $db;

	$topic_id = intval($topic_id);
	$time = intval($time);

	$sql = 'UPDATE ' . TOPICS_TABLE . ' SET
		topic_time = \'' . $time . '\'
		WHERE topic_id = ' . $topic_id;

	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Failed to Update Topic Time for Topic ID \'' . $topic_id . '\'', '', __LINE__, __FILE__, $sql);
	}
}

function update_first_post($topic_id, $post_id, $time = NULL)
{
	global $db;

	$topic_id = intval($topic_id);
	$post_id = intval($post_id);

	if ($time === NULL)
	{
		$time_sql = '';
	}
	else
	{
		$time = intval($time);
		$time_sql = ', topic_time = \'' . $time . '\'';
	}

	$sql = 'UPDATE ' . TOPICS_TABLE . ' SET
		topic_first_post_id = ' . $post_id . $time_sql . '
		WHERE topic_id = ' . $topic_id;

	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Failed to Update First Post for Topic ID \'' . $topic_id . '\'', '', __LINE__, __FILE__, $sql);
	}
}

function update_last_post($topic_id, $post_id)
{
	global $db;

	$topic_id = intval($topic_id);
	$post_id = intval($post_id);

	$sql = 'UPDATE ' . TOPICS_TABLE . ' SET
		topic_last_post_id = ' . $post_id . '
		WHERE topic_id = ' . $topic_id;

	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Failed to Update Last Post for Topic ID \'' . $topic_id . '\'', '', __LINE__, __FILE__, $sql);
	}
}

function update_post_time($post_id, $time)
{
	global $db;

	$time = !is_numeric($time) ? intval($time) : $time;
	$post_id = !is_numeric($post_id) ? intval($post_id) : $post_id;

	$sql = 'UPDATE ' . POSTS_TABLE . ' SET
		post_time = \'' . $time . '\'
		WHERE post_id = ' . $post_id;
	
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Failed to update Post Date for Post #' . $post_id, '', __LINE__, __FILE__, $sql);
	}
}

function get_post_time($post_id)
{
	global $db;

	$post_id = intval($post_id);

	$sql = 'SELECT post_time as time 
		FROM ' . POSTS_TABLE . ' 
		WHERE post_id = ' . $post_id;

	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Couldn\'t Retrieve Post Time for Post \'' . $post_id . '\'', '', __LINE__, __FILE__, $sql);
	}
	
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	return intval($row['time']);
}

function get_topic_post_times($topic_id, $order)
{
	global $db;

	$topic_id = intval($topic_id);
	$order = strtoupper(trim($order));

	if ($order != 'DESC' && $order != 'ASC')
	{
		message_die (GENERAL_ERROR, 'Invalid Parameters Passed', '', __LINE__, __FILE__);
	}

	$sql = 'SELECT p.post_time as time, p.post_id as id 
		FROM ' . POSTS_TABLE . ' p
		WHERE p.topic_id = ' . $topic_id . ' 
		ORDER BY p.post_time ' . $order;

	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Failed to get Topic Post Times for Topic ID \'' . $topic_id . '\'', '', __LINE__, __FILE__, $sql);
	}
	
	$post_times = array();
	
	if ($row = $db->sql_fetchrow($result))
	{
		// TODO: Is this loop needed?
		do
		{
			$post_times[intval($row['id'])] = intval($row['time']);
		}
		while ($row = $db->sql_fetchrow($result));
	}
	$db->sql_freeresult($result);

	return $post_times;
}


/*********************/
/* WRAPPER FUNCTIONS */
/*********************/

function get_topic_newest_post_time($topic_id)
{
	$times = get_topic_post_times($topic_id, 'DESC');

	reset ($times);
	$newest_post = array();
	$newest_post['id'] = key($times);
	$newest_post['time'] = current($times);
	unset ($times);

	return $newest_post;
}

function get_topic_oldest_post_time($topic_id)
{
	$times = get_topic_post_times($topic_id, 'ASC');

	reset ($times);
	$odlest_post = array();
	$oldest_post['id'] = key($times);
	$oldest_post['time'] = current($times);

	unset ($times);

	return $oldest_post;
}
?>
