<?php
/***************************************************************************
 *                               functions.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: functions.php 455 2006-06-16 15:44:17Z arthur $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

if (!defined('IN_PHPBB'))
{
	die ('Hacking Attempt!');
}

if (defined('FUNCTIONS_INC'))
{
	return; // Multi Includes are _evil_!
}

include_once ($phpbb_root_path . 'includes/functions_forum.php');

define('FUNCTIONS_INC', TRUE);

//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- add v 1.0.9
//$nav_separator = "&nbsp;->&nbsp;";
$nav_separator = ' &raquo; ';
$nav_link_active = true;

/**
 * Replace array_intersect_key()
 *
 * @category	PHP
 * @package		PHP_Compat
 * @link		http://php.net/function.array_intersect_key
 * @author		Tom Buskens <ortega@php.net>
 * @version		$Revision: 455 $
 * @since		PHP 5.0.2
 * @require		PHP 4.0.0 (user_error)
 */
if (!function_exists('array_intersect_key'))
{
	function array_intersect_key()
	{
		$args = func_get_args();
		if (count($args) < 2)
		{
			user_error('Wrong parameter count for array_intersect_key()', E_USER_WARNING);
			return;
		}

		// Check arrays
		$array_count = count($args);
		for ($i = 0; $i !== $array_count; $i++)
		{
			if (!is_array($args[$i]))
			{
				user_error('array_intersect_key() Argument #' .	($i + 1) . ' is not an array', E_USER_WARNING);
				return;
			}
		}

		// Compare entries
		$result = array();
		foreach ($args[0] as $key1 => $value1)
		{
			for ($i = 1; $i !== $array_count; $i++)
			{
				foreach ($args[$i] as $key2 => $value2)
				{
					if ((string) $key1 === (string) $key2)
					{
						$result[$key1] = $value1;
					}
				}
			}
		}

		return $result;
	}
}

function get_db_stat($mode)
{
	global $db;

	switch ($mode)
	{
		case 'usercount':
			$sql = 'SELECT COUNT(user_id) AS total
				FROM ' . USERS_TABLE . '
				WHERE user_id <> ' . ANONYMOUS;
			break;

		case 'newestuser':
			$sql = 'SELECT user_id, username
				FROM ' . USERS_TABLE . '
				WHERE user_id <> ' . ANONYMOUS . '
				ORDER BY user_id DESC
				LIMIT 1';
			break;

		case 'postcount':
		case 'topiccount':
			$sql = 'SELECT SUM(forum_topics) AS topic_total, SUM(forum_posts) AS post_total
				FROM ' . FORUMS_TABLE;
			break;
	   	default:
	   		return false;
	}

	if (!($result = $db->sql_query($sql)))
	{
		return false;
	}

	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	switch ($mode)
	{
		case 'usercount':
			return $row['total'];
			break;
		case 'newestuser':
			return $row;
			break;
		case 'postcount':
			return $row['post_total'];
			break;
		case 'topiccount':
			return $row['topic_total'];
			break;
	}
	return false;
}

// added at phpBB 2.0.11 to properly format the username
function phpbb_clean_username($username)
{
	$username = substr(htmlspecialchars(str_replace("\'", "'", trim($username))), 0, 25);
	$username = phpbb_rtrim($username, "\\");
	$username = str_replace("'", "\'", $username);
	return $username;
}

/**
* This function is a wrapper for ltrim, as charlist is only supported in php >= 4.1.0
* Added in phpBB 2.0.18
*/
function phpbb_ltrim($str, $charlist = false)
{
	if ($charlist === false)
	{
		return ltrim($str);
	}
	
	$php_version = explode('.', PHP_VERSION);

	// php version < 4.1.0
	if ((int) $php_version[0] < 4 || ((int) $php_version[0] == 4 && (int) $php_version[1] < 1))
	{
		while ($str{0} == $charlist)
		{
			$str = substr($str, 1);
		}
	}
	else
	{
		$str = ltrim($str, $charlist);
	}

	return $str;
}

/**
* Our own generator of random values
* This uses a constantly changing value as the base for generating the values
* The board wide setting is updated once per page if this code is called
* With thanks to Anthrax101 for the inspiration on this one
* Added in phpBB 2.0.20
*/
function dss_rand()
{
	global $db, $board_config, $dss_seeded;

	$val = $board_config['rand_seed'] . microtime();
	$val = md5($val);
	$board_config['rand_seed'] = md5($board_config['rand_seed'] . $val . 'a');
   
	if($dss_seeded !== true)
	{
		$sql = "UPDATE " . CONFIG_TABLE . " SET
			config_value = '" . $board_config['rand_seed'] . "'
			WHERE config_name = 'rand_seed'";
		
		if( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Unable to reseed PRNG", "", __LINE__, __FILE__, $sql);
		}

		$dss_seeded = true;
	}

	return substr($val, 4, 16);
}

// added at phpBB 2.0.12 to fix a bug in PHP 4.3.10 (only supporting charlist in php >= 4.1.0)
function phpbb_rtrim($str, $charlist = false)
{
	if ($charlist === false)
	{
		return rtrim($str);
	}

	$php_version = explode('.', PHP_VERSION);

	// php version < 4.1.0
	if ((int) $php_version[0] < 4 || ((int) $php_version[0] == 4 && (int) $php_version[1] < 1))
	{
		$len = strlen($str);
		while ($str{$len - 1} == $charlist)
		{
			$str = substr($str, 0, $len - 1);
		}
	}
	else
	{
		$str = rtrim($str, $charlist);
	}

	return $str;
}

//
// This does exactly what preg_quote() does in PHP 4-ish
// If you just need the 1-parameter preg_quote call, then don't bother using this.
//
function phpbb_preg_quote($str, $delimiter)
{
	$text = preg_quote($str);
	$text = str_replace($delimiter, '\\' . $delimiter, $text);
	return $text;
}

function phpbb_realpath($path)
{
	return realpath($path);
}

//
// Get Userdata, $user can be username or user_id. If force_str is true, the username will be forced.
//
function get_userdata($user, $force_str = false)
{
	global $db;

	if (!is_numeric($user) || $force_str)
	{
		$user = phpbb_clean_username($user);
	}
	else
	{
		$user = intval($user);
	}

	$sql = 'SELECT *
		FROM ' . USERS_TABLE . '
		WHERE ';
	$sql .= ( ( is_integer($user) ) ? "user_id = $user" : "username = '" .  str_replace("\'", "''", $user) . "'" ) . " AND user_id <> " . ANONYMOUS;
	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Tried obtaining data for a non-existent user', '', __LINE__, __FILE__, $sql);
	}
	$return = ($row = $db->sql_fetchrow($result)) ? $row : false;
	$db->sql_freeresult($result);
	return $return;
}

function make_jumpbox($action, $match_forum_id = 0)
{
	global $template, $userdata, $lang, $db, $nav_links, $phpEx, $SID;

	$category_rows = array();
	$category_rows = get_auth_cat();

	$boxstring = '';
	if ($total_categories = count($category_rows))
	{
		$sql = 'SELECT forum_id, forum_name, cat_id
			FROM ' . FORUMS_TABLE . '
			ORDER BY cat_id, forum_order';
		if (!($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not obtain forums information', '', __LINE__, __FILE__, $sql);
		}

		$boxstring = '<select name="' . POST_FORUM_URL . '" onchange="if(this.options[this.selectedIndex].value != -1){ forms[\'jumpbox\'].submit() }"><option value="-1">' . $lang['Select_forum'] . '</option>';

		$forum_rows = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$forum_rows[] = $row;
		}
		$db->sql_freeresult($result);
		
		if ($total_forums = count($forum_rows))
		{
			for ($i = 0; $i < $total_categories; $i++)
			{
				$boxstring_forums = '';
				$inc = '';
				for ($k = 1; $k < $category_rows[$i]['level']; $k++)
				{
					$inc = '|&nbsp;&nbsp;&nbsp;' . $inc;
				}
				$inc = ( ($category_rows[$i]['level'] > 0) ? '|&nbsp;&nbsp;&nbsp;' : '|--' ) . $inc;
				$inc .= ($category_rows[$i]['level'] > 0) ? '|--' : '';

				for ($j = 0; $j < $total_forums; $j++)
				{
					$do_it = false;
					if ($forum_rows[$j]['cat_id'] == $category_rows[$i]['cat_id'])
					{
						$is_auth = array();
						$is_auth = auth(AUTH_ALL, $forum_rows[$j]['forum_id'], $userdata);
						$do_it = $is_auth['auth_view'];
					}
					if ($do_it)
					{
						$selected = ( $forum_rows[$j]['forum_id'] == $match_forum_id ) ? 'selected="selected"' : '';

						$boxstring_forums .=  '<option value="' . $forum_rows[$j]['forum_id'] . '"' . $selected . '>' . '|&nbsp;&nbsp;&nbsp;' . $inc . '&nbsp;' . $forum_rows[$j]['forum_name'] . '</option>';

						//
						// Add an array to $nav_links for the Mozilla navigation bar.
						// 'chapter' and 'forum' can create multiple items, therefore we are using a nested array.
						//
						$nav_links['chapter forum'][$forum_rows[$j]['forum_id']] = array (
							'url'	=> append_sid('viewforum.' . $phpEx . '?' . POST_FORUM_URL . '=' . $forum_rows[$j]['forum_id']),
							'title'	=> $forum_rows[$j]['forum_name'],
						);
					}
				}

				if ( $i == 0 )
				{
					$boxstring .= '<option value="-1">&nbsp;</option>';
					$boxstring .= '<option value="-1">' . $lang['Forum_index'] . '</option>';
				}
				$boxstring .= '<option value="-1">' . $inc . '[' . $category_rows[$i]['cat_title'] . ']</option>';
				$boxstring .= $boxstring_forums;
			}
		}
		unset ($total_forums);
		$boxstring .= '</select>';
	}
	else
	{
		$boxstring .= '<select name="' . POST_FORUM_URL . '" onchange="if(this.options[this.selectedIndex].value != -1){ forms[\'jumpbox\'].submit() }"></select>';
	}
	unset ($total_categories);
	$boxstring .= '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" />';

	$template->set_filenames(array(
		'jumpbox' => 'jumpbox.tpl')
	);
	$template->assign_vars(array(
		'L_GO' => $lang['Go'],
		'L_JUMP_TO' => $lang['Jump_to'],
		'L_SELECT_FORUM' => $lang['Select_forum'],

		'S_JUMPBOX_SELECT' => $boxstring,
		'S_JUMPBOX_ACTION' => append_sid($action))
	);
	$template->assign_var_from_handle('JUMPBOX', 'jumpbox');

	return;
}

//
// Include language files
//
function language_include($category)
{
	global $phpbb_root_path, $board_config, $lang, $faq, $phpEx;
	$dirname = $phpbb_root_path . 'language/lang_' . $board_config['default_lang'];
	$dir = opendir($dirname);
	while ($file = readdir($dir))
	{
		if (strpos($file, 'lang_' . $category) === 0 && is_file($dirname . '/' . $file) && !is_link($dirname . '/' . $file))
		{
			include($dirname . '/' . $file);
		}
	}
	closedir($dir);
}

//
// Initialise user settings on page load
function init_userprefs($userdata)
{
	global $board_config, $theme, $images;
	global $template, $lang, $phpEx, $phpbb_root_path, $db;
	global $nav_links;

	if ($userdata['user_id'] != ANONYMOUS)
	{
		if (!empty($userdata['user_lang']))
		{
			$default_lang = phpbb_ltrim(basename(phpbb_rtrim($userdata['user_lang'])), "'");
		}

		if (!empty($userdata['user_dateformat']))
		{
			$board_config['default_dateformat'] = $userdata['user_dateformat'];
		}

		if (!empty($userdata['user_timezone']))
		{
			$board_config['board_timezone'] = $userdata['user_timezone'];
		}
	}
	else
	{
		$default_lang = phpbb_ltrim(basename(phpbb_rtrim($board_config['default_lang'])), "'");
	}

	if ( !file_exists(@phpbb_realpath($phpbb_root_path . 'language/lang_' . $default_lang . '/lang_main.'.$phpEx)) )
	{
		if ( $userdata['user_id'] != ANONYMOUS )
		{
			// For logged in users, try the board default language next
			$default_lang = phpbb_ltrim(basename(phpbb_rtrim($board_config['default_lang'])), "'");
		}
		else
		{
			// For guests it means the default language is not present, try english
			// This is a long shot since it means serious errors in the setup to reach here,
			// but english is part of a new install so it's worth us trying
			$default_lang = 'english';
		}

		if ( !file_exists(@phpbb_realpath($phpbb_root_path . 'language/lang_' . $default_lang . '/lang_main.'.$phpEx)) )
		{
			message_die(CRITICAL_ERROR, 'Could not locate valid language pack');
		}
	}

	// If we've had to change the value in any way then let's write it back to the database
	// before we go any further since it means there is something wrong with it
	if ( $userdata['user_id'] != ANONYMOUS && $userdata['user_lang'] !== $default_lang )
	{
		$sql = 'UPDATE ' . USERS_TABLE . "
			SET user_lang = '" . $default_lang . "'
			WHERE user_lang = '" . $userdata['user_lang'] . "'";

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(CRITICAL_ERROR, 'Could not update user language info');
		}

		$userdata['user_lang'] = $default_lang;
	}
	elseif ( $userdata['user_id'] === ANONYMOUS && $board_config['default_lang'] !== $default_lang )
	{
		$sql = 'UPDATE ' . CONFIG_TABLE . "
			SET config_value = '" . $default_lang . "'
			WHERE config_name = 'default_lang'";

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(CRITICAL_ERROR, 'Could not update user language info');
		}
	}

	$board_config['default_lang'] = $default_lang;
	language_include('main');

	if (defined('IN_CASHMOD'))
	{
		if (!file_exists(@phpbb_realpath($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_cash.'.$phpEx)))
		{
			include($phpbb_root_path . 'language/lang_english/lang_cash.' . $phpEx);
		}
		else
		{
			include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_cash.' . $phpEx);
		}
	}
	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_news.' . $phpEx);
	//include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_ecp.' . $phpEx);

	if (defined('IN_ADMIN'))
	{
		if(!file_exists(@phpbb_realpath($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin.'.$phpEx)))
		{
			$board_config['default_lang'] = 'english';
		}
		language_include('admin');
	}
/**
* TODO: Fix
	include_mycalendar_lang();
	include_attach_lang();
*/
//-- mod : language settings -----------------------------------------------------------------------
//-- add
	include($phpbb_root_path . './includes/lang_extend_mac.' . $phpEx);
//-- fin mod : language settings -------------------------------------------------------------------

	//
	// Mozilla navigation bar
	// Default items that should be valid on all pages.
	// Defined here to correctly assign the Language Variables
	// and be able to change the variables within code.
	//
	$nav_links['top'] = array (
		'url' => append_sid($phpbb_root_path . 'index.' . $phpEx),
		'title' => sprintf($lang['Forum_Index'], $board_config['sitename'])
	);
	$nav_links['search'] = array (
		'url' => append_sid($phpbb_root_path . 'search.' . $phpEx),
		'title' => $lang['Search']
	);
	$nav_links['help'] = array (
		'url' => append_sid($phpbb_root_path . 'help.' . $phpEx),
		'title' => $lang['Help']
	);
	$nav_links['author'] = array (
		'url' => append_sid($phpbb_root_path . 'memberlist.' . $phpEx),
		'title' => $lang['Memberlist']
	);

	//
	// Set up style
	//
	if (!$board_config['override_user_style'])
	{
		if ($userdata['user_id'] != ANONYMOUS && $userdata['user_style'] > 0)
		{
			if ($theme = setup_style($userdata['user_style']))
			{
				return;
			}
		}
	}

	$theme = setup_style($board_config['default_style']);

	return;
}

function setup_style($style)
{
	global $db, $board_config, $template, $images, $phpbb_root_path;

	$sql = 'SELECT *
		FROM ' . THEMES_TABLE . '
		WHERE themes_id = ' . intval($style);
	if (!($result = $db->sql_query($sql)))
	{
		message_die(CRITICAL_ERROR, 'Could not query database for theme info');
	}


	if (!($row = $db->sql_fetchrow($result)))
	{
		// We are trying to setup a style which does not exist in the database
		// Try to fallback to the board default (if the user had a custom style)
		// and then any users using this style to the default if it succeeds
		if ( $style != $board_config['default_style'])
		{
			$sql = 'SELECT *
				FROM ' . THEMES_TABLE . '
				WHERE themes_id = ' . (int) $board_config['default_style'];
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(CRITICAL_ERROR, 'Could not query database for theme info');
			}

			if ( $row = $db->sql_fetchrow($result) )
			{
				$db->sql_freeresult($result);

				$sql = 'UPDATE ' . USERS_TABLE . '
					SET user_style = ' . (int) $board_config['default_style'] . "
					WHERE user_style = $style";
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(CRITICAL_ERROR, 'Could not update user theme info');
				}
			}
			else
			{
				message_die(CRITICAL_ERROR, "Could not get theme data for themes_id [{$style}]");
			}
		}
		else
		{
			message_die(CRITICAL_ERROR, "Could not get theme data for themes_id [{$style}]");
		}
	}
	$db->sql_freeresult($result);
	
	$template_path = 'templates/' ;
	$template_name = $row['template_name'] ;

	$template = new Template($phpbb_root_path . $template_path . $template_name);

	if ($template)
	{
		$current_template_path = $template_path . $template_name;
		@include($phpbb_root_path . $template_path . $template_name . '/' . $template_name . '.cfg');
		if ( !defined('TEMPLATE_CONFIG') )
		{
			message_die(CRITICAL_ERROR, 'Could not open ' . $template_name . ' template config file', '', __LINE__, __FILE__);
		}

		$img_lang = (file_exists(@phpbb_realpath($phpbb_root_path . $current_template_path . '/images/lang_' . $board_config['default_lang']))) ? $board_config['default_lang'] : 'english';
		if (!function_exists('setup_style_lang_replace'))
		{
			function setup_style_lang_replace(&$v, $k, $img_lang)
			{
				$v = str_replace('{LANG}', 'lang_' . $img_lang, $v);
			}
		}
		array_walk($images, 'setup_style_lang_replace', $img_lang);
	}
	return $row;
}

function encode_ip ($dotquad_ip)
{
	if ($dotquad_ip == NULL)
	{
		$dotquad_ip = '0.0.0.0';
	}
	$ip_sep = explode('.', $dotquad_ip);

	return sprintf('%02x%02x%02x%02x', $ip_sep[0], $ip_sep[1], $ip_sep[2], $ip_sep[3]);
}

function decode_ip($int_ip)
{
	$hexipbang = explode('.', chunk_split($int_ip, 2, '.'));
	return hexdec($hexipbang[0]) . '.' . hexdec($hexipbang[1]) . '.' . hexdec($hexipbang[2]) . '.' . hexdec($hexipbang[3]);
}

//
// Create date/time from format and timezone
//
function create_date($format, $gmepoch, $tz)
{
	global $board_config, $lang;
	static $translate;

	if (empty($translate) && $board_config['default_lang'] != 'english')
	{
		foreach ($lang['datetime'] as $match => $replace)
		{
			$translate[$match] = $replace;
		}
	}

	$current_timestamp = time() + (3600 * $tz);
	$given_timestamp = $gmepoch + (3600 * $tz);
	$difference = floor($current_timestamp / 86400) - floor($given_timestamp / 86400);

	$long_day = ( $difference == 0 ? $lang['Today'] :
			( $difference == 1 ? $lang['Yesterday'] :
				( $difference < 8 ? $lang['Last'] . ' ' . @gmdate('l', $given_timestamp) : @gmdate('l', $given_timestamp))));

	$short_day = ( $difference == 0 ? $lang['Today'] :
			( $difference == 1 ? $lang['Yesterday'] :
				( $difference < 8 ? $lang['Last'] . ' ' . @gmdate('D', $given_timestamp) : @gmdate('D', $given_timestamp))));

	//replace the C or c with something else first

	$format = str_replace(array('C','c'), array('#1', '#2'), $format);
	$translate['#1'] = $long_day;
	$translate['#2'] = $short_day;

	return (strtr(@gmdate($format, $given_timestamp + $board_config['board_offset']), $translate));

}

//
// Pagination routine, generates
// page number sequence
//
function generate_pagination($base_url, $num_items, $per_page, $start_item, $add_prevnext_text = TRUE)
{
	$total_pages = ceil($num_items / $per_page);

	if ($total_pages == 1)
	{
		return '';
	}
	
	$base_url = append_sid($base_url . ((strpos($base_url, '?') === false) ? '?%s' : '&amp;%s'));

	global $lang;
	
	$on_page = floor($start_item / $per_page) + 1;

	$page_string = '';
	if ($total_pages > 10)
	{
		$init_page_max = ($total_pages > 3) ? 3 : $total_pages;

		for ($i = 1; $i < $init_page_max + 1; $i++)
		{
			$page_string .= ($i == $on_page) ? '<b>' . $i . '</b>' : '<a href="' . sprintf($base_url, 'start=' . (($i - 1) * $per_page)) . '">' . $i . '</a>';
			if ($i <  $init_page_max)
			{
				$page_string .= ', ';
			}
		}

		if ($total_pages > 3)
		{
			if ($on_page > 1  && $on_page < $total_pages)
			{
				$page_string .= ($on_page > 5) ? ' ... ' : ', ';

				$init_page_min = ($on_page > 4) ? $on_page : 5;
				$init_page_max = ($on_page < $total_pages - 4) ? $on_page : $total_pages - 4;

				for ($i = $init_page_min - 1; $i < $init_page_max + 2; $i++)
				{
					$page_string .= ($i == $on_page) ? '<b>' . $i . '</b>' : '<a href="' . sprintf($base_url, 'start=' . (($i - 1) * $per_page)) . '">' . $i . '</a>';
					if ($i <  $init_page_max + 1)
					{
						$page_string .= ', ';
					}
				}

				$page_string .= ($on_page < $total_pages - 4) ? ' ... ' : ', ';
			}
			else
			{
				$page_string .= ' ... ';
			}

			for ($i = $total_pages - 2; $i < $total_pages + 1; $i++)
			{
				$page_string .= ($i == $on_page) ? '<b>' . $i . '</b>'  : '<a href="' . sprintf($base_url, 'start=' . (($i - 1) * $per_page)) . '">' . $i . '</a>';
				if ($i <  $total_pages)
				{
					$page_string .= ', ';
				}
			}
		}
	}
	else
	{
		for ($i = 1; $i < $total_pages + 1; $i++)
		{
			$page_string .= ($i == $on_page) ? '<b>' . $i . '</b>' : '<a href="' . sprintf($base_url, 'start=' . (($i - 1) * $per_page)) . '">' . $i . '</a>';
			if ($i <  $total_pages)
			{
				$page_string .= ', ';
			}
		}
	}

	if ($add_prevnext_text)
	{
		if ($on_page > 1)
		{
			$page_string = ' <a href="' . sprintf($base_url, 'start=' . (($on_page - 2) * $per_page)) . '">' . $lang['Previous'] . '</a>&nbsp;&nbsp;' . $page_string;
		}

		if ($on_page < $total_pages)
		{
			$page_string .= '&nbsp;&nbsp;<a href="' . sprintf($base_url, 'start=' . ($on_page * $per_page)) . '">' . $lang['Next'] . '</a>';
		}

	}

	$page_string = $lang['Goto_page'] . ' ' . $page_string;

	return $page_string;
}

//
// Obtain list of naughty words and build preg style replacement arrays for use by the
// calling script, note that the vars are passed as references this just makes it easier
// to return both sets of arrays
//
function obtain_word_list(&$orig_word, &$replacement_word)
{
	static $cache = array();
	if (empty($cache))
	{
		global $db;
		//
		// Define censored word matches
		//
		$sql = 'SELECT word, replacement
			FROM  ' . WORDS_TABLE;
		if (!($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not get censored words from database', '', __LINE__, __FILE__, $sql);
		}
		if ($row = $db->sql_fetchrow($result))
		{
			do
			{
				$orig_word[] = '#\b(' . str_replace('\*', '\w*?', preg_quote($row['word'], '#')) . ')\b#i';
				$replacement_word[] = $row['replacement'];
			}
			while ($row = $db->sql_fetchrow($result));
		}
		$db->sql_freeresult($result);
		$cache = array($orig_word, $replacement_word);
	}
	else
	{
		list ($orig_word, $replacement_word) = $cache;
	}
	return true;
}

function obtain_abbr_list(&$orig_word, &$replacement_word)
{
	static $cache = array();
	if (empty($cache))
	{
		global $db;

		//
		// Define censored word matches
		//
		$sql = 'SELECT acronym, description
			FROM  ' . ACRONYMS_TABLE;
		if (!($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not get censored words from database', '', __LINE__, __FILE__, $sql);
		}
		while ($row = $db->sql_fetchrow($result))
		{
			$orig_word[] = '#\b(' . str_replace('\*', '\w*?', phpbb_preg_quote( $row['acronym'], '#')) . ')\b#';
			$replacement_word[] = '[acronym=\\\\\"' . $row['description'] . '\\\\\"]\1[/acronym]';
		}
		$db->sql_freeresult($result);
		$cache = array($orig_word, $replacement_word);
	}
	else
	{
		list ($orig_word, $replacement_word) = $cache;
	}
	return true;
}

//
// This is general replacement for die(), allows templated
// output in users (or default) language, etc.
//
// $msg_code can be one of these constants:
//
// GENERAL_MESSAGE : Use for any simple text message, eg. results
// of an operation, authorisation failures, etc.
//
// GENERAL ERROR : Use for any error which occurs _AFTER_ the
// common.php include and session code, ie. most errors in
// pages/functions
//
// CRITICAL_MESSAGE : Used when basic config data is available but
// a session may not exist, eg. banned users
//
// CRITICAL_ERROR : Used when config data cannot be obtained, eg
// no database connection. Should _not_ be used in 99.5% of cases
//
function message_die($msg_code, $msg_text = '', $msg_title = '', $err_line = '', $err_file = '', $sql = '')
{
	global $db, $template, $board_config, $theme, $lang, $phpEx, $phpbb_root_path, $nav_links, $gen_simple_header, $images;
	global $userdata, $user_ip, $session_length;
	global $starttime;

	global $sub_template_key_image, $sub_templates;
	global $qbar_maps;

	if (defined('HAS_DIED'))
	{
		// TODO: Remove Comment.
		//die('message_die() was called multiple times. This isn\'t supposed to happen. Was message_die() used in page_tail.php?');
	}

	define('HAS_DIED', 1);


	$sql_store = $sql;

	//
	// Get SQL error if we are debugging. Do this as soon as possible to prevent
	// subsequent queries from overwriting the status of sql_error()
	//
	if ((intval($board_config['debug_value']) == 1 || DEBUG) && ($msg_code == GENERAL_ERROR || $msg_code == CRITICAL_ERROR))
	{
		$sql_error = $db->sql_error();

		$debug_text = '';

		if ( $sql_error['message'] != '' )
		{
			$debug_text .= '<br /><br />SQL Error : ' . $sql_error['code'] . ' ' . $sql_error['message'];
		}

		if ( $sql_store != '' )
		{
			$debug_text .= "<br /><br />$sql_store";
		}

		if ( $err_line != '' && $err_file != '' )
		{
			$debug_text .= '<br /><br />Line : ' . $err_line . '<br />File : ' . basename($err_file);
		}
	}

	if (empty($userdata) && ($msg_code == GENERAL_MESSAGE || $msg_code == GENERAL_ERROR))
	{
		$userdata = session_pagestart($user_ip, PAGE_INDEX);
		init_userprefs($userdata);
	}

	//
	// If the header hasn't been output then do it
	//
	if (!defined('HEADER_INC') && $msg_code != CRITICAL_ERROR)
	{
		if (empty($lang))
		{
			if ( !empty($board_config['default_lang']) )
			{
				include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_main.'.$phpEx);
			}
			else
			{
				include($phpbb_root_path . 'language/lang_english/lang_main.'.$phpEx);
			}
			include($phpbb_root_path . './includes/lang_extend_mac.' . $phpEx);
		}

		if ( empty($template) || empty($theme) )
		{
			$theme = setup_style($board_config['default_style']);
		}

		//
		// Load the Page Header
		//
		include($phpbb_root_path . ((!defined('IN_ADMIN')) ? 'includes/page_header.' : 'admin/page_header_admin.') . $phpEx);
	}

	switch ($msg_code)
	{
		case GENERAL_MESSAGE:
			if ($msg_title == '')
			{
				$msg_title = $lang['Information'];
			}
			break;

		case CRITICAL_MESSAGE:
			if ($msg_title == '')
			{
				$msg_title = $lang['Critical_Information'];
			}
			break;

		case GENERAL_ERROR:
			if ($msg_text == '')
			{
				$msg_text = $lang['An_error_occured'];
			}

			if ($msg_title == '')
			{
				$msg_title = $lang['General_Error'];
			}
			break;

		case CRITICAL_ERROR:
			//
			// Critical errors mean we cannot rely on _ANY_ DB information being
			// available so we're going to dump out a simple echo'd statement
			//
			include($phpbb_root_path . 'language/lang_english/lang_main.'.$phpEx);

			if ($msg_text == '')
			{
				$msg_text = $lang['A_critical_error'];
			}

			if ($msg_title == '')
			{
				$msg_title = 'Minerva : <b>' . $lang['Critical_Error'] . '</b>';
			}
			break;
	}

	//
	// Add on DEBUG info if we've enabled debug mode and this is an error. This
	// prevents debug info being output for general messages should DEBUG be
	// set TRUE by accident (preventing confusion for the end user!)
	//
	//if ( DEBUG && ( $msg_code == GENERAL_ERROR || $msg_code == CRITICAL_ERROR ) )
	if ((intval($board_config['debug_value']) == 1 || DEBUG) && ($msg_code == GENERAL_ERROR || $msg_code == CRITICAL_ERROR) && $debug_text != '')
	{
		$msg_text .= '<br /><br /><b><u>DEBUG MODE</u></b>' . $debug_text;
	}

	if ($msg_code != CRITICAL_ERROR)
	{
		if (isset($lang[$msg_text]))
		{
			$msg_text = $lang[$msg_text];
		}
		$template->set_filenames(array(
			'message_body' => ((!defined('IN_ADMIN')) ? 'message_body.tpl' : 'admin/admin_message_body.tpl')
		));

		$template->assign_vars(array(
			'MESSAGE_TITLE' => $msg_title,
			'MESSAGE_TEXT' => $msg_text)
		);

		if ($gen_simple_header)
		{
			$template->assign_vars(array(
				'U_INDEX' => '',
				'L_INDEX' => '')
			);
		}

		$template->pparse('message_body');

		include($phpbb_root_path . ((!defined('IN_ADMIN')) ? 'includes/page_tail.' : 'admin/page_footer_admin.') . $phpEx);
	}
	else
	{
		echo '<html>' . "\n" . '<body>' . "\n" . $msg_title . "\n" . '<br /><br />' . "\n" . $msg_text . '</body>' . "\n" . '</html>';
	}

	exit;
}

function redirect($url)
{
	global $db, $board_config;

	if (!empty($db))
	{
		$db->sql_close();
	}

	if (strpos(urldecode($url), "\n") !== false || strpos(urldecode($url), "\r") !== false)
	{
		message_die(GENERAL_ERROR, 'Tried to redirect to potentially insecure url.');
	}

	$server_protocol = ($board_config['cookie_secure']) ? 'https://' : 'http://';
	$server_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($board_config['server_name']));
	$server_port = ($board_config['server_port'] <> 80) ? ':' . trim($board_config['server_port']) : '';
	$script_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($board_config['script_path']));
	$script_name = ($script_name == '') ? $script_name : '/' . $script_name;
	$url = preg_replace('#^\/?(.*?)\/?$#', '/\1', trim($url));

	// Redirect via an HTML form for PITA webservers
	if (@preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE')))
	{
		header('Refresh: 0; URL=' . $server_protocol . $server_name . $server_port . $script_name . $url);
		echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html><head><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"><meta http-equiv="refresh" content="0; url=' . $server_protocol . $server_name . $server_port . $script_name . $url . '"><title>Redirect</title></head><body><div align="center">If your browser does not support meta redirection please click <a href="' . $server_protocol . $server_name . $server_port . $script_name . $url . '">HERE</a> to be redirected</div></body></html>';
		exit;
	}

	// Behave as per HTTP/1.1 spec for others
	header('Location: ' . $server_protocol . $server_name . $server_port . $script_name . $url);
	exit;
}

function meta_refresh($time, $url)
{
	global $template;

	$template->assign_vars(array(
		'META' => '<meta http-equiv="refresh" content="' . $time . ';url=' . $url . '">')
	);
}

function directory_rank($rank)
{
	if ($rank >= 0 && $rank < 10)
	{
		$rank_image = '0y.gif';
	}
	elseif ($rank >= 10 && $rank < 20)
	{
		$rank_image = '1y.gif';
	}
	elseif ($rank >= 20 && $rank < 30)
	{
		$rank_image = '2y.gif';
	}
	elseif ($rank >= 30 && $rank < 40)
	{
		$rank_image = '3y.gif';
	}
	elseif ($rank >= 40 && $rank < 50)
	{
		$rank_image = '4y.gif';
	}
	else
	{
		$rank_image = '5y.gif';
	}
	return $rank_image;
}

//
// This is the sig mod suite.
//

function sig_suite($sig)
{
	global $board_config;

	// Start Remove images/links in sigs mods
	if ($sig != '')
	{
		if ($board_config['allow_sig_images'] == 0)
		{
			$no_image_message = $board_config['no_sig_image_message'];
			if (preg_match('/(<img src=)(.+?)(\>)/i', $sig))
			{
				$sig = preg_replace('/(<img src=)(.+?)(\>)/i', $no_image_message, $sig);
			}

			if (preg_match('/(\[img\])([^\[]*)(\[\/img\])/i', $sig))
			{
				$sig = preg_replace('/(\[img\])([^\[]*)(\[\/img\])/i', $no_image_message, $sig);
			}
		}

		if ($board_config['allow_sig_links'] == 0)
		{
			$no_link_message = $board_config['no_sig_link_message'];

			if (preg_match('/(\[url=(.*?)\])([^\[]*)(\[\/url\])/i', $sig))
			{
				$sig = preg_replace('/(\[url=(.*?)\])([^\[]*)(\[\/url\])/i', $no_link_message, $sig);
			}

			if (preg_match('/(\[url\])([^\[]*)(\[\/url\])/i', $sig))
			{
				$sig = preg_replace('/(\[url\])([^\[]*)(\[\/url\])/i', $no_link_message, $sig);
			}

			if (preg_match('#([\n ])http://www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^,\t \n\r]*)?)#i', $sig) )
			{
				$sig = preg_replace('#([\n ])http://www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^,\t \n\r]*)?)#i', $no_link_message, $sig);
			}


			if (preg_match('#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^,\t \n\r]*)?)#i', $sig) )
			{
				$sig = preg_replace('#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^,\t \n\r]*)?)#i', $no_link_message, $sig);
			}

			if (preg_match('#<a(.*?)a>#is', $sig) )
			{
				$sig = preg_replace('#<a(.*?)a>#is', $no_link_message, $sig);
			}
		}
	}
	return $sig;
}// END sigs mods suite function

// Add function mkrealdate for Birthday MOD
// the originate php "mktime()", does not work proberly on all OS, especially when going back in time
// before year 1970 (year 0), this function "mkrealtime()", has a mutch larger valid date range,
// from 1901 - 2099. it returns a "like" UNIX timestamp divided by 86400, so
// calculation from the originate php date and mktime is easy.
// mkrealdate, returns the number of day (with sign) from 1.1.1970.

function mkrealdate($day, $month, $birth_year)
{
	// range check months
	if ($month < 1 || $month > 12)
	{
		return 'error';
	}
	// range check days
	switch ($month)
	{
		case 1:
			if ($day > 31)
			{
				return 'error';
			}
			break;
		case 2:
			if ($day > 29)
			{
				return 'error';
			}
			$epoch = $epoch + 31;
			break;
		case 3:
			if ($day > 31)
			{
				return 'error';
			}
			$epoch = $epoch + 59;
			break;
		case 4:
			if ($day > 30)
			{
				return 'error';
			}
			$epoch = $epoch + 90;
			break;
		case 5:
			if ($day > 31)
			{
				return 'error';
			}
			$epoch = $epoch + 120;
			break;
		case 6:
			if ($day > 30)
			{
				return 'error';
			}
			$epoch = $epoch + 151;
			break;
		case 7:
			if ($day > 31)
			{
				return 'error';
			}
			$epoch = $epoch + 181;
			break;
		case 8:
			if ($day > 31)
			{
				return 'error';
			}
			$epoch = $epoch + 212;
			break;
		case 9:
			if ($day > 30)
			{
				return 'error';
			}
			$epoch = $epoch + 243;
			break;
		case 10:
			if ($day > 31)
			{
				return 'error';
			}
			$epoch = $epoch + 273;
			break;
		case 11:
			if ($day > 30)
			{
				return 'error';
			}
			$epoch = $epoch + 304;
			break;
		case 12:
			if ($day > 31)
			{
				return 'error';
			}
			$epoch = $epoch + 334;
			break;
	}
	$epoch = $epoch + $day;
	$epoch_Y = sqrt(($birth_year - 1970) * ($birth_year - 1970));
	$leapyear = round((($epoch_Y + 2) / 4) - 0.5);
	if (($epoch_Y + 2) % 4 == 0)
	{
		// curent year is leapyear
		$leapyear--;
		if ($birth_year > 1970 && $month >= 3)
		{
			$epoch = $epoch+1;
		}
		if ($birth_year < 1970 && $month < 3)
		{
			$epoch = $epoch - 1;
		}
	}
	else if ($month == 2 && $day > 28)
	{
		return 'error';//only 28 days in feb.
	}
	//year
	if ($birth_year > 1970)
	{
		$epoch = $epoch + $epoch_Y * 365 - 1 + $leapyear;
	}
	else
	{
		$epoch = $epoch - $epoch_Y * 365 - 1 - $leapyear;
	}
	return $epoch;
}

// Add function realdate for Birthday MOD
// the originate php "date()", does not work proberly on all OS, especially when going back in time
// before year 1970 (year 0), this function "realdate()", has a mutch larger valid date range,
// from 1901 - 2099. it returns a "like" UNIX date format (only date, related letters may be used, due to the fact that
// the given date value should already be divided by 86400 - leaving no time information left)
// a input like a UNIX timestamp divided by 86400 is expected, so
// calculation from the originate php date and mktime is easy.
// e.g. realdate ("m d Y", 3) returns the string "1 3 1970"

// UNIX users should replace this function with the below code, since this should be faster
//
//function realdate($date_syntax="Ymd",$date=0)
//{ return create_date($date_syntax,$date*86400,$board_config['board_timezone']); }

function realdate($date_syntax='Ymd',$date=0)
{
	global $lang;
	$i = 2;
	$year = 0;
	if ($date >= 0)
	{
		$days = $date;
		while ($days > 364)
		{
			$year++;
			$days -= 365;
			if ($i ++== 3)
			{
				$i = 0;
				$days--;
			}
		}
		if ($days <= 0 && $i == 0)
		{
			$days++;
		}
	}
	else
	{
		$days = $date;
		while ($days < 0)
		{
			$year--;
			$days += 365;
			if ($i ++== 3)
			{
				$i = 0;
				$days++;
			}
		}
	}
	$leap_year = ($i == 0) ? true : false;
	$months_array = ($i == 0) ? array (0,31,60,91,121,152,182,213,244,274,305,335,366) : array (0,31,59,90,120,151,181,212,243,273,304,334,365);
	for ($month = 1; $month < 12; $month++)
	{
		if ($days < $months_array[$month])
		{
			break;
		}
	}

	$day=$days-$months_array[$month-1]+1;
	//you may gain speed performance by remove som of the below entry's if they are not needed/used
	return strtr ($date_syntax, array(
		'a' => '',
		'A' => '',
		'\\d' => 'd',
		'd' => ($day>9) ? $day : '0'.$day,
		'\\D' => 'D',
		'D' => $lang['day_short'][($date-3)%7],
		'\\F' => 'F',
		'F' => $lang['month_long'][$month-1],
		'g' => '',
		'G' => '',
		'H' => '',
		'h' => '',
		'i' => '',
		'I' => '',
		'\\j' => 'j',
		'j' => $day,
		'\\l' => 'l',
		'l' => $lang['day_long'][($date-3)%7],
		'\\L' => 'L',
		'L' => $leap_year,
		'\\m' => 'm',
		'm' => ($month>9) ? $month : '0'.$month,
		'\\M' => 'M',
		'M' => $lang['month_short'][$month-1],
		'\\n' => 'n',
		'n' => $month,
		'O' => '',
		's' => '',
		'S' => '',
		'\\t' => 't',
		't' => $months_array[$month]-$months_array[$month-1],
		'w' => '',
		'\\y' => 'y',
		'y' => ($year>29) ? $year-30 : $year+70,
		'\\Y' => 'Y',
		'Y' => $year+1970,
		'\\z' => 'z',
		'z' => $days,
		'\\W' => '',
		'W' => ''));
}

function serverload()
{
	global $db;

	// How many seconds load will represent.
	// Change the time representation in overall_footer.tpl to match this
	$duration = 300;

	// Delete old page counts
	$sql = 'DELETE 
		FROM ' . SERVERLOAD_TABLE . ' 
		WHERE time < ' . (time() - $duration);
	$result = $db->sql_query($sql);
	
	
	// Insert the current page count
	$sql = 'INSERT 
		INTO ' . SERVERLOAD_TABLE . ' 
		(time) 
		VALUES (' . time() . ')';
	$result = $db->sql_query($sql);
	
	// Get page count (number of rows in the table)
	$sql = 'SELECT COUNT(time) as count 
		FROM ' . SERVERLOAD_TABLE;
	if (!($result = $db->sql_query($sql)))
	{
		return '';
	}
	$count = $db->sql_fetchfield(0, 'count', $result);
	$db->sql_freeresult($result);
	return $count;
}

//
// Checks the unique hits table and adds a user if they haven't visited
// the forums during the past time interval, defined as $expires.
//
// Returns the number of unique hits during the time interval.
//
function uniquehits()
{
	global $db, $user_ip;

	/**
	* How many seconds to record unique hits for
	* Change the time in page_tail.php to match
	* Default is 24 hours (86400 seconds)
	*/
	$expires = 86400;
	// TODO: Cache Unique Hits

	// Purge expired hits from the table
	$sql = 'DELETE 
		FROM ' . UNIQUE_HITS_TABLE . ' 
		WHERE time < ' . (time() - $expires);
	$result = $db->sql_query($sql);

	// Insert the unique hit
	$sql = 'INSERT 
		INTO ' . UNIQUE_HITS_TABLE . '
		(user_ip, time)
		VALUES (\'' . $user_ip . '\', \'' . time() . '\')';
	$result = $db->sql_query($sql);


	// Get the number of rows in the table (unique hits)
	$sql = 'SELECT COUNT(user_ip) as count
		FROM ' . UNIQUE_HITS_TABLE;

	if (!($result = $db->sql_query($sql)))
	{
		return '';
	}
	$count = $db->sql_fetchfield(0, 'count', $result);
	$db->sql_freeresult($result);
	return $count;
}

function make_hours($base_time)
{
	global $lang;
	$years		= floor($base_time / 31536000);
	$base_time	= $base_time - ($years * 31536000);
	$weeks		= floor($base_time / 604800);
	$base_time	= $base_time - ($weeks * 604800);
	$days		= floor($base_time / 86400);
	$base_time	= $base_time - ($days * 86400);
	$hours		= floor($base_time/3600);
	$base_time	= $base_time - ($hours * 3600);
	$min		= floor($base_time / 60);
	$sek		= $base_time - ($min * 60);
	if ($sek < 10)
	{
		$sek = '0'. $sek;
	}
	if ($min < 10)
	{
		$min = '0' . $min;
	}
	if ($hours < 10)
	{
		$hours = '0' . $hours;
	}
	$result = (($years) ? $years . ' ' . (($years == 1) ? $lang['Year'] : $lang['Years']) . ', ' : ''). 
	(($years || $weeks) ? $weeks . ' ' . (($weeks == 1) ? $lang['Week'] : $lang['Weeks']) . ', ' : '').
	(($years || $weeks || $days) ? $days . ' ' . (($days == 1) ? $lang['Day'] : $lang['Days']) . ', ' : '').
	(($hours) ? $hours . ':' : '00:') . (($min) ? $min . ':' : '00:') . $sek;
	return ($result) ? $result : $lang['None'];
}

//
// Password-protected topics/forums
//
function password_check ($mode, $id, $password, $redirect)
{
	global $db, $template, $theme, $board_config, $lang, $phpEx, $phpbb_root_path, $gen_simple_header;
	global $userdata;
	global $HTTP_COOKIE_VARS;

	$id = intval($id);
	switch ($mode)
	{
		case 'topic':
			$sql = 'SELECT topic_password AS password 
				FROM ' . TOPICS_TABLE . ' 
				WHERE topic_id = ' . $id;
			$cookiename = $board_config['cookie_name'] . '_tpass';
			$passdata = (isset($HTTP_COOKIE_VARS[$cookiename])) ? unserialize(stripslashes($HTTP_COOKIE_VARS[$cookiename])) : '';
			break;
		case 'forum':
			$sql = 'SELECT forum_password AS password 
				FROM ' . FORUMS_TABLE . ' 
				WHERE forum_id = ' . $id;
			$cookiename = $board_config['cookie_name'] . '_fpass';
			$passdata = (isset($HTTP_COOKIE_VARS[$cookiename])) ? unserialize(stripslashes($HTTP_COOKIE_VARS[$cookiename])) : '';
			break;
		default:
			return false;
	}

	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not retrieve password', '', __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	if ($password != $row['password'])
	{
		message_die(GENERAL_MESSAGE, $lang['Incorrect_' . $mode . '_password']);
	}

	$passdata[$id] = md5($password);
	setcookie($cookiename, serialize($passdata), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);

	$template->assign_vars(array(
		'META' => '<meta http-equiv="refresh" content="3; url="' . $redirect . '" />'
	));

	$message = $lang['Password_login_success'] . '<br /><br />' . sprintf($lang['Click_return_page'], '<a href="' . $redirect . '">', '</a>');
	message_die(GENERAL_MESSAGE, $message);
}

function password_box ($mode, $s_form_action)
{
	global $db, $template, $theme, $board_config, $lang, $phpEx, $phpbb_root_path, $gen_simple_header;
	global $userdata;
	if ($mode != 'topic' || $mode != 'forum')
	{
		return false;
	}
	$l_enter_password = $lang['Enter_' . $mode . '_password'];

	$page_title = $l_enter_password;
	include ($phpbb_root_path . 'includes/page_header.' . $phpEx);

	$template->set_filenames(array(
		'body' => 'password_body.tpl'
	));

	$template->assign_vars(array(
		'L_ENTER_PASSWORD'	=> $l_enter_password,
		'L_SUBMIT'			=> $lang['Submit'],
		'L_CANCEL'			=> $lang['Cancel'],

		'S_FORM_ACTION'		=> $s_form_action,
	));

	$template->pparse('body');
	include($phpbb_root_path . 'includes/page_tail.' . $phpEx);
}
?>
