<?php
/***************************************************************************
*                            $RCSfile$
*                            -------------------
*   begin                : Tue January 20 2002
*   copyright            : (C) 2002-2003 Nivisec.com
*   email                : support@nivisec.com
*
*   $Id: functions_admin_topic_action_logging.php 2 2004-04-01 11:26:15Z flexiondotorg $
*
*
***************************************************************************/

/***************************************************************************
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
***************************************************************************/
/****************************************************************************
/** Constants and Main Vars.
/***************************************************************************/
define('LOGGING_ACTION_ALL', -1);
define('LOGGING_ACTION_MOVED', 0);
define('LOGGING_ACTION_LOCKED', 1);
define('LOGGING_ACTION_UNLOCKED', 2);
define('LOGGING_ACTION_DELETED', 3);
define('LOGGING_ACTION_SPLIT', 4);
define('LOGGING_ACTION_STICKY', 5);
define('LOGGING_ACTION_ANNOUNCE', 6);
define('LOGGING_ACTION_NORMAL', 7);
define('LOGGING_ACTION_MERGEPOST', 8);
define('LOGGING_ACTION_MERGETOPIC', 9);
define('LOGGING_ACTION_EDIT', 10);

function add_topic_action_log() {
    global $db, $lang, $userdata, $topics, $topic_id, $mode;

    $previous = -1;

    /* First, get our mode type by defining an array to the text mode */
    $mode_types = array(
    'move' => LOGGING_ACTION_MOVED,
    'delete' => LOGGING_ACTION_DELETED,
    'lock' => LOGGING_ACTION_LOCKED,
    'unlock' => LOGGING_ACTION_UNLOCKED,
    'split' => LOGGING_ACTION_SPLIT,
    'sticky' => LOGGING_ACTION_STICKY,
    'announce' => LOGGING_ACTION_ANNOUNCE,
    'normalise' => LOGGING_ACTION_NORMAL,
    'mergepost' => LOGGING_ACTION_MERGEPOST,
    'mergetopic' => LOGGING_ACTION_MERGETOPIC,
    'editpost' => LOGGING_ACTION_EDIT

    );
    /* To be compatible with people using versions of php < 4.1.0 another array is made of just texts */
    $mode_text_list = array(
    'move', 'delete', 'lock', 'unlock', 'split', 'sticky', 'announce', 'normalise', 'mergepost', 'mergetopic', 'editpost'
    );

    /* We only want to log junk if our $mode is a valid logger material */
    if(in_array($mode, $mode_text_list)) {
        /* Find out if there is more than one topic_id sent through the cp */
        if (isset($topics) && count($topics)) {
            /* Parse through the sql */
            foreach($topics as $val) {
                /* Cut off extra spaces */
                $t_id = trim($val);
                if ($t_id != $previous) {
                    $previous = $topic_id;
                    $action = $mode_types[$mode];
                    $user_id = $userdata['user_id'];

                    $sql = 'SELECT t.topic_title, pt.post_text FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TEXT_TABLE . ' pt, ' . POSTS_TABLE . " p
                       WHERE t.topic_first_post_id = pt.post_id
                       AND t.topic_id = $t_id";
                    if (!$result = $db->sql_query($sql)) message_die(GENERAL_ERROR, $lang['Error_Logs_Table'], '', __LINE__, __FILE__, $sql);

                    $topic_row = $db->sql_fetchrow($result);

                    $sql = 'INSERT INTO ' . TOPICS_TABLE . "_action_log
                       (user_id, topic_id, log_action, log_time, topic_title, topic_text)
                       VALUES
                       ($user_id, $t_id, $action, " . time() . ', \'' . addslashes($topic_row['topic_title']) . '\', \'' . addslashes($topic_row['post_text']) . '\')';

                    if (!$db->sql_query($sql)) message_die(GENERAL_ERROR, $lang['Error_Logs_Table'], '', __LINE__, __FILE__, $sql);
                }
            }
        }
        elseif (isset($topic_id)) {
            $action = $mode_types[$mode];
            $user_id = $userdata['user_id'];

            $sql = 'SELECT t.topic_title, pt.post_text FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TEXT_TABLE . ' pt, ' . POSTS_TABLE . " p
                       WHERE t.topic_first_post_id = pt.post_id
                       AND t.topic_id = $topic_id";
            if (!$result = $db->sql_query($sql)) message_die(GENERAL_ERROR, $lang['Error_Logs_Table'], '', __LINE__, __FILE__, $sql);

            $topic_row = $db->sql_fetchrow($result);

            $sql = 'INSERT INTO ' . TOPICS_TABLE . "_action_log
                       (user_id, topic_id, log_action, log_time, topic_title, topic_text)
                       VALUES
                       ($user_id, $topic_id, $action, " . time() . ', \'' . addslashes($topic_row['topic_title']) . '\', \'' . addslashes($topic_row['post_text']) . '\')';

            if (!$db->sql_query($sql)) message_die(GENERAL_ERROR, $lang['Error_Logs_Table'], '', __LINE__, __FILE__, $sql);

        }
    }
}

function prune_action_logs()
{
    return;
}
?>