<?php

/***************************************************************************
 *                              functions_news.php
 *                            -------------------
 *   begin                : Monday, January 13th 2003
 *   email                : webmaster@codemonkeyx.net
 *
 *
 ***************************************************************************/

if (!defined('IN_PHPBB'))
{
	die ('Hacking Attempt!');
}

include_once($phpbb_root_path . 'includes/bbcode.' . $phpEx );
include_once($phpbb_root_path . 'includes/functions_color_groups.' . $phpEx);

function news_attach_display($i)
{
	global $db, $news_items, $lang, $attach_config;

	$sql = 'SELECT a.* , d.*
		FROM ' . ATTACHMENTS_TABLE . ' as a, ' . ATTACHMENTS_DESC_TABLE . ' as d
		WHERE a.post_id = ' . $news_items[$i]['post_id'] .' 
			AND	a.attach_id = d.attach_id';

	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not query news attachment information', '', __LINE__, __FILE__, $sql);
	}

	$attach_items = array();

	while ($row = $db->sql_fetchrow($result))
	{
		$filesize = $row['filesize'];
		$size_lang = ($filesize >= 1048576) ? $lang['MB'] : (($filesize >= 1024) ? $lang['KB'] : $lang['Bytes']);
		if ($filesize >= 1048576)
		{
			$filesize = (round((round($filesize / 1048576 * 100) / 100), 2));
		}
		elseif ($filesize >= 1024)
		{
			$filesize = (round((round($filesize / 1024 * 100) / 100), 2));
		}
		$row['filesize'] = $filesize;
		$row['size_lang'] = $size_lang;
		$row['up_img'] ='<img src="'.$attach_config['upload_img'].'" alt="" />';
		$attach_items[] = $row;
	}

	return $attach_items;
}

function fetch_recent_news ($num_items, $news_id = 0, $forum_id = 0, $title_trim = 0, $trim_append_title = '')
//function fetch_recent_news( $num_items, $news_id = 0, $forum_id = 0, $title_trim = 0)
// $num_items: Number of news items to return.
// $news_title_trim: Number of characters to trim title to. (0 = disabled)
// $trim_append_title: What to attach to the end of a trimed title.
// $forum_id: Only retrive news in this forum. (0 = disabled)
{
	global $db, $userdata, $phpbb_root_path, $board_config, $phpEx;
	$fora_ids = implode(', ', get_fora_authed(AUTH_READ, false, true));
	$sql = 'SELECT t.*
		FROM ' . TOPICS_TABLE     . ' AS t, ' . POSTS_TABLE      . ' AS p
		WHERE t.topic_last_post_id = p.post_id 
			AND t.news_id IN (' . $fora_ids . ')';

	if ($news_id > 0)
	{
		$sql .= 'AND t.news_id = ' . intval($news_id) . ' ';
	}

	if ($forum_id > 0)
	{
		$sql .= 'AND t.forum_id = ' . intval($forum_id) . ' ';
	}

	$sql .= 'ORDER BY p.post_time DESC
		LIMIT 0, ' . $num_items;

	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
	}

	$topics = array( );
	$recent_items = array();
	while ($row = $db->sql_fetchrow($result))
	{
		//if( !in_array( $row['topic_id'], $topics ) )
		if ((!in_array($row['topic_id'], $topics)))// && (news_read_auth($row['forum_id'])))
		{
			// Trim the news title if needed.
			if ($title_trim > 0)
			{
				if (phpbb_trim_news_title($row['topic_title'], $title_trim))
				{
					//$row['topic_title'] .= $trim_append_title;
					$row['title_trimmed'] = true;
				}
				else
				{
					$row['title_trimmed'] = false;
				}
			}

			$recent_items[] = $row;
			$topics[] = $row['topic_id'];
		}
	}
	$db->sql_freeresult($result);
	return $recent_items;
}

function fetch_news_days($month, $year)
{
    global $db, $phpbb_root_path, $board_config, $phpEx;

    $interval_begin = mktime( 0,0,0, $month, 1, $year);
    $interval_end   = mktime( 0,0,0, $month+1, 1, $year);

    $sql = 'SELECT
            t.topic_time, t.forum_id
        FROM
            ' . TOPICS_TABLE     . ' AS t,
            ' . NEWS_TABLE       . ' AS n
        WHERE
            n.news_id = t.news_id AND
            t.news_id > 0 AND
            t.topic_time > ' . $interval_begin . ' AND
            t.topic_time < ' . $interval_end;

    if ( !($result = $db->sql_query($sql)) )
    {
        message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
    }

    $days = array_fill( 1, 32, 0 );

    while( $row = $db->sql_fetchrow($result) )
    {
        if ( news_read_auth($row['forum_id']) )
        {
            $days[ intval( create_date('j', $row['topic_time'], $board_config['board_timezone'])) ]++;
        }
    }

    $db->sql_freeresult( $result );

    return $days;
}

function fetch_recent_categories($num_items, $stats = false)
// $num_items: Number of news items to return.
{
    global $db, $phpbb_root_path, $board_config, $phpEx;
//, ' . NEWS_TABLE       . ' AS n 
message_die(GENERAL_ERROR, 'HEY', 'HEY', __LINE__, __FILE__);
    $sql = 'SELECT n.*, t.topic_id, t.topic_replies, t.forum_id
    	FROM ' . NEWS_TABLE     . ' AS n
    	LEFT JOIN ' . TOPICS_TABLE . ' AS t ON (t.news_id = n.news_id)
    	WHERE t.news_id > 0
        ORDER BY t.topic_time DESC';
    /*    
	$sql = 'SELECT n.*, t.topic_replies, t.forum_id
		FROM ' . NEWS_TABLE     . ' AS n, ' . TOPICS_TABLE . ' AS t
		WHERE t.news_id = n.news_id
			AND t.news_id > 0
		ORDER BY t.topic_time DESC';
	*/
    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
    }

    if ($num_items <= 0)
    {
        $num_items = 5;
    }

    $cats = array();
    $recent = array();

    while (($row = $db->sql_fetchrow($result)) && count($recent) < $num_items)
    {
    	var_dump($row); echo "<br />";
        if (!in_array($row['news_id'], $cats))
        {
            // We have not yet seen this news category.
            $sql = 'SELECT
                    t.topic_replies, t.forum_id
                FROM
                    ' . TOPICS_TABLE     . ' AS t
                WHERE
                    t.news_id = ' . $row['news_id'] . ' AND
                    t.news_id > 0';

            // Get all topics for the current news category.
            if ( !($result2 = $db->sql_query($sql)) )
            {
                message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
            }

            $topic_count = 0;
            $post_count = 0;

            while( $row2 = $db->sql_fetchrow($result2) )
            {
                if ( news_read_auth($row2['forum_id']) )
                {

                    // Count the topic.
                    $topic_count++;

                    // Count the original post.
                    $post_count++;

                    // Add the replies count to the total.
                    $post_count += $row2['topic_replies'];
                }
            }

			$row['news_image'] = news_image_path ($row['news_image']);
			$row['news_image_link'] = '<img src="' . $row['news_image'] . '" style="border:0;" alt="' . $row['news_category'] . '" />';
			$row['post_count'] = $post_count;
			$row['topic_count'] = $topic_count;
			
			$recent[] = $row;
			$cats[] = $row['news_id'];
        }

    }

    return $recent;
}

function fetch_categories($stats = false)
{
    global $db, $board_config, $phpbb_root_path;

    $sql = 'SELECT *
    	FROM ' . NEWS_TABLE   . ' AS n
        ORDER BY n.news_category';

    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
    }

    $cats = array();

    while ($row = $db->sql_fetchrow($result))
    // Process category
    {
		if ($stats === true)
		{
			$fora_ids = implode(', ', get_fora_authed(AUTH_READ, false, true));
			// We have not yet seen this news category.
			$sql = 'SELECT t.topic_replies, t.forum_id
				FROM ' . TOPICS_TABLE     . ' AS t
				WHERE t.news_id = ' . $row['news_id'] . ' 
					AND t.news_id IN (' . $fora_ids . ')';

			// Get all topics for the current news category.
			if (!($result2 = $db->sql_query($sql)))
			{
				message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
			}

			$topic_count = 0;
			$post_count = 0;

			while ($row2 = $db->sql_fetchrow($result2))
			{
				//if (news_read_auth($row2['forum_id']))
				//{
					// Count the topic.
					$topic_count++;

					// Count the original post.
					$post_count++;

					// Add the replies count to the total.
					$post_count += $row2['topic_replies'];
				//}
			}
			$row['post_count'] = $post_count;
			$row['topic_count'] = $topic_count;
			$db->sql_freeresult($result2);
		}

		$row['news_image'] = news_image_path ($row['news_image']);
		$row['news_image_link'] = '<img src="' . $row['news_image'] . '" style="border:0;" alt="' . $row['news_category'] . '" />';
		$cats[] = $row;
    }
	$db->sql_freeresult($result);
    return $cats;
}

//function fetch_news_posts($num_items, $news_id = 0, $forum_id = 0, $news_body_trim = 0, $news_title_trim = 0, $trim_append_body = '', $trim_append_title = '', $parse_body = true, $start = 0 )
function fetch_news_posts($num_items, $news_id = 0, $forum_id = 0, $parse_body = true, $start = 0, $news_title_trim = 0)

// $num_items: Number of news items to return.
// $news_body_trim: Number of characters to trim body to. (0 = disabled)
// $news_title_trim: Number of characters to trim title to. (0 = disabled)
// $trim_append_body: What to attach to the end of a trimed text.
// $trim_append_title: What to attach to the end of a trimed title.
// $news_id: Only retrive news in this category. (0 = disabled)
// $forum_id: Only retrive news in this forum. (0 = disabled)
{
    global $db, $userdata, $phpbb_root_path, $board_config, $phpEx;

    $current_time = time();
	$fora_ids = implode(', ', get_fora_authed(AUTH_READ, false, true));

	if (empty($fora_ids))
	{
		return array();
	}
	
	$sql = 'SELECT t.*, f.forum_name, f.forum_desc, n.*, p.*, pt.*, u.username, u.user_email
		FROM ' . TOPICS_TABLE     . ' AS t, ' . FORUMS_TABLE     . ' AS f, ' . USERS_TABLE      . ' AS u,
			' . NEWS_TABLE       . ' AS n, ' . POSTS_TEXT_TABLE . ' AS pt, ' . POSTS_TABLE      . ' AS p
		WHERE t.topic_first_post_id = p.post_id 
			AND t.forum_id = f.forum_id 
			AND t.forum_id IN (' . $fora_ids . ') 
			AND t.topic_first_post_id = pt.post_id 
			AND t.topic_poster = u.user_id 
			AND t.news_id = n.news_id 
			AND t.topic_time < '. $current_time .' 
			AND t.news_id > 0';

    if ($news_id > 0)
    {
        $sql .= ' AND t.news_id = ' . $news_id . ' ';
    }

    if ($forum_id > 0)
    {
        $sql .= ' AND t.forum_id = ' . $forum_id . ' ';
    }

    $sql .= ' ORDER BY
            t.topic_time DESC LIMIT ' . $start . ', ' . $num_items;

    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
    }

    $news_items = array();

    while ($row = $db->sql_fetchrow($result))
    {
        if (true)//news_read_auth($row['forum_id']))
        {

            // Set up path to news category image.
            //$row['news_image'] = $phpbb_root_path . $board_config['news_path'] . '/' . $row['news_image'];
			$row['news_image'] = news_image_path($row['news_image']);
            //Trim the news body if needed.
            //if( $news_body_trim > 0 )
            //{
            if (phpbb_trim_news_text($row['post_text'], 1, $row['bbcode_uid']))
            //if( phpbb_trim_news_text( $row['post_text'], $news_body_trim, 0 ) )
            {
                //$row['post_text'] .= $trim_append_body;
                $row['body_trimmed'] = true;
            }
            else
            {
                $row['body_trimmed'] = false;
            }
            //}

            // Parese any remaining BBCode, insert smiles, convert urls into links.
            if ($parse_body)
            {
                $row['post_text']  = phpbb_parse_news_text($row['post_text'], $row['bbcode_uid'], $row['enable_smilies']);
            }

            // Trim the news title if needed.
            if ($news_title_trim > 0)
            {
                if (phpbb_trim_news_title($row['topic_title'], $news_title_trim))
                {
                    //$row['topic_title'] .= $trim_append_title;
                    $row['title_trimmed'] = true;
                }
                else
                {
                    $row['title_trimmed'] = false;
                }
            }

            $row['read_more_url'] = $phpbb_root_path . 'index.' . $phpEx . '?article=' . $row['topic_id'];
            $row['comments_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
            $row['views_url'] = $phpbb_root_path . 'topic_view_users.' . $phpEx . '?t=' . $row['topic_id'];
            $row['topic_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
            $row['poster_url'] = $phpbb_root_path . 'profile.' . $phpEx . '?mode=viewprofile&amp;u=' . $row['topic_poster'];
            $row['username'] = color_group_colorize_name($row['topic_poster'], true);
            $row['forum_url'] = $phpbb_root_path . 'viewforum.' . $phpEx . '?f=' . $row['forum_id'];
            $row['format_topic_time'] = create_date($board_config['default_dateformat'], $row['topic_time'], $board_config['board_timezone']);
            $news_items[] = $row;
        }
    }
    $db->sql_freeresult($result);

    return $news_items;
}

function fetch_news_post($topic_id) // TODO: Auth
// $topic_id: the topic id of a news post.
{
    global $db, $userdata, $phpbb_root_path, $board_config, $phpEx;
	$topic_id = intval($topic_id);
	if (!$topic_id)
	{
		message_die (GENERAL_ERROR, 'Invalid Topic ID', '', __LINE__, __FILE__);
	}
	$sql = 'SELECT t.*, f.forum_name, f.forum_desc, n.*, p.*, pt.*, u.username, u.user_email
		FROM ' . TOPICS_TABLE     . ' AS t, ' . FORUMS_TABLE     . ' AS f, ' . USERS_TABLE      . ' AS u,
			' . NEWS_TABLE       . ' AS n, ' . POSTS_TEXT_TABLE . ' AS pt, ' . POSTS_TABLE      . ' AS p
		WHERE t.topic_first_post_id = p.post_id 
			AND t.forum_id = f.forum_id 
			AND t.topic_first_post_id = pt.post_id 
			AND t.topic_poster = u.user_id 
			AND t.news_id = n.news_id 
			AND t.topic_id = ' . $topic_id;

    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
    }

    //if( $row = $db->sql_fetchrow($result) )

    //Display news flag
    $display_this_article = TRUE;

    if ($row = $db->sql_fetchrow($result)) // && (news_read_auth($row['forum_id']))
    {
        // Set up path to news category image.
        //$row['news_image'] = $phpbb_root_path . $board_config['news_path'] . '/' . $row['news_image'];
		$row['news_image'] = news_image_path ($row['news_image']);
        // Parese any remaining BBCode, insert smiles, convert urls into links.
        $row['post_text']  = phpbb_parse_news_text( $row['post_text'], $row['bbcode_uid'], $row['enable_smilies'] );

        $row['comments_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
        $row['views_url'] = $phpbb_root_path . 'topic_view_users.' . $phpEx . '?t=' . $row['topic_id'];
        $row['topic_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
        $row['poster_url'] = $phpbb_root_path . 'profile.' . $phpEx . '?mode=viewprofile&amp;u=' . $row['topic_poster'];
        $row['username'] = color_group_colorize_name($row['topic_poster'],true);
        $row['forum_url'] = $phpbb_root_path . 'viewforum.' . $phpEx . '?f=' . $row['forum_id'];
        $row['format_topic_time'] = create_date($board_config['default_dateformat'], $row['topic_time'], $board_config['board_timezone']);
        $news_items[] = $row;
    }
    else
    {
        $display_this_article = FALSE;
    }
	$db->sql_freeresult($result);
    //BEGIN only do the last two things with read permission
    if ($display_this_article)
    {
        //
        // Update the topic view counter
        //
        if (!($news_items[0]['topic_poster'] == $userdata['user_id']))
        {
            $sql = 'UPDATE ' . TOPICS_TABLE . '
                SET topic_views = topic_views + 1
                WHERE topic_id = ' . $topic_id;
            if (!$db->sql_query($sql))
            {
                message_die(GENERAL_ERROR, 'Could not update topic views.', '', __LINE__, __FILE__, $sql);
            }
        }

        // update topic view information
        $sql = 'UPDATE ' . TOPIC_VIEW_TABLE . ' 
        	SET topic_id = ' . $topic_id . ', 
        		view_time = ' . time() . ', 
        		view_count = view_count + 1 
        	WHERE topic_id = ' . $topic_id . ' 
        		AND user_id = ' . $userdata['user_id'];
        if (!$db->sql_query($sql) || !$db->sql_affectedrows())
        {
            $sql = 'INSERT IGNORE INTO ' . TOPIC_VIEW_TABLE . ' 
            	(topic_id, user_id, view_time,view_count)
                VALUES (' . $topic_id . ', "' . $userdata['user_id'] . '", ' . time() . ', 1)';
            if (!($db->sql_query($sql)))
            {
                message_die(GENERAL_ERROR, 'Error create user view topic information ', '', __LINE__, __FILE__, $sql);
            }
        }
    }
    //END only do the last two things with read permission

    return $news_items;
}

function fetch_news_count($news_id)
{
	$fora = get_fora_authed(AUTH_READ, false, true);
	
	if (!sizeof($fora))
	{
		return 0;
	}

    global $db;

	$sql = 'SELECT COUNT(t.news_id) AS num_posts
		FROM ' . TOPICS_TABLE . ' AS t
		WHERE t.news_id > 0
		AND forum_id IN (' . implode(', ', $fora) . ')';

    if ($news_id > 0)
    {
        $sql .= ' AND t.news_id = ' . $news_id;
    }

    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not obtain limited news count information', '', __LINE__, __FILE__, $sql);
    }

    $total = ($row = $db->sql_fetchrow($result)) ? intval($row['num_posts']) : 0;
	$db->sql_freeresult($result);

    return $total;
}

/*
#######################################################################
##                                                                   ##
## Borrowed from "fetch_all_mod"                                     ##
##                                                                   ##
##                                                                   ##
## phpbb_parse_news_text()                                           ##
## ----------------------------------------------------------------- ##
## Parses text according to phpBB (BBCode, smilies, etc).            ##
##                                                                   ##
## PARAMETER                                                         ##
##                                                                   ##
##     text                                                          ##
##         the text to be parsed                                     ##
##     bbcode_uid                                                    ##
##         bbcode identifier                                         ##
##     enable_smilies                                                ##
##         if true all smilies will be parsed with their icon        ##
##         otherwise you will only see the smilie code               ##
##     enable_images                                                 ##
##         if true all images will be left untouched otherwise all   ##
##         images will be replaced with the text in the next         ##
##         parameter                                                 ##
##     replace_images                                                ##
##         text to replace images with                               ##
##                                                                   ##
#######################################################################
*/
function phpbb_parse_news_text( $text = null,
                            $bbcode_uid = null,
                            $enable_smilies = true,
                            $enable_images = true,
                            $replace_images = '')
{
    global $board_config, $phpbb_root_path, $userdata;

    if (!$text)
    {
        return;
    }

    // BEGIN CMX News Mod
    // Strip out the <!--break--> delimiter.
    $delim = '&lt;!--break--&gt;';
    if (($pos = strpos($text, $delim)) !== false)
    {
      $text = substr_replace($text, '<!--break-->', $pos, strlen($delim));
    }
    // END CMX News Mod

    stripslashes($text);

    //
    // define censored word matches
    //

    if (!$userdata['user_allowswearywords'])
    {
        $orig_word = array();
        $replacement_word = array();
        obtain_word_list($orig_word, $replacement_word);
    }
    //
    // censor text
    //
    if (count($orig_word))
    {
        //$posts[$i]['topic_title'] = preg_replace($orig_word, $replacement_word, $posts[$i]['topic_title']);
        $text = preg_replace($orig_word, $replacement_word, $text);
    }

    if (!$enable_images)
    {
        if ($replace_images)
        {
            $replacement = '[url=\\1]' . $replace_images . '[/url]';
        }
        else
        {
            $replacement = '';
        }
        $text = preg_replace("#\[img:$bbcode_uid\](.*?)\[/img:$bbcode_uid\]#si",
                             $replacement, $text);
    }

    //
    // parse bbcode
    //

    $text = bbencode_second_pass($text, $bbcode_uid);

    //
    // parse smilies if requested
    //

    if ($enable_smilies == 1)
    {
        $text = smilies_pass($text);

        //
        // need to overwrite the smilie path since we might not be within
        // the phpBB directory
        //
		// Fixed uneeded now -- Chris
        //$text = preg_replace("/images\/smiles/", $phpbb_root_path . $board_config['smilies_path'], $text);
    }

    $text = acronym_pass($text);
    $text = smart_pass($text);

    //
    // parse url's
    //

    $text = make_clickable($text);

    //
    // change newlines to HTML
    //

    $text = str_replace("\n", "\n<br />\n", $text);

    return $text;
} // end func phpbb_parse_text

/*
#######################################################################
##                                                                   ##
## Borrowed from "fetch_all_mod"                                     ##
##                                                                   ##
## phpbb_trim_news_text()                                            ##
## ----------------------------------------------------------------- ##
## This function can trim a text by number of characters or the      ##
## first appearence of a character combination.                      ##
##                                                                   ##
## PARAMETER                                                         ##
##                                                                   ##
##     text                                                          ##
##         contains the text which should be trimmed                 ##
##     is_trimmed                                                    ##
##         will be false if no trimming has been done and true if    ##
##         the text has been trimmed                                 ##
##     character                                                     ##
##         a character combination ('<br />')                        ##
##     number                                                        ##
##         a number of characters ('150')                            ##
##                                                                   ##
#######################################################################
*/

function trimText( &$text, $size, &$trimmed )
{
    $pos = strpos( $text, htmlspecialchars( '<!--break-->' ) );
    if( ($pos !== false) && ($pos < strlen( $text )) )
    {
      $trimmed = true;
      return substr( $text, 0, $pos );
    }
    // Breaks up the message by blocks of bbcodes.
    // The message is divided into two parts,
    // 1. text inside a pair of bbcode tags.
    // 2. text not contained inside a pair of bbcode tags.
    $segments = preg_split(
          '#(\[([a-zA-Z]+?).*?\].+?\[/\\2.*?\])#s' ,
          $text, -1,
          PREG_SPLIT_NO_EMPTY | PREG_SPLIT_OFFSET_CAPTURE );

    foreach( $segments as $segment )
    {
      if( ($segment[1] + strlen($segment[0]) > $size) &&
        ($segment[1] <= $size) )
      // $size fall inside the current block.
      {
        $trimmed = true;
        return substr( $text, 0, $size );
      }
      elseif( $segment[1] > $size )
      // We have gone past the trim point.
      {
        $trimmed = true;
        return substr( $text, 0, $segment[1] );
      }
    }
    $trimmed = false;
    return $text;

  }


function phpbb_trim_news_text( &$text, $number = 0, $bbcode_uid )
{
	if ($number != 0 && ((($pos = strpos($text, '&lt;!--break--&gt;')) !== false) || (($pos = strpos($text, ':break:')) !== false)))
	{
		$text = substr($text, 0, $pos);
		return true;
	}
	else
	{
		return false;
	}
} // end func phpbb_trim_news_text

function phpbb_trim_news_title(&$text, $number = 0)
{
	if ($number != 0 and strlen($text) > $number)
	{
		stripslashes($text);
		$text = substr($text, 0, $number);
		$text = $text . '...';
		return true;
	}
	else
	{
		return false;
	}
} // end func phpbb_trim_news_title

//
// Function strip all BBcodes (borrowed from Mouse Hover Topic Preview MOD)
//
function bbencode_news_strip($text, $uid)
{
    // pad it with a space so we can distinguish between FALSE and matching the 1st char (index 0).
    // This is important; bbencode_quote(), bbencode_list(), and bbencode_code() all depend on it.
    $text = " " . $text;

    // First: If there isn't a "[" and a "]" in the message, don't bother.
    if (strpos($text, '[') === false && strpos($text, ']') === false)
    {
        // Remove padding, return.
        return substr($text, 1);
    }

    // [CODE] and [ /CODE ] for posting code (HTML, PHP, C etc etc) in your posts.
    $text = str_replace("[code:1:$uid]",'', $text);
    $text = str_replace("[/code:1:$uid]", '', $text);
    $text = str_replace("[code:$uid]", '', $text);
    $text = str_replace("[/code:$uid]", '', $text);

    // [QUOTE] and [/QUOTE] for posting replies with quote, or just for quoting stuff.
    $text = str_replace("[quote:1:$uid]",'', $text);
    $text = str_replace("[/quote:1:$uid]", '', $text);
    $text = str_replace("[quote:$uid]", '', $text);
    $text = str_replace("[/quote:$uid]", '', $text);
    // New one liner to deal with opening quotes with usernames...
    // replaces the two line version that I had here before..
    $text = preg_replace("/\[quote:$uid=(?:\"?([^\"]*)\"?)\]/si", '', $text);
    $text = preg_replace("/\[quote:1:$uid=(?:\"?([^\"]*)\"?)\]/si", '', $text);

    // [list] and [list=x] for (un)ordered lists.
    // unordered lists
    $text = str_replace("[list:$uid]", '', $text);
    // li tags
    $text = str_replace("[*:$uid]", '', $text);
    // ending tags
    $text = str_replace("[/list:u:$uid]", '', $text);
    $text = str_replace("[/list:o:$uid]", '', $text);
    // Ordered lists
    $text = preg_replace("/\[list=([a1]):$uid\]/si", '', $text);

    // colours
    $text = preg_replace("/\[color=(\#[0-9A-F]{6}|[a-z]+):$uid\]/si", '', $text);
    $text = str_replace("[/color:$uid]", '', $text);

    // url #2
    $text = str_replace('[url]','', $text);
    $text = str_replace('[/url]', '', $text);

    // url /\[url=([a-z0-9\-\.,\?!%\*_\/:;~\\&$@\/=\+]+)\](.*?)\[/url\]/si
    $text = preg_replace('/\[url=([a-z0-9\-\.,\?!%\*_\/:;~\\&$@\/=\+]+)\]/si', '', $text);
    $text = str_replace("[/url:$uid]", '', $text);

    // img
    $text = str_replace("[img:$uid]",'', $text);
    $text = str_replace("[/img:$uid]", '', $text);

    // email
    $text = str_replace("[email:$uid]",'', $text);
    $text = str_replace("[/email:$uid]", '', $text);

    // size
    $text = preg_replace("/\[size=([\-\+]?[1-2]?[0-9]):$uid\]/si", '', $text);
    $text = str_replace("[/size:$uid]", '', $text);

    // align
    $text = preg_replace("/\[align=(left|right|center|justify):$uid\]/si", '', $text);
    $text = str_replace("[/align:$uid]", '', $text);

    // [b] and [/b] for bolding text.
    $text = str_replace("[b:$uid]",'', $text);
    $text = str_replace("[/b:$uid]", '', $text);

    // [u] and [/u] for underlining text.
    $text = str_replace("[u:$uid]", '', $text);
    $text = str_replace("[/u:$uid]", '', $text);

    // [i] and [/i] for italicizing text.
    $text = str_replace("[i:$uid]", '', $text);
    $text = str_replace("[/i:$uid]", '', $text);

	// [acronym] and [/acronym] for italicizing text.
    $text = str_replace("[acronym:$uid=([a-z0-9\-\.,\?!%\*_\/:;~\\&$@\/=\+]+)\]/si", '', $text);
    $text = str_replace("[/acronym:$uid]", '', $text);

    // Remove our padding from the string..
    $text = substr($text, 1);

    return $text;
}

function news_read_auth ($f_id)
{
	static $authed_fora = array();
	if (empty($authed_fora))
	{
		global $userdata;
		$authed_fora = array_flip(get_fora_authed(AUTH_READ, false, true));
	}
	return isset($authed_fora[$f_id]);
}

function news_image_path ($image = '')
{
	global $board_config, $phpbb_root_path;

    // Set up path to news category image.

	$temp_link = $phpbb_root_path . $board_config['news_path'] . '/'; // Make things a little easier

	    if ( file_exists($temp_link . 'lang_' . $board_config['default_lang'] . '/' . $image) )
		{
			// Preffered
			$news_image = $temp_link . 'lang_' . $board_config['default_lang'] . '/' . $image;
		}
		elseif ( file_exists($temp_link . 'lang_english/' . $image) )
		{
			// None in our users default language, perhaps english?
			$news_image = $temp_link . 'lang_english/' . $image;
		}
		else
		{
			// Last Attempt, are we using the previous builds image location
			$news_image = $temp_link . $image; 
		}


	unset ($temp_link); // No need anymore.

	return $news_image;
}

?>
