<?php
/***************************************************************************
 *                        functions_post_notification.php
 *                        -------------------------------
 *   created              : Tuesday, Jan 21, 2003
 *   author               : netclectic - Adrian Cockburn
 *   email                : adrian@netclectic.com
 *
 *   version              : 1.0.4
 *
 *
 ***************************************************************************/

if (!defined('IN_PHPBB'))
{
    die('Hacking attempt');
}

function netclectic_post_notify( $forum_id, $forum_name, $post_id, $message, $subject, $topic_title )
{
    global $db, $phpbb_root_path, $template, $board_config, $phpEx, $lang, $userdata;

    // find mods for this forum
    $sql = "SELECT DISTINCT u.user_id, u.username, u.user_email, u.user_lang
        FROM " . AUTH_ACCESS_TABLE . " aa, " . USER_GROUP_TABLE . " ug, " . GROUPS_TABLE . " g, " . USERS_TABLE . " u
        WHERE aa.forum_id = " . $forum_id . "
            AND ug.group_id = aa.group_id
            AND g.group_id = aa.group_id
            AND u.user_id = ug.user_id
            AND aa.auth_mod = " . TRUE . "
            AND u.user_id <> " . $userdata['user_id'] . "
            AND u.user_notify_mod = 1
            AND u.user_email <> ''";

    if ( $result = $db->sql_query($sql))
    {
        // various bits borrowed from functions_post.php
        $bcc_list_ary = array();
        // Sixty second limit
        @set_time_limit(60);

        while( $row = $db->sql_fetchrow($result) )
        {
            $bcc_list_ary[$row['user_lang']] .= (($bcc_list_ary[$row['user_lang']] != '') ? ', ' : '') . $row['user_email'];
        }
        $db->sql_freeresult($result);

        //
        // Let's do some checking to make sure that mass mail functions
        // are working in win32 versions of php.
        //
        if (preg_match('/[c-z]:\\\.*/i', getenv('PATH')) && !$board_config['smtp_delivery'])
        {
            $ini_val = (@phpversion() >= '4.0.0') ? 'ini_get' : 'get_cfg_var';

            // We are running on windows, force delivery to use our smtp functions
            // since php's are broken by default
            $board_config['smtp_delivery'] = 1;
            $board_config['smtp_host'] = @$ini_val('SMTP');
        }

        if (sizeof($bcc_list_ary))
        {
            include_once($phpbb_root_path . 'includes/emailer.'.$phpEx);
            $emailer = new emailer($board_config['smtp_delivery']);

            $script_name = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($board_config['script_path']));
            $script_name = ( $script_name != '' ) ? $script_name . '/viewtopic.'.$phpEx : 'viewtopic.'.$phpEx;
            $server_name = trim($board_config['server_name']);
            $server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
            $server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';

            $orig_word = array();
            $replacement_word = array();
            obtain_word_list($orig_word, $replacement_word);

            $this_message = preg_replace('/\:[0-9a-z\:]+\]/si', ']', $message);
            $this_message = stripslashes($this_message);
            $this_message = str_replace("<br />", "\n", $this_message);
            $this_message = (count($orig_word)) ? preg_replace($orig_word, $replacement_word, unprepare_message($this_message)) : unprepare_message($this_message);

            $notify_topic_title = ( !empty($subject) ) ? $subject : $topic_title;
            $notify_topic_title = (count($orig_word)) ? preg_replace($orig_word, $replacement_word, unprepare_message($notify_topic_title)) : unprepare_message($notify_topic_title);
            $notify_subject = '[ ' . $board_config['sitename'] . ' ] ';
            $notify_subject .= ' - ' . sprintf($lang['Always_notify_mod_new_forum_post'], $notify_topic_title);


            $email_headers = 'From: ' . $board_config['board_email'] . "\nReturn-Path: " . $board_config['board_email'] . "\n";
            $email_address = ' ';

            while (list($user_lang, $bcc_list) = each($bcc_list_ary))
            {
                $emailer->use_template('topic_notify_mods', $user_lang);
                $emailer->email_address($email_address);
                $emailer->set_subject($notify_subject);
                $emailer->extra_headers($email_headers . "Bcc: $bcc_list\n");

                // This is a nasty kludge to remove the username var ... till (if?)
                // translators update their templates
                $emailer->msg = preg_replace('#[ ]?{USERNAME}#', '', $emailer->msg);

                $emailer->assign_vars(array(
                    'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '',
                    'SITENAME' => $board_config['sitename'],

                    'NOTIFY_FORUM' => $forum_name,
                    'NOTIFY_SUBJECT' => $notify_subject,
                    'NOTIFY_TOPIC_TITLE' => $notify_topic_title,
                    'NOTIFY_USERNAME' => $userdata['username'],
                    'NOTIFY_URL' => $server_protocol . $server_name . $server_port . $script_name . '?' . POST_POST_URL . "=$post_id#$post_id",
                    'NOTIFY_MESSAGE' => $this_message )
                );

                $emailer->send();
                $emailer->reset();
            }
        }
    }
}
?>