<?php
/***************************************************************************
 *                           watched_topics_list.php
 *                           -----------------------
 *   Author         :   netclectic - Adrian Cockburn - adrian@netclectic.com
 *   Created        :   Monday, March 24, 2003
 *
 *   Version        :   1.0.0
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}

    // are we unwatching some topics?
    if ( isset($HTTP_POST_VARS['unwatch_list']) )
    {
        $topic_ids = implode(",", $HTTP_POST_VARS['unwatch_list']);
        $sql = "DELETE FROM " . TOPICS_WATCH_TABLE . "
            WHERE topic_id IN(" .  $topic_ids . ")
            AND user_id = " . $userdata['user_id'];
        if ( !($result = $db->sql_query($sql)) )
        {
            message_die(GENERAL_ERROR, "Could not delete topic watch information", '', __LINE__, __FILE__, $sql);
        }
    }

    // grab a list of watched topics
    $sql = "SELECT w.*, t.*, p.post_time, p.poster_id, f.forum_name,
            first.username as author_username,
            last.username as last_username
        FROM " . TOPICS_WATCH_TABLE . " w,
             " . TOPICS_TABLE . " t,
             " . POSTS_TABLE . " p,
             " . FORUMS_TABLE . " f,
             " . USERS_TABLE . " first,
             " . USERS_TABLE . " last
        WHERE t.topic_id = w.topic_id
            AND p.post_id = t.topic_last_post_id
            AND t.topic_poster = first.user_id
            AND p.poster_id = last.user_id
            AND f.forum_id = t.forum_id
            AND w.user_id = " . $userdata['user_id'] . "
        ORDER BY t.topic_last_post_id DESC";
    if ( !($result = $db->sql_query($sql)) )
    {
        message_die(GENERAL_ERROR, 'Could not obtain watch topic information', '', __LINE__, __FILE__, $sql);
    }
    $watch_rows = $db->sql_fetchrowset($result);

    // are we currently watching any topics?
        $template->set_filenames(array(
            'watched_topics_body' => 'watched_topics_body.tpl')
        );

        $template->assign_vars(array(
            'S_FORM_ACTION' => append_sid("favorites.$phpEx"),
            'L_TOPIC' => $lang['Topic'],
            'L_WATCHED_TOPICS' => $lang['Watched_Topics'],
            'L_FORUM' => $lang['Forum'],
            'L_REPLIES' => $lang['Replies'],
            'L_STARTED' => $lang['Watched_Topics_Started'],
            'L_LAST_POST' => $lang['Last_Post'],
            'L_STOP_WATCH' => $lang['Watched_Topics_Stop'],
            'L_DELETE' => $lang['Delete'],
            'L_CHECK_ALL' => $lang['Check_All'],
            'L_UNCHECK_ALL' => $lang['UnCheck_All'],
            )
        );

        $template->assign_block_vars('switch_watched_topics_block', array());
        if ( $watch_rows )
        {
            global $theme;
            $dummy = 0;
        for ( $i = 0; $i < count($watch_rows); $i++ )
        {
            $last_poster = ($watch_rows[$i]['poster_id'] == ANONYMOUS ) ? ( ($watch_rows[$i]['last_username'] != '' ) ? $watch_rows[$i]['last_username'] . ' ' : $lang['Guest'] . ' ' ) : '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '='  . $watch_rows[$i]['poster_id']) . '">' . $watch_rows[$i]['last_username'] . '</a> ';
            $last_poster .= '<a href="' . append_sid("viewtopic.$phpEx?"  . POST_POST_URL . '=' . $watch_rows[$i]['topic_last_post_id']) . '#' . $watch_rows[$i]['topic_last_post_id'] . '"><img src="' . $images['icon_latest_reply'] . '" border="0" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" /></a>';
            $topic_poster = ($watch_rows[$i]['topic_poster'] == ANONYMOUS ) ? ( ($watch_rows[$i]['author_username'] != '' ) ? $watch_rows[$i]['author_username'] . ' ' : $lang['Guest'] . ' ' ) : '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '='  . $watch_rows[$i]['topic_poster']) . '">' . $watch_rows[$i]['author_username'] . '</a> ';

            $replies = $watch_rows[$i]['topic_replies'];
            if( ( $replies + 1 ) > $board_config['posts_per_page'] )
            {
                $total_pages = ceil( ( $replies + 1 ) / $board_config['posts_per_page'] );
                $goto_page = ' [ <img src="' . $images['icon_gotopost'] . '" alt="' . $lang['Goto_page'] . '" title="' . $lang['Goto_page'] . '" />' . $lang['Goto_page'] . ': ';

                $times = 1;
                for($j = 0; $j < $replies + 1; $j += $board_config['posts_per_page'])
                {
                    $goto_page .= '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $watch_rows[$i]['topic_id'] . "&start=$j") . '">' . $times . '</a>';
                    if( $times == 1 && $total_pages > 4 )
                    {
                        $goto_page .= ' ... ';
                        $times = $total_pages - 3;
                        $j += ( $total_pages - 4 ) * $board_config['posts_per_page'];
                    }
                    else if ( $times < $total_pages )
                    {
                    $goto_page .= ', ';
                    }
                    $times++;
                }
                $goto_page .= ' ] ';
            }
            else
            {
                $goto_page = '';
            }

            $row_class = ( !($dummy % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
            $template->assign_block_vars('topic_watch_row', array(
                'ROW_CLASS' => $row_class,
                'S_WATCHED_TOPIC_ID' => $watch_rows[$i]['topic_id'],
                'S_WATCHED_TOPIC' => $watch_rows[$i]['topic_title'],
                'S_WATCHED_TOPIC_REPLIES' => $watch_rows[$i]['topic_replies'],
                'S_WATCHED_TOPIC_START' => create_date($board_config['default_dateformat'], $watch_rows[$i]['topic_time'], $board_config['board_timezone']),
                'S_WATCHED_TOPIC_LAST' => create_date($board_config['default_dateformat'], $watch_rows[$i]['post_time'], $board_config['board_timezone']),
                'S_FORUM_TITLE' => $watch_rows[$i]['forum_name'],
                'TOPIC_POSTER' => $topic_poster = color_group_colorize_name($watch_rows[$i]['topic_poster'],true),
                'LAST_POSTER' => $last_poster = color_group_colorize_name($watch_rows[$i]['poster_id'],true),
                'GOTO_PAGE' => $goto_page,

                'U_FORUM_LINK' => append_sid("viewforum.$phpEx?" . POST_FORUM_URL . '=' . $watch_rows[$i]['forum_id']),
                'U_WATCHED_TOPIC' => append_sid("viewtopic.$phpEx?"  . POST_TOPIC_URL . '=' . $watch_rows[$i]['topic_id']),
                'L_REMOVE' => $lang['Delete'],
                'U_REMOVE' => append_sid("viewtopic.$phpEx?t=" . $watch_rows[$i]['topic_id'] . "&unwatch=topic"),
                )
            );
        }
    }
    $template->assign_var_from_handle('WATCHED_TOPICS_OUTPUT', 'watched_topics_body');
    $db->sql_freeresult($result);

?>

