<?php
/****************************************************************************
 *                                index.php
 *                            -------------------
 *   begin                : Tuesday, August 13, 2002
 *   copyright            : (C) 2002 Smartor
 *   email                : smartor_xp@hotmail.com
 *
 *   $Id: index.php 435 2006-03-25 13:03:14Z arthurschreiber $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   Some code in this file I borrowed from the original index.php, Welcome
 *   Avatar MOD and others...
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/functions_news.' . $phpEx );
include($phpbb_root_path . 'includes/functions_poll.' . $phpEx );

// Change Style
include($phpbb_root_path . 'includes/functions_selects.'.$phpEx);
//read_tracking add
include($phpbb_root_path . 'includes/read_history.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

include_once($phpbb_root_path.'includes/functions_color_groups.'.$phpEx);
color_groups_setup_list();

function get_recent_topics($count = 10, $excluded_fora = array())
{
	global $userdata, $db;
	$count = intval($count);
	$count = ($count > 0) ? $count : 10;
	$fora = get_fora_authed(AUTH_READ);
	//$fora = get_fora();
	$excluded_fora = array_flip($excluded_fora); // Flip array for isset()ing
	//$is_auth_ary = auth(AUTH_ALL, AUTH_LIST_ALL, $userdata, array_values($fora)); // TODO: Check this
	if (empty($fora))
	{
		return array();
	}
	foreach (array_keys($fora) as $void => $forum_id)
	{
		if (isset($excluded_fora[$forum_id]))
		{
			unset($fora[$forum_id]);
		}
	}

	$sql = 'SELECT t.topic_id, t.topic_title, t.topic_last_post_id, t.forum_id, p.post_id, p.poster_id, p.post_time, u.user_id, u.username
		FROM ' . TOPICS_TABLE . ' AS t, ' . POSTS_TABLE . ' AS p, ' . USERS_TABLE . ' AS u
		WHERE t.forum_id IN (' . implode(', ', array_keys($fora)) . ')
			AND t.topic_status <> 2
			AND t.topic_time < ' . time() . '
			AND p.post_id = t.topic_last_post_id
			AND p.poster_id = u.user_id
		ORDER BY p.post_id DESC
		LIMIT ' . $count;
	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'ERROR_DATABASE', '', __LINE__, __FILE__, $sql);
	}
	$recent_topics = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$recent_topics[intval($row['topic_id'])] = $row;
	}
	$db->sql_freeresult($result);
	return $recent_topics;
}

function substr_index($text, $maxChars = 18, $splitter= '...')
{
	$theReturn = $text;
	$lastSpace = false;

	if (strlen($text) > $maxChars)
	{
		$theReturn = substr($text, 0, $maxChars - 1);

		if (in_array(substr($text, $maxChars - 1, 1), array(' ', '.', '!', '?')))
		{
			$theReturn .= substr($text, $maxChars, 1);
		}
		else 
		{
			$theReturn = substr($theReturn, 0, $maxChars - strlen($splitter));
			$lastSpace = strrpos($theReturn, ' ');

			if ($lastSpace !== false) 
			{
				$theReturn = substr($theReturn, 0, $lastSpace);
			}

			if (in_array(substr($theReturn, -1, 1), array(','))) 
			{
				$theReturn = substr($theReturn, 0, -1);
			}
			$theReturn .= $splitter;
		}
	}
	return $theReturn;
}

$news_id = isset($HTTP_GET_VARS['news_id']) ? intval($HTTP_GET_VARS['news_id']) : 0; // News Category
$start = isset($HTTP_GET_VARS['start']) ? intval($HTTP_GET_VARS['start']) : 0;
$archives = isset($HTTP_GET_VARS['archives']) ? intval($HTTP_GET_VARS['archives']) : 0;
$article = isset($HTTP_GET_VARS['article']) ? intval($HTTP_GET_VARS['article']) : 0; // News Article

//
// If you don't use these stats on your index you may want to consider
// removing them
//
$total_posts = get_db_stat('postcount');
$total_users = get_db_stat('usercount');
$total_topics = get_db_stat('topiccount');
$newest_userdata = get_db_stat('newestuser');
$newest_user = $newest_userdata['username'];
$newest_uid = $newest_userdata['user_id'];

if ($total_posts == 0)
{
    $l_total_post_s = $lang['Posted_articles_zero_total'];
}
elseif ($total_posts == 1)
{
    $l_total_post_s = $lang['Posted_article_total'];
}
else
{
    $l_total_post_s = $lang['Posted_articles_total'];
}

if ($total_users == 0)
{
    $l_total_user_s = $lang['Registered_users_zero_total'];
}
elseif ($total_users == 1)
{
    $l_total_user_s = $lang['Registered_user_total'];
}
else
{
    $l_total_user_s = $lang['Registered_users_total'];
}

// Grab Portal Config from Database

$CFG = array();
$sql = 'SELECT * 
	FROM ' . PORTAL_TABLE;

if (!($result = $db->sql_query($sql)))
{
    message_die(CRITICAL_ERROR, 'Could not query config information', '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
    $CFG[$row['portal_name']] = $row['portal_value'];
}
$db->sql_freeresult($result);

//
// Recent Topics
//
$recent_topics = get_recent_topics($CFG['number_recent_topics'], (!empty($CFG['exceptional_forums']) ? explode(',', $CFG['exceptional_forums']) : array()));
$temp_url = array(
	'viewpost'		=> append_sid('viewtopic.' . $phpEx . '?' . POST_POST_URL . '=%1$d#%1$d'),
	'viewprofile'	=> append_sid('profile.' . $phpEx . '?mode=viewprofile&amp;' . POST_USERS_URL . '=%1$d'),
);

foreach ($recent_topics as $topic_id => $topic_data)
{
	$recent_topics[$topic_id]['topic_title'] = substr_index($recent_topics[$topic_id]['topic_title']);
	$template->assign_block_vars('recent_topic_row', array(
		'U_TITLE' => sprintf($temp_url['viewpost'], $topic_id),
		'L_TITLE' => $topic_data['topic_title'],
		'U_POSTER' => sprintf($temp_url['viewprofile'], $topic_data['poster_id']),
		'S_POSTER' => color_group_colorize_name($topic_data['poster_id'], true),
		'S_POSTTIME' => create_date($board_config['default_dateformat'], $topic_data['post_time'], $board_config['board_timezone']),
	));
}
//
// END - Recent Topics
//

//Added for read_tracking
if ($userdata['session_logged_in'])
{
	// 60 days limit
	if ($userdata['user_lastvisit'] < (time() - 5184000))
	{
		$userdata['user_lastvisit'] = time() - 5184000;
	}
	// New Content Block
	// Several Parts of this are 'buggy'
	// we have not found fixes, as yet.
	// We are not looking either as we
	// are running out of time fast.
	// Some parts of this block are disabled
	// to re-enable them uncomment the
	// correct constant below.

	// define ('NEW_ARTICLES_ENABLED', TRUE); // KB!
	// define ('NEW_DOWNLOADS_ENABLED', TRUE);
	// define ('NEW_LINKS_ENABLED', TRUE);
	// define ('NEW_PICTURES_ENABLED', TRUE);

	// New Forum Posts since last visit
	// DB read_tracking
	if ($board_config['db_read_tracking'])
	{
		$unread_post_count = unread_post_count();
	}
	else
	// Cookie read_tracking
	{
		$sql = 'SELECT COUNT(post_id) as total
			FROM ' . POSTS_TABLE . '
			WHERE post_time >= ' . $userdata['user_lastvisit'] . '
				AND poster_id != ' . $userdata['user_id'];

		$result = $db->sql_query($sql);
		$unread_post_count = ($result) ? $db->sql_fetchfield('total', -1, $result) : 0;
		$db->sql_freeresult($result);
	}
	$lang['Search_new'] = $lang['Search_new'] . ' (' . $unread_post_count . ')';
	unset($unread_post_count);
	
	if (defined('NEW_ARTICLES_ENABLED'))
	{
		// New KB Articles since last visit.
		$sql = 'SELECT COUNT(article_id) as total
			FROM ' . KB_ARTICLES_TABLE . '
			WHERE article_date >= ' . $userdata['user_lastvisit'] . '
				AND article_author_id != ' . $userdata['user_id'] . '
				AND approved = 1';

		$result = $db->sql_query($sql);
		if ($result)
		{
			$row = $db->sql_fetchrow($result);
			$lang['New_Articles'] = $lang['New_Articles'] . ' (' . $row['total'] . ')';
		}
		$db->sql_freeresult($result);
	}

	if (defined('NEW_DOWNLOADS_ENABLED'))
	{
		// New Downloads since last visit.
		$sql = 'SELECT COUNT(file_id) as total
			FROM ' . PA_FILES_TABLE . '
			WHERE file_time >= ' . $userdata['user_lastvisit'];

		$result = $db->sql_query($sql);
		if ($result)
		{
			$row = $db->sql_fetchrow($result);
			$lang['New_Downloads'] = $lang['New_Downloads'] . ' (' . $row['total'] . ')';
		}
		$db->sql_freeresult($result);
	}

	if (defined('NEW_LINKS_ENABLED'))
	{
		// New Links since last visit.
		$sql = 'SELECT COUNT(site_id) as total
			FROM ' . DIRECTORY_SITE_TABLE . '
			WHERE site_date >= ' . $userdata['user_lastvisit'] . ' 
				AND user_id != ' . $userdata['user_id'] . '
				AND site_status = 1';

		$result = $db->sql_query($sql);
		if ($result)
		{
			$row = $db->sql_fetchrow($result);
			$lang['New_Links'] = $lang['New_Links'] . ' (' . $row['total'] . ')';
		}
		$db->sql_freeresult($result);
	}

	if (defined('NEW_PICTURES_ENABLED'))
	{
		// New Pictures since last visit.
		$sql = 'SELECT COUNT(pic_id) as total
			FROM ' . ALBUM_TABLE . '
			WHERE pic_time >= ' . $userdata['user_lastvisit'] . '
				AND pic_user_id != ' . $userdata['user_id'] . '
				AND pic_approval = 1';

		$result = $db->sql_query($sql);
		if ($result)
		{
			$row = $db->sql_fetchrow($result);
			$lang['New_Pictures'] = $lang['New_Pictures'] . ' (' . $row['total'] . ')';
		}
		$db->sql_freeresult($result);
	}
	unset ($row);
}

//
// Hit Counter
//

$time_now = time();
$time_hour = $time_now - 3600;
$minutes = date('is', $time_now);
$hour_now = $time_now - (60 * ($minutes[0].$minutes[1])) - ($minutes[2].$minutes[3]);
$dato = create_date('H', $time_now, $board_config['board_timezone']);
$time_today = $hour_now - (3600 * $dato);
//var_dump(date('l dS of F Y h:i:s A', $time_today) . "  $dato");
//die ();
$sql = 'SELECT session_ip, MAX(session_time) as session_time 
	FROM '. SESSIONS_TABLE . '
	WHERE session_user_id = ' . ANONYMOUS . ' 
		AND session_time >= ' . $time_today . ' 
		AND session_time < ' . ($time_today + 86399) . ' 
	GROUP BY session_ip';
if (!($result = $db->sql_query($sql)))
{
	message_die(GENERAL_ERROR, 'Couldn\'t retrieve guest user today data', '', __LINE__, __FILE__, $sql);
}
$users_lasthour = null;
$logged_visible_today2 = null;
$logged_hidden_today2 = null;
while ($guest_list = $db->sql_fetchrow($result))
{
	if ($guest_list['session_time'] > $time_hour)
	{
		$users_lasthour++;
	}
}
$guests_today = $db->sql_numrows($result);
$db->sql_freeresult($result);
$sql = 'SELECT user_id, username, user_allow_viewonline, user_level, user_lastlogon 
	FROM ' . USERS_TABLE . ' 
	WHERE user_id != "' . ANONYMOUS . '" 
	AND user_session_time >= ' . $time_today . ' 
	AND user_session_time < ' . ($time_today +86399) . ' 
	ORDER BY username';
if (!($result = $db->sql_query($sql)))
{
	message_die(GENERAL_ERROR, 'Could not retrieve user today data', '', __LINE__, __FILE__, $sql);
}

$number_todayrow = $db->sql_numrows($result);

while ($todayrow = $db->sql_fetchrow($result))
{
	if ($todayrow['user_lastlogon'] >= $time_hour)
	{
		$users_lasthour++;
	}

	if (!$todayrow['user_allow_viewonline'])
	{
		$logged_hidden_today2++;
	}
	else
	{
		$logged_visible_today2++;
	}
}
$db->sql_freeresult($result);
$total_users_today = $number_todayrow + $guests_today;


$l_today_user_s = ($total_users_today) ? ( ( $total_users_today == 1 )? $lang['User_today_total'] : $lang['Users_today_total'] ) : $lang['Users_today_zero_total'];
$l_today_r_user_s = ($logged_visible_today2) ? ( ( $logged_visible_today2 == 1 ) ? $lang['Reg_user_total'] : $lang['Reg_users_total'] ) : $lang['Reg_users_zero_total'];
$l_today_h_user_s = ($logged_hidden_today2) ? (($logged_hidden_today2 == 1) ? $lang['Hidden_user_total'] : $lang['Hidden_users_total'] ) : $lang['Hidden_users_zero_total'];
$l_today_g_user_s = ($guests_today) ? (($guests_today == 1) ? $lang['Guest_user_total'] : $lang['Guest_users_total']) : $lang['Guest_users_zero_total'];
$l_today_users = sprintf($l_today_user_s, $total_users_today);
$l_today_users .= sprintf($l_today_r_user_s, $logged_visible_today2);
$l_today_users .= sprintf($l_today_h_user_s, $logged_hidden_today2);
$l_today_users .= sprintf($l_today_g_user_s, $guests_today);

//
// Start output of page
//
define('SHOW_ONLINE', true);

//
// Set up general page configuration for Index.
//

$NEWS_CFG['recent_categories'] = 5;
$NEWS_CFG['num_news_items'] = $board_config['news_item_num'];
$NEWS_CFG['num_archives_items'] = $board_config['news_archives_num'];
$NEWS_CFG['news_title_trim'] = $board_config['news_title_trim'];

if ($news_id > 0)
{
    $NEWS_CFG['news_category'] = $news_id;
}

require($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
    'body' => 'index_body.tpl')
);

// last seen hack
$sql = 'SELECT username, user_id, user_level, user_allow_viewonline, user_lastlogon 
	FROM ' . USERS_TABLE . ' 
	WHERE user_id != ' . ANONYMOUS . ' 
	ORDER BY user_lastlogon DESC 
	LIMIT ' . $CFG['last_seen'];

if (!($result = $db->sql_query($sql)))
{
	message_die(GENERAL_ERROR, 'Could not query last seen information', '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
	$user_online_link = color_group_colorize_name($row['user_id'], true);
	if ( $row['user_allow_viewonline'] )
	{
		$logged_visible_online++;
	}
	else
	{
		$logged_hidden_online++;
	}

	if ( $row['user_allow_viewonline'] || $userdata['user_level'] == ADMIN )
	{
		$template->assign_block_vars('last_seen_row', array(
		'L_LSEEN_USERNAME' => $user_online_link,
		'L_LSEEN_TIME' => create_date($board_config['default_dateformat'], $row['user_lastlogon'], $board_config['board_timezone']))
		);
	}
}
$db->sql_freeresult($result);
//
// Avatar On Index MOD
//
$avatar_img = '';
if (empty($userdata['user_avatar']) && $userdata['session_logged_in'])
{
    $avatar_img = '<img src="'. $images['default_avatar'] .'" alt="" border="0" />';
}
else if (!$userdata['session_logged_in'])
{
    $avatar_img = '<img src="'. $images['guest_avatar'] .'" alt="" border="0" />';
}
else if ($userdata['user_avatar_type'] && $userdata['user_allowavatar'])
{
    switch ($userdata['user_avatar_type'])
    {
        case USER_AVATAR_UPLOAD:
            $avatar_img = ($board_config['allow_avatar_upload']) ? '<img src="' . $board_config['avatar_path'] . '/' . $userdata['user_avatar'] . '" alt="" border="0" />' : '';
            break;
        case USER_AVATAR_REMOTE:
            $avatar_img = ($board_config['allow_avatar_remote']) ? '<img src="' . $userdata['user_avatar'] . '" alt="" border="0" />' : '';
            break;
        case USER_AVATAR_GALLERY:
            $avatar_img = ($board_config['allow_avatar_local']) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $userdata['user_avatar'] . '" alt="" border="0" />' : '';
            break;
    }
}

if (!empty($userdata['user_vacances']))
{
    switch ($userdata['user_vacances'])
    {
        case 1:
        	$avatar_img = '<img src="'.  $images['vacs'] .'" alt="" border="0" />';
        	break;
        default:
        	$vacances_image = '';
    }
}
$name_link = color_group_colorize_name($userdata['user_id']);

//
// END: Avatar On Index MOD
//

// The News
//                                                          - Display the Categories

if (isset($HTTP_GET_VARS['topics']))
{
	$template->assign_block_vars('topics', array());

	$template->assign_vars(array(
		'L_NEWS_INDEX' => $lang['News'] . ' ' . $lang['Index'],
		'U_NEWS_INDEX' => $phpbb_root_path . 'index.' . $phpEx)
	);
	$cats = fetch_categories();
	$count = 0;
	$max = count($cats);
	while ($count < $max)
	{
		$template->assign_block_vars('topics.catrow', array());
		for ($i = 0; $i < 4; $i++)
		{
			$cats[$count]['news_url'] = $phpbb_root_path . 'index.' . $phpEx . '?news_id=' . $cats[$count]['news_id'];

			if ($cats[$count]['news_image_link'] != '')
			{
				$cats[$count]['news_href'] = '<a href="' . $cats[$count]['news_url'] . '" style="border:0;">' . $cats[$count]['news_image_link'] . '</a>';
			}

			foreach ($cats[$count] as $k => $v)
			{
				$cat_vars[strtoupper($k)] = $v;
			}

			if ($cats[$count]['news_image_link'] != '')
			{
				$template->assign_block_vars('topics.catrow.catitem', $cat_vars);
			}
			else
			{
				$template->assign_block_vars('topics.catrow.catitem', '');
			}
			$count++;
		}
	}
}
//                                                          - Done with the Categories
else
{
	if (!isset($HTTP_GET_VARS['article']))
	{
		if (!isset($HTTP_GET_VARS['news_id']) && !isset($HTTP_GET_VARS['archives']))
		{
			$template->assign_block_vars('welcome_text', array());
		}

		$topics_count = fetch_news_count($news_id);

		if (isset($HTTP_GET_VARS['archives']))
		{
			$template->assign_block_vars('archives', array());
			$news_items = fetch_news_posts($NEWS_CFG['num_archives_items'], $NEWS_CFG['news_category'], 0, true, $start, $NEWS_CFG['news_title_trim']);
		}
		else
		{
			$news_items = fetch_news_posts($NEWS_CFG['num_news_items'], $NEWS_CFG['news_category'], 0, true, $start, $NEWS_CFG['news_title_trim']);
		}
	}
	else
	{
		$news_items = fetch_news_post($article);
	}

	//$cats = fetch_recent_categories($NEWS_CFG['recent_categories']);

	if (!empty($news_items))
	{
		for ($i = 0, $max=count($news_items); $i < $max; $i++)
		{
			//
			// Convert array.
			//

			foreach ($news_items[$i] as $k => $v)
			{
				$posts_vars[strtoupper($k)] = $v;
			}

			$posts_vars['READ_MORE_LINK'] = ($news_items[$i]['body_trimmed'] == true) ? '[ <a href="' . $news_items[$i]['read_more_url'] . '">' . $lang['Read_More'] . '</a> ]' : '';
			if (!isset($HTTP_GET_VARS['archives']))
			{
				$template->assign_block_vars('newsitem', $posts_vars);
				if ($news_items[$i]['post_attachment'] == 1)
				{
					$attach_items = news_attach_display($i);
					for ($t = 0, $maxx=count($attach_items); $t < $maxx; $t++)
					{
						foreach ($attach_items[$t] as $k => $v)
						{
							$attach_vars[strtoupper($k)] = $v;
						}
						$attach_vars['DOWNLOAD_NAME'] = strtolower(trim($attach_items[$t]['real_filename']));
						$attach_vars['COMMENT'] = stripslashes(trim(nl2br($attach_items[$t]['comment'])));
						$attach_vars['U_DOWNLOAD_LINK'] = append_sid('download.php?id='.$attach_items[$t]['attach_id']);
						$attach_vars['L_DOWNLOAD_COUNT'] = sprintf($lang['Download_number'], $attach_items[$t]['download_count']);
						$attach_vars['FILESIZE'] = $attach_items[$t]['filesize'];
						$attach_vars['SIZE_VAR'] = $attach_items[$t]['size_lang'];
						$attach_vars['S_UPLOAD_IMAGE'] = $attach_items[$t]['up_img'];
						$attach_vars['L_DOWNLOADED_VIEWED'] = $lang['Downloaded'];
						$attach_vars['L_DESCRIPTION'] = $lang['Description'];
						$attach_vars['L_DOWNLOAD'] = $lang['Download'];
						$attach_vars['L_FILENAME'] = $lang['File_name'];
						$attach_vars['L_FILESIZE'] = $lang['Filesize'];
						$template->assign_block_vars('newsitem.attachrow', $attach_vars);
					}
				}
			}
			else
			{
				$template->assign_block_vars('archives.newsitem', $posts_vars);
			}
		}
/**
		for ($i = 0, $maxyx=count($cats); $i < $maxyx; $i++)
		{
			foreach ($cats[$i] as $k => $v)
			{
				$cat_vars[strtoupper($k)] = $v;
			}
			if (!isset($HTTP_GET_VARS['archives']))
			{
				$template->assign_block_vars('catitem', $cat_vars);
			}
			else
			{
				$template->assign_block_vars('archives.catitem', $posts_vars);
			}
		}
*/
		if (!isset($HTTP_GET_VARS['archives']))
		{
			$pagination = generate_pagination("index.$phpEx?news_id=".$news_id, $topics_count, $NEWS_CFG['num_news_items'], $start);
		}
		else
		{
			$pagination = generate_pagination("index.$phpEx?news_id=".$news_id.'&amp;archives=1', $topics_count, $NEWS_CFG['num_archives_items'] , $start);
		}

		$template->assign_vars(array( 
			'PAGINATION' => $pagination) 
		);
	}
	else
	{
		$template->assign_block_vars('no_news', array(
			'L_NO_NEWS_TITLE' => $lang['No_News_Title'],
			'L_NO_NEWS_MESSAGE' => $lang['No_News_Message'])
		);
	}
}

// Generate the Page Title
if (isset($HTTP_GET_VARS['topics']))
{
	$page_title = $lang['News'] . ' &raquo; ' . $lang['News_Categories'];
}
elseif (isset($HTTP_GET_VARS['archives']))
{
	$page_title = $lang['News'] . ' &raquo; ' . $lang['News_Archives'];
}
elseif (isset($HTTP_GET_VARS['news_id']))
{
	$page_title = $lang['News'] . ' &raquo; ' . $lang['News_Categories'] . ' &raquo; ' . $news_items[0]['news_category'];
}
elseif (isset($HTTP_GET_VARS['article']))
{
	$page_title = $lang['News'];
}
else
{
	$page_title = $lang['Home'];
}

//Let's reduce the forums specified for poll display to the number allowed access to by the user
if (empty($CFG['poll_forum']) && $userdata['user_level'] != ADMIN)
{
	$sql = 'SELECT forum_id 
		FROM ' . FORUMS_TABLE;

	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not query forum information', __LINE__, __FILE__, $sql);
	}

	if ($row = $db->sql_fetchrow($result))
	{
		$arr_poll_forums = array();
		do
		{
			$arr_poll_forums[] = $row['forum_id'];
		}
		while ($row = $db->sql_fetchrow($result));
	}
	$db->sql_freeresult($result);
}
else
{
	$arr_poll_forums = split(',', $CFG['poll_forum']);
}

$allowed_poll_forums = '';
$fetchpoll = '';

$can_vote = array();

for ($i = 0, $max = count($arr_poll_forums); $i < $max; $i++)
{
	$is_auth = auth('auth_all', $arr_poll_forums[$i], $userdata);
	
	$can_vote[$arr_poll_forums[$i]] = $is_auth['auth_vote'];

	if ($is_auth['auth_view'] && $is_auth['auth_read'])
	{
		$allowed_poll_forums .= ($allowed_poll_forums != '' ? ',' : '') . $arr_poll_forums[$i];
	}
}

if (!empty($allowed_poll_forums))
{
    $fetchpoll = phpbb_fetch_poll($allowed_poll_forums);
	$can_vote = $can_vote[$fetchpoll['forum_id']];
}

unset ($arr_poll_forums);

if (!empty($fetchpoll))
{
	$template->assign_block_vars('switch_poll_block', array());
	
	if ($userdata['user_id'] == ANONYMOUS)
	{
		//$user_ip = $userdata['user_ip'];
		$guest_sql = " AND vote_user_ip = '$user_ip'";
	}
	else
	{
		$guest_sql = '';
	}

	$sql = 'SELECT vote_id
		FROM ' . VOTE_USERS_TABLE . '
		WHERE vote_id = ' . $fetchpoll['vote_id'] . ' 
			AND vote_user_id = ' . $userdata['user_id'] . 
			$guest_sql;

	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not obtain user vote data for this topic', '', __LINE__, __FILE__, $sql);
	}
	$user_voted = ($db->sql_numrows($result)) ? TRUE : FALSE;
	$db->sql_freeresult($result);	

	if (!$user_voted && $can_vote)
	{
		$vote_button = '<div align="center"><input type="submit" class="mainoption" name="submit" value="'.$lang['Vote'].'" /></div><input type="hidden" name="topic_id" value="' . $fetchpoll['topic_id'] . '" /><input type="hidden" name="mode" value="vote" />';
		
		$template->assign_vars(array(
			'S_POLL_QUESTION' => $fetchpoll['vote_text'],
			'S_POLL_ACTION' => append_sid('posting.'.$phpEx.'?'.POST_TOPIC_URL.'='.$fetchpoll['topic_id']),
			'L_SUBMIT_VOTE' => $lang['Submit_vote'],
			'POLL_TOPIC_ID' => $fetchpoll['topic_id'],
			'SUBMIT_BUTTON' => $vote_button
		));
		
		for ($i = 0, $maxzx=count($fetchpoll['options']); $i < $maxzx; $i++)
		{
			$template->assign_block_vars('switch_poll_block.poll_option_row', array(
				'OPTION_ID' => $fetchpoll['options'][$i]['vote_option_id'],
				'OPTION_TEXT' => $fetchpoll['options'][$i]['vote_option_text'],
				'VOTE_RESULT' => $fetchpoll['options'][$i]['vote_result'],
			));
		}
	}
	else
	{
		$votes_total = 0;

		for($i = 0, $maxzz=count($fetchpoll['options']); $i < $maxzz; $i++)
		{
			$votes_total += $fetchpoll['options'][$i]['vote_result'];
		}
		$template->assign_vars(array(
			'POLL_TOPIC_ID' => $fetchpoll['topic_id'],
			'S_POLL_QUESTION' => $fetchpoll['vote_text'],
			'VOTE_RESULTS' => '<div align="center"><span class="gensmall">'.$lang['Total_votes_index'].' ' . $votes_total . '</span></div>'
		));
		
		for ($i = 0, $maxzyx=count($fetchpoll['options']); $i < $maxzyx; $i++)
		{
			$vote_percent = ($votes_total > 0) ? $fetchpoll['options'][$i]['vote_result'] / $votes_total : 0;
			$vote_graphic_length = round($vote_percent * 70);
			
			$vote_graphic = 0;
			$vote_graphic = ($vote_graphic < $vote_graphic_max - 1) ? $vote_graphic + 1 : 0;
			
			if (count($orig_word))
			{
				$vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
			}
			
			$template->assign_block_vars('switch_poll_block.poll_results_row', array(
				'POLL_OPTION_CAPTION' => $fetchpoll['options'][$i]['vote_option_text'],
				'POLL_OPTION_RESULT' => $fetchpoll['options'][$i]['vote_result'],
				'POLL_OPTION_PERCENT' => sprintf("%.1d%%", ($vote_percent * 100)),
				'POLL_OPTION_IMG_WIDTH' => $vote_graphic_length
			));
		}
	}
}
//end poll

// Change Style
$fpage_style = $userdata['user_style'];
if (isset($HTTP_POST_VARS['fpage_theme']))
{
    $fpage_theme = intval($HTTP_POST_VARS['fpage_theme']);
    $sql = 'UPDATE ' . USERS_TABLE . ' 
    	SET user_style = "' . $fpage_theme . '" 
    	WHERE user_id = ' . $userdata['user_id'];
    if (!($result = $db->sql_query($sql)))
    {
        message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql);
    }
    else
    {
        $message = $lang['Profile_updated'] . '<br /><br />' . sprintf($lang['Click_return_index'],  '<a href="' . append_sid("index.$phpEx") . '">', '</a>');
        message_die(GENERAL_MESSAGE, $message);
    }
}

if (defined('NEW_ARTICLES_ENABLED'))
{
	$template->assign_block_vars('switch_user_logged_in.new_articles', array(
	    'L_NEW_ARTICLES' => $lang['New_Articles'],
	    'U_NEW_ARTICLES' => append_sid('kb.' . $phpEx)
	));
}

if (defined('NEW_LINKS_ENABLED'))
{
	$template->assign_block_vars('switch_user_logged_in.new_links', array(
	    'L_NEW_LINKS' => $lang['New_Links'],
	    'U_NEW_LINKS' => append_sid('directory.' . $phpEx)
	));
}

if (defined('NEW_DOWNLOADS_ENABLED'))
{
	$template->assign_block_vars('switch_user_logged_in.new_downloads', array(
	    'L_NEW_DOWNLOADS' => $lang['New_Downloads'],
	    'U_NEW_DOWNLOADS' => append_sid('dload.' . $phpEx)
	));
}

if (defined('NEW_PICTURES_ENABLED'))
{
	$template->assign_block_vars('switch_user_logged_in.new_pictures', array(
	    'L_NEW_PICTURES' => $lang['New_Pictures'],
	    'U_NEW_PICTURES' => append_sid('album.' . $phpEx)
	));
}

$server_protocol = ($board_config['cookie_secure']) ? 'https://' : 'http://';
$server_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($board_config['server_name']));
$server_port = ($board_config['server_port'] <> 80) ? ':' . trim($board_config['server_port']) : '';
$script_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($board_config['script_path']));
$script_name = ($script_name == '') ? $script_name : '/' . $script_name;
$url = preg_replace('#^\/?(.*?)\/?$#', '/\1', trim(basename(__FILE__) . '?article='));

$tell_link = $server_protocol . $server_name . $server_port . $script_name . $url;

$template->assign_vars(array(
    'L_WELCOME' => $lang['Welcome'],
    'WELCOME_TEXT' => $CFG['welcome_text'],
    'TOTAL_POSTS' => sprintf($l_total_post_s, $total_posts),
    'TOTAL_USERS' => sprintf($l_total_user_s, $total_users),
    'TOTAL_TOPICS' => sprintf($lang['total_topics'], $total_topics),
    'NEWEST_USER' => sprintf($lang['Newest_user'], color_group_colorize_name($newest_uid, FALSE)),
    'L_BOARD_NAVIGATION' => $lang['Board_navigation'],
    'L_STATISTICS' => $lang['Statistics'],
    'L_SYNDICATE' => $lang['Syndicate'],
    'RSS_FORUMS' => $images['rss_forums'],
    'RSS_NEWS' => $images['rss_news'],
    'L_ANNOUNCEMENT' => $lang['Post_Announcement'],
    'L_POSTED' => $lang['Posted'],
    'L_COMMENTS' => $lang['Comments'],
    'L_VIEW_COMMENTS' => $lang['View_comments'],
    'L_POST_COMMENT' => $lang['Post_your_comment'],
    'L_SEND_PASSWORD' => $lang['Forgotten_password'],
    'U_SEND_PASSWORD' => append_sid("profile.$phpEx?mode=sendpassword"),
    'L_REGISTER_NEW_ACCOUNT' => sprintf($lang['Register_new_account'], '<a href="' . append_sid("profile.$phpEx?mode=register") . '">', '</a>'),
    'L_REMEMBER_ME' => $lang['Remember_me'],
    'L_VIEW_COMPLETE_LIST' => $lang['View_complete_list'],
    'L_POLL' => $lang['Poll'],
    'L_VOTE_BUTTON' => $lang['Vote'],

    //New Content

    'L_NEW_CONTENT' => $lang['New_Content'],
    'L_NEW_CONTENT_EXPLAIN' => $lang['New_Content_Explain'],
/*
    'L_NEW_ARTICLES' => $lang['New_Articles'],
    'U_NEW_ARTICLES' => append_sid('kb.' . $phpEx),

    'L_NEW_LINKS' => $lang['New_Links'],
    'U_NEW_LINKS' => append_sid('directory.' . $phpEx),

    'L_NEW_DOWNLOADS' => $lang['New_Downloads'],
    'U_NEW_DOWNLOADS' => append_sid('dload.' . $phpEx),

    'L_NEW_PICTURES' => $lang['New_Pictures'],
    'U_NEW_PICTURES' => append_sid('album.' . $phpEx),
*/
    // Change Style
    'TEMPLATE_SELECT' => style_select($board_config['default_style'], 'template'),
    'L_SELECT_STYLE' => $lang['Change_style'],
    'L_SELECT_STYLE_EXPLAIN' => $lang['Change_style_explain'],
    'L_CHANGE_NOW' => $lang['Go'],
    'FPAGE_STYLE' => style_select($fpage_style, 'fpage_theme'),
    // Recent Topics
    'L_RECENT_TOPICS' => $lang['Recent_topics'],
    'L_LAST_SEEN' => $lang['Last_Seen'],
    // Search
    'L_SEARCH_AT' => $lang['Search_at'],
    'L_ADVANCED_SEARCH' => $lang['Advanced_search'],
    'L_WORD_ON' => $lang['Word_On'],
    'L_WORD_BY' => $lang['Word_By'],


    // News
    'L_NEWS' => $lang['News'],
    'L_NEWS_CATEGORIES' => $lang['News_Categories'],
    'L_NEWS_ARCHIVES' => $lang['News_Archives'],
    'L_CURRENT_PAGE' => $page_title,
    'L_PRINT_NEWS' => $lang['Print_news'],
    'L_EMAIL_NEWS' => $lang['Email_news'],
    'L_REPLY_NEWS' => $lang['Reply_news'],
    'L_NEWS_TITLE' => $lang['News_Title'],
    'L_NEWS_AUTHOR' => $lang['News_Author'],
    'L_NEWS_DATE' => $lang['News_Date'],
    'L_NEWS_CATEGORY' => $lang['News_Category'],
    'L_NEWS_SUMMARY' => $lang['News_Summary'],
    'L_NEWS_COMMENTS' => $lang['News_Comments'],
    'L_NEWS_VIEWS' => $lang['News_Views'],
    'L_NEWS_AND' => $lang['News_and'],
    'L_NEWS_TOPICS' => $lang['News'] . ' ' . $lang['Topics'],
    'L_NEWS_INDEX' => $lang['News'] . ' ' . $lang['Index'],
    'L_POSTER' => $lang['Poster'],
    'L_DATE' => $lang['Date'],
    'L_COMMENTS' => $lang['View_comments'],
    'U_VIEWTOPICS' => append_sid($phpbb_root_path . 'index.' . $phpEx.'?topics=1'),
    'U_VIEWARCHIVES' => append_sid($phpbb_root_path . 'index.' . $phpEx.'?archives=1'),
    'U_VIEWNEWS' => append_sid($phpbb_root_path . 'index.' . $phpEx),

    'L_FUN_N_GAMES' => $lang['Fun_n_Games'],
    'L_ONLINE_CHAT' => $lang['Online_Chat'],
    'L_MESSAGING' => $lang['Messaging'],
    // Poll Validation MOD - Daz - forumimages.com - START
    'L_MUST_SELECT_POLL_OPTION' => $lang['No_vote_option'],
    // Poll Validation MOD - Daz - forumimages.com - END
    //Last Visit
    //'USERS_TODAY_LIST' => $users_today_list,
    'L_USERS_LASTHOUR' =>($users_lasthour)?sprintf($lang['Users_lasthour_explain'],$users_lasthour):$lang['Users_lasthour_none_explain'],
    'L_USERS_TODAY' => $l_today_users,

    'L_USERS_LASTHOUR' => ($users_lasthour) ? sprintf($lang['Users_lasthour_explain'], $users_lasthour) : $lang['Users_lasthour_none_explain'],
    'L_ADMIN_USERS' => $lang['Admin_users'],
    'L_MOD_USERS' =>  $lang['Mod_users'],
    'L_USERS_LIST' =>  $lang['Registered_users'],
    'L_USERS_TODAY' => $l_today_users,
    'L_LAST_SEEN' => $lang['Last_Seen'],
    'L_ENHANCED_ONLINE' => $lang['Enhanced_Online'],

    // Welcome Avatar
    'L_NAME_WELCOME' => $lang['Welcome'],
    'U_NAME_LINK' => $name_link,
    'MINIPOST_IMG' => $images['icon_minipost'],
    'NEWS_PRINT_IMG' => $images['news_print'],
    'NEWS_EMAIL_IMG' => $images['news_email'],
    'NEWS_REPLY_IMG' => $images['news_reply'],
    "TELL_LINK" => $tell_link,
    'AVATAR_IMG' => $avatar_img)
);

// MOD MINI CAL BEGIN
include($phpbb_root_path . 'includes/mini_cal.'.$phpEx);
// MOD MINI CAL END

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>
