#
# phpBB2 - MySQL schema
#
# $Id: mysql_schema.sql 441 2006-04-13 10:28:29Z arthurschreiber $
#

#
# Table structure for table 'phpbb_auth_access'
#
CREATE TABLE phpbb_auth_access (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   forum_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   auth_view tinyint(1) DEFAULT '0' NOT NULL,
   auth_read tinyint(1) DEFAULT '0' NOT NULL,
   auth_post tinyint(1) DEFAULT '0' NOT NULL,
   auth_reply tinyint(1) DEFAULT '0' NOT NULL,
   auth_edit tinyint(1) DEFAULT '0' NOT NULL,
   auth_delete tinyint(1) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(1) DEFAULT '0' NOT NULL,
   auth_announce tinyint(1) DEFAULT '0' NOT NULL,
   auth_globalannounce tinyint(1) NOT NULL,
   auth_vote tinyint(1) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(1) DEFAULT '0' NOT NULL,
   auth_calendar TINYINT(1)  DEFAULT '0' NOT NULL,
   auth_attachments tinyint(1) DEFAULT '0' NOT NULL,
   auth_mod tinyint(1) DEFAULT '0' NOT NULL,
   auth_news TINYINT(1) DEFAULT '0' NOT NULL,
   auth_delayedpost TINYINT(1) DEFAULT '3' NOT NULL,
   KEY group_id (group_id),
   KEY forum_id (forum_id)
);

#
# Table structure for table 'phpbb_user_group'
#
CREATE TABLE phpbb_user_group (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   user_pending tinyint(1),
   group_moderator TINYINT(1) NOT NULL,
   KEY group_id (group_id),
   KEY user_id (user_id)
);

#
# Table structure for table 'phpbb_groups'
#
CREATE TABLE phpbb_groups (
   group_id mediumint(8) NOT NULL auto_increment,
   group_type tinyint(4) DEFAULT '1' NOT NULL,
   group_name varchar(40) NOT NULL,
   group_description varchar(255) NOT NULL,
   group_moderator mediumint(8) DEFAULT '0' NOT NULL,
   group_single_user tinyint(1) DEFAULT '1' NOT NULL,
   group_count INT (4) UNSIGNED DEFAULT '99999999',
   group_count_enable SMALLINT (2) UNSIGNED DEFAULT '0',
   group_color_group MEDIUMINT UNSIGNED NOT NULL,
   rank_id mediumint(5) unsigned DEFAULT '0' not null,
   group_priority mediumint(3) unsigned DEFAULT '999' not null,
   PRIMARY KEY (group_id),
   KEY group_single_user (group_single_user)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_banlist'
#
CREATE TABLE phpbb_banlist (
   ban_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   ban_userid mediumint(8) NOT NULL,
   ban_ip char(8) NOT NULL,
   ban_email varchar(255),
   ban_time int(11) default NULL,
   ban_expire_time int(11) default NULL,
   ban_by_userid mediumint(8) default NULL,
   ban_priv_reason text,
   ban_pub_reason_mode tinyint(1) default NULL,
   ban_pub_reason text,
   PRIMARY KEY (ban_id),
   KEY ban_ip_user_id (ban_ip, ban_userid)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_categories'
#
CREATE TABLE phpbb_categories (
   cat_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   cat_title varchar(100),
   cat_order mediumint(8) UNSIGNED NOT NULL,
   cat_main MEDIUMINT(8) UNSIGNED DEFAULT '0' NOT NULL,
   cat_desc TEXT NOT NULL,
   cat_head TEXT NOT NULL,
   cat_foot TEXT NOT NULL,
   PRIMARY KEY (cat_id),
   KEY cat_order (cat_order)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_config'
#
CREATE TABLE phpbb_config (
    config_name varchar(255) NOT NULL,
    config_value varchar(255) NOT NULL,
    PRIMARY KEY (config_name)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_disallow'
#
CREATE TABLE phpbb_disallow (
   disallow_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   disallow_username varchar(25) DEFAULT '' NOT NULL,
   PRIMARY KEY (disallow_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_forum_prune'
#
CREATE TABLE phpbb_forum_prune (
   prune_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   forum_id smallint(5) UNSIGNED NOT NULL,
   prune_days smallint(5) UNSIGNED NOT NULL,
   prune_freq smallint(5) UNSIGNED NOT NULL,
   PRIMARY KEY(prune_id),
   KEY forum_id (forum_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_forums'
#
CREATE TABLE phpbb_forums (
   forum_id smallint(5) UNSIGNED NOT NULL,
   cat_id mediumint(8) UNSIGNED NOT NULL,
   forum_name varchar(150),
   forum_desc text,
   forum_status tinyint(4) DEFAULT '0' NOT NULL,
   forum_order mediumint(8) UNSIGNED DEFAULT '1' NOT NULL,
   forum_posts mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_topics mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_last_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   prune_next int(11),
   prune_enable tinyint(1) DEFAULT '0' NOT NULL,
   auth_view tinyint(2) DEFAULT '0' NOT NULL,
   auth_read tinyint(2) DEFAULT '0' NOT NULL,
   auth_post tinyint(2) DEFAULT '0' NOT NULL,
   auth_reply tinyint(2) DEFAULT '0' NOT NULL,
   auth_edit tinyint(2) DEFAULT '0' NOT NULL,
   auth_delete tinyint(2) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(2) DEFAULT '0' NOT NULL,
   auth_announce tinyint(2) DEFAULT '0' NOT NULL,
   auth_globalannounce tinyint(2) DEFAULT '3' NOT NULL,
   auth_vote tinyint(2) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(2) DEFAULT '0' NOT NULL,
   auth_calendar TINYINT(2)  DEFAULT '0' NOT NULL,
   auth_attachments tinyint(2) DEFAULT '0' NOT NULL,
   auth_news TINYINT(2) DEFAULT '2' NOT NULL,
   auth_delayedpost TINYINT(2) DEFAULT '3' NOT NULL,
   forum_password varchar(20) NOT NULL DEFAULT '',
   sort_order TINYINT(2) DEFAULT '0' NOT NULL,
   forum_external tinyint(4) NOT NULL default '0',
   forum_redirect_url text,
   forum_redirects_user mediumint(8) UNSIGNED NOT NULL default '0',
   forum_redirects_guest mediumint(8) UNSIGNED NOT NULL default '0',
   custom_head TEXT NOT NULL,
   custom_foot TEXT NOT NULL,
   forum_postcount TINYINT( 1 ) DEFAULT '1' NOT NULL,
   PRIMARY KEY (forum_id),
   KEY forums_order (forum_order),
   KEY cat_id (cat_id),
   KEY forum_last_post_id (forum_last_post_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_posts'
#
CREATE TABLE phpbb_posts (
   post_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   topic_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   forum_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   poster_id mediumint(8) DEFAULT '0' NOT NULL,
   post_time int(11) DEFAULT '0' NOT NULL,
   poster_ip char(8) NOT NULL,
   post_username varchar(25),
   enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   enable_html tinyint(1) DEFAULT '0' NOT NULL,
   enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
   enable_sig tinyint(1) DEFAULT '1' NOT NULL,
   post_edit_time int(11),
   post_edit_count smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   post_edit_user MEDIUMINT(8) DEFAULT NULL,
   reporter_id MEDIUMINT(8) DEFAULT '0' NOT NULL,
   user_avatar VARCHAR(100),
   user_avatar_type TINYINT NOT NULL,
   rating_rank_id smallint unsigned NOT NULL,
   post_icon TINYINT (2) UNSIGNED DEFAULT '0' NOT NULL,
   post_edit_percent SMALLINT(3) NOT NULL DEFAULT '0',
   PRIMARY KEY (post_id),
   KEY forum_id (forum_id),
   KEY topic_id (topic_id),
   KEY poster_id (poster_id),
   KEY post_time (post_time),
   KEY posts_ratingrankid(rating_rank_id)
);

ALTER TABLE phpbb_posts ADD INDEX (reporter_id);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_posts_text'
#
CREATE TABLE phpbb_posts_text (
   post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   bbcode_uid char(10) DEFAULT '' NOT NULL,
   post_subject VARCHAR(120) DEFAULT NULL,
   post_text text,
   user_avatar VARCHAR(100),
   user_avatar_type TINYINT NOT NULL,
   PRIMARY KEY (post_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_privmsgs'
#
CREATE TABLE phpbb_privmsgs (
   privmsgs_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   privmsgs_type tinyint(4) DEFAULT '0' NOT NULL,
   privmsgs_subject varchar(255) DEFAULT '0' NOT NULL,
   privmsgs_from_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_to_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_date int(11) DEFAULT '0' NOT NULL,
   privmsgs_ip char(8) NOT NULL,
   privmsgs_enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_enable_html tinyint(1) DEFAULT '0' NOT NULL,
   privmsgs_enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_attach_sig tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_from_username varchar(25) DEFAULT '' NOT NULL,
   privmsgs_to_username varchar(25) DEFAULT '' NOT NULL,
   site_id mediumint(8) DEFAULT '0' NOT NULL,
   room_id mediumint(8) DEFAULT '0' NOT NULL,
   INDEX room_id (room_id),
   INDEX site_id (site_id),
   PRIMARY KEY (privmsgs_id),
   KEY privmsgs_from_userid (privmsgs_from_userid),
   KEY privmsgs_to_userid (privmsgs_to_userid)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_privmsgs_text'
#
CREATE TABLE phpbb_privmsgs_text (
   privmsgs_text_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   privmsgs_bbcode_uid char(10) DEFAULT '0' NOT NULL,
   privmsgs_text text,
   PRIMARY KEY (privmsgs_text_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_ranks'
#
CREATE TABLE phpbb_ranks (
   rank_id smallint(5) UNSIGNED NOT NULL auto_increment,
   rank_title varchar(50) NOT NULL,
   rank_min mediumint(8) DEFAULT '0' NOT NULL,
   rank_special tinyint(1) DEFAULT '0',
   rank_image varchar(255),
   PRIMARY KEY (rank_id)
);

# --------------------------------------------------------
#
# Table structure for table phpbb_search_results
#
CREATE TABLE phpbb_search_results (
  search_id int(11) UNSIGNED NOT NULL default '0',
  session_id char(32) NOT NULL default '',
  search_array text NOT NULL,
  PRIMARY KEY  (search_id),
  KEY session_id (session_id)
);


# --------------------------------------------------------
#
# Table structure for table phpbb_search_wordlist
#
CREATE TABLE phpbb_search_wordlist (
  word_text varchar(50) binary NOT NULL default '',
  word_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  word_common tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY (word_text),
  KEY word_id (word_id)
);

# --------------------------------------------------------
#
# Table structure for table phpbb_search_wordmatch
#
CREATE TABLE phpbb_search_wordmatch (
  post_id mediumint(8) UNSIGNED NOT NULL default '0',
  word_id mediumint(8) UNSIGNED NOT NULL default '0',
  title_match tinyint(1) NOT NULL default '0',
  KEY post_id (post_id),
  KEY word_id (word_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_sessions'
#
# Note that if you're running 3.23.x you may want to make
# this table a type HEAP. This type of table is stored
# within system memory and therefore for big busy boards
# is likely to be noticeably faster than continually
# writing to disk ...
#
CREATE TABLE phpbb_sessions (
   session_id char(32) DEFAULT '' NOT NULL,
   session_user_id mediumint(8) DEFAULT '0' NOT NULL,
   session_start int(11) DEFAULT '0' NOT NULL,
   session_time int(11) DEFAULT '0' NOT NULL,
   session_ip char(8) DEFAULT '0' NOT NULL,
   session_page int(11) DEFAULT '0' NOT NULL,
   session_logged_in tinyint(1) DEFAULT '0' NOT NULL,
   session_admin tinyint(2) DEFAULT '0' NOT NULL,
   PRIMARY KEY (session_id),
   KEY session_user_id (session_user_id),
   KEY session_id_ip_user_id (session_id, session_ip, session_user_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_smilies'
#
CREATE TABLE phpbb_smilies (
  smilies_id smallint(5) unsigned NOT NULL auto_increment,
  code varchar(50) default NULL,
  smile_url varchar(100) default NULL,
  emoticon varchar(75) default NULL,
  smilies_order int(5) NOT NULL default '0',
  PRIMARY KEY  (smilies_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_themes'
#
CREATE TABLE phpbb_themes (
   themes_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   template_name varchar(30) NOT NULL default '',
   style_name varchar(30) NOT NULL default '',
   head_stylesheet varchar(100) default NULL,
   body_background varchar(100) default NULL,
   body_bgcolor varchar(6) default NULL,
   body_text varchar(6) default NULL,
   body_link varchar(6) default NULL,
   body_vlink varchar(6) default NULL,
   body_alink varchar(6) default NULL,
   body_hlink varchar(6) default NULL,
   tr_color1 varchar(6) default NULL,
   tr_color2 varchar(6) default NULL,
   tr_color3 varchar(6) default NULL,
   tr_class1 varchar(25) default NULL,
   tr_class2 varchar(25) default NULL,
   tr_class3 varchar(25) default NULL,
   th_color1 varchar(6) default NULL,
   th_color2 varchar(6) default NULL,
   th_color3 varchar(6) default NULL,
   th_class1 varchar(25) default NULL,
   th_class2 varchar(25) default NULL,
   th_class3 varchar(25) default NULL,
   td_color1 varchar(6) default NULL,
   td_color2 varchar(6) default NULL,
   td_color3 varchar(6) default NULL,
   td_class1 varchar(25) default NULL,
   td_class2 varchar(25) default NULL,
   td_class3 varchar(25) default NULL,
   fontface1 varchar(50) default NULL,
   fontface2 varchar(50) default NULL,
   fontface3 varchar(50) default NULL,
   fontsize1 tinyint(4) default NULL,
   fontsize2 tinyint(4) default NULL,
   fontsize3 tinyint(4) default NULL,
   fontcolor1 varchar(6) default NULL,
   fontcolor2 varchar(6) default NULL,
   fontcolor3 varchar(6) default NULL,
   span_class1 varchar(25) default NULL,
   span_class2 varchar(25) default NULL,
   span_class3 varchar(25) default NULL,
   img_size_poll smallint(5) UNSIGNED,
   img_size_privmsg smallint(5) UNSIGNED,
   PRIMARY KEY  (themes_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_themes_name'
#
CREATE TABLE phpbb_themes_name (
   themes_id smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   tr_color1_name char(50),
   tr_color2_name char(50),
   tr_color3_name char(50),
   tr_class1_name char(50),
   tr_class2_name char(50),
   tr_class3_name char(50),
   th_color1_name char(50),
   th_color2_name char(50),
   th_color3_name char(50),
   th_class1_name char(50),
   th_class2_name char(50),
   th_class3_name char(50),
   td_color1_name char(50),
   td_color2_name char(50),
   td_color3_name char(50),
   td_class1_name char(50),
   td_class2_name char(50),
   td_class3_name char(50),
   fontface1_name char(50),
   fontface2_name char(50),
   fontface3_name char(50),
   fontsize1_name char(50),
   fontsize2_name char(50),
   fontsize3_name char(50),
   fontcolor1_name char(50),
   fontcolor2_name char(50),
   fontcolor3_name char(50),
   span_class1_name char(50),
   span_class2_name char(50),
   span_class3_name char(50),
   PRIMARY KEY (themes_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_topics'
#
CREATE TABLE phpbb_topics (
   topic_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   forum_id smallint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_title CHAR(120) NOT NULL,
   topic_desc varchar(255) DEFAULT '',
   topic_poster mediumint(8) DEFAULT '0' NOT NULL,
   topic_time int(11) DEFAULT '0' NOT NULL,
   topic_views mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_replies mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_status tinyint(3) DEFAULT '0' NOT NULL,
   topic_vote tinyint(1) DEFAULT '0' NOT NULL,
   topic_type tinyint(3) DEFAULT '0' NOT NULL,
   topic_first_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_last_post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   topic_moved_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   rating_rank_id smallint unsigned NOT NULL,
   news_id INT UNSIGNED DEFAULT '0' NOT NULL,
   topic_icon TINYINT (2) UNSIGNED DEFAULT '0' NOT NULL,
   title_compl_infos VARCHAR (255),
   PRIMARY KEY (topic_id),
   KEY forum_id (forum_id),
   KEY topic_moved_id (topic_moved_id),
   KEY topic_status (topic_status),
   KEY topic_type (topic_type),
   KEY topics_ratingrankid(rating_rank_id)
);

ALTER TABLE phpbb_topics ADD INDEX ( news_id );

CREATE TABLE phpbb_title_infos (
    id INT NOT NULL AUTO_INCREMENT,
    title_info VARCHAR( 255 ) NOT NULL,
    date_format VARCHAR( 25 ),
    admin_auth TINYINT( 1 ) DEFAULT '0',
    mod_auth TINYINT( 1 ) DEFAULT '0',
    poster_auth TINYINT( 1 ) DEFAULT '0',
    UNIQUE (id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_topics_watch'
#
CREATE TABLE phpbb_topics_watch (
  topic_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  user_id mediumint(8) NOT NULL DEFAULT '0',
  notify_status tinyint(1) NOT NULL default '0',
  KEY topic_id (topic_id),
  KEY user_id (user_id),
  KEY notify_status (notify_status)
);

CREATE TABLE phpbb_forums_watch (
   forum_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   notify_status tinyint(1) NOT NULL default '0',
   KEY forum_id (forum_id),
   KEY user_id (user_id),
   KEY notify_status (notify_status)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_users'
#
CREATE TABLE phpbb_users (
   user_id mediumint(8) NOT NULL,
   user_active tinyint(1) DEFAULT '1',
   username varchar(25) NOT NULL,
   user_password varchar(32) NOT NULL,
   user_session_time int(11) DEFAULT '0' NOT NULL,
   user_session_page smallint(5) DEFAULT '0' NOT NULL,
   user_lastvisit int(11) DEFAULT '0' NOT NULL,
   user_regdate int(11) DEFAULT '0' NOT NULL,
   user_level tinyint(4) DEFAULT '0',
   user_posts mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
   user_articles mediumint(8) unsigned NOT NULL DEFAULT '0',
   user_comments mediumint(8) unsigned NOT NULL DEFAULT '0',
   user_timezone decimal(5,2) DEFAULT '0' NOT NULL,
   user_style tinyint(4),
   user_lang varchar(255),
   user_dateformat varchar(14) DEFAULT 'd M Y H:i' NOT NULL,
   user_new_privmsg smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   user_unread_privmsg smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   user_last_privmsg int(11) DEFAULT '0' NOT NULL,
   user_login_tries smallint(5) UNSIGNED DEFAULT '0' NOT NULL,
   user_last_login_try int(11) DEFAULT '0' NOT NULL,
   user_emailtime int(11),
   user_viewemail tinyint(1),
   user_attachsig tinyint(1),
   user_allowhtml tinyint(1) DEFAULT '1',
   user_allowbbcode tinyint(1) DEFAULT '1',
   user_allowsmile tinyint(1) DEFAULT '1',
   user_allowavatar tinyint(1) DEFAULT '1' NOT NULL,
   user_allow_pm tinyint(1) DEFAULT '1' NOT NULL,
   user_allow_viewonline tinyint(1) DEFAULT '1' NOT NULL,
   user_notify tinyint(1) DEFAULT '1' NOT NULL,
   user_notify_pm tinyint(1) DEFAULT '0' NOT NULL,
   user_popup_pm tinyint(1) DEFAULT '0' NOT NULL,
   user_rank int(11) DEFAULT '0',
   user_avatar varchar(100),
   user_avatar_type tinyint(4) DEFAULT '0' NOT NULL,
   user_email varchar(255),
   user_icq varchar(15),
   user_website varchar(100),
   user_from varchar(100),
   user_from_flag varchar(25) NULL,
   user_sig text,
   user_sig_bbcode_uid char(10),
   user_aim varchar(255),
   user_yim varchar(255),
   user_msnm varchar(255),
   user_occ varchar(100),
   user_interests varchar(255),
   user_response TEXT,
   user_response_bbcode_uid VARCHAR(10),
   user_response_on TINYINT(1) NOT NULL default '0',
   user_allow_response TINYINT(1) NOT NULL default '1',
   user_actkey varchar(32),
   user_newpasswd varchar(32),
   user_allowswearywords tinyint(1) NOT NULL,
   user_notify_mod tinyint(1) NOT NULL,
   no_report_popup TINYINT(1) DEFAULT '0' NOT NULL,
   refresh_report_popup TINYINT(1) DEFAULT '0' NOT NULL,
   no_report_mail TINYINT(1) DEFAULT '0' NOT NULL,
   user_gender TINYINT DEFAULT '0' NOT NULL,
   avatar_sticky TINYINT NOT NULL,
   user_birthday INT DEFAULT '999999' NOT NULL,
   user_next_birthday_greeting INT DEFAULT '0' NOT NULL,
   user_badlogin SMALLINT(5) NOT NULL,
   user_blocktime INT(11) NOT NULL,
   user_block_by VARCHAR (8),
   user_points INT NOT NULL,
   rating_status tinyint unsigned NOT NULL,
   user_photo VARCHAR(100),
   user_photo_type TINYINT(4) DEFAULT '0' NOT NULL,
   user_lastlogon INT (11) DEFAULT '0',
   user_totaltime INT (11) DEFAULT '0',
   user_totallogon SMALLINT (5) DEFAULT '0',
   user_totalpages INT (11) not null,
   user_infotext text,
   user_computer_name VARCHAR(50),
   user_system_enclosure VARCHAR(100),
   user_system_motherboard VARCHAR(100),
   user_processor_brand VARCHAR(10),
   user_processor_desc VARCHAR(100),
   user_memory_amt SMALLINT(5),
   user_memory_details VARCHAR(100),
   user_vid_brand VARCHAR(10),
   user_vid_desc VARCHAR(100),
   user_storage_details VARCHAR(100),
   user_audio_details VARCHAR(100),
   user_system_cooling VARCHAR(100),
   user_system_monitor VARCHAR(50),
   user_system_os VARCHAR(50),
   user_favorite_game VARCHAR(100),
   user_threedmark MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_futuremark MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_cpu_dhry MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_cpu_whet MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_cpu_integer MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_cpu_floating MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_ram_integer MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_ram_floating MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_drive_idx MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT '0',
   user_total_idx BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
   user_show_specs TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
   user_custom_title varchar(255) NULL,
   user_custom_title_status tinyint(1) default '0' not null,
   user_allowdirectory tinyint(1) DEFAULT '1' NOT NULL,
   user_blockpm TINYINT(1) DEFAULT '0' NOT NULL,
   user_vacances TINYINT(1) DEFAULT '0' NOT NULL,
   user_rules INT( 11 ) NOT NULL,
   PRIMARY KEY (user_id),
   KEY user_session_time (user_session_time)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_desc'
#
CREATE TABLE phpbb_vote_desc (
  vote_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  topic_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_text text NOT NULL,
  vote_start int(11) NOT NULL DEFAULT '0',
  vote_length int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY  (vote_id),
  KEY topic_id (topic_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_results'
#
CREATE TABLE phpbb_vote_results (
  vote_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_option_id tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  vote_option_text varchar(255) NOT NULL,
  vote_result int(11) NOT NULL DEFAULT '0',
  KEY vote_option_id (vote_option_id),
  KEY vote_id (vote_id)
);


# --------------------------------------------------------
#
# Table structure for table 'phpbb_vote_voters'
#
CREATE TABLE phpbb_vote_voters (
  vote_id mediumint(8) UNSIGNED NOT NULL DEFAULT '0',
  vote_user_id mediumint(8) NOT NULL DEFAULT '0',
  vote_user_ip char(8) NOT NULL,
  vote_cast tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  KEY vote_id (vote_id),
  KEY vote_user_id (vote_user_id),
  KEY vote_user_ip (vote_user_ip)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_words'
#
CREATE TABLE phpbb_words (
   word_id mediumint(8) UNSIGNED NOT NULL auto_increment,
   word char(100) NOT NULL,
   replacement char(100) NOT NULL,
   PRIMARY KEY (word_id)
);


#
# phpBB2 - attach_mod schema
#
# $Id: mysql_schema.sql 441 2006-04-13 10:28:29Z arthurschreiber $
#

#
# Table structure for table 'phpbb_attachments_config'
#
CREATE TABLE phpbb_attachments_config (
  config_name varchar(255) NOT NULL,
  config_value varchar(255) NOT NULL,
  PRIMARY KEY (config_name)
);

#
# Table structure for table 'phpbb_forbidden_extensions'
#
CREATE TABLE phpbb_forbidden_extensions (
  ext_id mediumint(8) UNSIGNED NOT NULL auto_increment, 
  extension varchar(100) NOT NULL, 
  PRIMARY KEY (ext_id)
);

#
# Table structure for table 'phpbb_extension_groups'
#
CREATE TABLE phpbb_extension_groups (
  group_id mediumint(8) NOT NULL auto_increment,
  group_name char(20) NOT NULL,
  cat_id tinyint(2) DEFAULT '0' NOT NULL, 
  allow_group tinyint(1) DEFAULT '0' NOT NULL,
  download_mode tinyint(1) UNSIGNED DEFAULT '1' NOT NULL,
  upload_icon varchar(100) DEFAULT '',
  max_filesize int(20) DEFAULT '0' NOT NULL,
  forum_permissions varchar(255) default '' NOT NULL,
  PRIMARY KEY group_id (group_id)
);

#
# Table structure for table 'phpbb_extensions'
#
CREATE TABLE phpbb_extensions (
  ext_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  group_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  extension varchar(100) NOT NULL,
  comment varchar(100),
  PRIMARY KEY ext_id (ext_id)
);

#
# Table structure for table 'phpbb_attachments_desc'
#
CREATE TABLE phpbb_attachments_desc (
  attach_id mediumint(8) UNSIGNED NOT NULL auto_increment,
  physical_filename varchar(255) NOT NULL,
  real_filename varchar(255) NOT NULL,
  download_count mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  comment varchar(255),
  extension varchar(100),
  mimetype varchar(100),
  filesize int(20) NOT NULL,
  filetime int(11) DEFAULT '0' NOT NULL,
  thumbnail tinyint(1) DEFAULT '0' NOT NULL,
  PRIMARY KEY (attach_id),
  KEY filetime (filetime),
  KEY physical_filename (physical_filename(10)),
  KEY filesize (filesize)
);

#
# Table structure for table 'phpbb_attachments'
#
CREATE TABLE phpbb_attachments (
  attach_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL, 
  post_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL, 
  privmsgs_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
  user_id_1 mediumint(8) NOT NULL,
  user_id_2 mediumint(8) NOT NULL,
  KEY attach_id_post_id (attach_id, post_id),
  KEY attach_id_privmsgs_id (attach_id, privmsgs_id),
  KEY post_id (post_id),
  KEY privmsgs_id (privmsgs_id)
); 

#
# Table structure for table 'phpbb_quota_limits'
#
CREATE TABLE phpbb_quota_limits (
  quota_limit_id mediumint(8) unsigned NOT NULL auto_increment,
  quota_desc varchar(20) NOT NULL default '',
  quota_limit bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (quota_limit_id)
);

#
# Table structure for table 'phpbb_attach_quota'
#
CREATE TABLE phpbb_attach_quota (
  user_id mediumint(8) unsigned NOT NULL default '0',
  group_id mediumint(8) unsigned NOT NULL default '0',
  quota_type smallint(2) NOT NULL default '0',
  quota_limit_id mediumint(8) unsigned NOT NULL default '0',
  KEY quota_type (quota_type)
);

ALTER TABLE phpbb_forums ADD auth_download TINYINT(2) DEFAULT '0' NOT NULL;  
ALTER TABLE phpbb_auth_access ADD auth_download TINYINT(1) DEFAULT '0' NOT NULL;  
ALTER TABLE phpbb_posts ADD post_attachment TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_topics ADD topic_attachment TINYINT(1) DEFAULT '0' NOT NULL;
ALTER TABLE phpbb_privmsgs ADD privmsgs_attachment TINYINT(1) DEFAULT '0' NOT NULL;

#
# Who Viewed Modification
#

CREATE TABLE phpbb_topic_view (
    topic_id mediumint(8) NOT NULL,
    user_id mediumint(8) NOT NULL,
    view_time int(11) NOT NULL,
    view_count int(11) NOT NULL
);

#
# Favourites Mod
#

CREATE TABLE phpbb_favorites (
    fav_id int(11) NOT NULL auto_increment,
    user_id int(11) NOT NULL default '0',
    topic_id int(11) NOT NULL default '0',
PRIMARY KEY (fav_id)
);

#
# Anti Robotic Flood
#

CREATE TABLE phpbb_anti_robotic_reg (
    session_id char(32) DEFAULT '' NOT NULL,
    reg_key char(5) NOT NULL,
    timestamp int(11) unsigned NOT NULL,
PRIMARY KEY (session_id)
);

#
# ezPortal Admin
#

CREATE TABLE phpbb_portal (
  portal_name varchar(255) NOT NULL,
  portal_value TEXT NOT NULL,
PRIMARY KEY (portal_name)
);

#
# Flags
#

CREATE TABLE phpbb_flags (
   flag_id int(10) NOT NULL auto_increment,
   flag_name varchar(25),
   flag_image varchar(25),
   PRIMARY KEY (flag_id)
);

#
# Board Message XL
#

CREATE TABLE phpbb_board_message (
  msg_id mediumint(8) NOT NULL auto_increment,
  title varchar(25) NOT NULL default '(empty)',
  message text NOT NULL,
  showpage smallint(5) NOT NULL default '0',
  auth tinyint(2) NOT NULL default '5',
  width smallint(3) NOT NULL default '75',
  starttime int(11) NOT NULL default '0',
  endtime int(11) NOT NULL default '0',
  startdate int(11) NOT NULL default '0',
  enddate int(11) NOT NULL default '0',
  users_timezone tinyint(1) NOT NULL default '0',
  bbcode_uid varchar(10) NOT NULL default '',
  days varchar(7) NOT NULL default '0000000',
  images varchar(100) default NULL,
  ordr smallint(3) NOT NULL default '0',
  PRIMARY KEY  (msg_id)
);

#
# Statistics Mod
#

CREATE TABLE phpbb_stats_config (
  config_name varchar(50) NOT NULL default '',
  config_value varchar(255) NOT NULL default '',
  PRIMARY KEY (config_name)
);

CREATE TABLE phpbb_stats_modules (
  module_id tinyint(8) NOT NULL default '0',
  name varchar(150) NOT NULL default '',
  active tinyint(1) NOT NULL default '0',
  installed tinyint(1) NOT NULL default '0',
  display_order mediumint(8) unsigned NOT NULL default '0',
  update_time mediumint(8) unsigned NOT NULL default '0',
  auth_value tinyint(2) NOT NULL default '0',
  module_info_cache blob,
  module_db_cache blob,
  module_result_cache blob,
  module_info_time int(10) unsigned NOT NULL default '0',
  module_cache_time int(10) unsigned NOT NULL default '0',
  PRIMARY KEY (module_id)
);

#
# Slash Mod
#
CREATE TABLE phpbb_news (
  news_id MEDIUMINT UNSIGNED NOT NULL AUTO_INCREMENT,
  news_category VARCHAR( 70 ) NOT NULL ,
  news_image VARCHAR( 70 ) NOT NULL ,
  PRIMARY KEY ( news_id )
);

#
# Downloads
#
CREATE TABLE phpbb_pa_cat (
  cat_id int(10) NOT NULL auto_increment,
  cat_name text,
  cat_desc text,
  cat_files int(10) default NULL,
  cat_1xid int(10) default NULL,
  cat_parent int(50) default NULL,
  cat_order int(50) default NULL,
  PRIMARY KEY  (cat_id)
);

CREATE TABLE phpbb_pa_comments (
  comments_id int(10) NOT NULL auto_increment,
  file_id int(10) NOT NULL default '0',
  comments_text text NOT NULL,
  comments_title text NOT NULL,
  comments_time int(50) NOT NULL default '0',
  comment_bbcode_uid varchar(10) default NULL,
  poster_id mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (comments_id),
  KEY comments_id (comments_id),
  FULLTEXT KEY comment_bbcode_uid (comment_bbcode_uid)
);

CREATE TABLE phpbb_pa_custom (
  custom_id int(50) NOT NULL auto_increment,
  custom_name text NOT NULL,
  custom_description text NOT NULL,
  PRIMARY KEY  (custom_id)
);

CREATE TABLE phpbb_pa_customdata (
  customdata_file int(50) NOT NULL default '0',
  customdata_custom int(50) NOT NULL default '0',
  data text NOT NULL
);

CREATE TABLE phpbb_pa_files (
  file_id int(10) NOT NULL auto_increment,
  file_name text,
  file_desc text,
  file_creator text,
  file_version text,
  file_longdesc text,
  file_ssurl text,
  file_dlurl text,
  file_time int(50) default NULL,
  file_catid int(10) default NULL,
  file_posticon text,
  file_license int(10) default NULL,
  file_dls int(10) default NULL,
  file_last int(50) default NULL,
  file_pin int(2) default NULL,
  file_docsurl text,
  file_rating double(6,4) NOT NULL default '0.0000',
  file_totalvotes int(255) NOT NULL default '0',
  PRIMARY KEY  (file_id)
);

CREATE TABLE phpbb_pa_license (
  license_id int(10) NOT NULL auto_increment,
  license_name text,
  license_text text,
  PRIMARY KEY  (license_id)
);

CREATE TABLE phpbb_pa_settings (
  settings_id int(1) NOT NULL default '1',
  settings_dbname text NOT NULL,
  settings_sitename text NOT NULL,
  settings_dbdescription text NOT NULL,
  settings_dburl text NOT NULL,
  settings_topnumber int(5) NOT NULL default '0',
  settings_homeurl text NOT NULL,
  settings_newdays int(5) NOT NULL default '0',
  settings_stats int(5) NOT NULL default '0',
  settings_viewall int(5) NOT NULL default '0',
  settings_showss int(5) NOT NULL default '0',
  settings_disable int(5) NOT NULL default '0',
  allow_html int(5) NOT NULL default '0',
  allow_bbcode int(5) NOT NULL default '0',
  allow_smilies int(5) NOT NULL default '0',
  allow_comment_links int(5) NOT NULL default '0',
  no_comment_link_message varchar(255) NOT NULL default '',
  allow_comment_images int(5) NOT NULL default '0',
  no_comment_image_message varchar(255) NOT NULL default '',
  max_comment_chars int(255) NOT NULL default '0'
);

CREATE TABLE phpbb_pa_votes (
  votes_ip varchar(50) NOT NULL default '0',
  votes_file int(50) NOT NULL default '0'
);

#
# Banners
#
CREATE TABLE phpbb_banner (
    banner_id MEDIUMINT(8) UNSIGNED NOT NULL,
    banner_name VARCHAR(90) NOT NULL,
    banner_spot SMALLINT(1) UNSIGNED NOT NULL,
    banner_forum MEDIUMINT(8) UNSIGNED NOT NULL,
    banner_description VARCHAR(30) NOT NULL,
    banner_url VARCHAR(192) NOT NULL,
    banner_owner MEDIUMINT(8) NOT NULL,
    banner_click MEDIUMINT(8) UNSIGNED NOT NULL,
    banner_view MEDIUMINT(8) UNSIGNED NOT NULL,
    banner_weigth TINYINT(1) UNSIGNED DEFAULT '50' NOT NULL,
    banner_active TINYINT(1) NOT NULL,
    banner_timetype TINYINT(1) NOT NULL,
    time_begin INT(11) NOT NULL,
    time_end INT(11) NOT NULL,
    date_begin INT(11) NOT NULL,
    date_end INT(11) NOT NULL,
    banner_level TINYINT(1) NOT NULL,
    banner_level_type TINYINT(1) NOT NULL,
    banner_comment VARCHAR(50) NOT NULL,
    INDEX (banner_id)
);

CREATE TABLE phpbb_banner_stats (
    banner_id MEDIUMINT(8) UNSIGNED NOT NULL,
    click_date int (11) NOT NULL,
    click_ip char(8) NOT NULL,
    click_user MEDIUMINT(8) NOT NULL,
    user_duration int (11) NOT NULL
);

#
# Server Load
#
CREATE TABLE phpbb_serverload (
   time int(14) DEFAULT '0' NOT NULL
);

#
# Unique Hits
#
CREATE TABLE phpbb_unique_hits (
   user_ip char(8) DEFAULT '0' not null,
   time int(11) DEFAULT '0' not null,
   INDEX (user_ip)
);

CREATE TABLE phpbb_referers (
    referer_id mediumint( 8 ) UNSIGNED NOT NULL auto_increment,
    referer_host varchar( 255 ) NOT NULL default '',
    referer_url varchar( 255 ) NOT NULL default '',
    referer_ip varchar( 8 ) NOT NULL default '',
    referer_hits int( 10 ) NOT NULL default '1',
    referer_firstvisit int( 11 ) DEFAULT '0' NOT NULL,
    referer_lastvisit int( 11 ) DEFAULT '0' NOT NULL,
    PRIMARY KEY (referer_id)
);

#
# Photo Album Addon v2.x.x for phpBB 2.0.4 - MySQL schema & basic (by Smartor)
#

CREATE TABLE phpbb_album (
    pic_id int(11) UNSIGNED NOT NULL auto_increment,
    pic_filename varchar(255) NOT NULL,
    pic_thumbnail varchar(255),
    pic_title varchar(255) NOT NULL,
    pic_desc text,
    pic_user_id mediumint(8) NOT NULL,
    pic_username varchar(32),
    pic_user_ip char(8) NOT NULL DEFAULT '0',
    pic_time int(11) UNSIGNED NOT NULL,
    pic_cat_id mediumint(8) UNSIGNED NOT NULL DEFAULT '1',
    pic_view_count int(11) UNSIGNED NOT NULL DEFAULT '0',
    pic_lock tinyint(3) NOT NULL DEFAULT '0',
    pic_approval tinyint(3) NOT NULL DEFAULT '1',
    PRIMARY KEY (pic_id),
    KEY pic_cat_id (pic_cat_id),
    KEY pic_user_id (pic_user_id),
    KEY pic_time (pic_time));

CREATE TABLE phpbb_album_rate (
    rate_pic_id int(11) UNSIGNED NOT NULL,
    rate_user_id mediumint(8) NOT NULL,
    rate_user_ip char(8) NOT NULL,
    rate_point tinyint(3) UNSIGNED NOT NULL,
    rate_hon_point TINYINT(3) DEFAULT '0' NOT NULL,
    KEY rate_pic_id (rate_pic_id),
    KEY rate_user_id (rate_user_id),
    KEY rate_user_ip (rate_user_ip),
    KEY rate_point (rate_point));

CREATE TABLE phpbb_album_comment (
    comment_id int(11) UNSIGNED NOT NULL auto_increment,
    comment_pic_id int(11) UNSIGNED NOT NULL,
    comment_user_id mediumint(8) NOT NULL,
    comment_username varchar(32),
    comment_user_ip char(8) NOT NULL,
    comment_time int(11) UNSIGNED NOT NULL,
    comment_text TEXT,
    comment_edit_time int(11) UNSIGNED,
    comment_edit_count smallint(5) UNSIGNED NOT NULL DEFAULT '0',
    comment_edit_user_id mediumint(8),
    PRIMARY KEY(comment_id),
    KEY comment_pic_id (comment_pic_id),
    KEY comment_user_id (comment_user_id),
    KEY comment_user_ip (comment_user_ip),
    KEY comment_time (comment_time));

CREATE TABLE phpbb_album_cat (
    cat_id mediumint(8) UNSIGNED NOT NULL auto_increment,
    cat_title varchar(255) NOT NULL,
    cat_desc text,
    cat_order mediumint(8) NOT NULL,
    cat_view_level tinyint(3) NOT NULL DEFAULT '-1',
    cat_upload_level tinyint(3) NOT NULL DEFAULT '0',
    cat_rate_level tinyint(3) NOT NULL DEFAULT '0',
    cat_comment_level tinyint(3) NOT NULL DEFAULT '0',
    cat_edit_level tinyint(3) NOT NULL DEFAULT '0',
    cat_delete_level tinyint(3) NOT NULL DEFAULT '2',
    cat_view_groups varchar(255),
    cat_upload_groups varchar(255),
    cat_rate_groups varchar(255),
    cat_comment_groups varchar(255),
    cat_edit_groups varchar(255),
    cat_delete_groups varchar(255),
    cat_moderator_groups varchar(255),
    cat_approval tinyint(3) NOT NULL DEFAULT '0',
    PRIMARY KEY (cat_id),
    KEY cat_order (cat_order));

CREATE TABLE phpbb_album_config (
    config_name varchar(255) NOT NULL,
    config_value varchar(255) NOT NULL,
    PRIMARY KEY (config_name));

CREATE TABLE phpbb_album_sp_config (
    config_name varchar(255) NOT NULL default '',
    config_value varchar(255) NOT NULL default '',
    PRIMARY KEY  (config_name));

#
# Calendar
#

CREATE TABLE phpbb_mycalendar (
  cal_id mediumint(8) unsigned NOT NULL auto_increment,
  topic_id mediumint(8) unsigned NOT NULL default '0',
  forum_id smallint(5) unsigned NOT NULL default '0',
  cal_date timestamp(14) NOT NULL,
  cal_time_end time NOT NULL default '00:00:00',
  cal_interval tinyint(3) NOT NULL default '1',
  cal_interval_units enum('DAY','WEEK','MONTH','YEAR') NOT NULL default 'DAY',
  cal_repeat mediumint(3) NOT NULL default '1',
  PRIMARY KEY  (cal_id),
  UNIQUE KEY topic_id (topic_id),
  KEY forum_id (forum_id)
);

CREATE TABLE phpbb_mycal_date (
  day tinyint(3) NOT NULL default '0',
  fday char(2) NOT NULL default '00',
  UNIQUE KEY day (day)
);

#
# Referrals
#

CREATE TABLE phpbb_referral (
  referral_id mediumint(8) unsigned NOT NULL auto_increment,
  ruid varchar(7) NOT NULL default '0',
  nuid varchar(7) NOT NULL default '0',
  referral_time varchar(10) NOT NULL default '',
  KEY referraler_id(referral_id)
);

#
# Knowledge Base
#

CREATE TABLE phpbb_kb_articles (
    article_id mediumint(8) unsigned NOT NULL auto_increment,
    article_category_id mediumint(8) unsigned NOT NULL default '0',
    article_title varchar(255) binary NOT NULL default '',
    article_description varchar(255) binary NOT NULL default '',
    article_date varchar(255) binary NOT NULL default '',
    article_author_id mediumint(8) unsigned NOT NULL default '0',
    username VARCHAR(255),
    bbcode_uid varchar(10) binary NOT NULL default '',
    article_body text NOT NULL,
    article_type mediumint(8) unsigned NOT NULL default '0',
    approved tinyint(1) unsigned NOT NULL default '0',
    topic_id mediumint(8) unsigned NOT NULL default '0',
    views BIGINT(8) NOT NULL DEFAULT '0',
    KEY article_id (article_id)
);

CREATE TABLE phpbb_kb_categories (
    category_id mediumint(8) unsigned NOT NULL auto_increment,
    category_name VARCHAR(255) binary NOT NULL,
    category_details VARCHAR(255) binary NOT NULL,
    number_articles mediumint(8) unsigned NOT NULL,
    parent mediumint(8) unsigned,
    cat_order mediumint(8) unsigned NOT NULL,
    KEY category_id (category_id)
);

CREATE TABLE `phpbb_kb_config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`config_name`)
);

CREATE TABLE phpbb_kb_types (
    id mediumint(8) unsigned NOT NULL auto_increment,
    type varchar(255) binary DEFAULT '' NOT NULL,
    KEY id (id)
);

CREATE TABLE phpbb_kb_results (
  search_id int(11) unsigned NOT NULL default '0',
  session_id varchar(32) NOT NULL default '',
  search_array text NOT NULL,
  PRIMARY KEY  (search_id),
  KEY session_id (session_id)
);

CREATE TABLE phpbb_kb_wordlist (
  word_text varchar(50) binary NOT NULL default '',
  word_id mediumint(8) unsigned NOT NULL auto_increment,
  word_common tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (word_text),
  KEY word_id (word_id)
);

CREATE TABLE phpbb_kb_wordmatch (
  article_id mediumint(8) unsigned NOT NULL default '0',
  word_id mediumint(8) unsigned NOT NULL default '0',
  title_match tinyint(1) NOT NULL default '0',
  KEY post_id (article_id),
  KEY word_id (word_id)
);

CREATE TABLE phpbb_kb_votes (
  votes_ip varchar(50) NOT NULL default "0",
  votes_file int(50) NOT NULL default "0"
) TYPE=MyISAM;

#
# Activity
#
CREATE TABLE phpbb_ina_data (
  version varchar(255) default NULL
);

CREATE TABLE phpbb_ina_games (
  game_id smallint(5) NOT NULL auto_increment,
  game_name varchar(25) default NULL,
  game_path varchar(255) default NULL,
  game_desc varchar(255) default NULL,
  game_charge int(11) unsigned default '0',
  game_reward int(11) unsigned NOT NULL default '0',
  game_bonus smallint(5) unsigned default '0',
  game_use_gl tinyint(3) unsigned default '0',
  game_flash tinyint(1) unsigned NOT NULL default '0',
  win_width smallint(6) NOT NULL default '0',
  win_height smallint(6) NOT NULL default '0',
  KEY game_id (game_id)
);

CREATE TABLE phpbb_ina_scores (
  game_name varchar(255) default NULL,
  player varchar(40) default NULL,
  score int(10) unsigned NOT NULL default '0',
  date int(11) default NULL
);

#
# Chatbox
#

CREATE TABLE phpbb_chatbox(
    id int( 11 ) NOT NULL auto_increment,
    name varchar( 99 ) NOT NULL,
    msg varchar( 255 ) NOT NULL,
    timestamp int( 10 ) unsigned NOT NULL,
    PRIMARY KEY ( id )
);

CREATE TABLE phpbb_chatbox_session(
    username varchar( 99 ) NOT NULL,
    lastactive int( 10 ) DEFAULT '0' NOT NULL,
    laststatus varchar( 8 ) NOT NULL,
    UNIQUE username( username )
);

#
# Advanced HTML
#
CREATE TABLE phpbb_advance_html (
    config_name VARCHAR( 255 ) NOT NULL,
    config_value LONGTEXT NOT NULL
);

#
# Admin Private Message Manager
#
CREATE TABLE phpbb_privmsgs_archive (
    privmsgs_id mediumint( 8 ) unsigned NOT NULL AUTO_INCREMENT ,
    privmsgs_type tinyint( 4 ) NOT NULL default '0',
    privmsgs_subject varchar( 255 ) NOT NULL default '0',
    privmsgs_from_userid mediumint( 8 ) NOT NULL default '0',
    privmsgs_to_userid mediumint( 8 ) NOT NULL default '0',
    privmsgs_date int( 11 ) NOT NULL default '0',
    privmsgs_ip varchar( 8 ) NOT NULL default '',
    privmsgs_enable_bbcode tinyint( 1 ) NOT NULL default '1',
    privmsgs_enable_html tinyint( 1 ) NOT NULL default '0',
    privmsgs_enable_smilies tinyint( 1 ) NOT NULL default '1',
    privmsgs_attach_sig tinyint( 1 ) NOT NULL default '1',
    PRIMARY KEY ( privmsgs_id ) ,
    KEY privmsgs_from_userid ( privmsgs_from_userid ) ,
    KEY privmsgs_to_userid ( privmsgs_to_userid )
) AUTO_INCREMENT = 1;

#
# Admin Hacks List
#
CREATE TABLE phpbb_hacks_list (
  hack_id mediumint(8) unsigned NOT NULL auto_increment,
  hack_add_date int(10) unsigned NOT NULL default '0',
  hack_name varchar(255) NOT NULL default '',
  hack_desc varchar(255) NOT NULL default '',
  hack_author varchar(255) NOT NULL default '',
  hack_author_email varchar(255) NOT NULL default '',
  hack_author_website tinytext NOT NULL,
  hack_version varchar(32) NOT NULL default '',
  hack_hide enum('Yes','No') NOT NULL default 'No',
  PRIMARY KEY  (hack_id),
  UNIQUE KEY hack_name (hack_name),
  KEY hack_add_date (hack_add_date),
  KEY hack_hide (hack_hide)
) TYPE=MyISAM ;

#
# Prillian
#

CREATE TABLE phpbb_im_prefs (
  user_id mediumint(8) NOT NULL default '0',
  user_allow_ims tinyint(1) NOT NULL default '1',
  user_allow_shout tinyint(1) NOT NULL default '1',
  user_allow_chat tinyint(1) NOT NULL default '1',
  attach_sig tinyint(1) NOT NULL default '0',
  admin_allow_ims tinyint(1) NOT NULL default '1',
  admin_allow_shout tinyint(1) NOT NULL default '1',
  admin_allow_chat tinyint(1) NOT NULL default '1',
  new_ims smallint(5) unsigned NOT NULL default '0',
  unread_ims smallint(5) unsigned NOT NULL default '0',
  read_ims smallint(5) unsigned NOT NULL default '0',
  total_sent mediumint(8) unsigned NOT NULL default '0',
  refresh_rate smallint(5) unsigned NOT NULL default '60',
  success_close tinyint(1) NOT NULL default '1',
  refresh_method tinyint(1) NOT NULL default '2',
  auto_launch tinyint(1) NOT NULL default '1',
  popup_ims tinyint(1) NOT NULL default '1',
  list_ims tinyint(1) NOT NULL default '0',
  show_controls tinyint(1) NOT NULL default '1',
  list_all_online tinyint(1) NOT NULL default '1',
  win_main_height varchar(4) NOT NULL default '400',
  win_main_width varchar(4) NOT NULL default '225',
  win_online_height varchar(4) NOT NULL default '225',
  win_online_width varchar(4) NOT NULL default '400',
  win_read_height varchar(4) NOT NULL default '225',
  win_read_width varchar(4) NOT NULL default '400',
  win_send_height varchar(4) NOT NULL default '365',
  win_send_width varchar(4) NOT NULL default '460',
  play_sound tinyint(1) NOT NULL default '1',
  default_sound tinyint(1) NOT NULL default '1',
  sound_name varchar(255) default NULL,
  themes_id mediumint(8) UNSIGNED DEFAULT '1' NOT NULL,
  user_allow_s2s tinyint(1) NOT NULL default '1',
  admin_allow_s2s tinyint(1) NOT NULL default '1',
  s2s_user_list tinyint(1) NOT NULL default '1',
  open_pms tinyint(1) NOT NULL default '0',
  auto_delete tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (user_id)
);

# --------------------------------------------------------
#
# Table structure for table phpbb_buddy_list
#

CREATE TABLE phpbb_buddy_list (
  user_id mediumint(8) NOT NULL default '0',
  buddy_id mediumint(8) NOT NULL default '0',
  user_ignore tinyint(1) NOT NULL default '0',
  alert tinyint(1) NOT NULL default '0',
  alert_status tinyint(1) NOT NULL default '0',
  disallow tinyint(1) NOT NULL default '0',
  KEY buddy_id (buddy_id),
  KEY user_id (user_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_im_sitetosite'
#
CREATE TABLE phpbb_im_sitetosite (
   site_id mediumint(8) NOT NULL auto_increment,
   site_name varchar(50) NOT NULL,
   site_url varchar(100) NOT NULL,
   site_phpex varchar(4) DEFAULT 'php' NOT NULL,
   site_ppu varchar(15) DEFAULT 'p' NOT NULL,
   site_puu varchar(15) DEFAULT 'u' NOT NULL,
   site_profile varchar(50) DEFAULT 'profile' NOT NULL,
   PRIMARY KEY (site_id)
);

# --------------------------------------------------------
#
# Table structure for table 'phpbb_im_sessions'
#
CREATE TABLE phpbb_im_sessions (
   session_user_id mediumint(8) DEFAULT '0' NOT NULL,
   session_id char(32) DEFAULT '' NOT NULL,
   session_time int(11) DEFAULT '0' NOT NULL,
   session_popup tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (session_id),
   KEY session_user_id (session_user_id)
);

#
# Acronym
#
CREATE TABLE phpbb_acronyms (
    acronym_id MEDIUMINT NOT NULL AUTO_INCREMENT,
    acronym VARCHAR( 80 ) NOT NULL,
    description VARCHAR( 255 ) NOT NULL,
    PRIMARY KEY ( acronym_id )
);

#
# Smart Tags
#
CREATE TABLE phpbb_smart (
    smart_id MEDIUMINT NOT NULL AUTO_INCREMENT,
    smart VARCHAR( 80 ) NOT NULL,
    url VARCHAR( 255 ) NOT NULL,
    PRIMARY KEY ( smart_id )
);

#
# Custom bbCode
#
CREATE TABLE phpbb_bbcodes (
    bbcode_id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    bbcode_params VARCHAR(255) NOT NULL DEFAULT '',
    bbcode_code VARCHAR(255) NOT NULL DEFAULT '',
    bbcode_replace VARCHAR(255) NOT NULL DEFAULT '',
    bbcode_example VARCHAR(255) NOT NULL DEFAULT '',
    PRIMARY KEY(bbcode_id)
);

# New in Build 231

# Upgrade to Hacks/Mods List 1.20
ALTER TABLE phpbb_hacks_list ADD hack_download_url TINYTEXT NOT NULL;
ALTER TABLE phpbb_hacks_list DROP hack_add_date;
ALTER TABLE phpbb_hacks_list ADD hack_file VARCHAR( 255 ) NOT NULL;
ALTER TABLE phpbb_hacks_list ADD hack_file_mtime INT UNSIGNED NOT NULL;
ALTER TABLE phpbb_hacks_list ADD INDEX hack_file_list ( hack_file );

# Color Groups 1.1.0
CREATE TABLE phpbb_color_groups (
  group_id mediumint(8) unsigned NOT NULL auto_increment,
  group_name varchar(255) NOT NULL default '',
  group_color varchar(50) NOT NULL default '',
  hidden TINYINT( 1 ) DEFAULT '0' NOT NULL,
  order_num MEDIUMINT NOT NULL,
  PRIMARY KEY  (group_id),
  UNIQUE KEY group_name (group_name)
);
ALTER TABLE phpbb_users ADD user_color_group MEDIUMINT UNSIGNED NOT NULL;

#Admin Topic Action Logging 0.95
CREATE TABLE phpbb_topics_action_log (
  log_id mediumint(8) unsigned NOT NULL auto_increment,
  user_id mediumint(9) NOT NULL default '0',
  topic_id mediumint(8) unsigned NOT NULL default '0',
  topic_title varchar(255) NOT NULL default '',
  topic_text varchar(255) NOT NULL default '',
  log_time int(10) unsigned NOT NULL default '0',
  log_action tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (log_id),
  KEY user_id (user_id),
  KEY log_time (log_time),
  KEY log_action (log_action)
);

# New in Build 232

# Jnr. Admin 2.0.4
CREATE TABLE phpbb_jr_admin_users (
  user_id mediumint(9) NOT NULL default '0',
  user_jr_admin longtext NOT NULL,
  start_date int(10) unsigned NOT NULL default '0',
  update_date int(10) unsigned NOT NULL default '0',
  admin_notes text NOT NULL,
  notes_view tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (user_id)
);

CREATE TABLE phpbb_faq (
  lang_id varchar(50) NOT NULL default 'english',
  faq_id tinyint(11) NOT NULL default '0',
  faq_title varchar(255) NOT NULL default '',
  PRIMARY KEY (faq_id,lang_id)
);

CREATE TABLE phpbb_faq_text (
  lang_id varchar(50) NOT NULL default 'english',
  q_id tinyint(11) NOT NULL default '0',
  faq_id tinyint(11) NOT NULL default '1',
  q text NOT NULL,
  a text NOT NULL,
  PRIMARY KEY  (q_id,lang_id)
);

CREATE TABLE phpbb_dir_category (
   category_id mediumint(8) NOT NULL auto_increment,
   category_name varchar(35) NOT NULL,
   category_description text,
   PRIMARY KEY (category_id)
);
CREATE TABLE phpbb_dir_site (
   site_id mediumint(8) DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   site_url varchar(50) NOT NULL,
   site_title varchar(50),
   site_description varchar(200),
   site_keywords text,
   site_date int(11) DEFAULT '0' NOT NULL,
   site_rank tinyint(8) DEFAULT '0' NOT NULL,
   visible tinyint(1) DEFAULT '0' NOT NULL,
   site_status tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (site_id)
);
CREATE TABLE phpbb_dir_sitecat (
   site_id mediumint(8) DEFAULT '0' NOT NULL,
   category_id mediumint(8) DEFAULT '0' NOT NULL
);
CREATE TABLE phpbb_dir_votes (
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   user_vote mediumint(8) DEFAULT '0' NOT NULL
);

CREATE TABLE phpbb_cash (
  cash_id smallint(6) NOT NULL auto_increment,
  cash_order smallint(6) NOT NULL default '0',
  cash_settings smallint(4) NOT NULL default '3313',
  cash_dbfield varchar(64) NOT NULL default '',
  cash_name varchar(64) NOT NULL default 'GP',
  cash_default int(11) NOT NULL default '0',
  cash_decimals tinyint(2) NOT NULL default '0',
  cash_imageurl varchar(255) NOT NULL default '',
  cash_exchange int(11) NOT NULL default '1',
  cash_perpost int(11) NOT NULL default '25',
  cash_postbonus int(11) NOT NULL default '2',
  cash_perreply int(11) NOT NULL default '25',
  cash_maxearn int(11) NOT NULL default '75',
  cash_perpm int(11) NOT NULL default '0',
  cash_perchar int(11) NOT NULL default '20',
  cash_allowance tinyint(1) NOT NULL default '0',
  cash_allowanceamount int(11) NOT NULL default '0',
  cash_allowancetime tinyint(2) NOT NULL default '2',
  cash_allowancenext int(11) NOT NULL default '0',
  cash_forumlist varchar(255) NOT NULL default '',
  PRIMARY KEY  (cash_id)
);

CREATE TABLE phpbb_cash_events (
  event_name varchar(32) NOT NULL default '',
  event_data varchar(255) NOT NULL default '',
  PRIMARY KEY  (event_name)
);

CREATE TABLE phpbb_cash_exchange (
  ex_cash_id1 int(11) NOT NULL default '0',
  ex_cash_id2 int(11) NOT NULL default '0',
  ex_cash_enabled int(1) NOT NULL default '0',
  PRIMARY KEY  (ex_cash_id1,ex_cash_id2)
);

CREATE TABLE phpbb_cash_groups (
  group_id mediumint(6) NOT NULL default '0',
  group_type tinyint(2) NOT NULL default '0',
  cash_id smallint(6) NOT NULL default '0',
  cash_perpost int(11) NOT NULL default '0',
  cash_postbonus int(11) NOT NULL default '0',
  cash_perreply int(11) NOT NULL default '0',
  cash_perchar int(11) NOT NULL default '0',
  cash_maxearn int(11) NOT NULL default '0',
  cash_perpm int(11) NOT NULL default '0',
  cash_allowance tinyint(1) NOT NULL default '0',
  cash_allowanceamount int(11) NOT NULL default '0',
  cash_allowancetime tinyint(2) NOT NULL default '2',
  cash_allowancenext int(11) NOT NULL default '0',
  PRIMARY KEY  (group_id,group_type,cash_id)
);

CREATE TABLE phpbb_cash_log (
  log_id int(11) NOT NULL auto_increment,
  log_time int(11) NOT NULL default '0',
  log_type smallint(6) NOT NULL default '0',
  log_action varchar(255) NOT NULL default '',
  log_text varchar(255) NOT NULL default '',
  PRIMARY KEY  (log_id)
);

CREATE TABLE phpbb_read_history
(
    user_id mediumint(8) NOT NULL default '0',
    forum_id smallint(5) unsigned NOT NULL default '0',
    topic_id mediumint(8) unsigned NOT NULL default '0',
    post_id mediumint(8) unsigned NOT NULL default '0',
    post_time int(11) NOT NULL default '0',
    PRIMARY KEY (user_id, forum_id, topic_id, post_id, post_time),
    KEY user_id (user_id),
    KEY forum_id (forum_id),
    KEY topic_id (topic_id)
);

CREATE TABLE phpbb_optimize_db (
  cron_enable enum('0','1') NOT NULL default '0',
  cron_every int(7) NOT NULL default '86400',
  cron_next int(11) NOT NULL default '0',
  cron_count int(5) NOT NULL default '0',
  cron_lock enum('0','1') NOT NULL default '0',
  show_begin_for varchar(150) NOT NULL default '',
  show_not_optimized enum('0','1') NOT NULL default '0'
);

CREATE TABLE phpbb_rules (
  date int(11) NOT NULL default '0',
  rules text NOT NULL,
  pm_subject varchar(255) NOT NULL default '',
  pm_message text
);

# phpbb 2.0.18 - 2.0.19
CREATE TABLE phpbb_sessions_keys (
	key_id varchar(32) DEFAULT '0' NOT NULL,
	user_id mediumint(8) DEFAULT '0' NOT NULL,
	last_ip varchar(8) DEFAULT '0' NOT NULL,
	last_login int(11) DEFAULT '0' NOT NULL,
	PRIMARY KEY (key_id, user_id),
	KEY last_login (last_login)
);


