
<?php 
/*************************************************************************** 
 *                          lang_rss_faq.php [english] 
 *                            ------------------- 
 * 
 *   copyright            : (C) 2003 Minerva Project - Philippt 
 * 
 * 
 * 
 ***************************************************************************/ 

/*************************************************************************** 
 * 
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of the GNU General Public License as published by 
 *   the Free Software Foundation; either version 2 of the License, or 
 *   (at your option) any later version. 
 * 
 ***************************************************************************/ 
  
// 
// To add an entry to your Rules simply add a line to this file in this format: 
// $faq[] = array("question", "answer"); 
// If you want to separate a section enter $faq[] = array("--","Block heading goes here if wanted"); 
// Links will be created automatically 
// 
// DO NOT forget the ; at the end of the line. 
// Do NOT put double quotes (") in your FAQ entries, if you absolutely must then escape them ie. \"something\" 
// 
// The FAQ items will appear on the FAQ page in the same order they are listed in this file 
// 

$faq[] = array("--","Introducing RSS"); 
$faq[] = array("Introducing", "Think about all of the information that you access on the Web on a day-to-day basis; news headlines, search results, \"What's New\", job vacancies, and so forth. A large amount of this content can be thought of as a list; although it probably isn't in HTML < li > elements, the information is list-oriented. 
Most people need to track a number of these lists, but it becomes difficult once there are more than a handful of sources. This is because they have to go to each page, load it, remember how it's formatted, and find where they last left off in the list. 
RSS is an XML-based format that allows the syndication of lists of hyperlinks, along with other information, or metadata, that helps viewers decide whether they want to follow the link. 
RSS allows peoples' computers to fetch and understand the information, so that all of the lists they're interested in can be tracked and personalized for them. It is a format that's intended for use by computers on behalf of people, rather than being directly presented to them (like HTML). 
To enable this, a Web site will make an RSS feed, or channel, available, just like any other file or resource on the server. Once a feed is available, computers can regularly fetch the file to get the most recent items on the list. Most often, people will do this with an aggregator, a program that manages a number of lists and presents them in a single interface. 
RSS can also be used for other kinds of list-oriented information, such as syndicating the content itself (often weblogs) along with the links. However, this tutorial focuses on the use of RSS for syndication of links."); 

$faq[] = array("What's in a RSS feed?","A feed contains a list of items, each of which is identified by a link. Each item can have any amount of metadata associated with it. 
The most basic metadata supported by RSS includes a title for the link and a description of it; when syndicating news headlines, these fields might be used for the story title and the first paragraph or a summary, for example. For example, an simple item might look like; 
<br /></span><table width=\"90%\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" align=\"center\"> 
<tr><td><span class=\"genmed\"><b>Code:</b></span></td>   </tr> 
<tr><td class=\"code\"> 
< item > 
<br />< title >Earth Invaded</ title > 
<br />< link >http://news.example.com/2004/12/17/invasion< /link > 
<br />< description >The earth was attacked by an invasion fleet 
<br />from halfway across the galaxy; luckily, a fatal 
<br />miscalculation of scale resulted in the entire armada 
<br />being eaten by a small dog.< /description > 
<br />< /item > 
</td></tr></table><span class=\"postbody\"> 
Additionally, the feed itself can have metadata associated with it, so that it can be given a title (e.g., \"Bob's news headlines\"), description, and other fields like publisher and copyright terms. 
For an idea of what full feeds look like, see '<a href=\"help.php?mode=rss#5\">RSS Versions and Modules</a>'."); 

$faq[] = array("How do people use feeds?","Aggregators are the most common use of RSS feeds, and there are several types. Web aggregators (sometimes called portals) make this view available in a Web page; <a href=\"http://my.yahoo.com\">my Yahoo<a> is a well-known example of this. Aggregators have also been integrated into e-mail clients, users' desktops, or standalone, dedicated software. See '<a href=\"help.php?mode=rss#9\">Aggregators and other RSS Clients</a>' for more information. 
Aggregators can offer a variety of special features, including combining several related feeds into a single view, hiding items that the viewer has already seen, and categorizing feeds and items. 
Other uses of RSS feeds include site tracking by search engines and other software; because the feed is machine-readable, the search software doesn't have to figure out which parts of the site are important and which parts are just the navigation and presentation. You may also choose to allow people to republish your feeds on their Web sites, giving them the ability to represent your content as they require."); 

$faq[] = array("Why should I make an RSS feed available?","our viewers will thank you, and there will be more of them, because RSS allows them to see your site without going out of their way to visit it. 

While this seems bad at first glance, it actually improves your site's visibility; by making it easier for your users to keep up with your site - allowing them to see it the way they want to - it's more likely that they'll know when something that interests them is available on your site. 
For example, imagine that your company announces a new product or feature every month or two. Without a feed, your viewers have to remember to come to your site and see if they find anything new - if they have time. If you provide a feed for them, they can point their aggregator or other software at it, and it will give them a link and a description of developments at your site almost as soon as they happen. 
News is similar; because there are so many sources of news on the Internet, most of your viewers won't come to your site every day. By providing an RSS feed, you are in front of them constantly, improving the chances that they'll click through to an article that catches their eye."); 

$faq[] = array("But isn't that giving away my content?","No! You still retain copyright on your content if you wish to. 
By supplying an RSS feed, you can control what information is syndicated in the feed, whether it's a full article or just a teaser. Your content can still be protected by your current access control mechanisms; only the links and metadata are distributed. You can also protect the RSS feed itself with SSL encryption and HTTP username/password authentication too, if you'd like. 
In many ways, RSS is similar to the subscription newsletters that many sites offer to keep viewers up-to-date. The big difference is that they don't have to supply an e-mail address, lowering the barrier of privacy concerns, while still giving you a direct channel to your viewers. Also, they get to see the content in the manner that's most convenient to them, which means that you get more eyes looking at your content."); 


$faq[] = array("--","RSS Versions and Modules"); 

$faq[] = array("Overview","There are two main versions of the RSS format in use today; RSS 0.9x and RSS 1.0. Although the numbers might lead you to believe that 1.0 replaces 0.9x, both are being actively used and developed. Each version has its benefits and drawbacks; RSS 0.9x is known for its simplicity, while RSS 1.0 is more extensible and fully specified. Both formats are XML-based and have the same basic structure. 
People tend to get into heated discussions about the better format. Ultimately, it's a choice you shouldn't worry too much over; good RSS tools and aggregators will understand both formats. This section presents a quick overview of each; for more information, see their specifications and supporting materials."); 

$faq[] = array("RSS 0.9x","RSS 0.9x (the 'x' is for the last digit; as of writing, RSS 0.94 is in development) was designed by Netscape Communications and <a href=\"http://www.userland.com\">UserLand software</a>, and is championed by <a href=\"http://www.userland.com\">UserLand's</a> Dave Winer. In this version, RSS stands for 'Really Simple Syndication,' and simplicity is its focus. 
This branch of RSS is based on RSS 0.91, which was first <a href=\"http://my.netscape.com/publish/formats/rss-spec-0.91.html\">documented at Netscape</a> and later refined by <a href=\"http://www.userland.com\">Userland</a>. 
Included in <a href=\"http://backend.userland.com/rss092\">0.92</a> - the latest stable version - are channel metadata like link, title, description; image, which allows you to specify a thumbnail image to display with the feed); webMaster and managingEditor, to identify who's responsible for the feed, and lastBuildDate, which shows when the feed was last updated. Items have the standard link, title and description metadata, as well as other, more experimental facilities like enclosure, which allows attachments to be automatically downloaded (don't expect these features to be supported by all aggregators, however). 
RSS 0.9x takes a versioned approach to extensibility; new features are added by declaring a new version of RSS in the 0.9 series. Winer controls the release of new versions, so if you have suggestions about the future of RSS 0.9x, it's best to talk to him. 
Here's an example of a minimal RSS 0.9x feed: 
<br /></span><table width=\"90%\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" align=\"center\"> 
<tr><td><span class=\"genmed\"><b>Code:</b></span></td>   </tr> 
<tr><td class=\"code\"> 
< ?xml version=\"1.0\"? > 
<br />< rss version=\"0.91\" > 
<br />  < channel > 
<br />    < title >Example Channel< /title > 
<br />    < link >http://example.com/< /link > 
<br />    < description >My example channel< /description > 
<br />    < item > 
<br />       < title >News for September the Second< /title > 
<br />       < link >http://example.com/2002/09/01< /link > 
<br />       < description >other things happened today< /description > 
<br />    </ item > 
<br />    < item > 
<br />       < title >News for September the First< /title > 
<br />       < link >http://example.com/2002/09/02< /link > 
<br />    < /item > 
<br />  < /channel > 
<br /></ rss > 
</td></tr></table><span class=\"postbody\"> 
"); 

$faq[] = array("RSS 1.0","SS 1.0 stands for \"RDF Site Summary.\" This flavor of RSS incorporates RDF, a Web standard for metadata. Because RSS 1.0 uses RDF, any RDF processor can understand RSS without knowing anything about it in particular. 
RSS 1.0 also uses XML Namespaces to allow extensions - called RSS Modules - to be added without worrying about conflicts. This is because RSS 1.0 doesn't use a central person for extending the format; instead, namespaces are used to describe a space for your own extensions. For example, if you had an ISBN module to track books, it might look like this; 
<br /></span><table width=\"90%\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" align=\"center\"> 
<tr><td><span class=\"genmed\"><b>Code:</b></span></td>   </tr> 
<tr><td class=\"code\"> 
< item xmlns:book=\"http://namespace.example.com/book/1.0\" rdf:about=\"http://www.amazon.com/exec/obidos/tg/detail/-/0553575376\" > 
<br />  < title >Excession< /link > 
<br />  < link >http://www.amazon.com/exec/obidos/tg/detail/-/0553575376< /link > 
<br />  < book:isbn >0553575376< /book:isbn > 
<br />< /item> 
</td></tr></table><span class=\"postbody\"> 
Generally, though, you should look for available RSS Modules, rather than defining your own, unless you're sure that what you need doesn't exist. 
RSS 1.0 feeds look very similar to RSS 0.9x feeds, with a few key differences; 
<p>RSS 1.0 feeds look very similar to RSS 0.9x feeds, with a few key 
differences;</p> 
<ul> 
  <li>The entire feed is wrapped in <code>&lt;rdf:RDF&gt;</code> ... 
    <code>&lt;/rdf:RDF&gt;</code> elements (so that processors know that it's 
    RDF)</li> 
  <li>Each <code>&lt;item&gt;</code> has an <code>rdf:about</code> attribute 
    that usually, but not always, matches the <code>&lt;link&gt;</code>; this 
    assigns an identifier to each item</li> 
  <li>There's an <code>&lt;items&gt;</code> element in the channel metadata 
    that contains a list of items in the channel, so that RDF processors can 
    keep track of the relationship between the items</li> 
  <li>Some metadata uses the <code>rdf:resource</code> attribute to carry 
    links, instead of putting it inside the element.</li> 
</ul>"); 

$faq[] = array("Dublin Core Module","The most well-known example of an RSS Module is the Dublin Core Module. The Dublin Core is a set of metadata developed by librarians and information scientists that standardizes a set of common metadata that is useful for describing documents, among other things. The Dublin Core Module uses these metadata to attach information to both feeds (in the channel metadata) and to individual items. 
This module includes useful elements like dc:date, for associating dates with items, dc:subject, which can be useful for categorizing items or feeds, and dc:rights, for dictating the intellectual property rights associated with an item or a feed. 
Here's an example of a minimal RSS 1.0 feed that uses the Dublin Core Module: 
<br /></span><table width=\"90%\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" align=\"center\"> 
<tr><td><span class=\"genmed\"><b>Code:</b></span></td>   </tr> 
<tr><td class=\"code\"> 
< ?xml version=\"1.0\"? > 
<br />< rdf:RDF  xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns=\"http://purl.org/rss/1.0/\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\" > 
<br />  < channel rdf:about=\"http://example.com/news.rss\" > 
<br />    < title >Example Channel</ title > 
<br />    < link >http://example.com/< /link > 
<br />    < description >My example channel< /description > 
<br />    < items > 
<br />      < rdf:Seq > 
<br />        < rdf:li resource=\"http://example.com/2002/09/01/\"/ > 
<br />        < rdf:li resource=\"http://example.com/2002/09/02/\"/ > 
<br />      < /rdf:Seq > 
<br />    < /items > 
<br />  < /channel > 
<br />  < item rdf:about=\"http://example.com/2002/09/01\" > 
<br />     < title >News for September the Second< /title > 
<br />     < link >http://example.com/2002/09/01< /link > 
<br />     < description >other things happened today< /description > 
<br />     < dc:date >2002-09-01</ dc:date > 
<br />  < /item > 
<br />  < item rdf:about=\"http://example.com/2002/09/01\" > 
<br />     < title >News for September the First< /title > 
<br />     < link >http://example.com/2002/09/02< /link > 
<br />     < dc:date >2002-09-02< /dc:date > 
<br />  < /item > 
<br />< /rdf:RDF > 
</td></tr></table><span class=\"postbody\"> 
As you can see, RSS 1.0 is a bit more verbose than 0.9x, mostly because it needs to be compatible with other versions of RSS while containing the markup that RDF processors need. 
"); 


$faq[] = array("--","List and research"); 
$faq[] = array("Aggregators and Other RSS Clients","<p>This is an incomplete listing of aggregators and other consumers of RSS 
content. For more, see <a href=\"hep.php?mode=#\">More Information about 
RSS</a>.</p> 
<ul> 
  <li><strong><a href=\"http://www.headlineviewer.com\">Headline 
    Viewer</a></strong> - The original desktop aggregator. For most versions of Windows.</li> 
  <li><a href=\"http://www.sharpreader.net\"><strong>SharpReader</strong></a> - Windows-based desktop aggregator; many features.</li> 
  <li><strong><a href=\"http://ranchero.com/software/netnewswire/\">NetNewsWire</a></strong> - A newer, standalone desktop aggregator for MacOS X.</li> 
  <li><strong><a href=\"http://radio.userland.com/\">Radio UserLand</a></strong> - Hybrid desktop/Web aggregator and weblogging tool. Windows and Macintosh (7.5.5+ and OSX).</li> 
  <li><strong><a href=\"http://www.oreillynet.com/meerkat/\">Meerkat</a></strong> - A Web-based aggregator by O'Reilly.</li> 
  <li><strong><a href=\"http://newsisfree.com\">News is Free</a></strong> - Another Web-based aggregator which also does some third-party scraping.</li> 
  <li><strong><a href=\"http://www.daypop.com/\">Daypop</a></strong> - A search engine for RSS-based news.</li> 
</ul>"); 

$faq[] = array("More Information about RSS"," 
<ul> 
  <li><strong><a href=\"http://www.syndic8.com\">Syndic8</a></strong> - A community effort to gather, validate and search feeds with lots of other information.</li> 
  <li><strong><a href=\"http://gils.utah.gov/rss\">RSS Workshop</a></strong> - A well-regarded introduction to publishing RSS feeds, from the state of Utah Online Services division.</li> 
  <li><strong><a href=\"http://rss.benhammersley.com\">Content Syndication with XML and RSS</a></strong> - RSS information and a forthcoming book by Ben Hammersley.</li> 
  <li><strong><a href=\"http://blogspace.com/rss/\">RSSInfo</a></strong> - Lists aggregators, toolsets and RSS-related news.</li> 
  <li><strong><a href=\"http://www.oreillynet.com/rss/\">RSS Devcenter</a></strong> - O'reilly's Web portal for all things RSS.</li> 
</ul> 
"); 

$faq[] = array("About this Document","This document is Copyright ©2002 Mark Nottingham <mnot@pobox.com>. It may be freely distributed in any medium as long as the text (including this notice) is kept intact and the content is not modified, edited, added to or otherwise changed. Formatting and presentation may be modified. Small excerpts may be made as long as the full document is properly and conspicuously referenced. 
If you do mirror this document, please send e-mail to the address above, so that you can be informed of updates. 
All trademarks within are property of their respective holders. Although the author believes the contents to be accurate at the time of publication, no liability is assumed for them, their application or any consequences thereof. If any misrepresentations, errors or other need for clarification is found, please contact the author. 
The latest revision of this document can always be obtained from http://www.mnot.net/rss/tutorial/"); 
?> 
