<?php
#################################################################
## Mod Title: mycalendar+ Mod w/selected forum integration
##      (based on mycalendar Mod by marksten)
## Mod Version: 0.8
## Author: flashdagger
## Description: Enables users to add events to the calendar
##              through a chosen forum.
#################################################################


if (!defined('IN_PHPBB'))
{
    die('Hacking attempt');
}

include($phpbb_root_path . 'mods/calendar/mycalendar_functions.'.$phpEx);


function include_mycalendar_lang()
{
    global $phpbb_root_path, $phpEx, $lang, $board_config;

    //
    // Include Language
    //
    include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_main_mycalendar.' . $phpEx);
    if (defined('IN_ADMIN'))
    {
    	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin_mycalendar.' . $phpEx);
	}
}

//
// Setup Forum Authentication (admin_forumauth.php)
//
function mycal_setup_forum_auth(&$simple_auth_ary, &$forum_auth_fields, &$field_names)
{
    global $lang;

    //
    // Add Mycalendar Auth
    // Add Events
    $simple_auth_ary[0][] = AUTH_MOD;
    $simple_auth_ary[1][] = AUTH_MOD;
    $simple_auth_ary[2][] = AUTH_MOD;
    $simple_auth_ary[3][] = AUTH_MOD;
    $simple_auth_ary[4][] = AUTH_MOD;
    $simple_auth_ary[5][] = AUTH_MOD;
    $simple_auth_ary[6][] = AUTH_MOD;

    $forum_auth_fields[] = 'auth_calendar';
    $field_names['auth_calendar'] = $lang['Auth_calendar'];
}

//
// Setup Usergroup Authentication (admin_ug_auth.php)
//
function mycal_setup_usergroup_auth(&$forum_auth_fields, &$auth_field_match, &$field_names)
{
    global $lang;

    //
    // Post Attachments
    //
    $forum_auth_fields[] = 'auth_calendar';
    $auth_field_match['auth_calendar'] = AUTH_CALENDAR;
    $field_names['auth_calendar'] = $lang['Auth_calendar'];

}

function mycal_build_auth_levels($is_auth, &$s_auth_can)
{
    global $lang;
    $s_auth_can .= ( ( $is_auth['auth_calendar'] && $is_auth['auth_post'] ) ? $lang['Rules_calendar_can'] : $lang['Rules_calendar_cannot'] ) . '<br />';
}


function mycal_make_dropdown($min_value, $max_value, $selection = '', $step = 1 )
{
	$output = '';
    $selected = $selection == '' ? 'selected="selected"' : '';
    for ($i = $min_value; $i <= $max_value; $i += $step)
    {
        $selected = ($selection >= $i AND $selection < $i + $step) ? 'selected="selected"' : '';
        $output .= '<option value="' . $i . '" ' . $selected . '>' . str_pad($i, 2, "0", STR_PAD_LEFT) . '</option>';
    }
    return $output;
}

function mycal_month_dropdown($selection = '')
{
    global $lang;
    $output = '';
    for ($i = 1; $i <= 12; $i++)
    {
        $month = date('F', mktime (0,0,0,$i,1,00));
        $selected = ($selection == $i) ? 'selected="selected"' : '';
        $output .= '<option value="' . str_pad($i, 2, "0", STR_PAD_LEFT) . '"' . $selected . '>' . $lang['datetime'][$month] . '</option>';
    }
    return $output;
}

function mycal_forum_dropdown($mode, $in_forums, $selection = '', $use_style = true)
{
    global $lang, $db, $userdata;

    if (empty($in_forums)) return;
    $in_forums = $in_forums == '*' ? ' 1=1 ' : " f.forum_id IN ($in_forums) ";
    $forumstyle = $use_style ? mycal_get_forumstyle() : '';

    $selected = ($selection == '' ? 'selected="selected"' : '');

    switch ($mode) {
        CASE 'read':
            $join_sql = ", " . MYCALENDAR_TABLE . " as c WHERE f.forum_id = c.forum_id AND $in_forums ";
            $output = '<option value=""' . $selected . '>' . $lang['All_mycal_forums'] . '</option>';
            break;
        DEFAULT:
            $join_sql = " WHERE $in_forums ";
    }

        $sql = "SELECT DISTINCT f.forum_id, f.forum_name
            FROM " . FORUMS_TABLE . " as f $join_sql
        ORDER BY f.forum_name ASC";

        if (!$result = $db->sql_query($sql)) {
            message_die(GENERAL_ERROR, 'Failure when looking up date entry for topic.');
    }

    $empty_rows = TRUE;
        while ( $row = $db->sql_fetchrow($result) )
    {
        $empty_rows = FALSE;
        $style_forum_id = $row['forum_id'];
        $style = $forumstyle[$style_forum_id] ? 'style="' . $forumstyle[$style_forum_id] . ';"' : '';

        $selected = $selection == $row['forum_id'] ? "selected=\"selected\"" : "";
        $output .= '<option value="' . $row['forum_id'] . '"' . $selected .'' . $style . '>' . $row['forum_name'] . '</option>';
    }

    if ($empty_rows) return;
    return $output;
}

function mycal_alter_sql(&$query, $mode)
{
    switch ($mode) {
        CASE 'viewforum':
            $mycal_join = " LEFT JOIN " . MYCALENDAR_TABLE . " as c ON t.topic_id = c.topic_id WHERE";
            $cal_date = ", UNIX_TIMESTAMP(c.cal_date) as cal_date FROM";
            $query = str_replace("WHERE", $mycal_join, $query);
            $query = str_replace("FROM", $cal_date, $query);
            break;
        CASE 'viewtopic':
            $mycal_select = "t.topic_first_post_id, t.topic_last_post_id";
            $query = str_replace("t.topic_last_post_id", $mycal_select, $query);
            break;
        CASE 'viewtopic_order':
            $mycal_group = "f.auth_vote, f.auth_calendar";
            $query = str_replace("f.auth_vote", $mycal_group, $query);
            break;
    }
    return;
}

function mycal_suggestion_redirect()
{
	global $phpEx, $is_auth;
	if ((!$is_auth['auth_read'] || !$is_auth['auth_view']) && $is_auth['auth_post'] && $is_auth['auth_calendar'])
	{
		redirect(append_sid('mycalendar.'.$phpEx, true));
	}
}

function topic_sort()
{
	global $lang, $HTTP_POST_VARS, $HTTP_GET_VARS, $order_by, $select_sort_mode, $select_sort_order;

	if (isset($HTTP_POST_VARS['order']))
	{
		$sort_order = ($HTTP_POST_VARS['order'] == 'ASC') ? 'ASC' : 'DESC';
	}
	elseif (isset($HTTP_GET_VARS['order']))
	{
		$sort_order = ($HTTP_GET_VARS['order'] == 'ASC') ? 'ASC' : 'DESC';
	}
	else
	{
		$sort_order = 'DESC';
	}

	if (isset($HTTP_GET_VARS['mode']) || isset($HTTP_POST_VARS['mode']))
	{
		$mode = (isset($HTTP_POST_VARS['mode'])) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];

		switch ($mode)
		{
			case 'topics':
				$order_by = 't.topic_title ' . $sort_order;
				break;
			case 'replies':
				$order_by = 't.topic_replies ' . $sort_order;
				break;
			case 'author':
				$order_by = 'u.username $sort_order, p.post_username ' . $sort_order;
				break;
			case 'views':
				$order_by = 't.topic_views ' . $sort_order;
				break;
			case 'time':
				$order_by = 't.topic_id ' . $sort_order;
				break;
			case 'event':
				$order_by = 'c.cal_date ' . $sort_order;
				break;
			default:
				$order_by = 't.topic_last_post_id ' . $sort_order;
				break;
		}
	}
	else
	{
		$mode = '';
		$order_by = "t.topic_last_post_id DESC";
	}

	//
	// Topics sorting
	//
	$mode_types_text = array($lang['Post_Normal'],$lang['Topics'],$lang['Date'],$lang['Replies'],$lang['Author'],$lang['Views'],$lang['Event']);
	$mode_types = array('default', 'topics', 'time', 'replies', 'author', 'views', 'event');

	$select_sort_mode = '<select name="mode">';
	for ($i = 0; $i < count($mode_types_text); $i++)
	{
		$selected = ($mode == $mode_types[$i]) ? ' selected="selected"' : '';
		$select_sort_mode .= '<option value="' . $mode_types[$i] . '"' . $selected . '>' . $mode_types_text[$i] . '</option>';
	}
	$select_sort_mode .= '</select>';

	$select_sort_order = '<select name="order">';
	if ($sort_order == 'ASC')
	{
		$select_sort_order .= '<option value="ASC" selected="selected">' . $lang['Sort_Ascending'] . '</option><option value="DESC">' . $lang['Sort_Descending'] . '</option>';
	}
	else
	{
		$select_sort_order .= '<option value="ASC">' . $lang['Sort_Ascending'] . '</option><option value="DESC" selected="selected">' . $lang['Sort_Descending'] . '</option>';
	}
	$select_sort_order .= '</select>';
}

function topic_sort_alter_sql(&$sql)
{
    global $order_by;
    $sql = str_replace('t.topic_last_post_id DESC', $order_by . ', t.topic_last_post_id DESC', $sql);
}


?>
