<?php
/***************************************************************************
 *                               referral_view.php
 *                            -------------------
 *   begin              : Friday, June 20, 2002
 *   copyright          : (C) 2001 The phpBB Group
 *   email              : support@phpbb.com
 *   created by         : John B. Abela <abela@phpbb.com>
 *   edited by          : Verfaillie Steven <rancisis@pandora.be>
 *
 *   $Id: referral_view.php 206 2004-06-20 13:06:10Z dmaj007 $
****************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

/**************************************************************************
*	This file will be used for displaying the referrals log publicaly, within a users profile.
*	File initially created by John B. Abela, edited by Verfaillie Steven to create new feature,
*  re-edited by John B. Abela to streamline code and setup for distribution with main package.
**************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

if ( !empty($board_config['default_lang']) )
{
    include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_referral.'.$phpEx);
}
else
{
    include($phpbb_root_path . 'language/lang_english/lang_referral.'.$phpEx);
}

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

$template->set_filenames(array(
	'body' => 'referral_view_body.tpl')
);

if ( !empty($HTTP_GET_VARS['ruid']) )
{
    $ruid = $HTTP_GET_VARS['ruid'];
}
elseif ( !empty($HTTP_GET_VARS['ruid']) )
{
    $ruid = $HTTP_GET_VARS['ruid'];
}
else
{
    $ruid = $board_config['referral_id'];
}
//
// Generate SQL
//
$sql = "SELECT * 
	FROM " . REFERRAL_TABLE . " 
	WHERE ruid = '" . $ruid . "'";
if( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, "Could not query referral table", $lang['Error'], __LINE__, __FILE__, $sql);
}

$referral_rows = $db->sql_fetchrowset($result);
$referral_count = count($referral_rows);

$template->assign_vars(array(
	"L_REFERRAL_N_NAME" => $lang['Referral_Admin_New_Name'],
	"L_REFERRAL_DATETIME" => $lang['Referral_Admin_DateTime']
    )
);

for($i = 0; $i < $referral_count; $i++)
{
    //
    // GET NEW USER DATA
    $nuid = $referral_rows[$i]['nuid'];
    settype($nuid, "integer");
    //
    $new_userdata = get_userdata($nuid);
	if( !$new_userdata )
    {
		$new_username = $lang['Referral_Admin_User_Delete'];
	}
	else
	{
		$temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=".$new_userdata['user_id']."");
		$new_username = '<a href="' . $temp_url . '">' . $new_userdata['username'] . '</a>';
	}

	$referral_date = create_date($board_config['default_dateformat'], $referral_rows[$i]['referral_time'], $board_config['board_timezone']);

	$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
	$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

	$template->assign_block_vars("referrers", array(
		"ROW_COLOR" => "#" . $row_color,
		"ROW_CLASS" => $row_class,
        "NEW_USER" => $new_username,
		"REPLACEMENT" => $referral_date
        )
	);
}

$gen_simple_header = TRUE;

include($phpbb_root_path . 'includes/page_header.' . $phpEx);
$template->pparse('body');
include($phpbb_root_path . 'includes/page_tail.' . $phpEx);

?>