<?php
/***************************************************************************
 *                              staff.php
 *                            -------------------
 *   begin                : Friday, May 11, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: staff.php 423 2005-09-25 02:11:47Z mikethecoder $
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include_once($phpbb_root_path.'includes/functions_color_groups.'.$phpEx);

$userdata = session_pagestart($user_ip, PAGE_STAFF);
init_userprefs($userdata);

$page_title = $lang['Staff'];
include('includes/page_header.'.$phpEx);


$template->set_filenames(array(
        'body' => 'staff_body.tpl')
);
           
$is_auth_ary = array();

function get_auth_ary($udata){

	global $forum_data, $db;	
	
	$is_auth_ary = auth(AUTH_VIEW, AUTH_LIST_ALL, $udata, $forum_data);
	$sql = "SELECT ug.user_id, f.forum_id, f.forum_name
           FROM ".AUTH_ACCESS_TABLE." aa, ".USER_GROUP_TABLE." ug, ".FORUMS_TABLE." f
           WHERE aa.auth_mod = " . TRUE . "
                      AND ug.group_id = aa.group_id
                      AND f.forum_id = aa.forum_id";
                      
	if ( !$result = $db->sql_query($sql) )
	{
			message_die(GENERAL_ERROR, 'Could not query forums.', '', __LINE__, __FILE__, $sql);
	}
	while( $row = $db->sql_fetchrow($result) )
	{
		$display_forums = ( $is_auth_ary[$row['forum_id']]['auth_view'] ) ? true : false;
		if( $display_forums )
		{
			$forum_id = $row['forum_id'];
			$staff2[$row['user_id']][$row['forum_id']] = '<strong>&raquo;</strong>&nbsp;<a href='.append_sid("viewforum.$phpEx?f=$forum_id").' class=genmed>'.$row['forum_name'].'</a><br />';
		}
	}
}

//main


get_auth_ary($userdata);

$sql = "SELECT * FROM ".USERS_TABLE."
           WHERE user_level >= 1
           ORDER BY user_level = 2, user_level = 3";
if ( !($results = $db->sql_query($sql)) )
{
        message_die(GENERAL_ERROR, 'Could not obtain user information.', '', __LINE__, __FILE__, $sql);
}

while($staff = $db->sql_fetchrow($results))
{
        if ( $staff['user_avatar'] )
        {
                switch( $staff['user_avatar_type'] )
                {
                        case USER_AVATAR_UPLOAD:
                            $avatar = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $staff['user_avatar'] . '" border="0" />' : '';
                            break;

                        case USER_AVATAR_REMOTE:
                            $avatar = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $staff['user_avatar'] . '" width="60" height="40" alt="" border="0" />' : '';
                            break;

                        case USER_AVATAR_GALLERY:
                            $avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $staff['user_avatar'] . '" alt="" border="0" />' : '';
                            break;
                }
        }
        else
        {
                $avatar = '';
        }

        $forums = '';
        if ( !empty($staff2[$staff['user_id']]) )
        {
                asort($staff2[$staff['user_id']]);
                $forums = implode(' ',$staff2[$staff['user_id']]);
        }

        $memberdays = max(1, round( ( time() - $staff['user_regdate'] ) / 86400 ));
        $posts_per_day = $staff['user_posts'] / $memberdays;
        if ( $staff['user_posts'] != 0 )
        {
                $total_posts = get_db_stat('postcount');
                $percentage = ( $total_posts ) ? min(100, ($staff['user_posts'] / $total_posts) * 100) : 0;
        }
        else
        {
                $percentage = 0;
        }
        $user_id = $staff['user_id'];
        $sql = "SELECT post_time, post_id FROM ".POSTS_TABLE." WHERE poster_id = " . $user_id . " ORDER BY post_time DESC LIMIT 1";
        if ( !($result = $db->sql_query($sql)) )
        {
                message_die(GENERAL_ERROR, 'Error getting user last post time', '', __LINE__, __FILE__, $post_time_sql);
        }
        $row = $db->sql_fetchrow($result);
        $last_post = ( isset($row['post_time']) ) ? '<a href="'.append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=$row[post_id]#$row[post_id]").'" class="gensmall">'.create_date($board_config['default_dateformat'], $row['post_time'], $board_config['board_timezone']).'</a>' : $lang['None'];

        $mailto = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $staff['user_id']) : 'mailto:' . $staff['user_email'];
        $mail = ( $staff['user_email'] ) ? '<a href="' . $mailto . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>' : '';

        $pmto = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=$staff[user_id]");
        $pm = '<a href="' . $pmto . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';

        $msn = ( $staff['user_msnm'] ) ? '<a href="http://members.msn.com?mem=' . $staff['user_msnm'] . '" target="_blank"><img src="' . $images['icon_msnm'] . '" alt="' . $lang['MSNM'] . '" title="' . $lang['MSNM'] . '" border="0" /></a>' : '';
        $yim = ( $staff['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $staff['user_yim'] . '&amp;.src=pg" target="_blank"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
        $aim = ( $staff['user_aim'] ) ? '<a href="aim:goim?screenname=' . $staff['user_aim'] . '&amp;message=Hello+Are+you+there?" target="_blank"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '';
        $icq = ( $staff['user_icq'] ) ? '<a href="http://wwp.icq.com/scripts/contact.dll?msgto=' . $staff['user_icq'] . '" target="_blank"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>' : '';

        $www = ( $staff['user_website'] ) ? '<a href="' . $staff['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '';

        $sql = "SELECT * FROM " . RANKS_TABLE . " ORDER BY rank_special, rank_min";
        if ( !($result = $db->sql_query($sql)) )
        {
            message_die(GENERAL_ERROR, "Could not obtain ranks information.", '', __LINE__, __FILE__, $sql);
        }
        $ranksrow = array();
        while ( $row = $db->sql_fetchrow($result) )
        {
                $ranksrow[] = $row;
        }
        $db->sql_freeresult($result);


        $user_group_rank ='';
        $sql = "SELECT g.rank_id, g.group_id FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug
            WHERE ug.user_id = '" . $staff['user_id'] . "'
            AND g.group_id = ug.group_id
            AND g.group_single_user <> " . TRUE . "
            AND ug.user_pending <> ".TRUE . "
            AND g.rank_id > 0
            ORDER BY g.group_priority, g.group_id";
        if(!$user_group_rank = $db->sql_query($sql))
            message_die(GENERAL_ERROR, "Error getting group information", "", __LINE__, __FILE__, $sql);

        $groups_rank = array();
        while ( $row = $db->sql_fetchrow($user_group_rank) )
        {
            $groups_rank[] = $row;
        }

        $rank = '';
        $rank_image = '';
        $custom_title = '';
        if ( $staff['user_rank'] )
        {
                for($j = 0; $j < count($ranksrow); $j++)
                {
                        if ( $staff['user_rank'] == $ranksrow[$j]['rank_id'] && $ranksrow[$j]['rank_special'] )
                        {
                                $rank = $ranksrow[$j]['rank_title'];
                                $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$j]['rank_image'] . '" alt="' . $rank . '" title="' . $rank . '" border="0" /><br />' : '';
                        }
                }
        }
        else
        {
                /* Original Code
                for($j = 0; $j < count($ranksrow); $j++)
                {
                        if ( $staff['user_posts'] >= $ranksrow[$j]['rank_min'] && !$ranksrow[$j]['rank_special'] )
                        {
                                $rank = $ranksrow[$j]['rank_title'];
                                $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$j]['rank_image'] . '" alt="' . $rank . '" title="' . $rank . '" border="0" /><br />' : '';
                        }
                }
                */


                //Ranks for Groups code
                if ( $groups_rank[0]['rank_id'] == 0 )
                {
                    for($j = 0; $j < count($ranksrow); $j++)
                    {
                        if ( $staff['user_posts'] >= $ranksrow[$j]['rank_min'] && !$ranksrow[$j]['rank_special'] && ($ranksrow[$j]['rank_group'] == 0))
                        {
                            $rank = $ranksrow[$j]['rank_title'];
                            $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                        }
                    }
                }
                else
                {
                    for($l = 0; $l < count($ranksrow); $l++)
                    {
                        if ( $groups_rank[0]['rank_id'] == $ranksrow[$l]['rank_id'] && $ranksrow[$l]['rank_special'])
                        {
                            $rank = $ranksrow[$l]['rank_title'];
                            $rank_image = ( $ranksrow[$l]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$l]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                        }
                    }
                }

        }

        if ( !empty($staff['user_custom_title']) )
        {
            switch( $board_config['custom_title_mode'] )
            {
                case CUSTOM_TITLE_MODE_INDEPENDENT:
                    $custom_title = '<br />' . $staff['user_custom_title'];
                    break;
                case CUSTOM_TITLE_MODE_REPLACE_RANK:
                    $poster_rank = $staff['user_custom_title'];
                    break;
                case CUSTOM_TITLE_MODE_REPLACE_BOTH:
                    $poster_rank = $staff['user_custom_title'];
                    $rank_image = '';
                    break;
                default:
                break;
            }
        }

        $template->assign_block_vars('staff', array(
                'AVATAR' => $avatar,
                'RANK' => $rank,
                'RANK_IMAGE' => $rank_image,
                'CUSTOM_TITLE' => $custom_title,
                'U_NAME' => append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$staff[user_id]"),
                //'NAME' => $staff[username],
                'NAME' => color_group_colorize_name($staff['user_id'],true),
                //'LEVEL' => $level,
                'FORUMS' => $forums,
                'JOINED' => create_date($board_config['default_dateformat'], $staff['user_regdate'], $board_config['board_timezone']),
                'PERIOD' => sprintf($lang['Period'], $memberdays),
                'POSTS' => $staff['user_posts'],
                'POST_DAY' => sprintf($lang['User_post_day_stats'], $posts_per_day),
                'POST_PERCENT' => sprintf($lang['User_post_pct_stats'], $percentage),
                'LAST_POST' => $last_post,
                'MAIL' => $mail,
                'PM' => $pm,
                'MSN' => $msn,
                'YIM' => $yim,
                'AIM' => $aim,
                'ICQ' => $icq,
                'WWW' => $www)
        );
}
        $template->assign_vars(array(
                'L_AVATAR' => $lang['Avatar'],
                'L_USERNAME' => $lang['Username'],
                'L_FORUMS' => $lang['Forums'],
                'L_POSTS' => $lang['Posts'],
                'L_JOINED' => $lang['Joined'],
                'L_CONTACT' => $lang['Contact'],
                'L_MESSENGER' => $lang['Messenger'])
        );

        $template->pparse('body');

include('includes/page_tail.'.$phpEx);
?>