<?php
/***************************************************************************
 *                              viewactive.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: viewactive.php 199 2004-06-20 04:02:57Z dmaj007 $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

// ---- MAGIC VALUES FOR TIME ---- //
define('TIME_ALL_TOPICS', 0);
define('TIME_LAST_VISIT', 1);
define('TIME_1_HOURS', 3600);
define('TIME_3_HOURS', 10800);
define('TIME_6_HOURS', 21600);
define('TIME_12_HOURS', 43200);
define('TIME_1_DAYS', 86400);
define('TIME_3_DAYS', 259200);
define('TIME_7_DAYS', 604800);
define('TIME_14_DAYS', 1209600);
define('TIME_1_MONTHS', 2678400);
define('TIME_3_MONTHS', 7948800);
define('TIME_6_MONTHS', 15984000);
define('TIME_1_YEARS', 31536000);

// ---- MAGIC VALUES FOR SORTING ----//
define('SORT_LASTPOST', 0);
define('SORT_FORUM', 1);
define('SORT_TITLE', 2);
define('SORT_AUTHOR', 3);
define('SORT_REPLIES', 4);
define('SORT_VIEWS', 5);

// ---- SET-UP PHPBB2 ---- //
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include_once($phpbb_root_path.'includes/functions_color_groups.'.$phpEx);

// ---- HANDLE SESSIONS ---- //
$userdata = session_pagestart($user_ip, PAGE_ACTIVE);
init_userprefs($userdata);

// ---- INCLUDE EXTERNAL CONFIG FILE ---- //
include($phpbb_root_path.'active_config.'.$phpEx);

// ---- TIME LANGUAGE VARIABLES ---- //
$lang_time[TIME_ALL_TOPICS] = $lang['All_Topics'];
$lang_time[TIME_LAST_VISIT] = $lang['Since_Lastvisit'];
$lang_time[TIME_1_HOURS] = $lang['1_Hour'];
$lang_time[TIME_3_HOURS] = $lang['3_Hours'];
$lang_time[TIME_6_HOURS] = $lang['6_Hours'];
$lang_time[TIME_12_HOURS] = $lang['12_Hours'];
$lang_time[TIME_1_DAYS] = $lang['1_Day'];
$lang_time[TIME_3_DAYS] = $lang['3_Days'];
$lang_time[TIME_7_DAYS] = $lang['7_Days'];
$lang_time[TIME_14_DAYS] = $lang['2_Weeks'];
$lang_time[TIME_1_MONTHS] = $lang['1_Month'];
$lang_time[TIME_3_MONTHS] = $lang['3_Months'];
$lang_time[TIME_6_MONTHS] = $lang['6_Months'];
$lang_time[TIME_1_YEARS] = $lang['1_Year'];

// ---- SORTING LANGUAGE VARIABLES ---- //
$lang_sort[SORT_LASTPOST] = $lang['Last_Post'];
$lang_sort[SORT_FORUM] = $lang['Sort_Forum'];
$lang_sort[SORT_TITLE] = $lang['Sort_Topic_Title'];
$lang_sort[SORT_AUTHOR] = $lang['Sort_Author'];
$lang_sort[SORT_REPLIES] = $lang['Replies'];
$lang_sort[SORT_VIEWS] = $lang['Views'];

// ---- HANDLE FORUM PERMISSIONS ---- //
$limit_forums_arr = auth(AUTH_READ, AUTH_LIST_ALL, $userdata);
$limit_forums_sql = '';

while(list($forum_id, $is_auth) = each($limit_forums_arr))
{
    if(!$is_auth['auth_read'])
    {
        $limit_forums_sql .= ($limit_forums_sql != '') ? ", $forum_id" : $forum_id;
    }

}
$limit_forums_sql = ($limit_forums_sql != '') ? "AND t.forum_id NOT IN($limit_forums_sql)" : '';

// ---- HANDLE TIME ---- //
$topic_days = intval(isset($HTTP_POST_VARS['topicdays']) ? $HTTP_POST_VARS['topicdays'] : (isset($HTTP_GET_VARS['topicdays']) ? $HTTP_GET_VARS['topicdays'] : $default_time));
switch($topic_days)
{
    case TIME_ALL_TOPICS:
        $limit_time_sql = '';
        break;
    case TIME_LAST_VISIT:
        $limit_time_sql = 'AND p2.post_time >= ' . (time() - $userdata['user_lastvisit']);
        break;
    default:
        $limit_time_sql = 'AND p2.post_time >= ' . (time() - $topic_days);
        break;
}

// ---- HANDLE SORTING ---- //
$sort_by = isset($HTTP_GET_VARS['sort_by']) ? intval($HTTP_GET_VARS['sort_by']) : (isset($HTTP_POST_VARS['sort_by']) ? $HTTP_POST_VARS['sort_by'] : $default_sort);
$sort_sql = 't.topic_last_post_id DESC';
switch($sort_by)
{
    case SORT_FORUM:
        $sort_sql = "f.forum_name ASC, $sort_sql"; // forum name
        break;
    case SORT_TITLE:
        $sort_sql = "t.topic_title ASC, $sort_sql"; // topic title
        break;
    case SORT_AUTHOR:
        $sort_sql = "u.username ASC, $sort_sql"; // author
        break;
    case SORT_REPLIES:
        $sort_sql = "t.topic_replies DESC, $sort_sql"; // replies
        break;
    case SORT_VIEWS:
        $sort_sql = "t.topic_views DESC, $sort_sql"; // views
        break;
}

// ---- HANDLE PAGINATION ---- //
$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;

$pagination_sql = "SELECT COUNT(t.topic_id) AS forum_topics
    FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p2
    WHERE p2.post_id = t.topic_last_post_id $limit_forums_sql $limit_time_sql";

if(!($pagination_result = $db->sql_query($pagination_sql)))
{
    message_die(GENERAL_ERROR, 'Could not obtain limited topics count information', '', __LINE__, __FILE__, $sql);
}

$pagination_row = $db->sql_fetchrow($pagination_result);
$topics_count = $pagination_row['forum_topics'] ? $pagination_row['forum_topics'] : 1;

$db->sql_freeresult($pagination_result);

$pagination = generate_pagination("viewactive.$phpEx?topicdays=$topic_days&amp;sort_by=$sort_by", $topics_count, $default_per_page, $start);
$page_number = sprintf($lang['Page_of'], ( floor( $start / $default_per_page ) + 1 ), ceil( $topics_count / $default_per_page ));

// ---- GET TOPICS ---- //
$topics_sql = "SELECT f.forum_name, f.forum_id, t.*, u.username, u.user_id, u2.username as user2, u2.user_id as id2, p.post_username, p2.post_username AS post_username2, p2.post_time, pt.post_text, pt.bbcode_uid
    FROM " . FORUMS_TABLE . " f, " . TOPICS_TABLE . " t, " . USERS_TABLE . " u, " . POSTS_TABLE . " p, " . POSTS_TABLE . " p2, " . USERS_TABLE . " u2, " . POSTS_TEXT_TABLE . " pt
    WHERE t.forum_id = f.forum_id
        AND t.topic_poster = u.user_id
        AND p.post_id = t.topic_first_post_id
        AND p2.post_id = t.topic_last_post_id
        AND p.post_id = pt.post_id
        AND u2.user_id = p2.poster_id
        $limit_forums_sql $limit_time_sql
    ORDER BY $sort_sql
    LIMIT $start, $default_per_page";

if (!($topics_result = $db->sql_query($topics_sql)))
{
   message_die(GENERAL_ERROR, 'Could not obtain topic information', '', __LINE__, __FILE__, $sql);
}

$total_topics = 0;
$topics_on_page = '';
while( $topics_row = $db->sql_fetchrow($topics_result) )
{
    $topic_rowset[] = $topics_row;
    $total_topics++;
    $topics_on_page .= ( ( $topics_on_page != '' ) ? ', ' : '' ) . $topics_row['topic_id'];
}

$db->sql_freeresult($topics_result);

// MOD
$posted_topics = array();
if ( $userdata['session_logged_in'] && !empty($topics_on_page))
{
        $sql = "SELECT p.topic_id FROM " . POSTS_TABLE . " p
                WHERE p.topic_id IN ($topics_on_page)
                AND p.poster_id = " . $userdata['user_id'];

        if ( !($result = $db->sql_query($sql)) )
        {
           message_die(GENERAL_ERROR, 'Could not obtain topic information', '', __LINE__, __FILE__, $sql);
        }
        while( $row = $db->sql_fetchrow($result) )
        {
                $posted_topics[] = $row['topic_id'];
        }
}
// END MOD

// ---- GENERATE TEMPLATE ---- //
$select_topic_days = '<select name="topicdays">';
while(list($time_value, $lang_value) = each($lang_time))
{
    $selected = ($topic_days == $time_value) ? ' selected="selected"' : '';
    $select_topic_days .= '<option value="' . $time_value . '"' . $selected . '>' . $lang_value . '</option>';
}
$select_topic_days .= '</select>';

$select_sort_by = '<select name="sort_by">';
while(list($sort_value, $lang_value) = each($lang_sort))
{
    $selected = ($sort_by == $sort_value) ? ' selected="selected"' : '';
    $select_sort_by .= '<option value="' . $sort_value . '"' . $selected . '>' . $lang_value . '</option>';
}
$select_sort_by .= '</select>';

$nav_links['up'] = array(
    'url' => append_sid('forum.'.$phpEx),
    'title' => sprintf($lang['Forum_Index'], $board_config['sitename'])
);

$page_title = $lang['Active_Topics'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
    'body' => 'viewactive_body.tpl')
);

$template->assign_vars(array(
    'U_MARK_READ' => append_sid("forum.$phpEx?mark=forums"),

    'PAGINATION' => $pagination,
    'PAGE_NUMBER' => $page_number,

    'FOLDER_IMG' => $images['folder'],
    'FOLDER_NEW_IMG' => $images['folder_new'],
    'FOLDER_HOT_IMG' => $images['folder_hot'],
    'FOLDER_HOT_NEW_IMG' => $images['folder_hot_new'],
    'FOLDER_LOCKED_IMG' => $images['folder_locked'],
    'FOLDER_LOCKED_NEW_IMG' => $images['folder_locked_new'],
    'FOLDER_STICKY_IMG' => $images['folder_sticky'],
    'FOLDER_STICKY_NEW_IMG' => $images['folder_sticky_new'],
    'FOLDER_ANNOUNCE_IMG' => $images['folder_announce'],
    'FOLDER_ANNOUNCE_NEW_IMG' => $images['folder_announce_new'],
    'FOLDER_GLOBAL_ANNOUNCE_IMG' => $images['folder_global_announce'],
    'FOLDER_GLOBAL_ANNOUNCE_NEW_IMG' => $images['folder_global_announce_new'],
    'FOLDER_MOVED_IMG' => $images['folder_moved'],
    'FOLDER_POLL_IMG' => $images['folder_poll'],
    'FOLDER_POLL_NEW_IMG' => $images['folder_poll_new'],
    'FOLDER_NEWS_IMG' => $images['folder_news'],
    'FOLDER_NEWS_NEW_IMG' => $images['folder_news_new'],

    'L_ACTIVE_TOPICS' => $lang['Active_Topics'],
    'L_TOPICS' => $lang['Topics'],
    'L_REPLIES' => $lang['Replies'],
    'L_VIEWS' => $lang['Views'],
    'L_POSTS' => $lang['Posts'],
    'L_LASTPOST' => $lang['Last_Post'],
    'L_MARK_TOPICS_READ' => $lang['Mark_all_topics'],
    'L_NO_NEW_POSTS' => $lang['No_new_posts'],
    'L_NEW_POSTS' => $lang['New_posts'],
    'L_NO_NEW_POSTS_LOCKED' => $lang['No_new_posts_locked'],
    'L_NEW_POSTS_LOCKED' => $lang['New_posts_locked'],
    'L_NO_NEW_POSTS_HOT' => $lang['No_new_posts_hot'],
    'L_NEW_POSTS_HOT' => $lang['New_posts_hot'],
    'L_ANNOUNCEMENT' => $lang['Post_Announcement'],
    'L_STICKY' => $lang['Post_Sticky'],
    'L_GLOBAL_ANNOUNCEMENT' => $lang['Post_global_announcement'],
    'L_MOVED' => $lang['Moved'],
    'L_POLL' => $lang['Post_Poll'],
    'L_NEWS' => $lang['Post_News'],
    'L_POSTED' => $lang['Posted'],
    'L_JOINED' => $lang['Joined'],
    'L_AUTHOR' => $lang['Author'],
    'L_DESCRIPTION' => $lang['Description'],
    'L_FORUM' => $lang['Forum'],
    'L_DISPLAY_TOPICS' => $lang['Display_topics'],
    'L_SORT_BY' => $lang['Sort_by'],
    'L_GO' => $lang['Go'],
    'L_GOTO_PAGE' => $lang['Goto_page'],
    'L_NO_TOPICS' => $lang['No_active_topics'],

    'S_SELECT_TOPIC_DAYS' => $select_topic_days,
    'S_SELECT_SORT_BY' => $select_sort_by,
    'S_POST_DAYS_ACTION' => append_sid("viewactive.$phpEx?start=$start")
));

// ---- HANDLE BADWORDS ---- //
$orig_word = array();
$replacement_word = array();
obtain_word_list($orig_word, $replacement_word);

// ---- MAIN TOPICS LOOP FROM VIEWFORUM.PHP ---- //
if($total_topics > 0)
{
    for($i = 0; $i < $total_topics; $i++)
    {
        $topic_id = $topic_rowset[$i]['topic_id'];
        $topic_title = ( count($orig_word) ) ? preg_replace($orig_word, $replacement_word, $topic_rowset[$i]['topic_title']) : $topic_rowset[$i]['topic_title'];
        $topic_title = (empty($topic_rowset[$i]['title_compl_infos'])) ? $topic_title : $topic_rowset[$i]['title_compl_infos'].$topic_title;
        $topic_type = $topic_rowset[$i]['topic_type'];

        if ( $topic_rowset[$i]['topic_icon'] == 0 )
        {
            $icon = "<img src=\"images/spacer.gif\" alt=\"\" width=\"25\" height=\"1\" />";
        }
        else
        {
            $icon = '<img width="25" height="25" src="'.$images['root'].'post_icon/icon'.$topic_rowset[$i]['topic_icon'].'.gif" alt="Message Icon" border="0" align="absmiddle" />';
        }

        $forum_id = $topic_rowset[$i]['forum_id'];
        $forum_name = $topic_rowset[$i]['forum_name'];
        $forum_link = append_sid("viewforum.$phpEx?".POST_FORUM_URL."=$forum_id");

        $views = $topic_rowset[$i]['topic_views'];
        $replies = $topic_rowset[$i]['topic_replies'];

        if( $topic_type == POST_ANNOUNCE )
        {
            $topic_type = $lang['Topic_Announcement'] . ' ';
        }
        else if( $topic_type == POST_GLOBAL_ANNOUNCE )
        {
            $topic_type = $lang['Topic_global_announcement'] . ' ';
        }
        else if( $topic_type == POST_STICKY )
        {
            $topic_type = $lang['Topic_Sticky'] . ' ';
        }
        else
        {
            $topic_type = '';
        }

        if ( $topic_rowset[$i]['news_id'] > 0 )
        {
            $topic_type .= $lang['Topic_News'] . ' ';
        }
        else if ( $topic_rowset[$i]['topic_vote'] )
        {
            $topic_type .= $lang['Topic_Poll'] . ' ';
        }
        else if ( $topic_rowset[$i]['topic_status'] == TOPIC_MOVED )
        {
            $topic_type .= $lang['Topic_Moved'] . ' ';
        }

        if( $topic_rowset[$i]['topic_status'] == TOPIC_MOVED )
        {
            //$topic_type = $lang['Topic_Moved'] . ' ';
            $topic_id = $topic_rowset[$i]['topic_moved_id'];
            $folder_image = $images['folder_moved'];
            $folder_alt = $lang['Topics_Moved'];
            $newest_post_img = '';
        }
        else
        {
            if( $topic_rowset[$i]['topic_status'] == TOPIC_LOCKED )
            {
                $folder = $images['folder_locked'];
                $folder_new = $images['folder_locked_new'];
            }
            else if( $topic_rowset[$i]['topic_type'] == POST_GLOBAL_ANNOUNCE )
            {
                $folder = $images['folder_global_announce'];
                $folder_new = $images['folder_global_announce_new'];
            }
            else if( $topic_rowset[$i]['topic_type'] == POST_ANNOUNCE )
            {
                $folder = $images['folder_announce'];
                $folder_new = $images['folder_announce_new'];
            }
            else if( $topic_rowset[$i]['topic_type'] == POST_STICKY )
            {
                $folder = $images['folder_sticky'];
                $folder_new = $images['folder_sticky_new'];
            }
            else if ( $topic_rowset[$i]['news_id'] > 0 )
            {
                $folder = $images['folder_news'];
                $folder_new = $images['folder_news_new'];
            }
            else if( $topic_rowset[$i]['topic_vote'] )
            {
                $folder = $images['folder_poll'];
                $folder_new = $images['folder_poll_new'];
            }
            else
            {
                if($replies >= $board_config['hot_threshold'])
                {
                    $folder = $images['folder_hot'];
                    $folder_new = $images['folder_hot_new'];
                }
                else
                {
                    $folder = $images['folder'];
                    $folder_new = $images['folder_new'];
                }
            }

            $newest_post_img = '';
            if( $userdata['session_logged_in'] )
            {
                if( $topic_rowset[$i]['post_time'] > $userdata['user_lastvisit'] )
                {
                    if( !empty($tracking_topics) || !empty($tracking_forums) || isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f_all']) )
                    {
                        $unread_topics = true;

                        if( !empty($tracking_topics[$topic_id]) )
                        {
                            if( $tracking_topics[$topic_id] >= $topic_rowset[$i]['post_time'] )
                            {
                                $unread_topics = false;
                            }
                        }

                        if( !empty($tracking_forums[$forum_id]) )
                        {
                            if( $tracking_forums[$forum_id] >= $topic_rowset[$i]['post_time'] )
                            {
                                $unread_topics = false;
                            }
                        }

                        if( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f_all']) )
                        {
                            if( $HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f_all'] >= $topic_rowset[$i]['post_time'] )
                            {
                                $unread_topics = false;
                            }
                        }

                        if( $unread_topics )
                        {
                            $folder_image = $folder_new;
                            $folder_alt = $lang['New_posts'];
                            $newest_post_img = '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=newest") . '"><img src="' . $images['icon_newest_reply'] . '" alt="' . $lang['View_newest_post'] . '" title="' . $lang['View_newest_post'] . '" border="0" /></a> ';
                        }
                        else
                        {
                            $folder_image = $folder;
                            $folder_alt = ( $topic_rowset[$i]['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['No_new_posts'];

                            $newest_post_img = '';
                        }
                    }
                    else
                    {
                        $folder_image = $folder_new;
                        $folder_alt = ( $topic_rowset[$i]['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['New_posts'];

                        $newest_post_img = '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=newest") . '"><img src="' . $images['icon_newest_reply'] . '" alt="' . $lang['View_newest_post'] . '" title="' . $lang['View_newest_post'] . '" border="0" /></a> ';
                    }
                }
                else
                {
                    $folder_image = $folder;
                    $folder_alt = ( $topic_rowset[$i]['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['No_new_posts'];

                    $newest_post_img = '';
                }
            }
            else
            {
                $folder_image = $folder;
                $folder_alt = ( $topic_rowset[$i]['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['No_new_posts'];
                $newest_post_img = '';
            }
        }

        if( ( $replies + 1 ) > $board_config['posts_per_page'] )
        {
            $total_pages = ceil( ( $replies + 1 ) / $board_config['posts_per_page'] );
            $goto_page = '<br />[ <img src="' . $images['icon_gotopost'] . '" alt="' . $lang['Goto_page'] . '" title="' . $lang['Goto_page'] . '" />' . $lang['Goto_page'] . ': ';

            $times = 1;
            for($j = 0; $j < $replies + 1; $j += $board_config['posts_per_page'])
            {
                $goto_page .= '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $topic_id . "&amp;start=$j") . '">' . $times . '</a>';
                if( $times == 1 && $total_pages > 4 )
                {
                    $goto_page .= ' ... ';
                    $times = $total_pages - 3;
                    $j += ( $total_pages - 4 ) * $board_config['posts_per_page'];
                }
                else if ( $times < $total_pages )
                {
                    $goto_page .= ', ';
                }
                $times++;
            }
            $goto_page .= ' ] ';
        }
        else
        {
            $goto_page = '';
        }

        $view_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id");

        $topic_author = ( $topic_rowset[$i]['user_id'] != ANONYMOUS ) ? '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $topic_rowset[$i]['user_id']) . '">' : '';
        $topic_author .= ( $topic_rowset[$i]['user_id'] != ANONYMOUS ) ? $topic_rowset[$i]['username'] : ( ( $topic_rowset[$i]['post_username'] != '' ) ? $topic_rowset[$i]['post_username'] : $lang['Guest'] );
        $topic_author .= ( $topic_rowset[$i]['user_id'] != ANONYMOUS ) ? '</a>' : '';

        $first_post_time = create_date($board_config['default_dateformat'], $topic_rowset[$i]['topic_time'], $board_config['board_timezone']);

        $last_post_time = create_date($board_config['default_dateformat'], $topic_rowset[$i]['post_time'], $board_config['board_timezone']);
        //
        // MOD - TODAY AT - BEGIN
        //
        if ( $board_config['time_today'] < $topic_rowset[$i]['post_time'])
        {
            $last_post_time = sprintf($lang['Today_at'], create_date($board_config['default_timeformat'], $topic_rowset[$i]['post_time'], $board_config['board_timezone']));
        }
        else if ( $board_config['time_yesterday'] < $topic_rowset[$i]['post_time'])
        {
            $last_post_time = sprintf($lang['Yesterday_at'], create_date($board_config['default_timeformat'], $topic_rowset[$i]['post_time'], $board_config['board_timezone']));
        }
        // MOD - TODAY AT - END

        $last_post_author = ( $topic_rowset[$i]['id2'] == ANONYMOUS ) ? ( ($topic_rowset[$i]['post_username2'] != '' ) ? $topic_rowset[$i]['post_username2'] . ' ' : $lang['Guest'] . ' ' ) : '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '='  . $topic_rowset[$i]['id2']) . '">' . $topic_rowset[$i]['user2'] . '</a>';
        $last_post_url = '<a href="' . append_sid("viewtopic.$phpEx?"  . POST_POST_URL . '=' . $topic_rowset[$i]['topic_last_post_id']) . '#' . $topic_rowset[$i]['topic_last_post_id'] . '"><img src="' . $images['icon_latest_reply'] . '" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" border="0" /></a>';

        $row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
        $row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

        $template->assign_block_vars('topicrow', array(
            'ICON' => $icon,
            'ROW_COLOR' => $row_color,
            'ROW_CLASS' => $row_class,

            'NEWEST_POST_IMG' => $newest_post_img,
            'TOPIC_ATTACHMENT_IMG' => topic_attachment_image($topic_rowset[$i]['topic_attachment']),
            'TOPIC_ID' => $topic_id,
            'TOPIC_FOLDER_IMG' => $folder_image,
            'TOPIC_TITLE' => $topic_title,
            'TOPIC_TYPE' => $topic_type,
            'TOPIC_AUTHOR' => ($poster_name = color_group_colorize_name($topic_rowset[$i]['user_id'],true)) ? $poster_name : $topic_rowset[$i]['username'],
            'GOTO_PAGE' => $goto_page,

            'FORUM_ID' => $forum_id,
            'FORUM_NAME' => $forum_name,

            'REPLIES' => $replies,
            'VIEWS' => $views,

            'FIRST_POST_TIME' => $first_post_time,
            'LAST_POST_TIME' => $last_post_time,
            //'LAST_POST_AUTHOR' => $last_post_author,
            'LAST_POST_AUTHOR' => ($last_poster_name = color_group_colorize_name($topic_rowset[$i]['id2'],true)) ? $last_poster_name : $topic_rowset[$i]['post_username2'],
            'LAST_POST_IMG' => $last_post_url,
            'POSTED' => in_array($topic_id, $posted_topics) ? $board_config['me_posted_css'] : '',

            'U_VIEWFORUM' => $forum_link,
            'U_VIEW_TOPIC' => $view_topic_url,

            'L_TOPIC_FOLDER_ALT' => $folder_alt
        ));
        if ( !empty($topic_rowset[$i]['topic_desc']))
        {
            $topic_desc = $topic_rowset[$i]['topic_desc'];
            $template->assign_block_vars('topicrow.switch_topic_desc', array(
                'TOPIC_DESCRIPTION' => smilies_pass($topic_desc))
            );
        }
    }

}
else
{
    $template->assign_block_vars('switch_no_topics', array() );
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>