<?php
/***************************************************************************
 *                               viewtopic.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: viewtopic.php 456 2006-06-16 16:11:07Z arthur $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
define('IN_CASHMOD', true);
define('CM_VIEWTOPIC', true);

$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
//read_tracking add
include($phpbb_root_path . 'includes/read_history.'.$phpEx);
include($phpbb_root_path . 'includes/chinese.'.$phpEx);

//
// Start initial var setup
//
$topic_id = $post_id = 0;
if ( isset($HTTP_GET_VARS[POST_TOPIC_URL]) )
{
    $topic_id = intval($HTTP_GET_VARS[POST_TOPIC_URL]);
}
else if ( isset($HTTP_GET_VARS['topic']) )
{
    $topic_id = intval($HTTP_GET_VARS['topic']);
}

if ( isset($HTTP_GET_VARS[POST_POST_URL]))
{
    $post_id = intval($HTTP_GET_VARS[POST_POST_URL]);
}

$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;

if(isset($HTTP_GET_VARS['printertopic']))
{
    $start = ( isset($HTTP_GET_VARS['start_rel']) ) && ( isset($HTTP_GET_VARS['printertopic']) ) ? intval($HTTP_GET_VARS['start_rel']) - 1 : $start;
    // $finish when positive indicates last message; when negative it indicates range; can't be 0
    if(isset($HTTP_GET_VARS['finish_rel']))
    {
        $finish = intval($HTTP_GET_VARS['finish_rel']);
    }
    if(($finish >= 0) && (($finish - $start) <=0))
    {
        unset($finish);
    }
}

if (!$topic_id && !$post_id)
{
    message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
}

//
// Find topic id if user requested a newer
// or older topic
//
if ( isset($HTTP_GET_VARS['view']) && empty($HTTP_GET_VARS[POST_POST_URL]) )
{
    if ( $HTTP_GET_VARS['view'] == 'newest' )
    {
        if ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid']) || isset($HTTP_GET_VARS['sid']) )
        {
            $session_id = isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid']) ? $HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid'] : $HTTP_GET_VARS['sid'];

			if (!preg_match('/^[A-Za-z0-9]*$/', $session_id))
			{
				$session_id = '';
			}

            if ( $session_id )
            {
                //Added for read_tracking
                if ( $board_config['db_read_tracking'] )
                {
                    $sql = "SELECT p.post_id
                    FROM " . POSTS_TABLE . " p, " . READ_HIST_TABLE . " rh, " . SESSIONS_TABLE . " s
                    WHERE s.session_id = '$session_id'
                        AND s.session_user_id = rh.user_id
                        AND rh.topic_id = $topic_id
                        AND rh.topic_id = p.topic_id
                        AND (p.post_time >= rh.post_time
                        OR p.post_edit_time >= rh.post_time)
                    ORDER BY p.post_time ASC
                    LIMIT 1";
                }
                else
                {
                    $tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) : array();
                    $tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) : array();

                    if ( !empty($tracking_topics[$topic_id]) && !empty($tracking_forums[$forum_id]) )
                    {
                        $topic_last_read = ( $tracking_topics[$topic_id] > $tracking_forums[$forum_id] ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
                    }
                    else if ( !empty($tracking_topics[$topic_id]) || !empty($tracking_forums[$forum_id]) )
                    {
                        $topic_last_read = ( !empty($tracking_topics[$topic_id]) ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
                    }
                    else
                    {
                        $topic_last_read = 'u.user_lastvisit';
                    }

                    $sql = "SELECT p.post_id, p.post_time
                        FROM " . POSTS_TABLE . " p, " . SESSIONS_TABLE . " s,  " . USERS_TABLE . " u
                        WHERE s.session_id = '$session_id'
                        AND u.user_id = s.session_user_id
                        AND p.topic_id = " . intval($topic_id) . "
                        AND p.post_time >= " . $topic_last_read . "
                        LIMIT 1";
                }

                if ( !($result = $db->sql_query($sql)) )
                {
                    message_die(GENERAL_ERROR, 'Could not obtain newer/older topic information', '', __LINE__, __FILE__, $sql);
                }

                if ( !($row = $db->sql_fetchrow($result)) )
                {
                    $sql = "SELECT topic_last_post_id as post_id FROM " . TOPICS_TABLE . " WHERE topic_id = " . intval($topic_id);
                    if ( !($result = $db->sql_query($sql)) )
                    {
                        message_die(GENERAL_ERROR, 'Could not obtain newer/older topic information', '', __LINE__, __FILE__, $sql);
                    }

                    if ( !($row = $db->sql_fetchrow($result)) )
                    {
                        message_die(GENERAL_MESSAGE, 'No_new_posts_last_visit');
                    }
                }

                $post_id = $row['post_id'];

                if (isset($HTTP_GET_VARS['sid']))
                {
                    redirect("viewtopic.$phpEx?sid=$session_id&amp;" . POST_POST_URL . "=$post_id#$post_id");
                }
                else
                {
                    redirect("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id#$post_id");
                }
            }
        }

        redirect(append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id", true));
    }
    else if ( $HTTP_GET_VARS['view'] == 'next' || $HTTP_GET_VARS['view'] == 'previous' )
    {
        $sql_condition = ( $HTTP_GET_VARS['view'] == 'next' ) ? '>' : '<';
        $sql_ordering = ( $HTTP_GET_VARS['view'] == 'next' ) ? 'ASC' : 'DESC';

        $sql = "SELECT t.topic_id
            FROM " . TOPICS_TABLE . " t, " . TOPICS_TABLE . " t2, " . POSTS_TABLE . " p, " . POSTS_TABLE . " p2
            WHERE t2.topic_id = $topic_id
                AND p2.post_id = t2.topic_last_post_id
                AND t.forum_id = t2.forum_id
                AND p.post_id = t.topic_last_post_id
                AND p.post_time $sql_condition p2.post_time
                AND p.topic_id = t.topic_id
            ORDER BY p.post_time $sql_ordering
            LIMIT 1";
        if ( !($result = $db->sql_query($sql)) )
        {
            message_die(GENERAL_ERROR, "Could not obtain newer/older topic information", '', __LINE__, __FILE__, $sql);
        }

        if ( $row = $db->sql_fetchrow($result) )
        {
            $topic_id = intval($row['topic_id']);
        }
        else
        {
            $message = ( $HTTP_GET_VARS['view'] == 'next' ) ? 'No_newer_topics' : 'No_older_topics';
            message_die(GENERAL_MESSAGE, $message);
        }
    }
}

//
// This rather complex gaggle of code handles querying for topics but
// also allows for direct linking to a post (and the calculation of which
// page the post is on and the correct display of viewtopic)
//
$join_sql_table = (!$post_id) ? '' : ", " . POSTS_TABLE . " p, " . POSTS_TABLE . " p2 ";
$join_sql = (!$post_id) ? "t.topic_id = $topic_id" : "p.post_id = $post_id AND t.topic_id = p.topic_id AND p2.topic_id = p.topic_id AND p2.post_id <= $post_id";
$count_sql = (!$post_id) ? '' : ", COUNT(p2.post_id) AS prev_posts";

$order_sql = (!$post_id) ? '' : "GROUP BY p.post_id, t.topic_id, t.topic_title, t.topic_status, t.topic_replies, t.topic_time, t.topic_type, t.topic_vote, t.topic_last_post_id, f.forum_name, f.forum_status, f.forum_id, f.auth_view, f.auth_read, f.auth_post, f.auth_reply, f.auth_edit, f.auth_delete, f.auth_sticky, f.auth_announce, f.auth_pollcreate, f.auth_vote, f.auth_attachments, f.auth_delayedpost ORDER BY p.post_id ASC";

//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- delete
// $sql = "SELECT t.topic_id, t.topic_title, t.topic_status, t.topic_replies, t.topic_time, t.topic_type, t.topic_vote, t.topic_last_post_id, f.forum_name, f.forum_status, f.forum_id, f.auth_view, f.auth_read, f.auth_post, f.auth_reply, f.auth_edit, f.auth_delete, f.auth_sticky, f.auth_announce, f.auth_pollcreate, f.auth_vote, f.auth_attachments" . $count_sql . "
//  FROM " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f" . $join_sql_table . "
//  WHERE $join_sql
//      AND f.forum_id = t.forum_id
//      $order_sql";
//-- add
   $sql = "SELECT t.topic_id, t.topic_title, t.topic_status, t.topic_replies, t.topic_time, t.topic_type, t.topic_vote, t.topic_last_post_id, t.title_compl_infos, f.forum_name, f.forum_status, f.forum_password, f.forum_id, f.auth_view, f.auth_read, f.auth_post, f.auth_reply, f.auth_edit, f.auth_delete, f.auth_sticky, f.auth_announce, f.auth_pollcreate, f.auth_vote, f.auth_attachments, f.auth_delayedpost, f.auth_news, f.auth_globalannounce, f.cat_id, c.cat_title" . $count_sql . "
    FROM " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f," . CATEGORIES_TABLE . " c" . $join_sql_table . "
    WHERE $join_sql
        AND f.forum_id = t.forum_id
        AND c.cat_id = f.cat_id
        $order_sql";
//-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

mycal_alter_sql($sql, 'viewtopic');
mycal_alter_sql($sql, 'viewtopic_order');

attach_setup_viewtopic_auth($order_sql, $sql);
if ( !($result = $db->sql_query($sql)) )
{
    message_die(GENERAL_ERROR, "Could not obtain topic information", '', __LINE__, __FILE__, $sql);
}

if ( !($forum_topic_data = $db->sql_fetchrow($result)) )
{
    message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
}

$forum_id = intval($forum_topic_data['forum_id']);
$topic_first_post_id = intval($forum_topic_data['topic_first_post_id']); //mycal mod
$topic_id = intval($forum_topic_data['topic_id']);

//
// Start session management
//
$userdata = session_pagestart($user_ip, $forum_id);
init_userprefs($userdata);
//
// End session management
//

if(!file_exists(@phpbb_realpath($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_printertopic.'.$phpEx)))
{
	include($phpbb_root_path . 'language/lang_english/lang_printertopic.' . $phpEx);
} else
{
	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_printertopic.' . $phpEx);
}
include_once($phpbb_root_path.'includes/functions_color_groups.'.$phpEx);

//
// Start auth check
//
$is_auth = array();
$is_auth = auth(AUTH_ALL, $forum_id, $userdata, $forum_topic_data);

if( !$is_auth['auth_view'] || !$is_auth['auth_read'] )
{
    if ( !$userdata['session_logged_in'] )
    {
		$redirect = ($post_id) ? POST_POST_URL . "=$post_id" : POST_TOPIC_URL . "=$topic_id";
		$redirect .= ($start) ? "&start=$start" : '';
        mycal_suggestion_redirect();
        redirect(append_sid("login.$phpEx?redirect=viewtopic.$phpEx&amp;$redirect", true));
    }

    $message = ( !$is_auth['auth_view'] ) ? $lang['Topic_post_not_exist'] : sprintf($lang['Sorry_auth_read'], $is_auth['auth_read_type']);

    message_die(GENERAL_MESSAGE, $message);
}
//
// End auth check
//

//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- add
$cat_id   = $forum_topic_data['cat_id'];
//-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

// update topic view information

$forum_name = $forum_topic_data['forum_name'];
$topic_title = $forum_topic_data['topic_title'];
$topic_title = (empty($forum_topic_data['title_compl_infos'])) ? $topic_title : $forum_topic_data['title_compl_infos'].$topic_title;
$topic_id = intval($forum_topic_data['topic_id']);
$topic_time = $forum_topic_data['topic_time'];

$sql='UPDATE '.TOPIC_VIEW_TABLE.' SET topic_id="'.$topic_id.'", view_time="'.time().'", view_count=view_count+1 WHERE topic_id='.$topic_id.' AND user_id='.$userdata['user_id'];
if ( !$db->sql_query($sql) || !$db->sql_affectedrows() )
{
    $sql = 'INSERT IGNORE INTO '.TOPIC_VIEW_TABLE.' (topic_id, user_id, view_time,view_count)
        VALUES ('.$topic_id.', "'.$userdata['user_id'].'", "'.time().'","1")';
    if ( !($db->sql_query($sql)) )
    {
        message_die(CRITICAL_ERROR, 'Error create user view topic information ', '', __LINE__, __FILE__, $sql);
    }
}


//
// Password check
//
if( !$is_auth['auth_mod'] && $userdata['user_level'] != ADMIN )
{
    $redirect = str_replace("&amp;", "&", preg_replace('#.*?([a-z]+?\.' . $phpEx . '.*?)$#i', '\1', htmlspecialchars($HTTP_SERVER_VARS['REQUEST_URI'])));

    if(isset($HTTP_POST_VARS['cancel']))
    {
        redirect(append_sid('index.'.$phpEx));
    }
    else if(isset($HTTP_POST_VARS['pass_login']) && $HTTP_POST_VARS['pass_login'])
    {
/*
        if( $forum_topic_data['topic_password'] != '' )
        {
            password_check('topic', $topic_id, $HTTP_POST_VARS['password'], $redirect);
        }
        else
*/
        if( $forum_topic_data['forum_password'] != '' )
        {
            password_check('forum', $forum_id, $HTTP_POST_VARS['password'], $redirect);
        }
    }
/*
    if( $forum_topic_data['topic_password'] != '' )
    {
        $passdata = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_tpass']) ) ? unserialize(stripslashes($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_tpass'])) : '';
        if( $passdata[$topic_id] != md5($forum_topic_data['topic_password']) )
        {
            password_box('topic', $redirect);
        }
    }
    else
*/
    if( $forum_topic_data['forum_password'] != '' )
    {
        $passdata = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_fpass']) ) ? unserialize(stripslashes($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_fpass'])) : '';
        if( $passdata[$forum_id] != md5($forum_topic_data['forum_password']) )
        {
            password_box('forum', $redirect);
        }
    }
}
//
// END: Password check
//

if ($post_id)
{
    $start = floor(($forum_topic_data['prev_posts'] - 1) / intval($board_config['posts_per_page'])) * intval($board_config['posts_per_page']);
}

//
// Is user watching this thread?
//
if( $userdata['session_logged_in'] )
{
    $can_watch_topic = TRUE;

    $sql = "SELECT fav_id FROM " . $table_prefix . "favorites
                WHERE topic_id = $topic_id
                AND user_id = " . $userdata['user_id'];
    if ( !($result = $db->sql_query($sql)) )
        {
                message_die(GENERAL_ERROR, "Could not obtain favorite topic information", '', __LINE__, __FILE__, $sql);
        }
        $is_favorit_topic = 0;
        if ( $row = $db->sql_fetchrow($result) )
        {
                $fav_id = $row['fav_id'];
                if ($fav_id > 0) {
                        $is_favorit_topic = 1;
                }
        }

    $sql = "SELECT notify_status
        FROM " . TOPICS_WATCH_TABLE . "
        WHERE topic_id = $topic_id
            AND user_id = " . $userdata['user_id'];
    if ( !($result = $db->sql_query($sql)) )
    {
        message_die(GENERAL_ERROR, "Could not obtain topic watch information", '', __LINE__, __FILE__, $sql);
    }

    if ( $row = $db->sql_fetchrow($result) )
    {
        if ( isset($HTTP_GET_VARS['unwatch']) )
        {
            if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
            {
                $is_watching_topic = 0;

                $sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
                $sql = "DELETE $sql_priority FROM " . TOPICS_WATCH_TABLE . "
                    WHERE topic_id = $topic_id
                        AND user_id = " . $userdata['user_id'];
                if ( !($result = $db->sql_query($sql)) )
                {
                    message_die(GENERAL_ERROR, "Could not delete topic watch information", '', __LINE__, __FILE__, $sql);
                }
            }

            $template->assign_vars(array(
                'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">')
            );

            $message = $lang['No_longer_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">', '</a>');
            message_die(GENERAL_MESSAGE, $message);
        }
        else
        {
            $is_watching_topic = TRUE;

            if ( $row['notify_status'] )
            {
                $sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
                $sql = "UPDATE $sql_priority " . TOPICS_WATCH_TABLE . "
                    SET notify_status = 0
                    WHERE topic_id = $topic_id
                        AND user_id = " . $userdata['user_id'];
                if ( !($result = $db->sql_query($sql)) )
                {
                    message_die(GENERAL_ERROR, "Could not update topic watch information", '', __LINE__, __FILE__, $sql);
                }
            }
        }
    }
    else
    {
        if ( isset($HTTP_GET_VARS['watch']) )
        {
            if ( $HTTP_GET_VARS['watch'] == 'topic' )
            {
                $is_watching_topic = TRUE;

                $sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
                $sql = "INSERT $sql_priority INTO " . TOPICS_WATCH_TABLE . " (user_id, topic_id, notify_status)
                    VALUES (" . $userdata['user_id'] . ", $topic_id, 0)";
                if ( !($result = $db->sql_query($sql)) )
                {
                    message_die(GENERAL_ERROR, "Could not insert topic watch information", '', __LINE__, __FILE__, $sql);
                }
            }

            $template->assign_vars(array(
                'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">')
            );

            $message = $lang['You_are_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">', '</a>');
            message_die(GENERAL_MESSAGE, $message);
        }
        else
        {
            $is_watching_topic = 0;
        }
    }
}
else
{
    if ( isset($HTTP_GET_VARS['unwatch']) )
    {
        if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
        {
            redirect(append_sid("login.$phpEx?redirect=viewtopic.$phpEx&amp;" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic", true));
        }
    }
    else
    {
        $can_watch_topic = 0;
        $is_watching_topic = 0;
    }
}

//
// Generate a 'Show posts in previous x days' select box. If the postdays var is POSTed
// then get it's value, find the number of topics with dates newer than it (to properly
// handle pagination) and alter the main query
//
$previous_days = array(0, 1, 7, 14, 30, 90, 180, 364);
$previous_days_text = array($lang['All_Posts'], $lang['1_Day'], $lang['7_Days'], $lang['2_Weeks'], $lang['1_Month'], $lang['3_Months'], $lang['6_Months'], $lang['1_Year']);

if( !empty($HTTP_POST_VARS['postdays']) || !empty($HTTP_GET_VARS['postdays']) )
{
    $post_days = ( !empty($HTTP_POST_VARS['postdays']) ) ? intval($HTTP_POST_VARS['postdays']) : intval($HTTP_GET_VARS['postdays']);
    $min_post_time = time() - (intval($post_days) * 86400);

    $sql = "SELECT COUNT(p.post_id) AS num_posts
        FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p
        WHERE t.topic_id = $topic_id
            AND p.topic_id = t.topic_id
            AND p.post_time >= $min_post_time";
    if ( !($result = $db->sql_query($sql)) )
    {
        message_die(GENERAL_ERROR, "Could not obtain limited topics count information", '', __LINE__, __FILE__, $sql);
    }

    $total_replies = ( $row = $db->sql_fetchrow($result) ) ? intval($row['num_posts']) : 0;

    $limit_posts_time = "AND p.post_time >= $min_post_time ";

    if ( !empty($HTTP_POST_VARS['postdays']))
    {
        $start = 0;
    }
}
else
{
    $total_replies = intval($forum_topic_data['topic_replies']) + 1;

    $limit_posts_time = '';
    $post_days = 0;
}

$select_post_days = '<select name="postdays">';
for($i = 0; $i < count($previous_days); $i++)
{
    $selected = ($post_days == $previous_days[$i]) ? ' selected="selected"' : '';
    $select_post_days .= '<option value="' . $previous_days[$i] . '"' . $selected . '>' . $previous_days_text[$i] . '</option>';
}
$select_post_days .= '</select>';

//
// Decide how to order the post display
//
if ( !empty($HTTP_POST_VARS['postorder']) || !empty($HTTP_GET_VARS['postorder']) )
{
    $post_order = (!empty($HTTP_POST_VARS['postorder'])) ? htmlspecialchars($HTTP_POST_VARS['postorder']) : htmlspecialchars($HTTP_GET_VARS['postorder']);
    $post_time_order = ($post_order == "asc") ? "ASC" : "DESC";
}
else
{
    $post_order = 'asc';
    $post_time_order = 'ASC';
}

$select_post_order = '<select name="postorder">';
if ( $post_time_order == 'ASC' )
{
    $select_post_order .= '<option value="asc" selected="selected">' . $lang['Oldest_First'] . '</option><option value="desc">' . $lang['Newest_First'] . '</option>';
}
else
{
    $select_post_order .= '<option value="asc">' . $lang['Oldest_First'] . '</option><option value="desc" selected="selected">' . $lang['Newest_First'] . '</option>';
}
$select_post_order .= '</select>';

//
// Go ahead and pull all data for this topic
//

$sql = "SELECT u.username, u.user_id, u.user_posts, u.user_custom_title, u.user_from, u.user_from_flag, u.user_website, u.user_email, u.user_icq, u.user_aim, u.user_yim, u.user_regdate, u.user_msnm, u.user_viewemail, u.user_rank, u.user_sig, u.user_sig_bbcode_uid, u.user_avatar as current_user_avatar, u.user_avatar_type as current_user_avatar_type, u.user_allowavatar, u.user_allowsmile, u.avatar_sticky, u.user_allow_viewonline, u.user_session_time, u.user_gender, u.user_birthday, u.user_next_birthday_greeting, u.user_vacances, p.*,  pt.post_text, pt.post_subject, pt.bbcode_uid, t.topic_poster
    FROM " . POSTS_TABLE . " p, " . USERS_TABLE . " u, " . POSTS_TEXT_TABLE . " pt, " . TOPICS_TABLE . " t
    WHERE p.topic_id = $topic_id
    AND t.topic_id = p.topic_id
        $limit_posts_time
        AND pt.post_id = p.post_id
        AND u.user_id = p.poster_id
    ORDER BY p.post_time $post_time_order
    LIMIT $start, ".(isset($finish)? ((($finish - $start) > 0)? ($finish - $start): -$finish): $board_config['posts_per_page']);
    //LIMIT $start, ".$board_config['posts_per_page'];

$cm_viewtopic->generate_columns($template,$forum_id,$sql);

if ( !($result = $db->sql_query($sql)) )
{
    message_die(GENERAL_ERROR, "Could not obtain post/user information.", '', __LINE__, __FILE__, $sql);
}

$postrow = array();
if ($row = $db->sql_fetchrow($result))
{
    do
    {
        $postrow[] = $row;
    }
    while ($row = $db->sql_fetchrow($result));
    $db->sql_freeresult($result);

    $total_posts = count($postrow);
}
else
{
   include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
   sync('topic', $topic_id);

   message_die(GENERAL_MESSAGE, $lang['No_posts_topic']);
}

$resync = FALSE;
if ($forum_topic_data['topic_replies'] + 1 < $start + count($postrow))
{
   $resync = TRUE;
}
elseif ($start + $board_config['posts_per_page'] > $forum_topic_data['topic_replies'])
{
   $row_id = intval($forum_topic_data['topic_replies']) % intval($board_config['posts_per_page']);
   if ($postrow[$row_id]['post_id'] != $forum_topic_data['topic_last_post_id'] || $start + count($postrow) < $forum_topic_data['topic_replies'])
   {
      $resync = TRUE;
   }
}
elseif (count($postrow) < $board_config['posts_per_page'])
{
   $resync = TRUE;
}

if ($resync)
{
   include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
   sync('topic', $topic_id);

   $result = $db->sql_query('SELECT COUNT(post_id) AS total FROM ' . POSTS_TABLE . ' WHERE topic_id = ' . $topic_id);
   $row = $db->sql_fetchrow($result);
   $total_replies = $row['total'];
}

$sql = "SELECT *
    FROM " . RANKS_TABLE . "
    ORDER BY rank_special, rank_min";
if ( !($result = $db->sql_query($sql)) )
{
    message_die(GENERAL_ERROR, "Could not obtain ranks information.", '', __LINE__, __FILE__, $sql);
}

$ranksrow = array();
while ( $row = $db->sql_fetchrow($result) )
{
    $ranksrow[] = $row;
}
$db->sql_freeresult($result);

//
// Define censored word matches
//
if (!$userdata['user_allowswearywords'])
{
    $orig_word = array();
    $replacement_word = array();
    obtain_word_list($orig_word, $replacement_word);
}

//
// Censor topic title
//
if ( count($orig_word) )
{
    $topic_title = preg_replace($orig_word, $replacement_word, $topic_title);
}


//
// Was a highlight request part of the URI?
//
$highlight_match = $highlight = '';
if (isset($HTTP_GET_VARS['highlight']))
{
   // Split words and phrases
   $words = explode(' ', trim(htmlspecialchars($HTTP_GET_VARS['highlight'])));

   for($i = 0; $i < sizeof($words); $i++)
   {
        if (trim($words[$i]) != '')
        {
			$highlight_match .= (($highlight_match != '') ? '|' : '') . str_replace('*', '\w*', preg_quote($words[$i], '#'));
        }
    }
    unset($words);

    $highlight = urlencode($HTTP_GET_VARS['highlight']);
    $highlight_match = phpbb_rtrim($highlight_match, "\\"); 
}

//
// Post, reply and other URL generation for
// templating vars
//
$new_topic_url = append_sid("posting.$phpEx?mode=newtopic&amp;" . POST_FORUM_URL . "=$forum_id");
$reply_topic_url = append_sid("posting.$phpEx?mode=reply&amp;" . POST_TOPIC_URL . "=$topic_id");
$view_forum_url = append_sid("viewforum.$phpEx?" . POST_FORUM_URL . "=$forum_id");
$view_prev_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=previous");
$view_next_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=next");
$printer_topic_url = append_sid("viewtopic.$phpEx?printertopic=1&amp;" . POST_TOPIC_URL . "=$topic_id&amp;start=$start&amp;postdays=$post_days&amp;postorder=$post_order&amp;vote=viewresult");

//
// Mozilla navigation bar
//
$nav_links['prev'] = array(
    'url' => $view_prev_topic_url,
    'title' => $lang['View_previous_topic']
);
$nav_links['next'] = array(
    'url' => $view_next_topic_url,
    'title' => $lang['View_next_topic']
);
$nav_links['up'] = array(
    'url' => $view_forum_url,
    'title' => $forum_name
);

$reply_img =      ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_locked'] : $images['reply_new'];
$reply_img_mini = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_locked_mini'] : $images['reply_new_mini'];
$reply_alt =      ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['Reply_to_topic'];
$post_img =       ( $forum_topic_data['forum_status'] == FORUM_LOCKED ) ? $images['post_locked'] : $images['post_new'];
$post_alt =       ( $forum_topic_data['forum_status'] == FORUM_LOCKED ) ? $lang['Forum_locked'] : $lang['Post_new_topic'];

$printer_img = $images['printer'];
$printer_alt = $lang['printertopic_button'];
//$printer_img = $images['printer'];
//$printer_alt = "Printer-friendly version";

$tellfriend_img = $images['tellfriend'];
$tellfriend_alt = "Email to a Friend";

//Added for read_tracking
if ( $board_config['db_read_tracking'] )
{
    //nothing to do for read_tracking
}
else
{
    //
    // Set a cookie for this topic
    //
    if ( $userdata['session_logged_in'] )
    {
        $tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) : array();
        $tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) : array();

        if ( !empty($tracking_topics[$topic_id]) && !empty($tracking_forums[$forum_id]) )
        {
            $topic_last_read = ( $tracking_topics[$topic_id] > $tracking_forums[$forum_id] ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
        }
        else if ( !empty($tracking_topics[$topic_id]) || !empty($tracking_forums[$forum_id]) )
        {
            $topic_last_read = ( !empty($tracking_topics[$topic_id]) ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
        }
        else
        {
            $topic_last_read = $userdata['user_lastvisit'];
        }

        if ( count($tracking_topics) >= 150 && empty($tracking_topics[$topic_id]) )
        {
            asort($tracking_topics);
            unset($tracking_topics[key($tracking_topics)]);
        }

        $tracking_topics[$topic_id] = time();

        setcookie($board_config['cookie_name'] . '_t', serialize($tracking_topics), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
    }
}

$page_title = $lang['View_topic'] .' - ' . $topic_title;
//
// Load templates
//
if(isset($HTTP_GET_VARS['printertopic']))
{
    $template->set_filenames(array(
        'body' => 'printertopic_body.tpl')
    );
	include($phpbb_root_path . 'includes/page_header_printer.'.$phpEx);
} else
{
    $template->set_filenames(array(
        'body' => 'viewtopic_body.tpl')
    );
	include($phpbb_root_path . 'includes/page_header.'.$phpEx);
}
make_jumpbox('viewforum.'.$phpEx, $forum_id);

//
// Output page header
//

//-- mod : sub-template ----------------------------------------------------------------------------
//-- add
$reply_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_locked'] : $images['reply_new'];
$post_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED ) ? $images['post_locked'] : $images['post_new'];
//-- fin mod : sub-template ------------------------------------------------------------------------

//
// User authorisation levels output
//
$s_auth_can = ( ( $is_auth['auth_post'] ) ? $lang['Rules_post_can'] : $lang['Rules_post_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_reply'] ) ? $lang['Rules_reply_can'] : $lang['Rules_reply_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_edit'] ) ? $lang['Rules_edit_can'] : $lang['Rules_edit_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_delete'] ) ? $lang['Rules_delete_can'] : $lang['Rules_delete_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_vote'] ) ? $lang['Rules_vote_can'] : $lang['Rules_vote_cannot'] ) . '<br />';
mycal_build_auth_levels($is_auth, $s_auth_can);
attach_build_auth_levels($is_auth, $s_auth_can);

$topic_mod = '';

if ( $is_auth['auth_mod'] )
{
    $s_auth_can .= sprintf($lang['Rules_moderate'], "<a href=\"modcp.$phpEx?" . POST_FORUM_URL . "=$forum_id&amp;sid=" . $userdata['session_id'] . '">', '</a>');

    // MOD Modcp Extansion BEGIN
    $topic_mod .= ( $is_auth['auth_delete'] ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=delete&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_delete'] . '" alt="' . $lang['Delete_topic'] . '" title="' . $lang['Delete_topic'] . '" border="0" /></a>&nbsp;' : "";
    // MOD Modcp Extansion END

    $topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=move&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_move'] . '" alt="' . $lang['Move_topic'] . '" title="' . $lang['Move_topic'] . '" border="0" /></a>&nbsp;';

    $topic_mod .= ( $forum_topic_data['topic_status'] == TOPIC_UNLOCKED ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=lock&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_lock'] . '" alt="' . $lang['Lock_topic'] . '" title="' . $lang['Lock_topic'] . '" border="0" /></a>&nbsp;' : "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=unlock&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_unlock'] . '" alt="' . $lang['Unlock_topic'] . '" title="' . $lang['Unlock_topic'] . '" border="0" /></a>&nbsp;';

    $topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=mergepost&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_merge'] . '" alt="' . $lang['Merge_post'] . '" title="' . $lang['Merge_post'] . '" border="0" /></a>&nbsp;';

    $topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=split&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_split'] . '" alt="' . $lang['Split_topic'] . '" title="' . $lang['Split_topic'] . '" border="0" /></a>&nbsp;';

    // MOD Modcp Extansion BEGIN
    $normal_button = "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=normalise&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_normal'] . '" alt="' . $lang['Normal_topic'] . '" title="' . $lang['Normal_topic'] . '" border="0" /></a>&nbsp;';
    $sticky_button = ( $is_auth['auth_sticky'] ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=sticky&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_sticky'] . '" alt="' . $lang['Sticky_topic'] . '" title="' . $lang['Sticky_topic'] . '" border="0" /></a>&nbsp;' : "";
    $announce_button = ( $is_auth['auth_announce'] ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=announce&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_mod_announce'] . '" alt="' . $lang['Announce_topic'] . '" title="' . $lang['Announce_topic'] . '" border="0" /></a>&nbsp;' : "";
    switch( $forum_topic_data['topic_type'] )
    {
        case POST_NORMAL:
            $topic_mod .= $sticky_button . $announce_button;
            break;
        case POST_STICKY:
            $topic_mod .= $announce_button . $normal_button;
            break;
        case POST_ANNOUNCE:
            $topic_mod .= $sticky_button . $normal_button;
            break;
    }
    // MOD Modcp Extansion END
}

//
// Topic Favorites
//
$s_favorit_topic = '';
$s_favorit_link = '';
$s_favorit_img = '';
if ( isset($is_favorit_topic) && $is_favorit_topic )
{
    $s_favorit_topic =  append_sid("favorites.$phpEx?t=" . $topic_id . "&amp;mode=remove");
    $s_favorit_link = $lang['del_fav'];
    $s_favorit_img = ($userdata['session_logged_in']) ? '<a href="' . append_sid("favorites.$phpEx?t=" . $topic_id . "&amp;mode=remove") . '"><img src="' . $images['topic_un_favorites'] . '" alt="' . $lang['del_fav'] . '" title="' . $lang['del_fav'] . '" border="0" /></a>' : '';

}
else
{
    $s_favorit_topic =  append_sid("favorites.$phpEx?t=" . $topic_id . "&amp;mode=add");
    $s_favorit_link = $lang['add_fav'];
    $s_favorit_img = ($userdata['session_logged_in']) ? '<a href="' . append_sid("favorites.$phpEx?t=" . $topic_id . "&amp;mode=add") . '"><img src="' . $images['topic_favorites'] . '" alt="' . $lang['add_fav'] . '" title="' . $lang['add_fav'] . '" border="0" /></a>' : '';
}

//echo 'user_id : '.$userdata['user_id'];
//echo 'topic_poster : '.$postrow[0]['topic_poster'];

if ($userdata['session_logged_in'])
{
    if ( ($userdata['user_id'] == $postrow[0]['topic_poster']) || ( $userdata['user_level'] == ADMIN) || ( $userdata['user_level'] == MOD) )
    {
        $sql = "SELECT * FROM " . TITLE_INFOS_TABLE . " ORDER BY title_info ASC";
        if ( !($result = $db->sql_query($sql)) )
        {
            message_die(GENERAL_MESSAGE, 'Unable to query Quick Title Addon informations.');
        }
        $select_title = '<br /><form action="modcp.'.$phpEx.'?sid='.$userdata['session_id'].'" method="POST"><select name="qtnum"><option value="-1">---</option>';
        while ( $row = $db->sql_fetchrow($result) )
        {
            $select_title .= '<option value="'.$row['id'].'">'.$row['title_info'].'</option>';
        }
        $select_title .= '</select>&nbsp;<input type="submit" name="quick_title_edit" class="liteoption" value="'.$lang['Edit_title'].'"/><input type="hidden" name="' . POST_TOPIC_URL . '" value="'.$topic_id.'"/></form>';

        $topic_mod .= $select_title;
    }
}

//
// Topic watch information
//
$s_watching_topic = '';
if ( $can_watch_topic )
{
   if ( $is_watching_topic )
   {
      $s_watching_topic = "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Stop_watching_topic'] . '</a>';
      $s_watching_topic_img = ( isset($images['topic_un_watch']) ) ? "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_un_watch'] . '" alt="' . $lang['Stop_watching_topic'] . '" title="' . $lang['Stop_watching_topic'] . '" border="0" /></a>' : '';
   }
   else
   {
      $s_watching_topic = "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Start_watching_topic'] . '</a>';
      $s_watching_topic_img = ( isset($images['topic_watch']) ) ? "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_watch'] . '" alt="' . $lang['Start_watching_topic'] . '" title="' . $lang['Start_watching_topic'] . '" border="0" /></a>' : '';
   }
}

//
// Who Has Viewed
//
$topic_view_img = ($userdata['session_logged_in']) ?
    '<a href="' . append_sid("topic_view_users.$phpEx?".POST_TOPIC_URL."=$topic_id") . '"><img src="' . $images['topic_viewed'] . '" alt="' . $lang['Topic_view_users'] . '" title="' . $lang['Topic_view_users'] . '" border="0" /></a>' : '';

//
// Tell a Friend
//
//<a href="tellafriend.php?topic={TOPIC_TITLE}&link={TELL_LINK}"><img src="templates/fisubsilver/images/lang_english/topic_email.gif" alt="Email this topic" width="24" height="25" border="0" title="Email this topic" /></a>

//
// Printer Friendly
//
//<a href="{U_PRINTER_TOPIC}" target="_blank"><img src="templates/fisubsilver/images/lang_english/topic_print.gif" width="24" height="25" border="0" alt="{L_PRINT}" title="{L_PRINT}" /></a>

//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- add
// get the nav sentence
$nav_cat_desc = make_cat_nav_tree($cat_id, true);
if ($nav_cat_desc != "") $nav_cat_desc = $nav_separator . $nav_cat_desc;
//-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

//
// If we've got a hightlight set pass it on to pagination,
// I get annoyed when I lose my highlight after the first page.
//

//$pagination = ( $highlight != '' ) ? generate_pagination("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;highlight=$highlight", $total_replies, $board_config['posts_per_page'], $start) : generate_pagination("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order", $total_replies, $board_config['posts_per_page'], $start);

if(isset($HTTP_GET_VARS['printertopic']))
{
    $pagination_printertopic = "printertopic=1&amp;";
	if(isset($finish))
	{
	    $pagination_finish_rel = 'finish_rel='. - (($finish < 0)? -$finish: ($finish - $start)) . '&amp;';
	}
}
else
{
	$pagination_printertopic = $pagination_finish_rel = '';
}

$board_config['posts_per_page'] = intval($board_config['posts_per_page']);

$pagination = generate_pagination("viewtopic.$phpEx?". $pagination_printertopic . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order". ($highlight != '' ? "highlight=$highlight&amp;" : '') . $pagination_finish_rel, $total_replies, $board_config['posts_per_page'], $start);
if(isset($HTTP_GET_VARS['printertopic'])){
if(isset($pagination_printertopic))
{
    $pagination .= " &nbsp;<a href=\"viewtopic.$phpEx?". $pagination_printertopic. POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;". ($highlight != '' ? "highlight=$highlight&amp;" : ''). "start=0&amp;finish_rel=-10000\" title=\"  :| |:  \">:|&nbsp;|:</a>";
}
}
//
// Send vars to template
//
$template->assign_vars(array(
//-- mod : hi�rarchie des rubriques ----------------------------------------------------------------
//-- add
    'NAV_CAT_DESC' => $nav_cat_desc,
//-- fin mod : hi�rarchie des rubriques ------------------------------------------------------------

    'FORUM_ID' => $forum_id,
    'START_REL' => ($start + 1),
    'FINISH_REL' => (isset($HTTP_GET_VARS['finish_rel'])? intval($HTTP_GET_VARS['finish_rel']) : ($board_config['posts_per_page'] - $start)),
    'FORUM_NAME' => $forum_name,
    'TOPIC_ID' => $topic_id,
    'TOPIC_TITLE' => $topic_title,
    'PAGINATION' => $pagination,
    //'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / intval($board_config['posts_per_page']) ) + 1 ), ceil( $total_replies / intval($board_config['posts_per_page']) )),
    'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / $board_config['posts_per_page'] ) + 1 ), ceil( $total_replies / $board_config['posts_per_page'] )),

    'POST_IMG' => $post_img,
    'REPLY_IMG' => $reply_img,
    'PRINTER_IMG' => $printer_img,
    'TELLFRIEND_IMG' => $tellfriend_img,

    'REPLY_IMG_MINI' => $reply_img_mini,

    'L_PRINT' => (isset($lang['Print_View'])) ? $lang['Print_View'] : 'Printable version',
    'L_AUTHOR' => $lang['Author'],
    'L_MESSAGE' => $lang['Message'],
    'L_POSTED' => $lang['Posted'],
    'L_POST_SUBJECT' => $lang['Post_subject'],
    'L_VIEW_NEXT_TOPIC' => $lang['View_next_topic'],
    'L_VIEW_PREVIOUS_TOPIC' => $lang['View_previous_topic'],
    'L_POST_NEW_TOPIC' => $post_alt,
    'L_POST_REPLY_TOPIC' => $reply_alt,
    'L_PRINTER_TOPIC' => $printer_alt,
    'L_TELLFRIEND' => $tellfriend_alt,
    'L_BACK_TO_TOP' => $lang['Back_to_top'],
    'L_DISPLAY_POSTS' => $lang['Display_posts'],
    'L_LOCK_TOPIC' => $lang['Lock_topic'],
    'L_UNLOCK_TOPIC' => $lang['Unlock_topic'],
    'L_MOVE_TOPIC' => $lang['Move_topic'],
    'L_SPLIT_TOPIC' => $lang['Split_topic'],
    'L_DELETE_TOPIC' => $lang['Delete_topic'],
    'L_GOTO_PAGE' => $lang['Goto_page'],
    'L_TELL_FRIEND' => $lang['Tell_Friend'],
    'L_FAV' => $s_favorit_link,

    // Top of Page Links
    'PAGE_TOP_IMG' => '<a href="#top"><img src="' . $images['icon_up'] . '" alt="' . $lang['Back_to_top'] . '" title="' . $lang['Back_to_top'] . '" border="0" /></a>',
    'PAGE_TOP' => '<a href="#top">' . $lang['Back_to_top'] . '</a>',

    // Bottom of Page Links
    'PAGE_BOTTOM_IMG' => '<a href="#bot"><img src="' . $images['icon_down'] . '" alt="' . $lang['Go_to_bottom'] . '" title="' . $lang['Go_to_bottom'] . '" border="0" /></a>',
    'PAGE_BOTTOM' => '<a href="#bot">' . $lang['Go_to_bottom'] . '</a>',

    'S_TOPIC_LINK' => POST_TOPIC_URL,
    'S_SELECT_POST_DAYS' => $select_post_days,
    'S_SELECT_POST_ORDER' => $select_post_order,
    'S_POST_DAYS_ACTION' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . '=' . $topic_id . "&amp;start=$start"),
    'S_AUTH_LIST' => $s_auth_can,
    'S_TOPIC_ADMIN' => $topic_mod,
    'S_WATCH_TOPIC' => $s_watching_topic,
    'S_WATCH_TOPIC_IMG' => isset($s_watching_topic_img) ? $s_watching_topic_img : '',
    'S_TOPIC_VIEW_IMG' => $topic_view_img,
    'S_TOPIC_FAVORITES_IMG' => $s_favorit_img,

    'U_VIEW_TOPIC' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start&amp;postdays=$post_days&amp;postorder=$post_order&amp;highlight=$highlight"),
    'U_VIEW_FORUM' => $view_forum_url,
    'U_VIEW_OLDER_TOPIC' => $view_prev_topic_url,
    'U_VIEW_NEWER_TOPIC' => $view_next_topic_url,
    'U_POST_NEW_TOPIC' => $new_topic_url,
    'U_POST_REPLY_TOPIC' => $reply_topic_url,
    'U_PRINTER_TOPIC' => $printer_topic_url,
    'U_FAV' => $s_favorit_topic,
    )
);



//
// Does this topic contain a poll?
//
if ( !empty($forum_topic_data['topic_vote']) )
{

    $s_hidden_fields = '';

    $sql = "SELECT vd.vote_id, vd.vote_text, vd.vote_start, vd.vote_length, vr.vote_option_id, vr.vote_option_text, vr.vote_result
        FROM " . VOTE_DESC_TABLE . " vd, " . VOTE_RESULTS_TABLE . " vr
        WHERE vd.topic_id = $topic_id
            AND vr.vote_id = vd.vote_id
        ORDER BY vr.vote_option_id ASC";
    if ( !($result = $db->sql_query($sql)) )
    {
        message_die(GENERAL_ERROR, "Could not obtain vote data for this topic", '', __LINE__, __FILE__, $sql);
    }

    if ( $vote_info = $db->sql_fetchrowset($result) )
    {
        $db->sql_freeresult($result);
        $vote_options = count($vote_info);

        $vote_id = $vote_info[0]['vote_id'];
        $vote_title = $vote_info[0]['vote_text'];
//
// MOD: Allow Guest Voting
//

        if ($userdata['user_id'] == ANONYMOUS)
        {
            $guest_sql = " AND vote_user_ip = '$user_ip'";
        }
        else
        {
            $guest_sql = '';
        }

//
// MOD: -END-
//

        $sql = "SELECT vote_id
            FROM " . VOTE_USERS_TABLE . "
            WHERE vote_id = $vote_id
                AND vote_user_id = " . intval($userdata['user_id']) . $guest_sql;
        if ( !($result = $db->sql_query($sql)) )
        {
            message_die(GENERAL_ERROR, "Could not obtain user vote data for this topic", '', __LINE__, __FILE__, $sql);
        }

        $user_voted = ( $row = $db->sql_fetchrow($result) ) ? TRUE : 0;
        $db->sql_freeresult($result);

        if ( isset($HTTP_GET_VARS['vote']) || isset($HTTP_POST_VARS['vote']) )
        {
            $view_result = ( ( ( isset($HTTP_GET_VARS['vote']) ) ? $HTTP_GET_VARS['vote'] : $HTTP_POST_VARS['vote'] ) == 'viewresult' ) ? TRUE : 0;
        }
        else
        {
            $view_result = 0;
        }

        $poll_expired = ( $vote_info[0]['vote_length'] ) ? ( ( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] < time() ) ? TRUE : 0 ) : 0;

        if ( ( $poll_expired == 0 ) && ( $vote_info[0]['vote_length'] <> 0 ) )
            {
                $poll_expire_1 = (( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] ) - time() );
                $poll_expire_2 = intval($poll_expire_1/86400);
                $poll_expire_a = $poll_expire_2*86400;
                $poll_expire_3 = intval(($poll_expire_1 - ($poll_expire_a))/3600);
                $poll_expire_b = $poll_expire_3*3600;
                $poll_expire_4 = intval((($poll_expire_1 - ($poll_expire_a) - ($poll_expire_b)))/60);
                $poll_comma = ', ';
                $poll_space = ' ';
                $poll_expire_2 == '0' ? $poll_expire_6='' : ( ( $poll_expire_3 == 0 && $poll_expire_4 == 0 ) ? $poll_expire_6=$poll_expire_2.$poll_space.$lang['Days'] : $poll_expire_6=$poll_expire_2.$poll_space.$lang['Days'].$poll_comma ) ;
                $poll_expire_3 == '0' ? $poll_expire_7='' : ( $poll_expire_4 == 0 ? $poll_expire_7=$poll_expire_3.$poll_space.$lang['Hours'] : $poll_expire_7=$poll_expire_3.$poll_space.$lang['Hours'].$poll_comma ) ;
                $poll_expire_4 == '0' ? $poll_expire_8='' : $poll_expire_8=$poll_expire_4.$poll_space.$lang['Minutes'] ;
                $poll_expires_d = $lang['Poll_expires'];
				$template->assign_block_vars('switch_poll_expires', array());
            }
            else
            {
                $poll_expires_6 = '';
                $poll_expires_7 = '';
                $poll_expires_8 = '';
                $poll_expires_d = '';
            }
            $voted_vote_nb = $voted_vote;
            $template->assign_vars(array(
                'VOTED_SHOW' => $lang['Voted_show'],
                'L_TOTAL_VOTES' => $total_votes_1,
                'L_RESULTS_AFTER' => $poll_expires_c,
                'L_POLL_EXPIRES' => $poll_expires_d,
                'POLL_EXPIRES' => ($poll_expire_6.$poll_expire_7.$poll_expire_8),
                'TOTAL_VOTES' => $total_votes_2)
            );

        if ( $user_voted || $view_result || $poll_expired || !$is_auth['auth_vote'] || $forum_topic_data['topic_status'] == TOPIC_LOCKED )
        {
            $template->set_filenames(array(
                'pollbox' => 'viewtopic_poll_result.tpl')
            );

            $vote_results_sum = 0;

            for($i = 0; $i < $vote_options; $i++)
            {
                $vote_results_sum += $vote_info[$i]['vote_result'];
            }


            $vote_graphic = 0;
            $vote_graphic_max = count($images['voting_graphic']);

            for($i = 0; $i < $vote_options; $i++)
            {
                $vote_percent = ( $vote_results_sum > 0 ) ? $vote_info[$i]['vote_result'] / $vote_results_sum : 0;
                $vote_graphic_length = round($vote_percent * $board_config['vote_graphic_length']);

                $vote_graphic_img = $images['voting_graphic'][$vote_graphic];
                $vote_graphic = ($vote_graphic < $vote_graphic_max - 1) ? $vote_graphic + 1 : 0;

                if ( count($orig_word) )
                {
                    $vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
                }

                $template->assign_block_vars("poll_option", array(
                    'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'],
                    'POLL_OPTION_RESULT' => $vote_info[$i]['vote_result'],
                    'POLL_OPTION_PERCENT' => sprintf("%.1d%%", ($vote_percent * 100)),
                    'POLL_OPTION_IMG' => $vote_graphic_img,
                    'POLL_OPTION_IMG_LCAP' => $images['voting_lcap'],
                    'POLL_OPTION_IMG_RCAP' => $images['voting_rcap'],
                    'POLL_OPTION_IMG_WIDTH' => $vote_graphic_length)
                );
            }

            $template->assign_vars(array(
                'L_TOTAL_VOTES' => $lang['Total_votes'],
                'TOTAL_VOTES' => $vote_results_sum)
            );

        }
        else
        {
            $template->set_filenames(array(
                'pollbox' => 'viewtopic_poll_ballot.tpl')
            );

            for($i = 0; $i < $vote_options; $i++)
            {
                if ( count($orig_word) )
                {
                    $vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
                }

                $template->assign_block_vars("poll_option", array(
                    'POLL_OPTION_ID' => $vote_info[$i]['vote_option_id'],
                    'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'])
                );
            }

            $template->assign_vars(array(
                'L_SUBMIT_VOTE' => $lang['Submit_vote'],
                'L_VIEW_RESULTS' => $lang['View_results'],
                // Poll Validation MOD - Daz - forumimages.com - START
                'L_MUST_SELECT_POLL_OPTION' => $lang['No_vote_option'],
                // Poll Validation MOD - Daz - forumimages.com - END
                'U_VIEW_RESULTS' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;vote=viewresult"))
            );

            $s_hidden_fields = '<input type="hidden" name="topic_id" value="' . $topic_id . '" /><input type="hidden" name="mode" value="vote" />';
        }

        if ( count($orig_word) )
        {
            $vote_title = preg_replace($orig_word, $replacement_word, $vote_title);
        }

        $s_hidden_fields .= '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" />';

        $template->assign_vars(array(
            'POLL_QUESTION' => $vote_title,
            'S_HIDDEN_FIELDS' => $s_hidden_fields,
            'S_POLL_ACTION' => append_sid("posting.$phpEx?mode=vote&amp;" . POST_TOPIC_URL . "=$topic_id"))
        );

        $template->assign_var_from_handle('POLL_DISPLAY', 'pollbox');
    }
}

init_display_post_attachments($forum_topic_data['topic_attachment']);

//
// Update the topic view counter
//
if (!($postrow[0]['user_id'] == $userdata['user_id']))
{
    $sql = "UPDATE " . TOPICS_TABLE . "
        SET topic_views = topic_views + 1
        WHERE topic_id = $topic_id";
        if ( !$db->sql_query($sql) )
        {
            message_die(GENERAL_ERROR, "Could not update topic views.", '', __LINE__, __FILE__, $sql);
        }
}

$this_year=create_date('Y', time(), $board_config['board_timezone']);
$this_date = create_date('md', time(), $board_config['board_timezone']);

//
// Okay, let's do the loop, yeah come on baby let's do the loop
// and it goes like this ...
//
for($i = 0; $i < $total_posts; $i++)
{
    $poster_id = $postrow[$i]['user_id'];
    $poster = ( $poster_id == ANONYMOUS ) ? $lang['Guest'] : $postrow[$i]['username'];

    #
    # zodiacs, are out comment (require part 3), if you wish to have zodiac in viewtopic, then remove the outcomment signs
    #
    if ( $postrow[$i]['user_birthday'] != 999999 )
    {
        $poster_birthdate=realdate('md', $postrow[$i]['user_birthday']);
        $n=0;
        while ($n<26)
        {
            if ($poster_birthdate>=$zodiacdates[$n] & $poster_birthdate<=$zodiacdates[$n+1])
            {
                $zodiac = $lang[$zodiacs[($n/2)]];
                $u_zodiac = $images[$zodiacs[($n/2)]];
                $zodiac_img = '<img src="' . $u_zodiac . '" alt="' . $zodiac . '" title="' . $zodiac . '" style="vertical-align:middle" border="0" />';
                $n=26;
            } else
            {
                $n=$n+2;
            }
        }
        
        $poster_age = $this_year - realdate ('Y',$postrow[$i]['user_birthday']);
        if ($this_date < $poster_birthdate) $poster_age--;
        $poster_age = $lang['Age'] . ': ' . $poster_age;
        $chinese = get_chinese_year (realdate('Ymd', $postrow[$i]['user_birthday']));
        $u_chinese = $images[$chinese];
        $chinese_img = ($chinese=='Unknown') ? '' : '<img src="' . $u_chinese . '" alt="' . $lang[$chinese] . '" title="' . $lang[$chinese] . '" style="vertical-align:middle" border="0" />';
    } else
    {
        $zodiac = '';
        $u_zodiac = '';
        $zodiac_img = '';
        $poster_age = '';
        $chinese = '';
        $u_chinese = '';
        $chinese_img = '';
    }

    $post_date = create_date($board_config['default_dateformat'], $postrow[$i]['post_time'], $board_config['board_timezone']);
	/*
    //
    // MOD - TODAY AT - BEGIN
    //
    if ( $board_config['time_today'] < $postrow[$i]['post_time'])
    {
        $post_date = sprintf($lang['Today_at'], create_date($board_config['default_timeformat'], $postrow[$i]['post_time'], $board_config['board_timezone']));
    }
    else if ( $board_config['time_yesterday'] < $postrow[$i]['post_time'])
    {
        $post_date = sprintf($lang['Yesterday_at'], create_date($board_config['default_timeformat'], $postrow[$i]['post_time'], $board_config['board_timezone']));
    }
    // MOD - TODAY AT - END
	*/
    $poster_posts = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Posts'] . ': ' . $postrow[$i]['user_posts'] : '';

    $poster_from = ( $postrow[$i]['user_from'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Location'] . ': ' . $postrow[$i]['user_from'] : '';

    // FLAGHACK-start
    $poster_from_flag = ( $postrow[$i]['user_from_flag'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? "<img src=\"images/flags/" . $postrow[$i]['user_from_flag'] . "\" alt=\"" . $postrow[$i]['user_from_flag'] . "\" border=\"0\" width=\"32\" height=\"20\" />" : "";
    // FLAGHACK-end

    $poster_joined = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Joined'] . ': ' . create_date($lang['DATE_FORMAT'], $postrow[$i]['user_regdate'], $board_config['board_timezone']) : '';

    $poster_avatar = '';
    if ( $postrow[$i]['user_avatar_type'] && $poster_id != ANONYMOUS && $postrow[$i]['user_allowavatar'] && $userdata['avatar_sticky'] )
    {
        switch( $postrow[$i]['user_avatar_type'] )
        {
            case USER_AVATAR_UPLOAD:
                $poster_avatar = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . ((substr($board_config['avatar_path'], -1) == '/') ? '' : '/') . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
                break;
            case USER_AVATAR_REMOTE:
                $poster_avatar = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
                break;
            case USER_AVATAR_GALLERY:
                $poster_avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . ((substr($board_config['avatar_gallery_path'], -1) == '/') ? '' : '/') . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
                break;
        }
    }

    // MOD STICKY_AVATAR BEGIN
    else
    if ( ($postrow[$i]['current_user_avatar_type']) && $poster_id != ANONYMOUS && $postrow[$i]['user_allowavatar'] )
    {
        switch( $postrow[$i]['current_user_avatar_type'] )
        {
            case USER_AVATAR_UPLOAD:
                $poster_avatar = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . ((substr($board_config['avatar_path'], -1) == '/') ? '' : '/') . $postrow[$i]['current_user_avatar'] . '" alt="" border="0" />' : '';
                break;
            case USER_AVATAR_REMOTE:
                $poster_avatar = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $postrow[$i]['current_user_avatar'] . '" alt="" border="0" />' : '';
                break;
            case USER_AVATAR_GALLERY:
                $poster_avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . ((substr($board_config['avatar_gallery_path'], -1) == '/') ? '' : '/') . $postrow[$i]['current_user_avatar'] . '" alt="" border="0" />' : '';
                break;
        }
    }
    // MOD STICKY_AVATAR END

    //
    // Default Avatar MOD - Begin
    //
    if ( empty($poster_avatar) && $poster_id != ANONYMOUS)
    {
        $poster_avatar = '<img src="'.  $images['default_avatar'] .'" alt="" border="0" />';
    }
    if ( $poster_id == ANONYMOUS )
    {
        $poster_avatar = '<img src="'.  $images['guest_avatar'] .'" alt="" border="0" />';
    }
    //
    // Default Avatar MOD - End
    //

    if ( !empty($postrow[$i]['user_vacances']))
    {
        switch ($postrow[$i]['user_vacances'])
        {
            case 1 : $poster_avatar = '<img src="'.  $images['vacs'] .'" alt="" border="0" />'; break;
            default : $vacances_image="";
        }
    }

    //
    // Define the little post icon
    //

    //Added for read_tracking
    if ( $board_config['db_read_tracking'] )
    {
        //DB Read tracking
        if ( smart_is_new_topic_post( $topic_id, $postrow[$i]['post_time']) )
        {
            $mini_post_img = $images['icon_minipost_new'];
            $mini_post_alt = $lang['New_post'];
        }
        else
        {
            $mini_post_img = $images['icon_minipost'];
            $mini_post_alt = $lang['Post'];
        }
    }
    else
    {
        //Cookie Read tracking
        if ( $userdata['session_logged_in'] && $postrow[$i]['post_time'] > $userdata['user_lastvisit'] && $postrow[$i]['post_time'] > $topic_last_read )
        {
            $mini_post_img = $images['icon_minipost_new'];
            $mini_post_alt = $lang['New_post'];
        }
        else
        {
            $mini_post_img = $images['icon_minipost'];
            $mini_post_alt = $lang['Post'];
        }
    }

    $mini_post_url = append_sid("viewtopic.$phpEx?" . POST_POST_URL . '=' . $postrow[$i]['post_id']) . '#' . $postrow[$i]['post_id'];

    //
    // Generate ranks, set them to empty string initially.
    //
    $user_group_rank ='';
    $sql = "SELECT g.rank_id, g.group_id FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug
        WHERE ug.user_id = '" . $postrow[$i]['user_id'] . "'
        AND g.group_id = ug.group_id
        AND g.group_single_user <> " . TRUE . "
        AND ug.user_pending <> ".TRUE . "
        AND g.rank_id > 0
        ORDER BY g.group_priority, g.group_id";
    if(!$user_group_rank = $db->sql_query($sql))
        message_die(GENERAL_ERROR, "Error getting group information", "", __LINE__, __FILE__, $sql);

    $groups_rank = array();
    while ( $row = $db->sql_fetchrow($user_group_rank) )
    {
        $groups_rank[] = $row;
    }

    $poster_rank = '';
    $rank_image = '';
    $gender_image = '';
    $custom_title = '';

    if ( $postrow[$i]['user_id'] == ANONYMOUS )
    {
    }
    else if ( $postrow[$i]['user_rank'] )
    {
        for($j = 0; $j < count($ranksrow); $j++)
        {
            if ( $postrow[$i]['user_rank'] == $ranksrow[$j]['rank_id'] && $ranksrow[$j]['rank_special'] )
            {
                $poster_rank = $ranksrow[$j]['rank_title'];
                $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
            }
        }
    }
    else
    {
        /* Original Code
        for($j = 0; $j < count($ranksrow); $j++)
        {
            if ( $postrow[$i]['user_posts'] >= $ranksrow[$j]['rank_min'] && !$ranksrow[$j]['rank_special'] )
            {
                $poster_rank = $ranksrow[$j]['rank_title'];
                $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
            }
        }
        */

        // Rank for Groups code
        if ( $groups_rank[0]['rank_id'] == 0 )
        {
            for($j = 0; $j < count($ranksrow); $j++)
            {
                if ( $postrow[$i]['user_posts'] >= $ranksrow[$j]['rank_min'] && !$ranksrow[$j]['rank_special'] && ($ranksrow[$j]['rank_group'] == 0))
                {
                    $poster_rank = $ranksrow[$j]['rank_title'];
                    $rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                }
            }
        }
        else
        {
            for($l = 0; $l < count($ranksrow); $l++)
            {
                if ( $groups_rank[0]['rank_id'] == $ranksrow[$l]['rank_id'] && $ranksrow[$l]['rank_special'])
                {
                    $poster_rank = $ranksrow[$l]['rank_title'];
                    $rank_image = ( $ranksrow[$l]['rank_image'] ) ? '<img src="' . $images['rank'] . $ranksrow[$l]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';}
                }
            }
    }

    if ( !empty($postrow[$i]['user_custom_title']) )
    {
        switch( $board_config['custom_title_mode'] )
        {
            case CUSTOM_TITLE_MODE_INDEPENDENT:
                $custom_title = '<br />' . $postrow[$i]['user_custom_title'];
                break;
            case CUSTOM_TITLE_MODE_REPLACE_RANK:
                $poster_rank = $postrow[$i]['user_custom_title'];
                break;
            case CUSTOM_TITLE_MODE_REPLACE_BOTH:
                $poster_rank = $postrow[$i]['user_custom_title'];
                $rank_image = '';
                break;
            default:
                break;
        }
    }

    //
    // Handle anon users posting with usernames
    //
    if ( $poster_id == ANONYMOUS && $postrow[$i]['post_username'] != '' )
    {
        $poster = $postrow[$i]['post_username'];
        $poster_rank = $lang['Guest'];
        $poster_age='';
    }

    $temp_url = '';

    if ( $poster_id != ANONYMOUS )
    {
        $temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id");
        $profile_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_profile'] . '" alt="' . $lang['Read_profile'] . '" title="' . $lang['Read_profile'] . '" border="0" /></a>';
        $profile = '<a href="' . $temp_url . '">' . $lang['Read_profile'] . '</a>';

        $temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=$poster_id");
        $pm_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
        switch ($postrow[$i]['user_gender'])
        {
            case 1 :
                $gender_image = "<img src=\"" . $images['icon_minigender_male'] . "\" alt=\"" . $lang['Gender'].  ":".$lang['Male']."\" title=\"" . $lang['Gender'] . ":".$lang['Male']. "\" border=\"0\" style=\"vertical-align:middle\" />";
                break;
            case 2 :
                $gender_image = "<img src=\"" . $images['icon_minigender_female'] . "\" alt=\"" . $lang['Gender']. ":".$lang['Female']. "\" title=\"" . $lang['Gender'] . ":".$lang['Female']. "\" border=\"0\" style=\"vertical-align:middle\" />";
                break;
            default :
                $gender_image="";
        }
        $pm = '<a href="' . $temp_url . '">' . $lang['Send_private_message'] . '</a>';

        if ( !empty($postrow[$i]['user_viewemail']) || $is_auth['auth_mod'] )
        {
            $email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $poster_id) : 'mailto:' . $postrow[$i]['user_email'];

            $email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
            $email = '<a href="' . $email_uri . '">' . $lang['Send_email'] . '</a>';
        }
        else
        {
            $email_img = '';
            $email = '';
        }

        $www_img = ( $postrow[$i]['user_website'] ) ? '<a href="' . $postrow[$i]['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '';
        $www = ( $postrow[$i]['user_website'] ) ? '<a href="' . $postrow[$i]['user_website'] . '" target="_userwww">' . $lang['Visit_website'] . '</a>' : '';

        if ( !empty($postrow[$i]['user_icq']) )
        {
            $icq_status_img = '<a href="http://wwp.icq.com/' . $postrow[$i]['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $postrow[$i]['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
            $icq_img = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $postrow[$i]['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
            $icq =  '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $postrow[$i]['user_icq'] . '">' . $lang['ICQ'] . '</a>';
        }
        else
        {
            $icq_status_img = '';
            $icq_img = '';
            $icq = '';
        }

        $aim_img = ( $postrow[$i]['user_aim'] ) ? '<a href="aim:goim?screenname=' . $postrow[$i]['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '';
        $aim = ( $postrow[$i]['user_aim'] ) ? '<a href="aim:goim?screenname=' . $postrow[$i]['user_aim'] . '&amp;message=Hello+Are+you+there?">' . $lang['AIM'] . '</a>' : '';

        $temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id");
        $msn_img = ( $postrow[$i]['user_msnm'] ) ? '<a href="' . $temp_url . '"><img src="' . $images['icon_msnm'] . '" alt="' . $lang['MSNM'] . '" title="' . $lang['MSNM'] . '" border="0" /></a>' : '';
        $msn = ( $postrow[$i]['user_msnm'] ) ? '<a href="' . $temp_url . '">' . $lang['MSNM'] . '</a>' : '';

        $yim_img = ( $postrow[$i]['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $postrow[$i]['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
        $yim = ( $postrow[$i]['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $postrow[$i]['user_yim'] . '&amp;.src=pg">' . $lang['YIM'] . '</a>' : '';
    }
    else
    {
        $profile_img = '';
        $profile = '';
        $pm_img = '';
        $pm = '';

        $email_img = '';
        $email = '';
        $www_img = '';
        $www = '';
        $icq_status_img = '';
        $icq_img = '';
        $icq = '';
        $aim_img = '';
        $aim = '';
        $msn_img = '';
        $msn = '';
        $yim_img = '';
        $yim = '';
    }

    $temp_url = append_sid("posting.$phpEx?mode=quote&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
    $quote_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_quote'] . '" alt="' . $lang['Reply_with_quote'] . '" title="' . $lang['Reply_with_quote'] . '" border="0" /></a>';
    $quote = '<a href="' . $temp_url . '">' . $lang['Reply_with_quote'] . '</a>';

    $temp_url = append_sid("search.$phpEx?search_author=" . urlencode($postrow[$i]['username']) . "&amp;showresults=posts");
    $search_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_search'] . '" alt="' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '" title="' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '" border="0" /></a>';
    $search = '<a href="' . $temp_url . '">' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '</a>';

    // Edit Post Date hack
    //
    if ( $userdata['user_level'] == ADMIN)
    {
        $edit_post_date_id = $postrow[$i]['post_id'];
        $temp_url =  "javascript:window.open('includes/edit_post_date.php?p=$edit_post_date_id','edit_post_date','width=500,height=430');void(0);";
        $edit_date_img = '<a href="' . $temp_url . '"><img src="'  . $images['icon_edit_date'] . '" alt="' . $lang['Edit_post_date'] . '" title="' . $lang['Edit_post_date'] . '" border="0" /></a>';
    }
    else
    {
        $edit_date_img = '';
        $edit_date = '';
    }
    // End Edit Post Date hack

    if ( ( $userdata['user_id'] == $poster_id && $is_auth['auth_edit'] ) || $is_auth['auth_mod'] )
    {
        $temp_url = append_sid("posting.$phpEx?mode=editpost&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
        $edit_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_edit'] . '" alt="' . $lang['Edit_delete_post'] . '" title="' . $lang['Edit_delete_post'] . '" border="0" /></a>';
        $edit = '<a href="' . $temp_url . '">' . $lang['Edit_delete_post'] . '</a>';
    }
    else
    {
        $edit_img = '';
        $edit = '';
    }

    $topic_view_img = ($userdata['session_logged_in']) ?
      '<a href="' . append_sid("topic_view_users.$phpEx?".POST_TOPIC_URL."=$topic_id") . '"><img src="' . $images['topic_viewed'] . '" alt="' . $lang['Topic_view_users'] . '" title="' . $lang['Topic_view_users'] . '" border="0" /></a>':'';

    if ( $is_auth['auth_mod'] )
    {
        $temp_url = "modcp.$phpEx?mode=ip&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;" . POST_TOPIC_URL . "=" . $topic_id . "&amp;sid=" . $userdata['session_id'];
        $ip_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_ip'] . '" alt="' . $lang['View_IP'] . '" title="' . $lang['View_IP'] . '" border="0" /></a>';
        $ip = '<a href="' . $temp_url . '">' . $lang['View_IP'] . '</a>';

        $temp_url = "posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;sid=" . $userdata['session_id'];
        $delpost_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_delpost'] . '" alt="' . $lang['Delete_post'] . '" title="' . $lang['Delete_post'] . '" border="0" /></a>';
        $delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';
    }
    else
    {
        $ip_img = '';
        $ip = '';

        if ( $userdata['user_id'] == $poster_id && $is_auth['auth_delete'] && $forum_topic_data['topic_last_post_id'] == $postrow[$i]['post_id'] )
        {
            $temp_url = "posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;sid=" . $userdata['session_id'];
            $delpost_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_delpost'] . '" alt="' . $lang['Delete_post'] . '" title="' . $lang['Delete_post'] . '" border="0" /></a>';
            $delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';
        }
        else
        {
            $delpost_img = '';
            $delpost = '';
        }
    }

    // BEGIN Report post hack
    if ( $i == 0 && !isset($rp) )
    {
        include($phpbb_root_path . 'includes/reportpost.'.$phpEx);
    }
    if ( empty($postrow[$i]['reporter_id']) && ( !$userdata['session_logged_in'] || $postrow[$i]['poster_id'] != $userdata['user_id'] ) && !$rp->report_disabled2($postrow[$i]['poster_id']) && $rp->report_auth($userdata['user_id']) )
    {
        $temp_url = append_sid("report.$phpEx?mode=report&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
        $report_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_report'] . '" alt="' . $lang['Report_post'] . '" title="' . $lang['Report_post'] . '" border="0" /></a>';
        $report = '<a href="' . $temp_url . '">' . $lang['Report_post'] . '</a>';
    }
    else if ( !empty($postrow[$i]['reporter_id']) && ( ( $userdata['session_logged_in'] && $postrow[$i]['reporter_id'] == $userdata['user_id'] ) || ( $is_auth['auth_mod'] && $rp->check_access() ) ) )
    {
        $temp_url = append_sid("report.$phpEx?mode=del_report&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
        $report_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_del_report'] . '" alt="' . $lang['Report_del'] . '" title="' . $lang['Report_del'] . '" border="0" /></a>';
        $report = '<a href="' . $temp_url . '">' . $lang['Report_del'] . '</a>';
    }
    else
    {
        $report_img = '';
        $report = '';
    }
    // END Report post hack

    $post_subject = ( $postrow[$i]['post_subject'] != '' ) ? $postrow[$i]['post_subject'] : '';

    $message = $postrow[$i]['post_text'];
    $bbcode_uid = $postrow[$i]['bbcode_uid'];

    $user_sig = ( $postrow[$i]['enable_sig'] && $postrow[$i]['user_sig'] != '' && $board_config['allow_sig'] ) ? $postrow[$i]['user_sig'] : '';
    $user_sig_bbcode_uid = $postrow[$i]['user_sig_bbcode_uid'];

    //
    // Note! The order used for parsing the message _is_ important, moving things around could break any
    // output
    //

    //
    // If the board has HTML off but the post has HTML
    // on then we process it, else leave it alone
    //
	if ( !$board_config['allow_html'] || !$userdata['user_allowhtml'])
	{
		if ( $user_sig != '' )
        {
            $user_sig = sig_suite($user_sig); // Sig suite mod
            $user_sig = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $user_sig);
        }

        if ( $postrow[$i]['enable_html'] )
        {
            $message = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $message);
        }
    }

    //
    // Parse message and/or sig for BBCode if reqd
    //
	if ($user_sig != '' && $user_sig_bbcode_uid != '')
	{
    	$user_sig = sig_suite($user_sig); // Sig suite mod
		$user_sig = ($board_config['allow_bbcode']) ? bbencode_second_pass($user_sig, $user_sig_bbcode_uid) : preg_replace("/\:$user_sig_bbcode_uid/si", '', $user_sig);
	}

	if ($bbcode_uid != '')
	{
		$message = ($board_config['allow_bbcode']) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace("/\:$bbcode_uid/si", '', $message);
	}

    if ( $user_sig != '' )
    {
        $user_sig = sig_suite($user_sig); // Sig suite mod
        $user_sig = make_clickable($user_sig);
    }
    $message = make_clickable($message);

    // BEGIN CMX News Mod
    // Strip out the <!--break--> delimiter.
    $delim = htmlspecialchars( '<!--break-->' );
    $pos = strpos( $message, $delim );
    if( ($pos !== false) && ($pos < strlen( $message )) ) {
        $message = substr_replace( $message, html_entity_decode($delim), $pos, strlen($delim) );
    }
    // END CMX News Mod

    //
    // Parse smilies
    //
    if ( $board_config['allow_smilies'] )
    {
        if ( $postrow[$i]['user_allowsmile'] && $user_sig != '' )
        {
            $user_sig = smilies_pass($user_sig);
        }

        if ( $postrow[$i]['enable_smilies'] )
        {
            $message = smilies_pass($message);
        }
    }

    //
    // Highlight active words (primarily for search)
    //
    if ($highlight_match)
    {
		// This has been back-ported from 3.0 CVS
		$message = preg_replace('#(?!<.*)(?<!\w)(' . $highlight_match . ')(?!\w|[^<>]*>)#i', '<b style="color:#'.$theme['fontcolor3'].'">\1</b>', $message);
    }

    //
    // Replace naughty words
    //
    if (count($orig_word))
    {
        $post_subject = preg_replace($orig_word, $replacement_word, $post_subject);

        if ($user_sig != '')
        {
			$user_sig = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $user_sig . '<'), 1, -1));
		}

		$message = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $message . '<'), 1, -1));
    }

    //
    // Replace newlines (we use this rather than nl2br because
    // till recently it wasn't XHTML compliant)
    //
    if ( $user_sig != '' )
    {
        $user_sig = '<br />--------------------<br />' . str_replace("\n", "\n<br />\n", $user_sig);
    }

    $message = acronym_pass( $message );

    $message = smart_pass( $message );

    $message = str_replace("\n", "\n<br />\n", $message);

    //
    // Editing information
    //

    $l_edited_by = '';

    if ( $postrow[$i]['post_edit_count'] )
    {
        $editer = '';
        if ( !$postrow[$i]['post_edit_user'] )
        {
            $editer = $poster;
        }
        else
        {
            $usr_id = $postrow[$i]['post_edit_user'];
            $sql = "SELECT username
                FROM " . USERS_TABLE . " u
            WHERE user_id = " . $usr_id;
            if ( !($result = $db->sql_query($sql)) )
            {
                message_die(GENERAL_ERROR, 'Tried obtaining data for a non-existent user', '', __LINE__, __FILE__, $sql);
            }

            $row = $db->sql_fetchrow($result);
            $editer = $row['username'];
        }
        $l_edit_time_total = ( $postrow[$i]['post_edit_count'] == 1 ) ? $lang['Edited_time_total'] : $lang['Edited_times_total'];
        $l_edited_by = '<br /><br />' . sprintf($l_edit_time_total, $editer, create_date($board_config['default_dateformat'], $postrow[$i]['post_edit_time'], $board_config['board_timezone']), $postrow[$i]['post_edit_count'], 0);
    }

    if ( $postrow[$i]['post_icon'] == 0 )
    {
        $icon = '<img src="images/spacer.gif" alt="" width="25" height="1" />';
    }
    else
    {
        $icon = '<img width="25" height="25" src="'.$images['root'].'post_icon/icon'.$postrow[$i]['post_icon'].'.gif" alt="Message Icon" border="0" style="vertical-align:middle" />';
    }

    //
    // Again this will be handled by the templating
    // code at some point
    //
    $row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
    $row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

    if ($postrow[$i]['post_id'] == $topic_first_post_id) mycal_append_event($topic_id, $message);

    //Online/Offline
    if ($poster_id == ANONYMOUS)
    {
        $on_off_hidden = '';
    }
    else if (($postrow[$i]['user_session_time'] >= ( time() - 300 )) && ($postrow[$i]['user_allow_viewonline']))
    {
        $on_off_hidden = '<img src="' . $images['icon_online'] . '" alt="' . $lang['Online'] . '" title="' . $lang['Online'] . '" border="0" />';
    }
    else if (($postrow[$i]['user_allow_viewonline']) == 0)
    {
        $on_off_hidden = '<img src="' . $images['icon_hidden'] . '" alt="' . $lang['Hidden'] . '" title="' . $lang['Hidden'] . '" border="0" />';
    }
    else
    {
        $on_off_hidden = '<img src="' . $images['icon_offline'] . '" alt="' . $lang['Offline'] . '" title="' . $lang['Offline'] . '" border="0" />';
    }

    // Start add - Member Number Mod
    $poster_number = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Member_number'] . ' : ' . sprintf($postrow[$i]['user_id']-1) : '';
    // End add - Member Number Mod

    $template->assign_block_vars('postrow', array(
        'ICON' => $icon,
        'ROW_COLOR' => '#' . $row_color,
        'ROW_CLASS' => $row_class,
        'POSTER_NAME' => ($poster_name = color_group_colorize_name($poster_id,true)) ? $poster_name : $poster,
        'CUSTOM_TITLE' => $custom_title,
        #
        # if part 3 are installed, and you wish t include zodiac signs in view topic, then add these lines aswell
        'ZODIAC_IMG' => $zodiac_img,
        'ZODIAC' => $zodiac,
        'U_ZODIAC' => $u_zodiac,
        'L_ZODIAC' => ($zodiac) ? $lang['Zodiac'] . ': ' : '',
        #
        'CHINESE' => isset($lang[$chinese]) ? $lang[$chinese] : '',
        'CHINESE_IMG' => $chinese_img,
        'U_CHINESE' => $u_chinese,
        'L_CHINESE' => ($chinese) ? $lang['Chinese_zodiac'] . ': ' : '',
        'POSTER_AGE' => $poster_age,
        'POSTER_RANK' => $poster_rank,
        'POSTER_GENDER' => $gender_image,
        'RANK_IMAGE' => $rank_image,
        'POSTER_JOINED' => $poster_joined,
        // Start add - Member Number Mod
        'POSTER_USER_ID' => $poster_number,
        // End add - Member Number Mod
        'POSTER_POSTS' => $poster_posts,
        'POSTER_FROM' => $poster_from,
        // FLAGHACK-start
        'POSTER_FROM_FLAG' => $poster_from_flag,
        // FLAGHACK-end
        'POSTER_AVATAR' => $poster_avatar,
        'POSTER_ONLINE' => $on_off_hidden,
        'POST_DATE' => $post_date,
        'POST_NUMBER' => ($i + $start + 1),
        'POST_SUBJECT' => $post_subject,
        'MESSAGE' => $message,
        'SIGNATURE' => $user_sig,
        'EDITED_MESSAGE' => $l_edited_by,

        'MINI_POST_IMG' => $mini_post_img,
        'PROFILE_IMG' => $profile_img,
        'PROFILE' => $profile,
        'SEARCH_IMG' => $search_img,
        'SEARCH' => $search,
        'PM_IMG' => $pm_img,
        'PM' => $pm,
        'EMAIL_IMG' => $email_img,
        'EMAIL' => $email,
        'WWW_IMG' => $www_img,
        'WWW' => $www,
        'ICQ_STATUS_IMG' => $icq_status_img,
        'ICQ_IMG' => $icq_img,
        'ICQ' => $icq,
        'AIM_IMG' => $aim_img,
        'AIM' => $aim,
        'MSN_IMG' => $msn_img,
        'MSN' => $msn,
        'YIM_IMG' => $yim_img,
        'YIM' => $yim,
        'EDIT_IMG' => $edit_img,
        'EDIT' => $edit,
        'EDIT_DATE_IMG' => $edit_date_img,
        'QUOTE_IMG' => $quote_img,
        'QUOTE' => $quote,
        'IP_IMG' => $ip_img,
        'IP' => $ip,
        'DELETE_IMG' => $delpost_img,
        'DELETE' => $delpost,
        'L_GENDER' => $lang['Gender'],
        // BEGIN Report post hack
        'REPORT_IMG' => $report_img,
        'REPORT' => $report,
        // END Report post hack

        'L_MINI_POST_ALT' => $mini_post_alt,

        'U_MINI_POST' => $mini_post_url,
        'U_POST_ID' => $postrow[$i]['post_id'])
    );

    $cm_viewtopic->post_vars($postrow[$i],$userdata,$forum_id);

    display_post_attachments($postrow[$i]['post_id'], $postrow[$i]['post_attachment']);
}

/* BEGIN Quick Reply */
if ($is_auth['auth_reply'] == true)
{
    //$quick_reply_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_locked'] : $images['quick_reply'];
    $quick_reply_alt = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['Quick_Reply_to_topic'];

    if ( !$userdata['session_logged_in'] )
    {
        $template->assign_block_vars('switch_username_field', array());
    }

    $template->assign_block_vars('quick_reply', array(
    'QUOTE_IMG' => $quote_img,
    //'QUICK_REPLY_IMG' => $quick_reply_img,

    'L_QUICK_REPLY_TOPIC' => $quick_reply_alt,
    'L_EMPTY_MESSAGE' => $lang['Empty_message'],

    'U_QUICK_REPLY' => append_sid('posting.' . $phpEx),
    'U_HIDDEN_FORM_FIELDS' => ( ($userdata['user_attachsig'] ? '<input type="hidden" name="attach_sig" value="1" />' : "") . ($userdata['user_notify'] ? '<input type="hidden" name="notify" value="1" />' : "") . '<input type="hidden" name="mode" value="reply" /><input type="hidden" name="post" value="1" /><input type="hidden" name="' . POST_TOPIC_URL . '" value="' . $topic_id . '" /> <input type="hidden" name="sid" value="' . $userdata['session_id'] . '" />' )));
    if ( $board_config['message_length'] > 0 )
    {
	    $template->assign_block_vars('switch_msg', array('L_MESSAGE_CHARS' => $board_config['message_length']));
    }
	$template->assign_vars(array('L_EMPTY_MESSAGE' => $lang['Empty_message']));
}
/* END Quick Reply */

$template->assign_vars(array(
"TELL_LINK" => append_sid("http://".$HTTP_SERVER_VARS['HTTP_HOST'].$HTTP_SERVER_VARS['PHP_SELF']."?t=$topic_id", true)));

$template->pparse('body');

//Added for DB read_tracking
if ( $board_config['db_read_tracking'] )
{
    smart_read_topic( $topic_id );
}

if(isset($HTTP_GET_VARS['printertopic']))
{
    $gen_simple_header = 1;
}
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>
